# Contributing

When contributing to this repository, please first discuss the change
you wish to make via issue, email, or any other method with the owners
of this repository before making a change. There may even be an issue
already open, and together we may come up with a specific strategy
before you take your precious time to write code.

## Pull Request Process

When you're done with your part of code and ready to submit a PR, there
are a couple of guidelines we ask you to follow:

1. Make sure your branch is based on the master branch and includes the
   latest state
2. Add or update tests (if required). Check that all tests are still
   valid. Test the part that was changed
3. Make sure your code does not violate the lint rules.
4. Make sure the CI processes are successful
5. If your request is associated with a bug or issue from the issues
   list, add the line `Fixes #$ISSUE_NUMBER`. Ex. For closing issue
   `418`, include the line `Fixes #418`. If it doesn't close the issue
   but addresses it partially, just include a reference to the issue
   number, like `#418`.
6. You can merge the request after you have at least one approval of
   core contributor, or, if you do not have permission to do so, you may
   request the second reviewer to merge it for you

Thank you for helping to make this project better!
