"use strict";

var _Object$defineProperty = require("@babel/runtime-corejs3/core-js-stable/object/define-property");

_Object$defineProperty(exports, "__esModule", {
  value: true
});

exports.VOTE_TYPE_ID = exports.RESERVED_SPACE_ID = exports.IMPLEMENTATION_OBJECT_TYPE_ID = void 0;

/**
 * @typedef {Object} RESERVED_SPACE_ID_t
 * @property {0} RELATIVE_PROTOCOL
 * @property {1} PROTOCOL
 * @property {2} IMPLEMENTATION
 */

/** @typedef {RESERVED_SPACE_ID_t[keyof RESERVED_SPACE_ID_t]} ReservedSpaceId */

/** @type {RESERVED_SPACE_ID_t} */
var RESERVED_SPACE_ID = {
  RELATIVE_PROTOCOL: 0,
  PROTOCOL: 1,
  IMPLEMENTATION: 2
};
/**
 * @typedef {Object} IMPLEMENTATION_OBJECT_TYPE_t
 * @property {0} GLOBAL_PROPERTY
 * @property {1} DYNAMIC_GLOBAL_PROPERTY
 * @property {2} ASSET_DYNAMIC_DATA
 * @property {3} ASSET_BITASSET_DATA
 * @property {4} ACCOUNT_BALANCE
 * @property {5} ACCOUNT_STATISTICS
 * @property {6} TRANSACTION_DEDUPE
 * @property {7} BLOCK_SUMMARY
 * @property {8} ACCOUNT_TRANSACTION_HISTORY
 * @property {9} CHAIN_PROPERTY
 * @property {10} SPECIAL_AUTHORITY
 * @property {11} CONTRACT_BALANCE
 * @property {12} CONTRACT_HISTORY
 * @property {13} CONTRACT_STATISTICS
 * @property {14} ACCOUNT_ADDRESS
 * @property {15} CONTRACT_POOL
 * @property {16} MALICIOUS_COMMITTEEMEN
 * @property {17} INCENTIVES_POOL
 * @property {18} VERIFIERS
 * @property {19} IMPL_SPV_PENALTIES
 */

/** @typedef {IMPLEMENTATION_OBJECT_TYPE_t[keyof IMPLEMENTATION_OBJECT_TYPE_t]} ImplementationObjectTypeId */

/** @type {IMPLEMENTATION_OBJECT_TYPE_t} */

exports.RESERVED_SPACE_ID = RESERVED_SPACE_ID;
var IMPLEMENTATION_OBJECT_TYPE_ID = {
  GLOBAL_PROPERTY: 0,
  DYNAMIC_GLOBAL_PROPERTY: 1,
  ASSET_DYNAMIC_DATA: 2,
  ASSET_BITASSET_DATA: 3,
  ACCOUNT_BALANCE: 4,
  ACCOUNT_STATISTICS: 5,
  TRANSACTION_DEDUPE: 6,
  BLOCK_SUMMARY: 7,
  ACCOUNT_TRANSACTION_HISTORY: 8,
  CHAIN_PROPERTY: 9,
  SPECIAL_AUTHORITY: 10,
  CONTRACT_BALANCE: 11,
  CONTRACT_HISTORY: 12,
  CONTRACT_STATISTICS: 13,
  ACCOUNT_ADDRESS: 14,
  CONTRACT_POOL: 15,
  MALICIOUS_COMMITTEEMEN: 16,
  INCENTIVES_POOL: 17,
  VERIFIERS: 18,
  IMPL_SPV_PENALTIES: 19
};
/** @typedef {0} VoteType */

exports.IMPLEMENTATION_OBJECT_TYPE_ID = IMPLEMENTATION_OBJECT_TYPE_ID;
var VOTE_TYPE_ID = {
  COMMITTEE: 0
};
exports.VOTE_TYPE_ID = VOTE_TYPE_ID;