"use strict";

var _typeof = require("@babel/runtime-corejs3/helpers/typeof");

var _WeakMap = require("@babel/runtime-corejs3/core-js-stable/weak-map");

var _Object$defineProperty = require("@babel/runtime-corejs3/core-js-stable/object/define-property");

var _Object$getOwnPropertyDescriptor = require("@babel/runtime-corejs3/core-js-stable/object/get-own-property-descriptor");

var _interopRequireDefault = require("@babel/runtime-corejs3/helpers/interopRequireDefault");

_Object$defineProperty(exports, "__esModule", {
  value: true
});

exports.protocol = exports.chain = exports.WS_CONSTANTS = exports.USE_CACHE_BY_DEFAULT = exports.UPDATE_CALL_ORDER = exports.START_OPERATION_ID = exports.PROTOCOL_OBJECT_TYPE_ID = exports.OPERATIONS_IDS = exports.NET = exports.ECHO_MAX_SHARE_SUPPLY = exports.ECHO_ASSET_ID = exports.ECHORAND_TYPES = exports.DYNAMIC_GLOBAL_OBJECT_ID = exports.DEFAULT_MIN_CACHE_CLEANING_TIME = exports.DEFAULT_CACHE_EXPIRATION_TIME = exports.DEFAULT_BLOCKS_EXPIRATION_NUMBER = exports.CORE_ASSET_ID = exports.CLOSE_CALL_ORDER = exports.CHAIN_TYPES = exports.CHAIN_CONFIG = exports.CANCEL_LIMIT_ORDER = exports.CACHE_MAPS = exports.BITASSET_UPDATE = exports.API_CONFIG = exports.AMOUNT_MAX_NUMBER = void 0;

var _bignumber = _interopRequireDefault(require("bignumber.js"));

var API_CONFIG = _interopRequireWildcard(require("./api-config"));

exports.API_CONFIG = API_CONFIG;

var CACHE_MAPS = _interopRequireWildcard(require("./cache-maps"));

exports.CACHE_MAPS = CACHE_MAPS;

var chain = _interopRequireWildcard(require("./chain"));

exports.chain = chain;

var CHAIN_CONFIG = _interopRequireWildcard(require("./chain-config"));

exports.CHAIN_CONFIG = CHAIN_CONFIG;

var CHAIN_TYPES = _interopRequireWildcard(require("./chain-types"));

exports.CHAIN_TYPES = CHAIN_TYPES;

var PROTOCOL_OBJECT_TYPE_ID = _interopRequireWildcard(require("./object-types"));

exports.PROTOCOL_OBJECT_TYPE_ID = PROTOCOL_OBJECT_TYPE_ID;

var OPERATIONS_IDS = _interopRequireWildcard(require("./operations-ids"));

exports.OPERATIONS_IDS = OPERATIONS_IDS;

var WS_CONSTANTS = _interopRequireWildcard(require("./ws-constants"));

exports.WS_CONSTANTS = WS_CONSTANTS;

var protocol = _interopRequireWildcard(require("./protocol"));

exports.protocol = protocol;

var NET = _interopRequireWildcard(require("./net"));

exports.NET = NET;

function _getRequireWildcardCache(nodeInterop) { if (typeof _WeakMap !== "function") return null; var cacheBabelInterop = new _WeakMap(); var cacheNodeInterop = new _WeakMap(); return (_getRequireWildcardCache = function _getRequireWildcardCache(nodeInterop) { return nodeInterop ? cacheNodeInterop : cacheBabelInterop; })(nodeInterop); }

function _interopRequireWildcard(obj, nodeInterop) { if (!nodeInterop && obj && obj.__esModule) { return obj; } if (obj === null || _typeof(obj) !== "object" && typeof obj !== "function") { return { "default": obj }; } var cache = _getRequireWildcardCache(nodeInterop); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = _Object$defineProperty && _Object$getOwnPropertyDescriptor; for (var key in obj) { if (key !== "default" && Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? _Object$getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { _Object$defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj["default"] = obj; if (cache) { cache.set(obj, newObj); } return newObj; }

var START_OPERATION_ID = "1.".concat(PROTOCOL_OBJECT_TYPE_ID.OPERATION_HISTORY, ".0");
exports.START_OPERATION_ID = START_OPERATION_ID;
var CORE_ASSET_ID = "1.".concat(PROTOCOL_OBJECT_TYPE_ID.ASSET, ".0");
exports.CORE_ASSET_ID = CORE_ASSET_ID;
var ECHORAND_TYPES = {
  START_NOTIFICATION: 1,
  BLOCK_NOTIFICATION: 2
};
exports.ECHORAND_TYPES = ECHORAND_TYPES;
var CANCEL_LIMIT_ORDER = 'cancel-limit-order';
exports.CANCEL_LIMIT_ORDER = CANCEL_LIMIT_ORDER;
var UPDATE_CALL_ORDER = 'update-call-order';
exports.UPDATE_CALL_ORDER = UPDATE_CALL_ORDER;
var CLOSE_CALL_ORDER = 'close-call-order';
exports.CLOSE_CALL_ORDER = CLOSE_CALL_ORDER;
var BITASSET_UPDATE = 'bitasset-update';
exports.BITASSET_UPDATE = BITASSET_UPDATE;
var ECHO_ASSET_ID = "1.".concat(PROTOCOL_OBJECT_TYPE_ID.ASSET, ".0");
exports.ECHO_ASSET_ID = ECHO_ASSET_ID;
var DYNAMIC_GLOBAL_OBJECT_ID = "2.".concat(CHAIN_TYPES.IMPLEMENTATION_OBJECT_TYPE_ID.DYNAMIC_GLOBAL_PROPERTY, ".0");
exports.DYNAMIC_GLOBAL_OBJECT_ID = DYNAMIC_GLOBAL_OBJECT_ID;
var USE_CACHE_BY_DEFAULT = true;
exports.USE_CACHE_BY_DEFAULT = USE_CACHE_BY_DEFAULT;
var DEFAULT_BLOCKS_EXPIRATION_NUMBER = 20;
exports.DEFAULT_BLOCKS_EXPIRATION_NUMBER = DEFAULT_BLOCKS_EXPIRATION_NUMBER;
var DEFAULT_CACHE_EXPIRATION_TIME = null;
exports.DEFAULT_CACHE_EXPIRATION_TIME = DEFAULT_CACHE_EXPIRATION_TIME;
var DEFAULT_MIN_CACHE_CLEANING_TIME = 500;
/** @typedef {typeof PROTOCOL_OBJECT_TYPE_ID[keyof typeof PROTOCOL_OBJECT_TYPE_ID]} ProtocolObjectTypeId */

/** @typedef {typeof OPERATIONS_IDS[keyof typeof OPERATIONS_IDS]} OperationId */

exports.DEFAULT_MIN_CACHE_CLEANING_TIME = DEFAULT_MIN_CACHE_CLEANING_TIME;
var AMOUNT_MAX_NUMBER = new _bignumber["default"](2).pow(63).minus(1);
exports.AMOUNT_MAX_NUMBER = AMOUNT_MAX_NUMBER;
var ECHO_MAX_SHARE_SUPPLY = 1000000000000000;
exports.ECHO_MAX_SHARE_SUPPLY = ECHO_MAX_SHARE_SUPPLY;