"use strict";

var _Object$defineProperty = require("@babel/runtime-corejs3/core-js-stable/object/define-property");

var _interopRequireDefault = require("@babel/runtime-corejs3/helpers/interopRequireDefault");

_Object$defineProperty(exports, "__esModule", {
  value: true
});

exports["default"] = void 0;

var _map = _interopRequireDefault(require("@babel/runtime-corejs3/core-js-stable/instance/map"));

var _classCallCheck2 = _interopRequireDefault(require("@babel/runtime-corejs3/helpers/classCallCheck"));

var _createClass2 = _interopRequireDefault(require("@babel/runtime-corejs3/helpers/createClass"));

var _lodash = require("lodash");

var _decoders = _interopRequireDefault(require("./decoders"));

/** @typedef {import('../../types/echo/transaction').BroadcastingResult} BroadcastingResult */

/** @typedef {import('../../types/interfaces/ContractResult').ContractResult} ContractResult */

/** @typedef {import('./Method').default} Method */
var Result = /*#__PURE__*/function () {
  /**
   * @param {Method} method
   * @param {BroadcastingResult} transactionResult
   * @param {ContractResult} contractResult
   */
  function Result(method, transactionResult, contractResult) {
    var _context;

    (0, _classCallCheck2["default"])(this, Result);

    /**
     * @private
     * @type {BroadcastingResult}
     */
    this._transactionResult = transactionResult;
    /**
     * @private
     * @type {ContractResult}
     */

    this._contractResult = contractResult;
    /**
     * @private
     * @type {any[] | null | any}
     */

    this._decodedResult = (0, _decoders["default"])(this._contractResult.exec_res.output, (0, _map["default"])(_context = method.outputs).call(_context, function (_ref) {
      var type = _ref.type;
      return type;
    }));
    /**
     * @private
     * @type {{ [eventName: string]: { [field: string]: any } }}
     */

    this._events = method.contract.parseLogs(contractResult.tr_receipt.log);
  }

  (0, _createClass2["default"])(Result, [{
    key: "transactionResult",
    get:
    /**
     * @readonly
     * @type {BroadcastingResult[]}
     */
    function get() {
      return (0, _lodash.cloneDeep)(this._transactionResult);
    }
    /**
     * @readonly
     * @type {ContractResult}
     */

  }, {
    key: "contractResult",
    get: function get() {
      return (0, _lodash.cloneDeep)(this._contractResult);
    }
    /**
     * @readonly
     * @type {any[] | null | any}
     */

  }, {
    key: "decodedResult",
    get: function get() {
      return (0, _lodash.cloneDeep)(this._decodedResult);
    }
    /**
     * @readonly
     * @type {{ [eventName: string]: { [field: string]: string } }}
     */

  }, {
    key: "events",
    get: function get() {
      return (0, _lodash.cloneDeep)(this._events);
    }
  }]);
  return Result;
}();

exports["default"] = Result;