"use strict";

var _Object$keys = require("@babel/runtime-corejs3/core-js-stable/object/keys");

var _Object$getOwnPropertySymbols = require("@babel/runtime-corejs3/core-js-stable/object/get-own-property-symbols");

var _filterInstanceProperty = require("@babel/runtime-corejs3/core-js-stable/instance/filter");

var _Object$getOwnPropertyDescriptor = require("@babel/runtime-corejs3/core-js-stable/object/get-own-property-descriptor");

var _forEachInstanceProperty = require("@babel/runtime-corejs3/core-js-stable/instance/for-each");

var _Object$getOwnPropertyDescriptors = require("@babel/runtime-corejs3/core-js-stable/object/get-own-property-descriptors");

var _Object$defineProperties = require("@babel/runtime-corejs3/core-js-stable/object/define-properties");

var _Object$defineProperty = require("@babel/runtime-corejs3/core-js-stable/object/define-property");

var _interopRequireDefault = require("@babel/runtime-corejs3/helpers/interopRequireDefault");

_Object$defineProperty(exports, "__esModule", {
  value: true
});

exports["default"] = void 0;

var _regenerator = _interopRequireDefault(require("@babel/runtime-corejs3/regenerator"));

var _map = _interopRequireDefault(require("@babel/runtime-corejs3/core-js-stable/instance/map"));

var _promise = _interopRequireDefault(require("@babel/runtime-corejs3/core-js-stable/promise"));

var _startsWith = _interopRequireDefault(require("@babel/runtime-corejs3/core-js-stable/instance/starts-with"));

var _slice = _interopRequireDefault(require("@babel/runtime-corejs3/core-js-stable/instance/slice"));

var _parseInt = _interopRequireDefault(require("@babel/runtime-corejs3/core-js-stable/number/parse-int"));

var _defineProperty2 = _interopRequireDefault(require("@babel/runtime-corejs3/helpers/defineProperty"));

var _typeof2 = _interopRequireDefault(require("@babel/runtime-corejs3/helpers/typeof"));

var _slicedToArray2 = _interopRequireDefault(require("@babel/runtime-corejs3/helpers/slicedToArray"));

var _asyncToGenerator2 = _interopRequireDefault(require("@babel/runtime-corejs3/helpers/asyncToGenerator"));

var _classCallCheck2 = _interopRequireDefault(require("@babel/runtime-corejs3/helpers/classCallCheck"));

var _createClass2 = _interopRequireDefault(require("@babel/runtime-corejs3/helpers/createClass"));

var _assert = require("assert");

var _lodash = _interopRequireDefault(require("lodash"));

var _index = _interopRequireDefault(require("../echo/index"));

var _privateKey = _interopRequireDefault(require("../crypto/private-key"));

var _constants = require("../constants");

var _ContractTransaction = _interopRequireDefault(require("./ContractTransaction"));

var _decoders = _interopRequireDefault(require("./decoders"));

var _validators = require("./utils/validators");

function ownKeys(object, enumerableOnly) { var keys = _Object$keys(object); if (_Object$getOwnPropertySymbols) { var symbols = _Object$getOwnPropertySymbols(object); if (enumerableOnly) { symbols = _filterInstanceProperty(symbols).call(symbols, function (sym) { return _Object$getOwnPropertyDescriptor(object, sym).enumerable; }); } keys.push.apply(keys, symbols); } return keys; }

function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i] != null ? arguments[i] : {}; if (i % 2) { var _context11; _forEachInstanceProperty(_context11 = ownKeys(Object(source), true)).call(_context11, function (key) { (0, _defineProperty2["default"])(target, key, source[key]); }); } else if (_Object$getOwnPropertyDescriptors) { _Object$defineProperties(target, _Object$getOwnPropertyDescriptors(source)); } else { var _context12; _forEachInstanceProperty(_context12 = ownKeys(Object(source))).call(_context12, function (key) { _Object$defineProperty(target, key, _Object$getOwnPropertyDescriptor(source, key)); }); } } return target; }

var NATHAN_ID = '1.2.12';
/** @typedef {import("./Contract").default} Contract */

/** @typedef {import("../../types/interfaces/Abi").AbiArgument} AbiArgument */

/** @typedef {import("./ContractResult").default} ContractResult */

/**
 * @typedef {Object} CallOptions
 * @property {string} [contractId]
 * @property {{ asset_id: string, amount: number | string | BigNumber }} [asset]
 * @property {string} [accountId]
 * @property {Echo} [echo]
 */

/**
 * @typedef {Object} SendOptions
 * @property {string} [contractId]
 * @property {string} [registrar]
 * @property {PrivateKey} [privateKey]
 * @property {{ amount:number|string|BigNumber, asset_id:string }} [value]
 */

var Method = /*#__PURE__*/function () {
  function Method(contract, abiMethodOutputs, code) {
    (0, _classCallCheck2["default"])(this, Method);

    /**
     * @private
     * @type {Contract}
     */
    this._contract = contract;
    /**
     * @private
     * @type {Array<AbiArgument>}
     */

    this._abiMethodOutputs = abiMethodOutputs;
    /**
     * @private
     * @type {string}
     */

    this._code = code;
  }
  /**
   * @param {CallOptions} [options]
   * @returns {Promise<Array<*>|*|null>}
   */


  (0, _createClass2["default"])(Method, [{
    key: "code",
    get:
    /**
     * @readonly
     * @type {string}
     */
    function get() {
      return this._code;
    }
    /**
     * @readonly
     * @type {Array<AbiArgument>}
     */

  }, {
    key: "outputs",
    get: function get() {
      return _lodash["default"].cloneDeep(this._abiMethodOutputs);
    }
    /**
     * @readonly
     * @type {Contract}
     */

  }, {
    key: "contract",
    get: function get() {
      return this._contract;
    }
  }, {
    key: "call",
    value: function () {
      var _call = (0, _asyncToGenerator2["default"])( /*#__PURE__*/_regenerator["default"].mark(function _callee() {
        var options,
            stack,
            contractId,
            asset,
            caller,
            echo,
            _context,
            rawResult,
            _args = arguments;

        return _regenerator["default"].wrap(function _callee$(_context2) {
          while (1) {
            switch (_context2.prev = _context2.next) {
              case 0:
                options = _args.length > 0 && _args[0] !== undefined ? _args[0] : {};
                stack = new Error().stack.stack;
                contractId = options.contractId, asset = options.asset, caller = options.caller, echo = options.echo;

                if (!(contractId === undefined)) {
                  _context2.next = 9;
                  break;
                }

                if (!(this._contract.address === undefined)) {
                  _context2.next = 6;
                  break;
                }

                throw new Error('no contractId');

              case 6:
                contractId = this._contract.address;
                _context2.next = 10;
                break;

              case 9:
                (0, _validators.checkContractId)(contractId);

              case 10:
                if (asset === undefined) asset = {
                  amount: 0,
                  asset_id: '1.3.0'
                };
                if (caller === undefined) caller = NATHAN_ID;

                if (!(echo === undefined)) {
                  _context2.next = 18;
                  break;
                }

                if (!(this._contract.echo === undefined)) {
                  _context2.next = 15;
                  break;
                }

                throw new Error('no echo instance');

              case 15:
                // eslint-disable-next-line prefer-destructuring
                echo = this._contract.echo;
                _context2.next = 20;
                break;

              case 18:
                if (echo instanceof _index["default"]) {
                  _context2.next = 20;
                  break;
                }

                throw new Error('invalid echo instance');

              case 20:
                _context2.prev = 20;
                _context2.next = 23;
                return echo.api.callContractNoChangingState(contractId, caller, asset, this.code);

              case 23:
                rawResult = _context2.sent;

                if (!(rawResult === '')) {
                  _context2.next = 28;
                  break;
                }

                if (!(this._abiMethodOutputs.length === 0)) {
                  _context2.next = 27;
                  break;
                }

                return _context2.abrupt("return", null);

              case 27:
                throw new Error('call failed');

              case 28:
                return _context2.abrupt("return", (0, _decoders["default"])(rawResult, (0, _map["default"])(_context = this._abiMethodOutputs).call(_context, function (_ref) {
                  var type = _ref.type;
                  return type;
                })));

              case 31:
                _context2.prev = 31;
                _context2.t0 = _context2["catch"](20);
                _context2.t0.stack = stack;
                throw _context2.t0;

              case 35:
              case "end":
                return _context2.stop();
            }
          }
        }, _callee, this, [[20, 31]]);
      }));

      function call() {
        return _call.apply(this, arguments);
      }

      return call;
    }()
    /**
     * @param {SendOptions} options
     * @returns {ContractTransaction|Promise<ContractTransaction>}
     */

  }, {
    key: "buildTransaction",
    value: function buildTransaction() {
      var _this = this;

      var options = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : {};

      if (options.registrar === undefined && options.privateKey === undefined) {
        throw new Error('no registar provided');
      }

      if (options.privateKey !== undefined && !(options.privateKey instanceof _privateKey["default"])) {
        throw new Error('invalid privateKey');
      }

      if (options.contractId !== undefined) {
        if (!_validators.contractIdRegExp.test(options.contractId)) throw new Error('invalid contractId format');
      } else {
        if (this._contract.address === undefined) throw new Error('contractId is not provided');
        options.contractId = this._contract.address;
      }

      if (options.registrar !== undefined) {
        if (!/^1\.2\.(0|[1-9]\d*)$/.test(options.registrar)) throw new Error('invalid registrar format');
        return this._createTransaction(options.contractId, options.registrar, options.privateKey, options.value);
      }

      return new _promise["default"]( /*#__PURE__*/function () {
        var _ref2 = (0, _asyncToGenerator2["default"])( /*#__PURE__*/_regenerator["default"].mark(function _callee2(resolve, reject) {
          var publicKey, _yield$_this$_contrac, _yield$_this$_contrac2, _yield$_this$_contrac3, registrar;

          return _regenerator["default"].wrap(function _callee2$(_context3) {
            while (1) {
              switch (_context3.prev = _context3.next) {
                case 0:
                  _context3.prev = 0;
                  publicKey = options.privateKey.toPublicKey();
                  _context3.next = 4;
                  return _this._contract.echo.api.getKeyReferences([publicKey]);

                case 4:
                  _yield$_this$_contrac = _context3.sent;
                  _yield$_this$_contrac2 = (0, _slicedToArray2["default"])(_yield$_this$_contrac, 1);
                  _yield$_this$_contrac3 = (0, _slicedToArray2["default"])(_yield$_this$_contrac2[0], 1);
                  registrar = _yield$_this$_contrac3[0];
                  return _context3.abrupt("return", resolve(_this._createTransaction(options.contractId, registrar, options.privateKey, options.value)));

                case 11:
                  _context3.prev = 11;
                  _context3.t0 = _context3["catch"](0);
                  return _context3.abrupt("return", reject(_context3.t0));

                case 14:
                case "end":
                  return _context3.stop();
              }
            }
          }, _callee2, null, [[0, 11]]);
        }));

        return function (_x, _x2) {
          return _ref2.apply(this, arguments);
        };
      }());
    }
    /**
     * @param {SendOptions} options
     * @returns {Promise<ContractResult>}
     */

  }, {
    key: "broadcast",
    value: function () {
      var _broadcast = (0, _asyncToGenerator2["default"])( /*#__PURE__*/_regenerator["default"].mark(function _callee3() {
        var options,
            tx,
            result,
            _context4,
            _context5,
            _context6,
            _context7,
            _context8,
            _context9,
            expectedErrorPrefix,
            execRes,
            errorMessageLength,
            errorMessageBuffer,
            _args3 = arguments;

        return _regenerator["default"].wrap(function _callee3$(_context10) {
          while (1) {
            switch (_context10.prev = _context10.next) {
              case 0:
                options = _args3.length > 0 && _args3[0] !== undefined ? _args3[0] : {};
                (0, _assert.ok)(options.privateKey !== undefined, 'private key not provided');
                _context10.next = 4;
                return this.buildTransaction(options);

              case 4:
                tx = _context10.sent;
                _context10.prev = 5;
                _context10.next = 8;
                return tx.broadcast();

              case 8:
                result = _context10.sent;
                _context10.next = 24;
                break;

              case 11:
                _context10.prev = 11;
                _context10.t0 = _context10["catch"](5);

                if (!((0, _typeof2["default"])(_context10.t0) !== 'object' || _context10.t0.code !== 1 || typeof _context10.t0.message !== 'string')) {
                  _context10.next = 15;
                  break;
                }

                throw _context10.t0;

              case 15:
                expectedErrorPrefix = 'unspecified: Exception during execution: ';

                if ((0, _startsWith["default"])(_context4 = _context10.t0.message).call(_context4, expectedErrorPrefix)) {
                  _context10.next = 18;
                  break;
                }

                throw _context10.t0;

              case 18:
                execRes = JSON.parse((0, _slice["default"])(_context5 = _context10.t0.message).call(_context5, expectedErrorPrefix.length));

                if (!(execRes.excepted !== 'RevertInstruction' || (0, _slice["default"])(_context6 = execRes.output).call(_context6, 0, 8) !== '08c379a0')) {
                  _context10.next = 21;
                  break;
                }

                throw _context10.t0;

              case 21:
                errorMessageLength = (0, _parseInt["default"])((0, _slice["default"])(_context7 = execRes.output).call(_context7, 72, 136), 16);
                errorMessageBuffer = (0, _slice["default"])(_context8 = Buffer.from((0, _slice["default"])(_context9 = execRes.output).call(_context9, 136), 'hex')).call(_context8, 0, errorMessageLength);
                throw new Error(errorMessageBuffer.toString('utf8'));

              case 24:
                return _context10.abrupt("return", result);

              case 25:
              case "end":
                return _context10.stop();
            }
          }
        }, _callee3, this, [[5, 11]]);
      }));

      function broadcast() {
        return _broadcast.apply(this, arguments);
      }

      return broadcast;
    }()
    /**
     * @private
     * @param {string} callee
     * @param {string} registrar
     * @param {PrivateKey} [privateKey]
     * @param {{ amount:number|string|BigNumber, asset_id:string }} [value]
     * @returns {ContractTransaction}
     */

  }, {
    key: "_createTransaction",
    value: function _createTransaction(callee, registrar, privateKey, value) {
      value = _objectSpread({
        amount: 0,
        asset_id: '1.3.0'
      }, value);
      var result = new _ContractTransaction["default"](this._contract.echo.api, this).addOperation(_constants.OPERATIONS_IDS.CONTRACT_CALL, {
        callee: callee,
        code: this.code,
        registrar: registrar,
        value: value
      });
      if (privateKey !== undefined) result.addSigner(privateKey);
      return result;
    }
  }]);
  return Method;
}();

exports["default"] = Method;