"use strict";

var _sliceInstanceProperty2 = require("@babel/runtime-corejs3/core-js-stable/instance/slice");

var _Array$from2 = require("@babel/runtime-corejs3/core-js-stable/array/from");

var _Symbol = require("@babel/runtime-corejs3/core-js-stable/symbol");

var _getIteratorMethod = require("@babel/runtime-corejs3/core-js/get-iterator-method");

var _Array$isArray2 = require("@babel/runtime-corejs3/core-js-stable/array/is-array");

var _Object$defineProperty = require("@babel/runtime-corejs3/core-js-stable/object/define-property");

var _interopRequireDefault = require("@babel/runtime-corejs3/helpers/interopRequireDefault");

_Object$defineProperty(exports, "__esModule", {
  value: true
});

exports["default"] = encode;
exports.encodeAddress = encodeAddress;
exports.encodeArgument = encodeArgument;
exports.encodeBool = encodeBool;
exports.encodeDynamicArray = encodeDynamicArray;
exports.encodeDynamicBytes = encodeDynamicBytes;
exports.encodeInteger = encodeInteger;
exports.encodeStaticArray = encodeStaticArray;
exports.encodeStaticBytes = encodeStaticBytes;
exports.encodeString = encodeString;
exports.encodeUnsignedInteger = encodeUnsignedInteger;

var _toConsumableArray2 = _interopRequireDefault(require("@babel/runtime-corejs3/helpers/toConsumableArray"));

var _typeof2 = _interopRequireDefault(require("@babel/runtime-corejs3/helpers/typeof"));

var _slicedToArray2 = _interopRequireDefault(require("@babel/runtime-corejs3/helpers/slicedToArray"));

var _padStart = _interopRequireDefault(require("@babel/runtime-corejs3/core-js-stable/instance/pad-start"));

var _slice = _interopRequireDefault(require("@babel/runtime-corejs3/core-js-stable/instance/slice"));

var _map = _interopRequireDefault(require("@babel/runtime-corejs3/core-js-stable/instance/map"));

var _from = _interopRequireDefault(require("@babel/runtime-corejs3/core-js-stable/array/from"));

var _concat = _interopRequireDefault(require("@babel/runtime-corejs3/core-js-stable/instance/concat"));

var _isArray = _interopRequireDefault(require("@babel/runtime-corejs3/core-js-stable/array/is-array"));

var _parseInt = _interopRequireDefault(require("@babel/runtime-corejs3/core-js-stable/number/parse-int"));

var _includes = _interopRequireDefault(require("@babel/runtime-corejs3/core-js-stable/instance/includes"));

var _bignumber = _interopRequireDefault(require("bignumber.js"));

var _comprehension = _interopRequireDefault(require("comprehension"));

var _converters = require("./utils/converters");

var _numberRepresentations = require("./utils/number-representations");

var _solidityUtils = require("./utils/solidity-utils");

var _validators = require("./utils/validators");

var _constants = require("../constants");

function _createForOfIteratorHelper(o, allowArrayLike) { var it = typeof _Symbol !== "undefined" && _getIteratorMethod(o) || o["@@iterator"]; if (!it) { if (_Array$isArray2(o) || (it = _unsupportedIterableToArray(o)) || allowArrayLike && o && typeof o.length === "number") { if (it) o = it; var i = 0; var F = function F() {}; return { s: F, n: function n() { if (i >= o.length) return { done: true }; return { done: false, value: o[i++] }; }, e: function e(_e) { throw _e; }, f: F }; } throw new TypeError("Invalid attempt to iterate non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method."); } var normalCompletion = true, didErr = false, err; return { s: function s() { it = it.call(o); }, n: function n() { var step = it.next(); normalCompletion = step.done; return step; }, e: function e(_e2) { didErr = true; err = _e2; }, f: function f() { try { if (!normalCompletion && it["return"] != null) it["return"](); } finally { if (didErr) throw err; } } }; }

function _unsupportedIterableToArray(o, minLen) { var _context10; if (!o) return; if (typeof o === "string") return _arrayLikeToArray(o, minLen); var n = _sliceInstanceProperty2(_context10 = Object.prototype.toString.call(o)).call(_context10, 8, -1); if (n === "Object" && o.constructor) n = o.constructor.name; if (n === "Map" || n === "Set") return _Array$from2(o); if (n === "Arguments" || /^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(n)) return _arrayLikeToArray(o, minLen); }

function _arrayLikeToArray(arr, len) { if (len == null || len > arr.length) len = arr.length; for (var i = 0, arr2 = new Array(len); i < len; i++) { arr2[i] = arr[i]; } return arr2; }

/**
 * @param {boolean} value
 * @returns {string}
 */
function encodeBool(value) {
  if (typeof value !== 'boolean') throw new Error('value is not a boolean');
  return (0, _comprehension["default"])(63, function () {
    return '0';
  }).join('') + (value ? '1' : '0');
}
/**
 * @param {number} bitsCount
 * @param {number|BigNumber} value
 * @returns {string}
 */


function encodeUnsignedInteger(bitsCount, value) {
  (0, _solidityUtils.checkIntegerSize)(bitsCount);
  value = (0, _converters.toBigInteger)(value);
  if (value.isNegative()) throw new Error('value is negative');

  if (value.gte((0, _converters.toTwosPower)(bitsCount))) {
    throw new Error("uint".concat(bitsCount, " overflow"));
  }

  var preRes = value.toString(16);
  return (0, _comprehension["default"])(64 - preRes.length, function () {
    return '0';
  }).join('') + preRes;
}
/**
 * @param {number} bitsCount
 * @param {number|BigNumber} value
 * @returns {string}
 */


function encodeInteger(bitsCount, value) {
  (0, _solidityUtils.checkIntegerSize)(bitsCount);
  value = (0, _converters.toBigInteger)(value);
  if (value.abs().gte((0, _converters.toTwosPower)(bitsCount - 1))) throw new Error("int".concat(bitsCount, " overflow"));
  var twosComplementRepresentation = (0, _numberRepresentations.toTwosComplementRepresentation)(value, bitsCount);
  return encodeUnsignedInteger(bitsCount, twosComplementRepresentation);
}
/**
 * @param {string} address
 * @returns {string}
 */


function encodeAddress(address) {
  var _context, _context2;

  if (typeof address !== 'string') throw new Error('address is not a string');
  if (/^0x[a-fA-F\d]{40}$/.test(address)) return (0, _padStart["default"])(_context = (0, _slice["default"])(address).call(address, 2)).call(_context, 64, '0');
  if (!_validators.addressRegExp.test(address)) throw new Error('invalid address format');

  var _address$split$map = (0, _map["default"])(_context2 = address.split('.')).call(_context2, function (str) {
    return new _bignumber["default"](str, 10);
  }),
      _address$split$map2 = (0, _slicedToArray2["default"])(_address$split$map, 3),
      instanceTypeId = _address$split$map2[1],
      objectId = _address$split$map2[2];

  var preRes = objectId.toString(16);
  if (preRes.length > 38) throw new Error('objectId is greater or equals to 2**152');
  var isContract = instanceTypeId.eq(_constants.PROTOCOL_OBJECT_TYPE_ID.CONTRACT);
  return [(0, _comprehension["default"])(25, function () {
    return 0;
  }).join(''), isContract ? '1' : '0', (0, _comprehension["default"])(38 - preRes.length, function () {
    return 0;
  }).join(''), preRes].join('');
}
/** @typedef {'hex'|'ascii'|'utf8'|'utf16le'|'ucs2'|'base64'|'latin1'|'binary'} Encoding */

/**
 * @param {number} bytesCount
 * @param {Buffer|string|{value:Buffer|string,encoding:Encoding?,align:'left'|'right'|'none'}} input
 * @return {string}
 */


function encodeStaticBytes(bytesCount, input) {
  var _context5;

  var defaultEncoding = 'hex';
  var defaultAlign = 'none'; // typeof is uncovered. see https://github.com/gotwarlost/istanbul/issues/582

  if (Buffer.isBuffer(input) || (0, _typeof2["default"])(input) !== 'object') {
    input = {
      value: input,
      encoding: defaultEncoding,
      align: defaultAlign
    };
  }

  input.encoding = input.encoding || defaultEncoding;
  input.align = input.align || defaultAlign;
  (0, _solidityUtils.checkBytesCount)(bytesCount);

  if (!Buffer.isBuffer(input.value)) {
    if (input.encoding === 'hex' && input.value.substr(0, 2) === '0x') input.value = input.value.substr(2);

    if (input.encoding === 'hex' && !/^([\da-fA-F]{2}){1,32}$/.test(input.value)) {
      throw new Error('input is not a hex string');
    }

    input.value = Buffer.from(input.value, input.encoding);
  }

  if (input.value.length !== bytesCount) {
    var _context3, _context4;

    if (input.value.length > bytesCount) throw new Error('input is too large');
    if (input.align === 'none') throw new Error('input is too short, maybe u need to use align?');
    var arr = (0, _from["default"])(input.value);
    var zeros = (0, _comprehension["default"])(bytesCount - input.value.length, function () {
      return 0;
    });
    if (input.align === 'left') input.value = Buffer.from((0, _concat["default"])(_context3 = []).call(_context3, (0, _toConsumableArray2["default"])(arr), (0, _toConsumableArray2["default"])(zeros)));else if (input.align === 'right') input.value = Buffer.from((0, _concat["default"])(_context4 = []).call(_context4, (0, _toConsumableArray2["default"])(zeros), (0, _toConsumableArray2["default"])(arr)));else throw new Error('unknown align');
  }

  return (0, _padStart["default"])(_context5 = input.value.toString('hex')).call(_context5, 64, '0');
}
/** @typedef {{ type: ('dynamic'|'static'), code: Array.<string|_ArrayCode>, length: number }} _ArrayCode */

/**
 * @param {string|Buffer|{ value:(string|Buffer), encoding:Encoding }} input
 * @returns {_ArrayCode}
 */


function encodeDynamicBytes(input) {
  var defaultEncoding = 'hex'; // typeof is uncovered. see https://github.com/gotwarlost/istanbul/issues/582

  if (Buffer.isBuffer(input) || (0, _typeof2["default"])(input) !== 'object') {
    input = {
      value: input,
      encoding: defaultEncoding
    };
  }

  input.encoding = input.encoding || defaultEncoding;
  if (typeof input.value === 'string') input.value = Buffer.from(input.value, input.encoding);
  var partsCount = Math.ceil(input.value.length / 32);
  /** @type {Array<string>} */

  var code = (0, _comprehension["default"])({
    count: partsCount,
    step: 32
  }, function (i) {
    var _context6;

    return (0, _slice["default"])(_context6 = input.value).call(_context6, i, i + 32).toString('hex');
  });
  var lastCodeIndex = partsCount - 1;

  if (code[lastCodeIndex].length !== 64) {
    // eslint-disable-next-line operator-assignment
    code[lastCodeIndex] = code[lastCodeIndex] + (0, _comprehension["default"])(64 - code[lastCodeIndex].length, function () {
      return '0';
    }).join('');
  }

  return {
    type: 'dynamic',
    length: input.value.length,
    code: code
  };
}
/**
 * @param {string|{ value:string, encoding:Encoding }} input
 * @returns {_ArrayCode}
 */


function encodeString(input) {
  if (typeof input === 'string') input = {
    value: input,
    encoding: 'utf8'
  };
  return encodeDynamicBytes(input);
}
/**
 * @param {SolType} type
 * @param {Array.<*>} value
 * @returns {_ArrayCode}
 */


function encodeDynamicArray(value, type) {
  if (!(0, _isArray["default"])(value)) throw new Error('value is not an array'); // eslint-disable-next-line no-use-before-define

  return {
    type: 'dynamic',
    length: value.length,
    code: (0, _map["default"])(value).call(value, function (element) {
      return encodeArgument(element, type);
    })
  };
}
/**
 * @param {SolType} type
 * @param {Array.<*>} value
 * @param {number} length
 * @returns {_ArrayCode}
 */


function encodeStaticArray(value, type, length) {
  if (!(0, _isArray["default"])(value)) throw new Error('value is not an array');
  if (length !== value.length) throw new Error('invalid array elements count'); // eslint-disable-next-line no-use-before-define

  return {
    type: 'static',
    length: length,
    code: (0, _map["default"])(value).call(value, function (element) {
      return encodeArgument(element, type);
    })
  };
}
/**
 * @param {*} value
 * @param {SolType} type
 * @returns {string|_ArrayCode}
 */


function encodeArgument(value, type) {
  var dynamicArrayMatch = type.match(/^(.*)\[]$/);

  if (dynamicArrayMatch) {
    var typeOfMatch = dynamicArrayMatch[1];
    return encodeDynamicArray(value, typeOfMatch);
  }

  var staticArrayMatch = type.match(/^(.*)\[(\d+)]$/);

  if (staticArrayMatch) {
    var _typeOfMatch = staticArrayMatch[1];
    var length = (0, _parseInt["default"])(staticArrayMatch[2], 10);
    return encodeStaticArray(value, _typeOfMatch, length);
  }

  var bytesMatch = type.match(/^bytes(\d+)$/);

  if (bytesMatch) {
    var _length = (0, _parseInt["default"])(bytesMatch[1], 10);

    return encodeStaticBytes(_length, value);
  }

  var unsignedIntegerMatch = type.match(/^uint(\d+)$/);

  if (unsignedIntegerMatch) {
    var bitsCount = (0, _parseInt["default"])(unsignedIntegerMatch[1], 10);
    return encodeUnsignedInteger(bitsCount, value);
  }

  var signedIntegerMatch = type.match(/^int(\d+)$/);

  if (signedIntegerMatch) {
    var _bitsCount = (0, _parseInt["default"])(signedIntegerMatch[1], 10);

    return encodeInteger(_bitsCount, value);
  }

  if (type === 'bool') return encodeBool(value);
  if (type === 'address') return encodeAddress(value);
  if (type === 'string') return encodeString(value);
  if (type === 'bytes') return encodeDynamicBytes(value);
  throw new Error("unknown type ".concat(type));
}
/**
 * @param {Array.<{ value: *, type: SolType }>|{ value: *, type: SolType }} input
 * @returns {string}
 */


function encode(input) {
  if (!(0, _isArray["default"])(input)) input = [input]; // eslint-disable-next-line max-len

  /** @type {Array.<(string|{type: (string), code: Array<string|{type: (string), code: Array<string|_ArrayCode>, length: number}>, length: number}|number)>} */

  var result = (0, _map["default"])(input).call(input, function (_ref) {
    var value = _ref.value,
        type = _ref.type;
    return encodeArgument(value, type);
  });
  var post = [];

  do {
    var _iterator = _createForOfIteratorHelper(post),
        _step;

    try {
      for (_iterator.s(); !(_step = _iterator.n()).done;) {
        var _result, _context7;

        var _step$value = _step.value,
            link = _step$value.link,
            arr = _step$value.arr,
            length = _step$value.length;
        // result[link] = encodeUnsignedInteger(256, result.length * 32);
        result[link] = result.length;

        (_result = result).push.apply(_result, (0, _concat["default"])(_context7 = [encodeUnsignedInteger(256, length)]).call(_context7, (0, _toConsumableArray2["default"])(arr)));
      }
    } catch (err) {
      _iterator.e(err);
    } finally {
      _iterator.f();
    }

    post = [];

    var _loop = function _loop(_i) {
      var _context8;

      if ((0, _includes["default"])(_context8 = ['string', 'number']).call(_context8, (0, _typeof2["default"])(result[_i]))) {
        i = _i;
        return "continue";
      }

      if (result[_i].type === 'static') {
        var _context9;

        var shiftLength = result[_i].code.length - 1;
        result = (0, _concat["default"])(_context9 = []).call(_context9, (0, _toConsumableArray2["default"])((0, _slice["default"])(result).call(result, 0, _i)), (0, _toConsumableArray2["default"])(result[_i].code), (0, _toConsumableArray2["default"])((0, _slice["default"])(result).call(result, _i + 1)));
        result = (0, _map["default"])(result).call(result, function (element) {
          return typeof element === 'number' && element > _i ? element + shiftLength : element;
        });
        _i -= 1;
        i = _i;
        return "continue";
      }

      post.push({
        link: _i,
        arr: result[_i].code,
        length: result[_i].length
      });
      result[_i] = undefined;
      i = _i;
    };

    for (var i = 0; i < result.length; i += 1) {
      var _ret = _loop(i);

      if (_ret === "continue") continue;
    }
  } while (post.length > 0);

  return (0, _map["default"])(result).call(result, function (element) {
    return typeof element === 'number' ? encodeUnsignedInteger(256, element * 32) : element;
  }).join('');
}