"use strict";

var _Object$defineProperty = require("@babel/runtime-corejs3/core-js-stable/object/define-property");

var _interopRequireDefault = require("@babel/runtime-corejs3/helpers/interopRequireDefault");

_Object$defineProperty(exports, "__esModule", {
  value: true
});

exports.toBigInteger = toBigInteger;
exports.toTwosPower = toTwosPower;

var _maxSafeInteger = _interopRequireDefault(require("@babel/runtime-corejs3/core-js-stable/number/max-safe-integer"));

var _bignumber = _interopRequireDefault(require("bignumber.js"));

/**
 * @param {number|string|BigNumber} value
 * @returns {BigNumber}
 */
function toBigInteger(value) {
  if (typeof value === 'number') {
    if (value > _maxSafeInteger["default"]) throw new Error('loss of accuracy, use bignumber.js');
    value = new _bignumber["default"](value);
  } else if (typeof value === 'string') {
    value = new _bignumber["default"](value);
    if (!value.isFinite()) throw new Error('fail to convert string to BigNumber');
  }

  if (!_bignumber["default"].isBigNumber(value)) throw new Error('value is not a number');
  if (!value.isInteger()) throw new Error('value is not a integer');
  return value;
}
/**
 * @param {number} power
 * @returns {BigNumber}
 */


function toTwosPower(power) {
  return new _bignumber["default"](2).pow(power);
}