"use strict";

var _Object$keys2 = require("@babel/runtime-corejs3/core-js-stable/object/keys");

var _Object$getOwnPropertySymbols = require("@babel/runtime-corejs3/core-js-stable/object/get-own-property-symbols");

var _filterInstanceProperty = require("@babel/runtime-corejs3/core-js-stable/instance/filter");

var _Object$getOwnPropertyDescriptor = require("@babel/runtime-corejs3/core-js-stable/object/get-own-property-descriptor");

var _forEachInstanceProperty = require("@babel/runtime-corejs3/core-js-stable/instance/for-each");

var _Object$getOwnPropertyDescriptors = require("@babel/runtime-corejs3/core-js-stable/object/get-own-property-descriptors");

var _Object$defineProperties = require("@babel/runtime-corejs3/core-js-stable/object/define-properties");

var _Object$defineProperty = require("@babel/runtime-corejs3/core-js-stable/object/define-property");

var _sliceInstanceProperty2 = require("@babel/runtime-corejs3/core-js-stable/instance/slice");

var _Array$from = require("@babel/runtime-corejs3/core-js-stable/array/from");

var _Symbol = require("@babel/runtime-corejs3/core-js-stable/symbol");

var _getIteratorMethod = require("@babel/runtime-corejs3/core-js/get-iterator-method");

var _Array$isArray = require("@babel/runtime-corejs3/core-js-stable/array/is-array");

var _interopRequireDefault = require("@babel/runtime-corejs3/helpers/interopRequireDefault");

_Object$defineProperty(exports, "__esModule", {
  value: true
});

exports["default"] = generateInterface;

var _toConsumableArray2 = _interopRequireDefault(require("@babel/runtime-corejs3/helpers/toConsumableArray"));

var _defineProperty2 = _interopRequireDefault(require("@babel/runtime-corejs3/helpers/defineProperty"));

var _parseInt = _interopRequireDefault(require("@babel/runtime-corejs3/core-js-stable/number/parse-int"));

var _concat = _interopRequireDefault(require("@babel/runtime-corejs3/core-js-stable/instance/concat"));

var _map = _interopRequireDefault(require("@babel/runtime-corejs3/core-js-stable/instance/map"));

var _set = _interopRequireDefault(require("@babel/runtime-corejs3/core-js-stable/set"));

var _keys = _interopRequireDefault(require("@babel/runtime-corejs3/core-js-stable/object/keys"));

var _slice = _interopRequireDefault(require("@babel/runtime-corejs3/core-js-stable/instance/slice"));

var _assert = require("assert");

var _jsSha = require("js-sha3");

var _solidityUtils = require("./solidity-utils");

function _createForOfIteratorHelper(o, allowArrayLike) { var it = typeof _Symbol !== "undefined" && _getIteratorMethod(o) || o["@@iterator"]; if (!it) { if (_Array$isArray(o) || (it = _unsupportedIterableToArray(o)) || allowArrayLike && o && typeof o.length === "number") { if (it) o = it; var i = 0; var F = function F() {}; return { s: F, n: function n() { if (i >= o.length) return { done: true }; return { done: false, value: o[i++] }; }, e: function e(_e) { throw _e; }, f: F }; } throw new TypeError("Invalid attempt to iterate non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method."); } var normalCompletion = true, didErr = false, err; return { s: function s() { it = it.call(o); }, n: function n() { var step = it.next(); normalCompletion = step.done; return step; }, e: function e(_e2) { didErr = true; err = _e2; }, f: function f() { try { if (!normalCompletion && it["return"] != null) it["return"](); } finally { if (didErr) throw err; } } }; }

function _unsupportedIterableToArray(o, minLen) { var _context40; if (!o) return; if (typeof o === "string") return _arrayLikeToArray(o, minLen); var n = _sliceInstanceProperty2(_context40 = Object.prototype.toString.call(o)).call(_context40, 8, -1); if (n === "Object" && o.constructor) n = o.constructor.name; if (n === "Map" || n === "Set") return _Array$from(o); if (n === "Arguments" || /^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(n)) return _arrayLikeToArray(o, minLen); }

function _arrayLikeToArray(arr, len) { if (len == null || len > arr.length) len = arr.length; for (var i = 0, arr2 = new Array(len); i < len; i++) { arr2[i] = arr[i]; } return arr2; }

function ownKeys(object, enumerableOnly) { var keys = _Object$keys2(object); if (_Object$getOwnPropertySymbols) { var symbols = _Object$getOwnPropertySymbols(object); if (enumerableOnly) { symbols = _filterInstanceProperty(symbols).call(symbols, function (sym) { return _Object$getOwnPropertyDescriptor(object, sym).enumerable; }); } keys.push.apply(keys, symbols); } return keys; }

function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i] != null ? arguments[i] : {}; if (i % 2) { var _context38; _forEachInstanceProperty(_context38 = ownKeys(Object(source), true)).call(_context38, function (key) { (0, _defineProperty2["default"])(target, key, source[key]); }); } else if (_Object$getOwnPropertyDescriptors) { _Object$defineProperties(target, _Object$getOwnPropertyDescriptors(source)); } else { var _context39; _forEachInstanceProperty(_context39 = ownKeys(Object(source))).call(_context39, function (key) { _Object$defineProperty(target, key, _Object$getOwnPropertyDescriptor(source, key)); }); } } return target; }

/**
 * @param {string} type
 * @param {boolean?} isInput
 * @returns {{ res: string, tupleIsUsed?: boolean }}
 */
function parseType(type) {
  var isInput = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : true;
  var prefix = isInput ? 'INPUT' : 'OUTPUT';
  if (type === 'bool') return {
    res: "".concat(prefix, "['boolean']")
  };
  if (type === 'address') return {
    res: "".concat(prefix, "['address']")
  };
  if (type === 'string') return {
    res: "".concat(prefix, "['string']")
  };
  var integerMatch = type.match(/^u?int(\d+)$/);

  if (integerMatch) {
    var bitsCount = (0, _parseInt["default"])(integerMatch[1], 10);
    (0, _assert.ok)(bitsCount % 8 === 0);
    (0, _assert.ok)(bitsCount > 0);
    (0, _assert.ok)(bitsCount <= 256);
    if (bitsCount <= 48) return {
      res: "".concat(prefix, "['small_integer']")
    };
    return {
      res: "".concat(prefix, "['big_integer']")
    };
  }

  if (type === 'bytes') return {
    res: "".concat(prefix, "['bytes']")
  };
  var bytesMatch = type.match(/^bytes(\d+)?$/);

  if (bytesMatch) {
    var bytesCount = (0, _parseInt["default"])(bytesMatch[1], 10);
    (0, _assert.ok)(bytesCount > 0);
    (0, _assert.ok)(bytesCount <= 32);
    return {
      res: "".concat(prefix, "['bytes']")
    };
  }

  var staticArrayMatch = type.match(/^(.*)\[(\d+)]$/);

  if (staticArrayMatch) {
    var _context;

    var length = (0, _parseInt["default"])(staticArrayMatch[2], 10);
    return {
      res: (0, _concat["default"])(_context = "Tuple<".concat(parseType(staticArrayMatch[1], isInput).res, ", ")).call(_context, length, ">"),
      tupleIsUsed: true
    };
  }

  var dynamicArrayMatch = type.match(/^(.*)\[]$/);

  if (dynamicArrayMatch) {
    var _parseType = parseType(dynamicArrayMatch[1], isInput),
        res = _parseType.res,
        tupleIsUsed = _parseType.tupleIsUsed;

    return {
      res: "Array<".concat(res, ">"),
      tupleIsUsed: tupleIsUsed
    };
  }

  throw new Error("unknown type ".concat(type));
}
/**
 * @param {Array<import("../../../types/interfaces/Abi").AbiArgument>} inputs
 * @returns {{ res: string, tupleIsUsed: boolean }}
 */


function getArgs(inputs) {
  var tupleIsUsed = false;
  var res = (0, _map["default"])(inputs).call(inputs, function (_ref, argIndex) {
    var _context2;

    var name = _ref.name,
        type = _ref.type;

    // eslint-disable-next-line no-shadow
    var _parseType2 = parseType(type, true),
        res = _parseType2.res,
        tupleUsedInArg = _parseType2.tupleIsUsed;

    if (tupleUsedInArg) tupleIsUsed = true;
    return (0, _concat["default"])(_context2 = "".concat(name || "arg".concat(argIndex), ": ")).call(_context2, res);
  }).join(', ');
  return {
    res: res,
    tupleIsUsed: tupleIsUsed
  };
}
/**
 * @param {string} contractName
 * @param {import("../../../types/interfaces/Abi").Abi} abi
 * @param {Object} [props]
 * @param {string} [props.indent]
 * @param {number} [props.maxStringLength]
 * @returns {string}
 */


function generateInterface(contractName, abi) {
  var _context3, _context25, _context34;

  var props = arguments.length > 2 && arguments[2] !== undefined ? arguments[2] : {};

  var _indent$maxStringLeng = _objectSpread({
    indent: '\t',
    maxStringLength: 120
  }, props),
      indent = _indent$maxStringLeng.indent,
      maxStringLength = _indent$maxStringLeng.maxStringLength;

  var inputIsUsed = false;
  var outputIsUsed = false;
  var tupleIsUsed = false; // const events = [];

  /** @type {{ [nameOrSignature: string]: { name: string, str: string, signature: string, hash: string } }} */

  var methods = {};
  /** @type {Set<string>} */

  var names = new _set["default"]();
  /** @type {Set<string>} */

  var namesDuplicates = new _set["default"]();
  /** @type {boolean} */

  var hasEvents = false;
  /** @type {{ [key: string]: string }} */

  var events = "type ".concat(contractName, "Events = {");
  /** @type {Array<{ name: string, type: string }>|undefined} */

  var constructorArgs;

  var _iterator = _createForOfIteratorHelper(abi),
      _step;

  try {
    for (_iterator.s(); !(_step = _iterator.n()).done;) {
      var abiMethod = _step.value;
      var name = abiMethod.name,
          _type = abiMethod.type,
          inputs = abiMethod.inputs;

      switch (_type) {
        case 'function':
          {
            var _context31, _context32, _context33;

            if (inputs.length > 0) inputIsUsed = true;

            var _getArgs = getArgs(inputs),
                args = _getArgs.res,
                tupleUsedInFunc = _getArgs.tupleIsUsed;

            if (tupleUsedInFunc) tupleIsUsed = true;
            var signature = (0, _solidityUtils.getSignature)(abiMethod);
            var hash = "0x".concat((0, _slice["default"])(_context31 = (0, _jsSha.keccak256)(signature)).call(_context31, 0, 8));
            var potentialArgument = (0, _concat["default"])(_context32 = (0, _concat["default"])(_context33 = "type f".concat(hash, " = (")).call(_context33, args, ") => Method<any, ")).call(_context32, contractName, "Events>;");
            var str = potentialArgument.length >= maxStringLength ? potentialArgument.replace('(', "(\n".concat(indent)).replace(/, /g, ",\n".concat(indent)).replace(')', ',\n)') : potentialArgument;

            if (names.has(name)) {
              namesDuplicates.add(name);
              names["delete"](name);
            } else if (!namesDuplicates.has(name)) names.add(name);

            if (methods[signature]) throw new Error('signatures duplication');
            methods[signature] = {
              name: name,
              str: str,
              signature: signature,
              hash: hash
            };
            break;
          }

        case 'constructor':
          if (constructorArgs !== undefined) throw new Error('constructor duplicate');
          constructorArgs = inputs;
          break;

        case 'event':
          if (!hasEvents) {
            hasEvents = true;
            events += '\n';
          }

          events += (0, _concat["default"])(_context34 = "".concat(indent)).call(_context34, name, ": {\n"); // eslint-disable-next-line no-shadow

          var _iterator3 = _createForOfIteratorHelper(inputs),
              _step3;

          try {
            for (_iterator3.s(); !(_step3 = _iterator3.n()).done;) {
              var _context35, _context36, _context37;

              var _step3$value = _step3.value,
                  _name = _step3$value.name,
                  _type2 = _step3$value.type;

              var _parseType3 = parseType(_type2, false),
                  res = _parseType3.res,
                  tupleUsedInArg = _parseType3.tupleIsUsed;

              if (tupleUsedInArg) tupleIsUsed = true;
              outputIsUsed = true;
              events += (0, _concat["default"])(_context35 = (0, _concat["default"])(_context36 = (0, _concat["default"])(_context37 = "".concat(indent)).call(_context37, indent)).call(_context36, _name, ": ")).call(_context35, res, ",\n");
            }
          } catch (err) {
            _iterator3.e(err);
          } finally {
            _iterator3.f();
          }

          events += "".concat(indent, "},\n");
          break;

        default:
      }
    }
  } catch (err) {
    _iterator.e(err);
  } finally {
    _iterator.f();
  }

  events += '};';
  var result = "import Contract".concat(inputIsUsed ? ', { Method }' : '', " from \"echojs-lib\";\n");
  if (inputIsUsed || constructorArgs) result += 'import INPUT from "echojs-lib/types/contract/_inputs";\n';
  if (outputIsUsed) result += 'import OUTPUT from "echojs-lib/types/contract/_outputs";\n';
  if (tupleIsUsed) result += 'import Tuple from "echojs-lib/types/contract/_tuple";\n';
  result += '\n';
  result += (0, _map["default"])(_context3 = (0, _keys["default"])(methods)).call(_context3, function (signature) {
    var str = methods[signature].str;
    return "".concat(str, "\n");
  }).join('');
  result += '\n';
  result += events;
  result += '\n';
  var genericType = constructorArgs === undefined ? '' : "<[".concat((0, _map["default"])(constructorArgs).call(constructorArgs, function (_ref2) {
    var type = _ref2.type;
    return parseType(type).res;
  }).join(', '), "]>");

  var getInitStr = function getInitStr() {
    var _context4;

    return (0, _concat["default"])(_context4 = "export default class ".concat(contractName, " extends Contract")).call(_context4, genericType, " {");
  };

  if (getInitStr().length > maxStringLength) {
    genericType = '<[\n';

    var _iterator2 = _createForOfIteratorHelper(constructorArgs),
        _step2;

    try {
      for (_iterator2.s(); !(_step2 = _iterator2.n()).done;) {
        var _context5;

        var type = _step2.value.type;
        genericType += (0, _concat["default"])(_context5 = "".concat(indent)).call(_context5, parseType(type).res, ",\n");
      }
    } catch (err) {
      _iterator2.e(err);
    } finally {
      _iterator2.f();
    }

    genericType += ']>';
  }

  result += "".concat(getInitStr(), "\n");

  if (constructorArgs !== undefined) {
    var _context6, _context7, _context8, _context9, _context10, _context11, _context12, _context13, _context14, _context15, _context16, _context17, _context18, _context19, _context20, _context21, _context22, _context23, _context24;

    result += "".concat(indent, "static async deploy(\n");
    result += (0, _concat["default"])(_context6 = "".concat(indent)).call(_context6, indent, "code: string | Buffer,\n");
    result += (0, _concat["default"])(_context7 = "".concat(indent)).call(_context7, indent, "privateKey: PrivateKey,\n");
    result += (0, _concat["default"])(_context8 = "".concat(indent)).call(_context8, indent, "options: {\n");
    result += (0, _concat["default"])(_context9 = (0, _concat["default"])(_context10 = "".concat(indent)).call(_context10, indent)).call(_context9, indent, "abi: Abi,\n");
    result += (0, _concat["default"])(_context11 = (0, _concat["default"])(_context12 = "".concat(indent)).call(_context12, indent)).call(_context11, indent, "ethAccuracy?: boolean,\n");
    result += (0, _concat["default"])(_context13 = (0, _concat["default"])(_context14 = "".concat(indent)).call(_context14, indent)).call(_context13, indent, "supportedAssetId?: string,\n");
    result += (0, _concat["default"])(_context15 = (0, _concat["default"])(_context16 = "".concat(indent)).call(_context16, indent)).call(_context15, indent, "accountId?: string,\n");
    result += (0, _concat["default"])(_context17 = (0, _concat["default"])(_context18 = "".concat(indent)).call(_context18, indent)).call(_context17, indent, "echo?: Echo,\n");
    result += (0, _concat["default"])(_context19 = (0, _concat["default"])(_context20 = "".concat(indent)).call(_context20, indent)).call(_context19, indent, "value?: { amount?: number | string | BigNumber, asset_id?: string },\n");
    result += (0, _concat["default"])(_context21 = (0, _concat["default"])(_context22 = (0, _concat["default"])(_context23 = "".concat(indent)).call(_context23, indent)).call(_context22, indent, "args: [")).call(_context21, constructorArgs[0].type, "]\n");
    result += (0, _concat["default"])(_context24 = "".concat(indent)).call(_context24, indent, "},\n");
    result += "".concat(indent, ");\n");
  }

  result += "".concat(indent, "readonly methods: {\n");
  result += (0, _map["default"])(_context25 = (0, _keys["default"])(methods)).call(_context25, function (type) {
    var _context26, _context27;

    var _methods$type = methods[type],
        name = _methods$type.name,
        signature = _methods$type.signature,
        hash = _methods$type.hash;
    return (0, _map["default"])(_context26 = (0, _concat["default"])(_context27 = []).call(_context27, (0, _toConsumableArray2["default"])(namesDuplicates.has(name) ? [] : [name]), ["'".concat(signature, "'"), "'".concat(hash, "'")])).call(_context26, function (methodName) {
      var _context28, _context29, _context30;

      return (0, _concat["default"])(_context28 = (0, _concat["default"])(_context29 = (0, _concat["default"])(_context30 = "".concat(indent)).call(_context30, indent)).call(_context29, methodName, ": f")).call(_context28, hash, ",\n");
    }).join('');
  }).join('');
  result += "".concat(indent, "};\n");
  result += '}\n';
  return result;
}