"use strict";

var _Object$defineProperty = require("@babel/runtime-corejs3/core-js-stable/object/define-property");

var _interopRequireDefault = require("@babel/runtime-corejs3/helpers/interopRequireDefault");

_Object$defineProperty(exports, "__esModule", {
  value: true
});

exports.addressRegExp = void 0;
exports.checkContractId = checkContractId;
exports.contractIdRegExp = void 0;

var _concat = _interopRequireDefault(require("@babel/runtime-corejs3/core-js-stable/instance/concat"));

var _bignumber = _interopRequireDefault(require("bignumber.js"));

var _constants = require("../../constants");

var _context;

var MAX_CONTRACT_ID = new _bignumber["default"](2).pow(152).minus(1);
var CONTRACT_TYPE_ID = _constants.PROTOCOL_OBJECT_TYPE_ID.CONTRACT;
var ACCOUNT_TYPE_ID = _constants.PROTOCOL_OBJECT_TYPE_ID.ACCOUNT;
var contractIdRegExp = new RegExp("^1\\.".concat(CONTRACT_TYPE_ID, "\\.(([1-9]\\d*)|0)$"));
exports.contractIdRegExp = contractIdRegExp;
var addressRegExp = new RegExp((0, _concat["default"])(_context = "^1\\.(".concat(CONTRACT_TYPE_ID, "|")).call(_context, ACCOUNT_TYPE_ID, ")\\.(([1-9]\\d*)|0)$"));
exports.addressRegExp = addressRegExp;

function checkContractId(contractId) {
  if (!contractIdRegExp.test(contractId)) throw new Error('invalid contractId format');
  var id = new _bignumber["default"](contractId.split('.')[2]);
  if (id.gt(MAX_CONTRACT_ID)) throw new Error('contractId is greater than or equals to 2**152');
}