"use strict";

var _Object$defineProperty = require("@babel/runtime-corejs3/core-js-stable/object/define-property");

var _interopRequireDefault = require("@babel/runtime-corejs3/helpers/interopRequireDefault");

_Object$defineProperty(exports, "__esModule", {
  value: true
});

exports["default"] = void 0;

var _concat = _interopRequireDefault(require("@babel/runtime-corejs3/core-js-stable/instance/concat"));

var _classCallCheck2 = _interopRequireDefault(require("@babel/runtime-corejs3/helpers/classCallCheck"));

var _createClass2 = _interopRequireDefault(require("@babel/runtime-corejs3/helpers/createClass"));

var _bigi = _interopRequireDefault(require("bigi"));

var ECSignature = /*#__PURE__*/function () {
  /**
   * @param {BigInteger} r
   * @param {BigInteger} s
   */
  function ECSignature(r, s) {
    (0, _classCallCheck2["default"])(this, ECSignature);
    if (!(r instanceof _bigi["default"])) throw new Error('invalid r-component type');
    if (!(s instanceof _bigi["default"])) throw new Error('invalid s-component type');
    /**
     * @private
     * @readonly
     * @type {BigInteger}
     */

    this._r = r.clone();
    /**
     * @private
     * @readonly
     * @type {BigInteger}
     */

    this._s = s.clone();
  }
  /** @returns {Buffer} */


  (0, _createClass2["default"])(ECSignature, [{
    key: "r",
    get:
    /**
     * @readonly
     * @type {BigInteger}
     */
    function get() {
      return this._r.clone();
    }
    /**
     * @readonly
     * @type {BigInteger}
     */

  }, {
    key: "s",
    get: function get() {
      return this._s.clone();
    }
  }, {
    key: "toDER",
    value: function toDER() {
      var rBa = this.r.toDERInteger();
      var sBa = this.s.toDERInteger();
      var sequence = []; // INTEGER

      sequence.push(0x02, rBa.length);
      sequence = (0, _concat["default"])(sequence).call(sequence, rBa); // INTEGER

      sequence.push(0x02, sBa.length);
      sequence = (0, _concat["default"])(sequence).call(sequence, sBa); // SEQUENCE

      sequence.unshift(0x30, sequence.length);
      return Buffer.from(sequence);
    } // TODO: write implementation

  }]);
  return ECSignature;
}();

exports["default"] = ECSignature;