"use strict";

var _typeof = require("@babel/runtime-corejs3/helpers/typeof");

var _WeakMap = require("@babel/runtime-corejs3/core-js-stable/weak-map");

var _Object$defineProperty = require("@babel/runtime-corejs3/core-js-stable/object/define-property");

var _Object$getOwnPropertyDescriptor = require("@babel/runtime-corejs3/core-js-stable/object/get-own-property-descriptor");

var _interopRequireDefault = require("@babel/runtime-corejs3/helpers/interopRequireDefault");

_Object$defineProperty(exports, "__esModule", {
  value: true
});

exports["default"] = void 0;

var _classCallCheck2 = _interopRequireDefault(require("@babel/runtime-corejs3/helpers/classCallCheck"));

var _createClass2 = _interopRequireDefault(require("@babel/runtime-corejs3/helpers/createClass"));

var ed25519 = _interopRequireWildcard(require("ed25519.js"));

var _validators = require("../utils/validators");

function _getRequireWildcardCache(nodeInterop) { if (typeof _WeakMap !== "function") return null; var cacheBabelInterop = new _WeakMap(); var cacheNodeInterop = new _WeakMap(); return (_getRequireWildcardCache = function _getRequireWildcardCache(nodeInterop) { return nodeInterop ? cacheNodeInterop : cacheBabelInterop; })(nodeInterop); }

function _interopRequireWildcard(obj, nodeInterop) { if (!nodeInterop && obj && obj.__esModule) { return obj; } if (obj === null || _typeof(obj) !== "object" && typeof obj !== "function") { return { "default": obj }; } var cache = _getRequireWildcardCache(nodeInterop); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = _Object$defineProperty && _Object$getOwnPropertyDescriptor; for (var key in obj) { if (key !== "default" && Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? _Object$getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { _Object$defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj["default"] = obj; if (cache) { cache.set(obj, newObj); } return newObj; }

var ED25519 = /*#__PURE__*/function () {
  function ED25519() {
    (0, _classCallCheck2["default"])(this, ED25519);
  }

  (0, _createClass2["default"])(ED25519, null, [{
    key: "keyPairFromPrivateKey",
    value:
    /**
     *  @method keyPairFromPrivateKey
     *
     *  @param {String|Buffer} privateKey - 32 byte hex string.
     *
     *  @return {{privateKey:Buffer,publicKey:Buffer}} ed25519 privateKey and public key
     */
    function keyPairFromPrivateKey(privateKey) {
      if (!((0, _validators.isString)(privateKey) || (0, _validators.isBuffer)(privateKey))) {
        throw new Error('private key must be string of buffer');
      }

      if ((0, _validators.isString)(privateKey)) privateKey = Buffer.from(privateKey, 'hex');

      if (privateKey.length !== 32) {
        throw new Error("Expecting 32 bytes, instead got ".concat(privateKey.length));
      }

      var publicKey = ed25519.derivePublicKey(privateKey);
      return {
        privateKey: privateKey,
        publicKey: publicKey
      };
    }
    /**
     *  @method createKeyPair
     *
     *  @return {{privateKey:Buffer,publicKey:Buffer}} ed25519 privateKey and public key
     */

  }, {
    key: "createKeyPair",
    value: function createKeyPair() {
      return ed25519.createKeyPair();
    }
    /**
     *  @method signMessage
     *  @param {Buffer} message
     *  @param {Buffer} publicKey
    	 *  @param {Buffer} privateKey
     *  @return {{signature:Buffer}}
     */

  }, {
    key: "signMessage",
    value: function signMessage(message, publicKey, privateKey) {
      if (!(0, _validators.isBuffer)(message)) {
        throw new Error('message must be buffer');
      }

      if (!(0, _validators.isBuffer)(publicKey)) {
        throw new Error('public key must be buffer');
      }

      if (!(0, _validators.isBuffer)(privateKey)) {
        throw new Error('private key must be buffer');
      }

      return ed25519.sign(message, publicKey, privateKey);
    }
    /**
     *  @method verifyMessage
     *  @param {Buffer} signature
     *  @param {Buffer} message
     *  @param {Buffer} publicKey
     *  @return {Boolean}
     */

  }, {
    key: "verifyMessage",
    value: function verifyMessage(signature, message, publicKey) {
      if (!(0, _validators.isBuffer)(signature)) {
        throw new Error('signature must be buffer');
      }

      if (!(0, _validators.isBuffer)(message)) {
        throw new Error('message key must be buffer');
      }

      if (!(0, _validators.isBuffer)(publicKey)) {
        throw new Error('public key must be buffer');
      }

      return ed25519.verify(signature, message, publicKey);
    }
  }]);
  return ED25519;
}();

var _default = ED25519;
exports["default"] = _default;