"use strict";

var _Object$defineProperty = require("@babel/runtime-corejs3/core-js-stable/object/define-property");

var _interopRequireDefault = require("@babel/runtime-corejs3/helpers/interopRequireDefault");

_Object$defineProperty(exports, "__esModule", {
  value: true
});

exports.HmacSHA256 = HmacSHA256;
exports["default"] = void 0;
exports.ripemd160 = ripemd160;
exports.sha1 = sha1;
exports.sha256 = sha256;
exports.sha512 = sha512;

var _createHash = _interopRequireDefault(require("create-hash"));

var _createHmac = _interopRequireDefault(require("create-hmac"));

/**
 *  @method sha1
 *
 *  @param  {String|Buffer} data
 *  @param  {String} encoding [hex', 'binary' or 'base64']
 *
 *  @return {String|Buffer} [Buffer when digest is null, or string]
 */
function sha1(data, encoding) {
  return (0, _createHash["default"])('sha1').update(data).digest(encoding);
}
/**
 *  @method sha256
 *
 *  @param  {String|Buffer} data
 *  @param  {String} encoding [hex', 'binary' or 'base64']
 *
 *  @return {String|Buffer} [Buffer when digest is null, or string]
 */


function sha256(data, encoding) {
  return (0, _createHash["default"])('sha256').update(data).digest(encoding);
}
/**
 *  @method sha512
 *
 *  @param  {String|Buffer} data
 *  @param  {String} encoding [hex', 'binary' or 'base64']
 *
 *  @return {String|Buffer} [Buffer when digest is null, or string]
 */


function sha512(data, encoding) {
  return (0, _createHash["default"])('sha512').update(data).digest(encoding);
}
/**
 *  @method HmacSHA256
 *
 *  @param  {Buffer} buffer
 *  @param  {Buffer} secret
 *
 *  @return {String|Buffer} [Buffer when digest is null, or string]
 */


function HmacSHA256(buffer, secret) {
  return (0, _createHmac["default"])('sha256', secret).update(buffer).digest();
}
/**
 *  @method ripemd160
 *
 *  @param  {Buffer} data
 *
 *  @return {String|Buffer} [Buffer when digest is null, or string]
 */


function ripemd160(data) {
  return (0, _createHash["default"])('ripemd160').update(data).digest();
}

var _default = {
  sha1: sha1,
  sha256: sha256,
  sha512: sha512,
  HmacSHA256: HmacSHA256,
  ripemd160: ripemd160
};
exports["default"] = _default;