"use strict";

var _typeof = require("@babel/runtime-corejs3/helpers/typeof");

var _WeakMap = require("@babel/runtime-corejs3/core-js-stable/weak-map");

var _Object$defineProperty = require("@babel/runtime-corejs3/core-js-stable/object/define-property");

var _Object$getOwnPropertyDescriptor = require("@babel/runtime-corejs3/core-js-stable/object/get-own-property-descriptor");

var _interopRequireDefault = require("@babel/runtime-corejs3/helpers/interopRequireDefault");

_Object$defineProperty(exports, "__esModule", {
  value: true
});

exports["default"] = void 0;

var _classCallCheck2 = _interopRequireDefault(require("@babel/runtime-corejs3/helpers/classCallCheck"));

var _createClass2 = _interopRequireDefault(require("@babel/runtime-corejs3/helpers/createClass"));

var ed25519 = _interopRequireWildcard(require("ed25519.js"));

var _hash = require("./hash");

function _getRequireWildcardCache(nodeInterop) { if (typeof _WeakMap !== "function") return null; var cacheBabelInterop = new _WeakMap(); var cacheNodeInterop = new _WeakMap(); return (_getRequireWildcardCache = function _getRequireWildcardCache(nodeInterop) { return nodeInterop ? cacheNodeInterop : cacheBabelInterop; })(nodeInterop); }

function _interopRequireWildcard(obj, nodeInterop) { if (!nodeInterop && obj && obj.__esModule) { return obj; } if (obj === null || _typeof(obj) !== "object" && typeof obj !== "function") { return { "default": obj }; } var cache = _getRequireWildcardCache(nodeInterop); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = _Object$defineProperty && _Object$getOwnPropertyDescriptor; for (var key in obj) { if (key !== "default" && Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? _Object$getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { _Object$defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj["default"] = obj; if (cache) { cache.set(obj, newObj); } return newObj; }

/** @typedef {import('./private-key').default} PrivateKey */
var Signature = /*#__PURE__*/function () {
  /**
   * @param {Buffer} signature
   */
  function Signature(signature) {
    (0, _classCallCheck2["default"])(this, Signature);
    this.signat = signature;
  }
  /**
   * @static
   * @param {Buffer} hash
   * @param {PrivateKey} privateKey
   */


  (0, _createClass2["default"])(Signature, [{
    key: "toBuffer",
    value:
    /** @returns {Buffer} */
    function toBuffer() {
      return this.signat;
    }
  }], [{
    key: "signBufferSha256",
    value: function signBufferSha256(hash, privateKey) {
      if (!Buffer.isBuffer(hash)) throw new Error('invalid hash type');
      if (hash.length !== 32) throw new Error('invalid sha256 hash length');
      var signat = ed25519.sign(hash, privateKey.toPublicKey().toBuffer(), privateKey.toBuffer());
      return new Signature(signat);
    }
    /**
     * @static
     * @param {Buffer} buffer
     * @param {PrivateKey} privateKey
     */

  }, {
    key: "signBuffer",
    value: function signBuffer(buffer, privateKey) {
      var hash = (0, _hash.sha256)(buffer);
      return Signature.signBufferSha256(hash, privateKey);
    }
  }]);
  return Signature;
}();

exports["default"] = Signature;