"use strict";

var _Object$defineProperty = require("@babel/runtime-corejs3/core-js-stable/object/define-property");

var _interopRequireDefault = require("@babel/runtime-corejs3/helpers/interopRequireDefault");

_Object$defineProperty(exports, "__esModule", {
  value: true
});

exports["default"] = void 0;
exports.signData = signData;

var _isArray = _interopRequireDefault(require("@babel/runtime-corejs3/core-js-stable/array/is-array"));

var _some = _interopRequireDefault(require("@babel/runtime-corejs3/core-js-stable/instance/some"));

var _concat = _interopRequireDefault(require("@babel/runtime-corejs3/core-js-stable/instance/concat"));

var _map = _interopRequireDefault(require("@babel/runtime-corejs3/core-js-stable/instance/map"));

var _ed = _interopRequireDefault(require("./ed25519"));

var _privateKey = _interopRequireDefault(require("./private-key"));

/**
 *  @method signData
 *
 *  @param  {Buffer} data
 *  @param  {PrivateKey[]} privateKeys
 *
 *  @return {Buffer}
 */
function signData(data, privateKeys) {
  if (!(0, _isArray["default"])(privateKeys)) throw new Error('Private Keys field is not an array');
  if (!privateKeys.length) throw new Error('Private Keys length should be more than 0');
  if (!Buffer.isBuffer(data)) throw new Error('invalid data type');

  if (!(0, _some["default"])(privateKeys).call(privateKeys, function (key) {
    return key instanceof _privateKey["default"];
  })) {
    throw new Error('one of the elements in an array is not PrivateKey');
  }

  return (0, _concat["default"])(Buffer).call(Buffer, (0, _map["default"])(privateKeys).call(privateKeys, function (privateKey) {
    return _ed["default"].signMessage(data, privateKey.toPublicKey().toBuffer(), privateKey.toBuffer());
  }));
}

var _default = {
  signData: signData
};
exports["default"] = _default;