"use strict";

var _Reflect$construct = require("@babel/runtime-corejs3/core-js-stable/reflect/construct");

var _Object$defineProperty = require("@babel/runtime-corejs3/core-js-stable/object/define-property");

var _interopRequireDefault = require("@babel/runtime-corejs3/helpers/interopRequireDefault");

_Object$defineProperty(exports, "__esModule", {
  value: true
});

exports["default"] = void 0;

var _classCallCheck2 = _interopRequireDefault(require("@babel/runtime-corejs3/helpers/classCallCheck"));

var _createClass2 = _interopRequireDefault(require("@babel/runtime-corejs3/helpers/createClass"));

var _inherits2 = _interopRequireDefault(require("@babel/runtime-corejs3/helpers/inherits"));

var _possibleConstructorReturn2 = _interopRequireDefault(require("@babel/runtime-corejs3/helpers/possibleConstructorReturn"));

var _getPrototypeOf2 = _interopRequireDefault(require("@babel/runtime-corejs3/helpers/getPrototypeOf"));

var _wsConstants = require("../../constants/ws-constants");

var _baseApi = _interopRequireDefault(require("./base-api"));

function _createSuper(Derived) { var hasNativeReflectConstruct = _isNativeReflectConstruct(); return function _createSuperInternal() { var Super = (0, _getPrototypeOf2["default"])(Derived), result; if (hasNativeReflectConstruct) { var NewTarget = (0, _getPrototypeOf2["default"])(this).constructor; result = _Reflect$construct(Super, arguments, NewTarget); } else { result = Super.apply(this, arguments); } return (0, _possibleConstructorReturn2["default"])(this, result); }; }

function _isNativeReflectConstruct() { if (typeof Reflect === "undefined" || !_Reflect$construct) return false; if (_Reflect$construct.sham) return false; if (typeof Proxy === "function") return true; try { Boolean.prototype.valueOf.call(_Reflect$construct(Boolean, [], function () {})); return true; } catch (e) { return false; } }

/** @typedef {import("../providers").WsProvider} WsProvider */

/** @typedef {import("../providers").HttpProvider} HttpProvider */

/** @typedef {"" | "eth" | "btc"} SidechainType */
var AssetAPI = /*#__PURE__*/function (_BaseEchoApi) {
  (0, _inherits2["default"])(AssetAPI, _BaseEchoApi);

  var _super = _createSuper(AssetAPI);

  /**
   * @constructor
   * @param {WsProvider | HttpProvider} provider
   */
  function AssetAPI(provider) {
    (0, _classCallCheck2["default"])(this, AssetAPI);
    return _super.call(this, provider, _wsConstants.CHAIN_API.ASSET_API);
  }
  /**
   *  @method getAssetHolders
   *  Retrieve the information about the holders of the specified asset.
   *
   *  @param {String} assetId   [asset id to retrieve]
   *  @param {Number} start [account id to start retrieving from]
   *  @param {Number} limit     [count accounts (max 100)]
   *
   *  @return {Promise.<Array.<{name: String, account_id:String, amount: String}>>}
   *  [ { name: 'init0', account_id: '1.2.6', amount: '100000039900000' } ]
   */


  (0, _createClass2["default"])(AssetAPI, [{
    key: "getAssetHolders",
    value: function getAssetHolders(assetId, start, limit) {
      return this.exec('get_asset_holders', [assetId, start, limit]);
    }
    /**
     *  @method getAssetHoldersCount
     *  Retrieve the number of holders of the provided asset.
     *
     *  @param {String} assetId   [asset id to retrieve]
     *
     *  @return {Promise.<Number>} result - 8
     */

  }, {
    key: "getAssetHoldersCount",
    value: function getAssetHoldersCount(assetId) {
      return this.exec('get_asset_holders_count', [assetId]);
    }
    /**
     *  @method getAllAssetHolders
     *  Array of all asset IDs with the number of holders.
     *
     * 	@return {Promise.<Array.<{asset_id: String, count: Number}>>}
     * 	[ { asset_id: '1.3.0', count: 8 } ]
     */

  }, {
    key: "getAllAssetHolders",
    value: function getAllAssetHolders() {
      return this.exec('get_all_asset_holders', []);
    }
  }]);
  return AssetAPI;
}(_baseApi["default"]);

var _default = AssetAPI;
exports["default"] = _default;