"use strict";

var _Object$defineProperty = require("@babel/runtime-corejs3/core-js-stable/object/define-property");

var _interopRequireDefault = require("@babel/runtime-corejs3/helpers/interopRequireDefault");

_Object$defineProperty(exports, "__esModule", {
  value: true
});

exports["default"] = void 0;

var _regenerator = _interopRequireDefault(require("@babel/runtime-corejs3/regenerator"));

var _asyncToGenerator2 = _interopRequireDefault(require("@babel/runtime-corejs3/helpers/asyncToGenerator"));

var _classCallCheck2 = _interopRequireDefault(require("@babel/runtime-corejs3/helpers/classCallCheck"));

var _createClass2 = _interopRequireDefault(require("@babel/runtime-corejs3/helpers/createClass"));

var _providers = require("../providers");

var _wsConstants = require("../../constants/ws-constants");

/** @typedef {import("../providers").WSProvider} WSProvider */

/** @typedef {import("../providers").HttpProvider} HttpProvider */
var BaseEchoApi = /*#__PURE__*/function () {
  /**
   *
   * @param {HttpProvider | WSProvider} provider
   * @param {string} apiName
   */
  function BaseEchoApi(provider, apiName) {
    (0, _classCallCheck2["default"])(this, BaseEchoApi);
    this.provider = provider;
    this.apiName = apiName;
    /** @type {number | null} */

    this.apiId = null;
  }
  /**
   * @returns {Promise}
   */


  (0, _createClass2["default"])(BaseEchoApi, [{
    key: "init",
    value: function () {
      var _init = (0, _asyncToGenerator2["default"])( /*#__PURE__*/_regenerator["default"].mark(function _callee() {
        return _regenerator["default"].wrap(function _callee$(_context) {
          while (1) {
            switch (_context.prev = _context.next) {
              case 0:
                if (!(this.provider.connectionType === _providers.ConnectionType.WS)) {
                  _context.next = 10;
                  break;
                }

                if (!(this.apiName === _wsConstants.CHAIN_API.LOGIN_API)) {
                  _context.next = 5;
                  break;
                }

                this.apiId = 1;
                _context.next = 8;
                break;

              case 5:
                _context.next = 7;
                return this.provider.call([1, this.apiName, []]);

              case 7:
                this.apiId = _context.sent;

              case 8:
                _context.next = 15;
                break;

              case 10:
                if (!(this.apiName === _wsConstants.CHAIN_API.DATABASE_API)) {
                  _context.next = 14;
                  break;
                }

                this.apiId = 0;
                _context.next = 15;
                break;

              case 14:
                throw new Error("".concat(this.apiName, " not available through http connection"));

              case 15:
                return _context.abrupt("return", this);

              case 16:
              case "end":
                return _context.stop();
            }
          }
        }, _callee, this);
      }));

      function init() {
        return _init.apply(this, arguments);
      }

      return init;
    }()
    /**
     * execute API method with params
     * @param {string} method name
     * @param {any[]} params
     * @returns {Promise}
     */

  }, {
    key: "exec",
    value: function () {
      var _exec = (0, _asyncToGenerator2["default"])( /*#__PURE__*/_regenerator["default"].mark(function _callee2(method, params) {
        var errMessage;
        return _regenerator["default"].wrap(function _callee2$(_context2) {
          while (1) {
            switch (_context2.prev = _context2.next) {
              case 0:
                if (!(this.apiId === null)) {
                  _context2.next = 3;
                  break;
                }

                errMessage = ["".concat(this.apiName, " API is not available"), 'try to specify this in connection option called "apis"'].join(', ');
                throw new Error(errMessage);

              case 3:
                if (!(this.provider.connectionType === _providers.ConnectionType.HTTP)) {
                  _context2.next = 5;
                  break;
                }

                return _context2.abrupt("return", this.provider.call(method, params));

              case 5:
                return _context2.abrupt("return", this.provider.call([this.apiId, method, params]));

              case 6:
              case "end":
                return _context2.stop();
            }
          }
        }, _callee2, this);
      }));

      function exec(_x, _x2) {
        return _exec.apply(this, arguments);
      }

      return exec;
    }()
  }]);
  return BaseEchoApi;
}();

exports["default"] = BaseEchoApi;