"use strict";

var _Reflect$construct = require("@babel/runtime-corejs3/core-js-stable/reflect/construct");

var _Object$defineProperty = require("@babel/runtime-corejs3/core-js-stable/object/define-property");

var _interopRequireDefault = require("@babel/runtime-corejs3/helpers/interopRequireDefault");

_Object$defineProperty(exports, "__esModule", {
  value: true
});

exports["default"] = void 0;

var _classCallCheck2 = _interopRequireDefault(require("@babel/runtime-corejs3/helpers/classCallCheck"));

var _createClass2 = _interopRequireDefault(require("@babel/runtime-corejs3/helpers/createClass"));

var _inherits2 = _interopRequireDefault(require("@babel/runtime-corejs3/helpers/inherits"));

var _possibleConstructorReturn2 = _interopRequireDefault(require("@babel/runtime-corejs3/helpers/possibleConstructorReturn"));

var _getPrototypeOf2 = _interopRequireDefault(require("@babel/runtime-corejs3/helpers/getPrototypeOf"));

var _wsConstants = require("../../constants/ws-constants");

var _baseApi = _interopRequireDefault(require("./base-api"));

function _createSuper(Derived) { var hasNativeReflectConstruct = _isNativeReflectConstruct(); return function _createSuperInternal() { var Super = (0, _getPrototypeOf2["default"])(Derived), result; if (hasNativeReflectConstruct) { var NewTarget = (0, _getPrototypeOf2["default"])(this).constructor; result = _Reflect$construct(Super, arguments, NewTarget); } else { result = Super.apply(this, arguments); } return (0, _possibleConstructorReturn2["default"])(this, result); }; }

function _isNativeReflectConstruct() { if (typeof Reflect === "undefined" || !_Reflect$construct) return false; if (_Reflect$construct.sham) return false; if (typeof Proxy === "function") return true; try { Boolean.prototype.valueOf.call(_Reflect$construct(Boolean, [], function () {})); return true; } catch (e) { return false; } }

/** @typedef {import("../providers").WsProvider} WsProvider */

/** @typedef {import("../providers").HttpProvider} HttpProvider */

/** @typedef {import("../../../types/interfaces/vm/types").Log} Log */

/** @typedef {"" | "eth" | "btc"} SidechainType */
var DatabaseAPI = /*#__PURE__*/function (_BaseEchoApi) {
  (0, _inherits2["default"])(DatabaseAPI, _BaseEchoApi);

  var _super = _createSuper(DatabaseAPI);

  /**
   * @constructor
   * @param {WsProvider | HttpProvider} provider
   */
  function DatabaseAPI(provider) {
    (0, _classCallCheck2["default"])(this, DatabaseAPI);
    return _super.call(this, provider, _wsConstants.CHAIN_API.DATABASE_API);
  }
  /**
   *  @method getObjects
   *  @param  {Array<String>} objectIds
   *  @return {Promise}
   */


  (0, _createClass2["default"])(DatabaseAPI, [{
    key: "getObjects",
    value: function getObjects(objectIds) {
      return this.exec('get_objects', [objectIds]);
    }
    /**
     * @param {string} contractId
     * @returns {Promise<boolean>}
     */

  }, {
    key: "checkERC20Token",
    value: function checkERC20Token(contractId) {
      return this.exec('check_erc20_token', [contractId]);
    }
    /**
     *  @method setSubscribeCallback
     *  @param  {Function} callback
     *  @param  {Boolean} notifyRemoveCreate
     *
     *  @return {Promise}
     */

  }, {
    key: "setSubscribeCallback",
    value: function setSubscribeCallback(callback, notifyRemoveCreate) {
      return this.exec('set_subscribe_callback', [callback, notifyRemoveCreate]);
    }
    /**
     *  @method setPendingTransactionCallback
     *  @param  {Function} callback
     *
     *  @return {Promise}
     */

  }, {
    key: "setPendingTransactionCallback",
    value: function setPendingTransactionCallback(callback) {
      return this.exec('set_pending_transaction_callback', [callback]);
    }
    /**
     *  @method setBlockAppliedCallback
     *  @param  {Function} callback
     *
     *  @return {Promise}
     */

  }, {
    key: "setBlockAppliedCallback",
    value: function setBlockAppliedCallback(callback) {
      return this.exec('set_block_applied_callback', [callback]);
    }
    /**
     *  @method cancelAllSubscriptions
     *
     *  @return {Promise}
     */

  }, {
    key: "cancelAllSubscriptions",
    value: function cancelAllSubscriptions() {
      return this.exec('cancel_all_subscriptions', []);
    }
    /**
     *  @method getBlockHeader
     *  @param  {Number} blockNum
     *
     *  @return {Promise}
     */

  }, {
    key: "getBlockHeader",
    value: function getBlockHeader(blockNum) {
      return this.exec('get_block_header', [blockNum]);
    }
    /**
     *  @method getBlock
     *  @param  {Number} blockNum
     *
     *  @return {Promise}
     */

  }, {
    key: "getBlock",
    value: function getBlock(blockNum) {
      return this.exec('get_block', [blockNum]);
    }
    /**
     *  @method getTransaction
     *  @param  {Number} blockNum
     *  @param  {Number} transactionIndex
     *
     *  @return {Promise}
     */

  }, {
    key: "getTransaction",
    value: function getTransaction(blockNum, transactionIndex) {
      return this.exec('get_transaction', [blockNum, transactionIndex]);
    }
    /**
     *  @method getChainProperties
     *
     *  @return {Promise}
     */

  }, {
    key: "getChainProperties",
    value: function getChainProperties() {
      return this.exec('get_chain_properties', []);
    }
    /**
     *  @method getGlobalProperties
     *
     *  @return {Promise}
     */

  }, {
    key: "getGlobalProperties",
    value: function getGlobalProperties() {
      return this.exec('get_global_properties', []);
    }
    /**
     *  @method getConfig
     *
     *  @return {Promise}
     */

  }, {
    key: "getConfig",
    value: function getConfig() {
      return this.exec('get_config', []);
    }
    /**
     *  @method getChainId
     *
     *  @return {Promise}
     */

  }, {
    key: "getChainId",
    value: function getChainId() {
      return this.exec('get_chain_id', []);
    }
    /**
     *  @method getDynamicGlobalProperties
     *
     *  @return {Promise}
     */

  }, {
    key: "getDynamicGlobalProperties",
    value: function getDynamicGlobalProperties() {
      return this.exec('get_dynamic_global_properties', []);
    }
    /**
     *  @method getGitRevision
     *
     *  @return {Promise}
     */

  }, {
    key: "getGitRevision",
    value: function getGitRevision() {
      return this.exec('get_git_revision', []);
    }
    /**
     *  @method getCurrentIncentivesInfo
     *
     *  @return {Promise}
     */

  }, {
    key: "getCurrentIncentivesInfo",
    value: function getCurrentIncentivesInfo() {
      return this.exec('get_current_incentives_info', []);
    }
    /**
     *  @method getIncentivesInfo
     *  @param  {Number} blockStart
     *  @param  {Number} blockEnd
     *
     *
     *  @return {Promise}
     */

  }, {
    key: "getIncentivesInfo",
    value: function getIncentivesInfo(blockStart, blockEnd) {
      return this.exec('get_incentives_info', [blockStart, blockEnd]);
    }
    /**
     *  @method getAccountAddressByLabel
     *  @param  {String} accountNameOrId
     *  @param  {String} label
     *
     *
     *  @return {Promise}
     */

  }, {
    key: "getAccountAddressByLabel",
    value: function getAccountAddressByLabel(accountNameOrId, label) {
      return this.exec('get_account_address_by_label', [accountNameOrId, label]);
    }
    /**
     *  @method getKeyReferences
     *  @param  {Array<String>} keys [public keys]
     *
     *  @return {Promise}
     */

  }, {
    key: "getKeyReferences",
    value: function getKeyReferences(keys) {
      return this.exec('get_key_references', [keys]);
    }
    /**
     *  @method getAccounts
     *  @param  {Array<String>} accountIds
     *
     *  @return {Promise}
     */

  }, {
    key: "getAccounts",
    value: function getAccounts(accountIds) {
      return this.exec('get_accounts', [accountIds]);
    }
    /**
     *  @method getFullAccounts
     *  @param  {Array<String>} accountNamesOrIds
     *  @param  {Boolean} subscribe
     *
     *  @return {Promise}
     */

  }, {
    key: "getFullAccounts",
    value: function getFullAccounts(accountNamesOrIds, subscribe) {
      return this.exec('get_full_accounts', [accountNamesOrIds, subscribe]);
    }
    /**
     *  @method getAccountByName
     *  @param  {String} accountName
     *
     *  @return {Promise}
     */

  }, {
    key: "getAccountByName",
    value: function getAccountByName(accountName) {
      return this.exec('get_account_by_name', [accountName]);
    }
    /**
     * @method getAccountDeposits
     * @param {string} account
     * @param {SidechainType} type
     * @returns {Promise<unknown>}
     */

  }, {
    key: "getAccountDeposits",
    value: function getAccountDeposits(account, type) {
      return this.exec('get_account_deposits', [account, type]);
    }
    /**
     *  @method getAccountReferences
     *  @param  {String} accountId
     *
     *  @return {Promise}
     */

  }, {
    key: "getAccountReferences",
    value: function getAccountReferences(accountId) {
      return this.exec('get_account_references', [accountId]);
    }
    /**
     * @method getAccountWithdrawals
     * @param {string} account
     * @param {SidechainType} type
     * @returns {Promise<unknown>}
     */

  }, {
    key: "getAccountWithdrawals",
    value: function getAccountWithdrawals(account, type) {
      return this.exec('get_account_withdrawals', [account, type]);
    }
    /**
     *  @method lookupAccountNames
     *  @param  {Array<String>} accountNames
     *
     *  @return {Promise}
     */

  }, {
    key: "lookupAccountNames",
    value: function lookupAccountNames(accountNames) {
      return this.exec('lookup_account_names', [accountNames]);
    }
    /**
     *  @method lookupAccounts
     *  @param  {String} lowerBoundName
     *  @param  {Number} limit
     *
     *  @return {Promise}
     */

  }, {
    key: "lookupAccounts",
    value: function lookupAccounts(lowerBoundName, limit) {
      return this.exec('lookup_accounts', [lowerBoundName, limit]);
    }
    /**
     *  @method getAccountCount
     *
     *  @return {Promise}
     */

  }, {
    key: "getAccountCount",
    value: function getAccountCount() {
      return this.exec('get_account_count', []);
    }
    /**
     *  @method getAccountBalances
     *  @param  {String} accountId
     *  @param  {Array<String>} assetIds
     *
     *  @return {Promise}
     */

  }, {
    key: "getAccountBalances",
    value: function getAccountBalances(accountId, assetIds) {
      return this.exec('get_account_balances', [accountId, assetIds]);
    }
    /**
     *  @method getNamedAccountBalances
     *  @param  {String} accountName
     *  @param  {Array<String>} assetIds
     *
     *  @return {Promise}
     */

  }, {
    key: "getNamedAccountBalances",
    value: function getNamedAccountBalances(accountName, assetIds) {
      return this.exec('get_named_account_balances', [accountName, assetIds]);
    }
    /**
     *  @method getVestedBalances
     *  @param  {Array<String>} objectIds
     *
     *  @return {Promise}
     */

  }, {
    key: "getVestedBalances",
    value: function getVestedBalances(objectIds) {
      return this.exec('get_vested_balances', [objectIds]);
    }
    /**
     *  @method getVestingBalances
     *  @param  {String} accountId
     *
     *  @return {Promise}
     */

  }, {
    key: "getVestingBalances",
    value: function getVestingBalances(accountId) {
      return this.exec('get_vesting_balances', [accountId]);
    }
    /**
     *  @method getAssets
     *  @param  {Array<String>} assetIds
     *
     *  @return {Promise}
     */

  }, {
    key: "getAssets",
    value: function getAssets(assetIds) {
      return this.exec('get_assets', [assetIds]);
    }
    /**
     *  @method listAssets
     *  @param  {String} lowerBoundSymbol
     *  @param  {Number} limit
     *
     *  @return {Promise}
     */

  }, {
    key: "listAssets",
    value: function listAssets(lowerBoundSymbol, limit) {
      return this.exec('list_assets', [lowerBoundSymbol, limit]);
    }
    /**
     *  @method lookupAssetSymbols
     *  @param  {Array<String>} symbolsOrIds
     *
     *  @return {Promise}
     */

  }, {
    key: "lookupAssetSymbols",
    value: function lookupAssetSymbols(symbolsOrIds) {
      return this.exec('lookup_asset_symbols', [symbolsOrIds]);
    }
    /**
     *  @method getMarginPositions
     *  @param  {String} accountId
     *
     *  @return {Promise}
     */

  }, {
    key: "getMarginPositions",
    value: function getMarginPositions(accountId) {
      return this.exec('get_margin_positions', [accountId]);
    }
    /**
     *  @method getTicker
     *
     *  @param  {String} baseAssetName
     *  @param  {String} quoteAssetName
     *
     *  @return {Promise}
     */

  }, {
    key: "getTicker",
    value: function getTicker(baseAssetName, quoteAssetName) {
      return this.exec('get_ticker', [baseAssetName, quoteAssetName]);
    }
    /**
     *  @method get24Volume
     *
     *  @param  {String} baseAssetName
     *  @param  {String} quoteAssetName
     *
     *  @return {Promise}
     */

  }, {
    key: "get24Volume",
    value: function get24Volume(baseAssetName, quoteAssetName) {
      return this.exec('get_24_volume', [baseAssetName, quoteAssetName]);
    }
    /**
     *  @method getTradeHistory
     *
     *  @param  {String} baseAssetName
     *  @param  {String} quoteAssetName
     *  @param  {Number} start
     *  @param  {Number} stop
     *  @param  {Number} limit
     *
     *  @return {Promise}
     */

  }, {
    key: "getTradeHistory",
    value: function getTradeHistory(baseAssetName, quoteAssetName, start, stop) {
      var limit = arguments.length > 4 && arguments[4] !== undefined ? arguments[4] : 100;
      return this.exec('get_trade_history', [baseAssetName, quoteAssetName, start, stop, limit]);
    }
    /**
     *  @method getCommitteeMembers
     *
     *  @param  {Array<String>} committeeMemberIds
     *
     *  @return {Promise}
     */

  }, {
    key: "getCommitteeMembers",
    value: function getCommitteeMembers(committeeMemberIds) {
      return this.exec('get_committee_members', [committeeMemberIds]);
    }
    /**
     *  @method getCommitteeMemberByAccount
     *
     *  @param  {String} accountId
     *
     *  @return {Promise}
     */

  }, {
    key: "getCommitteeMemberByAccount",
    value: function getCommitteeMemberByAccount(accountId) {
      return this.exec('get_committee_member_by_account', [accountId]);
    }
    /**
     *  @method lookupCommitteeMemberAccounts
     *
     *  @param  {String} lowerBoundName
     *  @param  {Number} limit
     *
     *  @return {Promise}
     */

  }, {
    key: "lookupCommitteeMemberAccounts",
    value: function lookupCommitteeMemberAccounts(lowerBoundName, limit) {
      return this.exec('lookup_committee_member_accounts', [lowerBoundName, limit]);
    }
    /**
     *  @method getTransactionHex
     *
     *  @param  {Object} transaction
     *
     *  @return {Promise}
     */

  }, {
    key: "getTransactionHex",
    value: function getTransactionHex(transaction) {
      // transaction is signed
      return this.exec('get_transaction_hex', [transaction]);
    }
    /**
     *  @method getRequiredSignatures
     *
     *  @param  {Object} transaction
     *  @param  {Array<String>} availableKeys [public keys]
     *
     *  @return {Promise}
     */

  }, {
    key: "getRequiredSignatures",
    value: function getRequiredSignatures(transaction, availableKeys) {
      return this.exec('get_required_signatures', [transaction, availableKeys]);
    }
    /**
     *  @method getPotentialSignatures
     *
     *  @param  {Object} transaction
     *
     *  @return {Promise}
     */

  }, {
    key: "getPotentialSignatures",
    value: function getPotentialSignatures(transaction) {
      return this.exec('get_potential_signatures', [transaction]);
    }
    /**
     *  @method verifyAuthority
     *
     *  @param  {Object} transaction
     *
     *  @return {Promise}
     */

  }, {
    key: "verifyAuthority",
    value: function verifyAuthority(transaction) {
      return this.exec('verify_authority', [transaction]);
    }
    /**
     *  @method verifyAccountAuthority
     *
     *  @param  {Object} accountNameOrId
     *  @param  {Array<String>} signers [public keys]
     *
     *  @return {Promise}
     */

  }, {
    key: "verifyAccountAuthority",
    value: function verifyAccountAuthority(accountNameOrId, signers) {
      // signers - set of public keys
      return this.exec('verify_account_authority', [accountNameOrId, signers]);
    }
    /**
     *  @method validateTransaction
     *
     *  @param  {Object} transaction
     *
     *  @return {Promise}
     */

  }, {
    key: "validateTransaction",
    value: function validateTransaction(transaction) {
      // signed transaction
      return this.exec('validate_transaction', [transaction]);
    }
    /**
     *  @method getRequiredFees
     *
     *  @param  {Array<Object>} operations
     *  @param  {String} assetId
     *
     *  @return {Promise}
     */

  }, {
    key: "getRequiredFees",
    value: function getRequiredFees(operations, assetId) {
      return this.exec('get_required_fees', [operations, assetId]);
    }
    /**
     *  @method getProposedTransactions
     *
     *  @param  {String} accountNameOrId
     *
     *  @return {Promise}
     */

  }, {
    key: "getProposedTransactions",
    value: function getProposedTransactions(accountNameOrId) {
      return this.exec('get_proposed_transactions', [accountNameOrId]);
    }
    /**
     * @param {(result: Log[]) => any} callback
     * @param {ContractLogsFilterOptionsRaw} opts
     */

  }, {
    key: "getContractLogs",
    value: function getContractLogs(callback, opts) {
      return this.exec('get_contract_logs', [callback, opts]);
    }
    /**
     * @param {(result: Log[]) => any} cb
     * @param {ContractLogsFilterOptionsRaw} options
     * @returns {Promise<number|string>}
     */

  }, {
    key: "subscribeContractLogs",
    value: function subscribeContractLogs(cb, options) {
      return this.exec('subscribe_contract_logs', [cb, options]);
    }
    /** @param {number|string} cbId */

  }, {
    key: "unsubscribeContractLogs",
    value: function unsubscribeContractLogs(cbId) {
      return this.exec('unsubscribe_contract_logs', [cbId]);
    }
    /**
     *  @method getContractResult
     *
     *  @param  {String} resultContractId
     *
     *  @return {Promise}
     */

  }, {
    key: "getContractResult",
    value: function getContractResult(resultContractId) {
      return this.exec('get_contract_result', [resultContractId]);
    }
    /**
     *  @method getContract
     *
     *  @param  {String} contractId
     *
     *  @return {Promise}
     */

  }, {
    key: "getContract",
    value: function getContract(contractId) {
      return this.exec('get_contract', [contractId]);
    }
    /**
     * @method callContractNoChangingState
     * @param {string} contractId
     * @param {string} accountId
     * @param {string} asset
     * @param {string} code
     * @return {Promise<string>}
     */

  }, {
    key: "callContractNoChangingState",
    value: function callContractNoChangingState(contractId, caller, asset, code) {
      return this.exec('call_contract_no_changing_state', [contractId, caller, asset, code]);
    }
    /**
     *  @method getContracts
     *
     *  @param  {Array<String>} contractIds
     *
     *  @return {Promise}
     */

  }, {
    key: "getContracts",
    value: function getContracts(contractIds) {
      return this.exec('get_contracts', [contractIds]);
    }
    /**
     *  @method getContractBalances
     *
     *  @param  {String} contractId
     *
     *  @return {Promise}
     */

  }, {
    key: "getContractBalances",
    value: function getContractBalances(contractId) {
      return this.exec('get_contract_balances', [contractId]);
    }
    /**
     *  @method getContractPoolWhitelist
     *
     *  @param  {String} contractId
     *
     *  @return {Promise}
     */

  }, {
    key: "getContractPoolWhitelist",
    value: function getContractPoolWhitelist(contractId) {
      return this.exec('get_contract_pool_whitelist', [contractId]);
    }
    /**
     *  @method subscribeContracts
     *
     *  @param  {Array<String>} contractIds
     *
     *  @return {Promise}
     */

  }, {
    key: "subscribeContracts",
    value: function subscribeContracts(contractIds) {
      return this.exec('subscribe_contracts', [contractIds]);
    }
    /**
     *  @method getContractPoolBalance
     *
     *  @param  {String} contractId
     *
     *  @return {Promise}
     */

  }, {
    key: "getContractPoolBalance",
    value: function getContractPoolBalance(contractId) {
      return this.exec('get_contract_pool_balance', [contractId]);
    }
    /**
     *  @method getTransactionById
     *
     *  @param  {String} transactionId
     *
     *  @return {Promise}
     */

  }, {
    key: "getTransactionById",
    value: function getTransactionById(transactionId) {
      return this.exec('get_transaction_by_id', [transactionId]);
    }
    /**
     *  @method getBtcStakeAddress
     *
     *  @param  {String} accountNameOrId
     *
     *  @return {Promise}
     */

  }, {
    key: "getBtcStakeAddress",
    value: function getBtcStakeAddress(accountNameOrId) {
      return this.exec('get_btc_stake_address', [accountNameOrId]);
    }
    /**
     *  @method getBalanceObjects
     *
     *  @param  {Array<String>} keys [public keys]
     *
     * 	@return {Promise}
     */

  }, {
    key: "getBalanceObjects",
    value: function getBalanceObjects(keys) {
      return this.exec('get_balance_objects', [keys]);
    }
    /**
     *  @method getBlockVirtualOperations
     *
     *  @param  {Number} blockNum
     *
     * 	@return {Promise}
     */

  }, {
    key: "getBlockVirtualOperations",
    value: function getBlockVirtualOperations(blockNum) {
      return this.exec('get_block_virtual_ops', [blockNum]);
    }
    /**
     *  @method getFrozenBalances
     *  @param  {String} accountId
     *
     *  @return {Promise}
     */

  }, {
    key: "getFrozenBalances",
    value: function getFrozenBalances(accountId) {
      return this.exec('get_frozen_balances', [accountId]);
    }
  }, {
    key: "getERC20AccountWithdrawals",
    value: function getERC20AccountWithdrawals(account) {
      return this.exec('get_erc20_account_withdrawals', [account]);
    }
  }, {
    key: "getERC20AccountDeposits",
    value: function getERC20AccountDeposits(account) {
      return this.exec('get_erc20_account_deposits', [account]);
    }
    /**
     *  @method getBtcAddress
     *  @param  {String} accountId
     *
     *  @return {Promise}
     */

  }, {
    key: "getBtcAddress",
    value: function getBtcAddress(accountId) {
      return this.exec('get_btc_address', [accountId]);
    }
    /**
     *  @method getBtcDepositScript
     *  @param  {String} btcDepositId
     *
     *  @return {Promise}
     */

  }, {
    key: "getBtcDepositScript",
    value: function getBtcDepositScript(btcDepositId) {
      return this.exec('get_btc_deposit_script', [btcDepositId]);
    }
    /**
     *  @method getCommitteeFrozenBalance
     *  @param  {String} committeeMemberId
     *
     *  @return {Promise}
     */

  }, {
    key: "getCommitteeFrozenBalance",
    value: function getCommitteeFrozenBalance(committeeMemberId) {
      return this.exec('get_committee_frozen_balance', [committeeMemberId]);
    }
    /**
     *  @method getAccountAddresses
     *  @param  {String} id
     *  @param {Number} from
     *  @param {Number} limit
     *
     *  @return {Promise}
     */

  }, {
    key: "getAccountAddresses",
    value: function getAccountAddresses(id, from, limit) {
      return this.exec('get_account_addresses', [id, from, limit]);
    }
    /**
     *  @method getEthAddress
     *  @param  {String} id
     *
     *  @return {Promise}
     */

  }, {
    key: "getEthAddress",
    value: function getEthAddress(id) {
      return this.exec('get_eth_address', [id]);
    }
    /**
     *  @method getAccountByAddress
     *  @param  {String} address
     *
     *  @return {Promise}
     */

  }, {
    key: "getAccountByAddress",
    value: function getAccountByAddress(address) {
      return this.exec('get_account_by_address', [address]);
    }
  }]);
  return DatabaseAPI;
}(_baseApi["default"]);

var _default = DatabaseAPI;
exports["default"] = _default;