"use strict";

var _Reflect$construct = require("@babel/runtime-corejs3/core-js-stable/reflect/construct");

var _Object$defineProperty = require("@babel/runtime-corejs3/core-js-stable/object/define-property");

var _interopRequireDefault = require("@babel/runtime-corejs3/helpers/interopRequireDefault");

_Object$defineProperty(exports, "__esModule", {
  value: true
});

exports["default"] = void 0;

var _classCallCheck2 = _interopRequireDefault(require("@babel/runtime-corejs3/helpers/classCallCheck"));

var _createClass2 = _interopRequireDefault(require("@babel/runtime-corejs3/helpers/createClass"));

var _inherits2 = _interopRequireDefault(require("@babel/runtime-corejs3/helpers/inherits"));

var _possibleConstructorReturn2 = _interopRequireDefault(require("@babel/runtime-corejs3/helpers/possibleConstructorReturn"));

var _getPrototypeOf2 = _interopRequireDefault(require("@babel/runtime-corejs3/helpers/getPrototypeOf"));

var _wsConstants = require("../../constants/ws-constants");

var _baseApi = _interopRequireDefault(require("./base-api"));

function _createSuper(Derived) { var hasNativeReflectConstruct = _isNativeReflectConstruct(); return function _createSuperInternal() { var Super = (0, _getPrototypeOf2["default"])(Derived), result; if (hasNativeReflectConstruct) { var NewTarget = (0, _getPrototypeOf2["default"])(this).constructor; result = _Reflect$construct(Super, arguments, NewTarget); } else { result = Super.apply(this, arguments); } return (0, _possibleConstructorReturn2["default"])(this, result); }; }

function _isNativeReflectConstruct() { if (typeof Reflect === "undefined" || !_Reflect$construct) return false; if (_Reflect$construct.sham) return false; if (typeof Proxy === "function") return true; try { Boolean.prototype.valueOf.call(_Reflect$construct(Boolean, [], function () {})); return true; } catch (e) { return false; } }

/** @typedef {import("../providers").WsProvider} WsProvider */

/** @typedef {import("../providers").HttpProvider} HttpProvider */

/** @typedef {"" | "eth" | "btc"} SidechainType */
var NetworkAPI = /*#__PURE__*/function (_BaseEchoApi) {
  (0, _inherits2["default"])(NetworkAPI, _BaseEchoApi);

  var _super = _createSuper(NetworkAPI);

  /**
   * @constructor
   * @param {WsProvider | HttpProvider} provider
   */
  function NetworkAPI(provider) {
    (0, _classCallCheck2["default"])(this, NetworkAPI);
    return _super.call(this, provider, _wsConstants.CHAIN_API.NETWORK_BROADCAST_API);
  }
  /**
   *  @method broadcastTransaction
   *  Broadcast a transaction to the network.
   *
   *  @param  {Object} signedTransaction
   *  	transaction: {
   *  		ref_block_num,
   *  		ref_block_prefix,
   *  		operations,
   *  		signatures,
   *  	}
   *
   *  @return {Promise}
   */


  (0, _createClass2["default"])(NetworkAPI, [{
    key: "broadcastTransaction",
    value: function broadcastTransaction(signedTransaction) {
      return this.exec('broadcast_transaction', [signedTransaction]);
    }
    /**
     *  @method broadcastBlock
     *  Broadcast a block to the network.
     *
     *  @param  {Object} signedBlock
     *  	block: {
     *  		previous: previous-block-id,
     *  		timestamp: block-timestamp,
     *  		transaction_merkle_root: "merkle-root",
     *  		state_root_hash: "hash",
     *  		result_root_hash: "result-hash",
     *  		ed_signature: "eddsa signature",
     *  		round: round-id,
     *  		rand: rand,
     *  		cert: "certificate",
     *  		transactions: [{ref_block_num, ref_block_prefix, operations, signatures}],
     *  	}
     *
     *  @return {Promise}
     */

  }, {
    key: "broadcastBlock",
    value: function broadcastBlock(signedBlock) {
      return this.exec('broadcast_block', [signedBlock]);
    }
    /**
     *  @method broadcastTransactionSynchronous
     *  Synchronious version of broadcastTransaction
     *
     *  @param  {Object} signedTransaction
     *  	transaction: {
     *  		ref_block_num,
     *  		ref_block_prefix,
     *  		operations,
     *  		signatures,
     *  	}
     *
     *  @return {Promise}
     */

  }, {
    key: "broadcastTransactionSynchronous",
    value: function broadcastTransactionSynchronous(signedTransaction) {
      return this.exec('broadcast_transaction_synchronous', [signedTransaction]);
    }
    /**
     *  @method broadcastTransactionWithCallback
     *  This version of broadcastTransaction registers a callback method
     *  that will be called when the transaction is included into a block.
     *
     *  @param {Function} callback
     *  @param  {Object} signedTransaction
     *  	transaction: {
     *  		ref_block_num,
     *  		ref_block_prefix,
     *  		operations,
     *  		signatures,
     *  	}
     *
     *  @return {Promise}
     */

  }, {
    key: "broadcastTransactionWithCallback",
    value: function broadcastTransactionWithCallback(callback, signedTransaction) {
      return this.exec('broadcast_transaction_with_callback', [callback, signedTransaction]);
    }
  }]);
  return NetworkAPI;
}(_baseApi["default"]);

var _default = NetworkAPI;
exports["default"] = _default;