"use strict";

var _Reflect$construct = require("@babel/runtime-corejs3/core-js-stable/reflect/construct");

var _Object$defineProperty = require("@babel/runtime-corejs3/core-js-stable/object/define-property");

var _interopRequireDefault = require("@babel/runtime-corejs3/helpers/interopRequireDefault");

_Object$defineProperty(exports, "__esModule", {
  value: true
});

exports["default"] = void 0;

var _classCallCheck2 = _interopRequireDefault(require("@babel/runtime-corejs3/helpers/classCallCheck"));

var _createClass2 = _interopRequireDefault(require("@babel/runtime-corejs3/helpers/createClass"));

var _inherits2 = _interopRequireDefault(require("@babel/runtime-corejs3/helpers/inherits"));

var _possibleConstructorReturn2 = _interopRequireDefault(require("@babel/runtime-corejs3/helpers/possibleConstructorReturn"));

var _getPrototypeOf2 = _interopRequireDefault(require("@babel/runtime-corejs3/helpers/getPrototypeOf"));

var _wsConstants = require("../../constants/ws-constants");

var _baseApi = _interopRequireDefault(require("./base-api"));

function _createSuper(Derived) { var hasNativeReflectConstruct = _isNativeReflectConstruct(); return function _createSuperInternal() { var Super = (0, _getPrototypeOf2["default"])(Derived), result; if (hasNativeReflectConstruct) { var NewTarget = (0, _getPrototypeOf2["default"])(this).constructor; result = _Reflect$construct(Super, arguments, NewTarget); } else { result = Super.apply(this, arguments); } return (0, _possibleConstructorReturn2["default"])(this, result); }; }

function _isNativeReflectConstruct() { if (typeof Reflect === "undefined" || !_Reflect$construct) return false; if (_Reflect$construct.sham) return false; if (typeof Proxy === "function") return true; try { Boolean.prototype.valueOf.call(_Reflect$construct(Boolean, [], function () {})); return true; } catch (e) { return false; } }

/** @typedef {import("../providers").WsProvider} WsProvider */

/** @typedef {import("../providers").HttpProvider} HttpProvider */

/** @typedef {"" | "eth" | "btc"} SidechainType */

/** @typedef {
	import("../../constants/net/peer-database").e_POTENTIAL_PEER_LAST_CONNECTION_DISPOSITION
} e_POTENTIAL_PEER_LAST_CONNECTION_DISPOSITION */

/**
 * @typedef {Object} PeerDetails
 * @property {string} addr
 * @property {string} addrlocal
 * @property {string} services
 * @property {number} lastsend
 * @property {number} lastrecv
 * @property {number | string} bytessent
 * @property {number | string} bytesrecv
 * @property {string} conntime
 * @property {string} pingtime
 * @property {string} pingwait
 * @property {string} version
 * @property {string} subver
 * @property {boolean} inbound
 * @property {import("../../constants/net/core-messages").e_FIREWALLED_STATE} firewall_status
 * @property {string} startingheight
 * @property {string} banscore
 * @property {string} syncnode
 * @property {string} [fc_git_revision_sha]
 * @property {string} [fc_git_revision_unix_timestamp]
 * @property {string} [fc_git_revision_age]
 * @property {string} [platform]
 * @property {string} current_head_block
 * @property {number} current_head_block_number
 * @property {string} current_head_block_time
 */

/**
 * @typedef {Object} PotentialPeerRecord
 * @property {string} endpoint
 * @property {string} last_seen_time
 * @property {e_POTENTIAL_PEER_LAST_CONNECTION_DISPOSITION} last_connection_disposition
 * @property {string} last_connection_attempt_time
 * @property {number} number_of_successful_connection_attempts
 * @property {number} number_of_failed_connection_attempts
 * @property {unknown} [last_error]
 */
var NetworkNodeAPI = /*#__PURE__*/function (_BaseEchoApi) {
  (0, _inherits2["default"])(NetworkNodeAPI, _BaseEchoApi);

  var _super = _createSuper(NetworkNodeAPI);

  /**
   * @constructor
   * @param {WsProvider | HttpProvider} provider
   */
  function NetworkNodeAPI(provider) {
    (0, _classCallCheck2["default"])(this, NetworkNodeAPI);
    return _super.call(this, provider, _wsConstants.CHAIN_API.NETWORK_NODE_API);
  }
  /**
   * @method getConnectedPeers
   * @return {Promise<Array<{ version: number, host: string, info: PeerDetails }>>}
   */


  (0, _createClass2["default"])(NetworkNodeAPI, [{
    key: "getConnectedPeers",
    value: function getConnectedPeers() {
      return this.exec('get_connected_peers', []);
    }
    /**
     * @method getPotentialPeers
     * @return {Promise<PotentialPeerRecord[]>}
     */

  }, {
    key: "getPotentialPeers",
    value: function getPotentialPeers() {
      return this.exec('get_potential_peers', []);
    }
  }]);
  return NetworkNodeAPI;
}(_baseApi["default"]);

var _default = NetworkNodeAPI;
exports["default"] = _default;