"use strict";

var _Reflect$construct = require("@babel/runtime-corejs3/core-js-stable/reflect/construct");

var _Object$defineProperty = require("@babel/runtime-corejs3/core-js-stable/object/define-property");

var _interopRequireDefault = require("@babel/runtime-corejs3/helpers/interopRequireDefault");

_Object$defineProperty(exports, "__esModule", {
  value: true
});

exports["default"] = void 0;

var _classCallCheck2 = _interopRequireDefault(require("@babel/runtime-corejs3/helpers/classCallCheck"));

var _createClass2 = _interopRequireDefault(require("@babel/runtime-corejs3/helpers/createClass"));

var _inherits2 = _interopRequireDefault(require("@babel/runtime-corejs3/helpers/inherits"));

var _possibleConstructorReturn2 = _interopRequireDefault(require("@babel/runtime-corejs3/helpers/possibleConstructorReturn"));

var _getPrototypeOf2 = _interopRequireDefault(require("@babel/runtime-corejs3/helpers/getPrototypeOf"));

var _wsConstants = require("../../constants/ws-constants");

var _baseApi = _interopRequireDefault(require("./base-api"));

function _createSuper(Derived) { var hasNativeReflectConstruct = _isNativeReflectConstruct(); return function _createSuperInternal() { var Super = (0, _getPrototypeOf2["default"])(Derived), result; if (hasNativeReflectConstruct) { var NewTarget = (0, _getPrototypeOf2["default"])(this).constructor; result = _Reflect$construct(Super, arguments, NewTarget); } else { result = Super.apply(this, arguments); } return (0, _possibleConstructorReturn2["default"])(this, result); }; }

function _isNativeReflectConstruct() { if (typeof Reflect === "undefined" || !_Reflect$construct) return false; if (_Reflect$construct.sham) return false; if (typeof Proxy === "function") return true; try { Boolean.prototype.valueOf.call(_Reflect$construct(Boolean, [], function () {})); return true; } catch (e) { return false; } }

/** @typedef {import("../providers").WsProvider} WsProvider */

/** @typedef {import("../providers").HttpProvider} HttpProvider */

/** @typedef {"" | "eth" | "btc"} SidechainType */
var RegistrationAPI = /*#__PURE__*/function (_BaseEchoApi) {
  (0, _inherits2["default"])(RegistrationAPI, _BaseEchoApi);

  var _super = _createSuper(RegistrationAPI);

  /**
   * @constructor
   * @param {WsProvider | HttpProvider} provider
   */
  function RegistrationAPI(provider) {
    (0, _classCallCheck2["default"])(this, RegistrationAPI);
    return _super.call(this, provider, _wsConstants.CHAIN_API.REGISTRATION_API);
  }
  /**
   *  @method requestRegistrationTask
   *
   *  @return {Promise.<{block_id: String, rand_num: string, difficulty: number}>}
   */


  (0, _createClass2["default"])(RegistrationAPI, [{
    key: "requestRegistrationTask",
    value: function requestRegistrationTask() {
      return this.exec('request_registration_task', []);
    }
    /**
     *  @method submitRegistrationSolution
     *
     * 	@param {Function} callback
     * 	@param {String} name
     * 	@param {String} activeKey
     * 	@param {String} echorandKey
     * 	@param {String} evmAddress
     * 	@param {Number} nonce
     * 	@param {Number} randNum
     *
    	 *  @return {Promise}
     */

  }, {
    key: "submitRegistrationSolution",
    value: function submitRegistrationSolution(callback, name, activeKey, echorandKey, evmAddress, nonce, randNum) {
      return this.exec('submit_registration_solution', [callback, name, activeKey, echorandKey, evmAddress, nonce, randNum]);
    }
    /**
     *  @method getRegistrar
     *
    	 *  @return {Promise}
     */

  }, {
    key: "getRegistrar",
    value: function getRegistrar() {
      return this.exec('get_registrar', []);
    }
  }]);
  return RegistrationAPI;
}(_baseApi["default"]);

var _default = RegistrationAPI;
exports["default"] = _default;