"use strict";

var _typeof = require("@babel/runtime-corejs3/helpers/typeof");

var _WeakMap = require("@babel/runtime-corejs3/core-js-stable/weak-map");

var _Object$defineProperty = require("@babel/runtime-corejs3/core-js-stable/object/define-property");

var _Object$getOwnPropertyDescriptor = require("@babel/runtime-corejs3/core-js-stable/object/get-own-property-descriptor");

var _interopRequireDefault = require("@babel/runtime-corejs3/helpers/interopRequireDefault");

_Object$defineProperty(exports, "__esModule", {
  value: true
});

exports["default"] = void 0;

var _promise = _interopRequireDefault(require("@babel/runtime-corejs3/core-js-stable/promise"));

var _every = _interopRequireDefault(require("@babel/runtime-corejs3/core-js-stable/instance/every"));

var _isArray = _interopRequireDefault(require("@babel/runtime-corejs3/core-js-stable/array/is-array"));

var _some = _interopRequireDefault(require("@babel/runtime-corejs3/core-js-stable/instance/some"));

var _regenerator = _interopRequireDefault(require("@babel/runtime-corejs3/regenerator"));

var _asyncToGenerator2 = _interopRequireDefault(require("@babel/runtime-corejs3/helpers/asyncToGenerator"));

var _classCallCheck2 = _interopRequireDefault(require("@babel/runtime-corejs3/helpers/classCallCheck"));

var _createClass2 = _interopRequireDefault(require("@babel/runtime-corejs3/helpers/createClass"));

var serializers = _interopRequireWildcard(require("../../serializers"));

var _constants = require("../../constants");

var _WsProvider = _interopRequireDefault(require("../providers/WsProvider"));

var _validators = require("../../utils/validators");

function _getRequireWildcardCache(nodeInterop) { if (typeof _WeakMap !== "function") return null; var cacheBabelInterop = new _WeakMap(); var cacheNodeInterop = new _WeakMap(); return (_getRequireWildcardCache = function _getRequireWildcardCache(nodeInterop) { return nodeInterop ? cacheNodeInterop : cacheBabelInterop; })(nodeInterop); }

function _interopRequireWildcard(obj, nodeInterop) { if (!nodeInterop && obj && obj.__esModule) { return obj; } if (obj === null || _typeof(obj) !== "object" && typeof obj !== "function") { return { "default": obj }; } var cache = _getRequireWildcardCache(nodeInterop); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = _Object$defineProperty && _Object$getOwnPropertyDescriptor; for (var key in obj) { if (key !== "default" && Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? _Object$getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { _Object$defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj["default"] = obj; if (cache) { cache.set(obj, newObj); } return newObj; }

var _serializers$protocol = serializers.protocol,
    ethAddress = _serializers$protocol.ethAddress,
    accountListing = _serializers$protocol.accountListing;
var _serializers$collecti = serializers.collections,
    vector = _serializers$collecti.vector,
    optional = _serializers$collecti.optional;
var _serializers$chain = serializers.chain,
    privateKey = _serializers$chain.privateKey,
    publicKey = _serializers$chain.publicKey,
    ripemd160 = _serializers$chain.ripemd160;
var _serializers$protocol2 = serializers.protocol.asset,
    options = _serializers$protocol2.options,
    bitassetOptions = _serializers$protocol2.bitassetOptions;
var _serializers$protocol3 = serializers.protocol,
    price = _serializers$protocol3.price,
    authority = _serializers$protocol3.authority;
var config = serializers.plugins.echorand.config;
var _serializers$chain$id = serializers.chain.ids,
    anyObjectId = _serializers$chain$id.anyObjectId,
    operationHistoryId = _serializers$chain$id.operationHistoryId;
var _serializers$basic$in = serializers.basic.integers,
    uint64 = _serializers$basic$in.uint64,
    uint32 = _serializers$basic$in.uint32,
    int64 = _serializers$basic$in.int64,
    uint16 = _serializers$basic$in.uint16,
    uint8 = _serializers$basic$in.uint8,
    uint256 = _serializers$basic$in.uint256;
var _serializers$basic = serializers.basic,
    timePointSec = _serializers$basic.timePointSec,
    variantObject = _serializers$basic.variantObject,
    string = _serializers$basic.string,
    bool = _serializers$basic.bool;
var operation = serializers.operation,
    wallet = serializers.wallet,
    signedTransaction = serializers.signedTransaction,
    transaction = serializers.transaction;
var _serializers$chain$id2 = serializers.chain.ids.protocol,
    accountId = _serializers$chain$id2.accountId,
    contractId = _serializers$chain$id2.contractId,
    erc20TokenId = _serializers$chain$id2.erc20TokenId,
    proposalId = _serializers$chain$id2.proposalId,
    assetId = _serializers$chain$id2.assetId,
    committeeMemberId = _serializers$chain$id2.committeeMemberId;
/** @typedef {import("bignumber.js").BigNumber} BigNumber */

/**
 * @typedef {typeof import("../../serializers/transaction")['signedTransactionSerializer']} SignedTransactionSerializer
 */

/** @typedef {SignedTransactionSerializer['__TOutput__']} SignedTransaction */

/** @typedef {typeof import("../../serializers/chain")['ripemd160']['__TOutput__']} TransactionIdType */

/** @typedef {typeof import("../../serializers/chain")['asset']['__TOutput__']} Asset */

/** @typedef {typeof import("../../serializers/transaction")['default']} TransactionSerializer */

/** @typedef {TransactionSerializer['__TOutput__']} Transaction */

/** @typedef {typeof import("../../serializers")['operation']['__TOutput__']} Operation */

var WalletAPI = /*#__PURE__*/function () {
  function WalletAPI() {
    (0, _classCallCheck2["default"])(this, WalletAPI);
    this.wsProvider = new _WsProvider["default"]();
  }
  /**
   * Init params and connect to chain.
   * @param {string} url remote node address
   * @param {Parameters<WsProvider['connect']>1} connectionOptions connection params.
   * @returns {Promise<void>}
   */


  (0, _createClass2["default"])(WalletAPI, [{
    key: "connect",
    value: function () {
      var _connect = (0, _asyncToGenerator2["default"])( /*#__PURE__*/_regenerator["default"].mark(function _callee(url, connectionOptions) {
        return _regenerator["default"].wrap(function _callee$(_context) {
          while (1) {
            switch (_context.prev = _context.next) {
              case 0:
                _context.next = 2;
                return this.wsProvider.connect(url, connectionOptions);

              case 2:
              case "end":
                return _context.stop();
            }
          }
        }, _callee, this);
      }));

      function connect(_x, _x2) {
        return _connect.apply(this, arguments);
      }

      return connect;
    }()
    /**
     * Exit from current wallet.
     * @returns {Promise<never>}
     */

  }, {
    key: "exit",
    value: function exit() {
      return this.wsProvider.call([0, 'exit', []]);
    }
    /**
     * Returns a list of all commands supported by the wallet API or detailed help on a single API command.
     *
     * This lists each command, along with its arguments and return types.
     * @param {string} [method] the name of the API command you want help with or empty if you want to get all commands
     * @returns {Promise<string>} a multi-line string suitable for displaying on a terminal
     * @example ```ts
     * echo.walletApi.help("network_add_nodes");
     * ```
     */

  }, {
    key: "help",
    value: function () {
      var _help = (0, _asyncToGenerator2["default"])( /*#__PURE__*/_regenerator["default"].mark(function _callee2(method) {
        return _regenerator["default"].wrap(function _callee2$(_context2) {
          while (1) {
            switch (_context2.prev = _context2.next) {
              case 0:
                if (!(method !== undefined && !(0, _validators.isMethodExists)(method))) {
                  _context2.next = 2;
                  break;
                }

                throw new Error('Method does not exists');

              case 2:
                return _context2.abrupt("return", this.wsProvider.call([0, 'help', method !== undefined ? [method] : []]));

              case 3:
              case "end":
                return _context2.stop();
            }
          }
        }, _callee2, this);
      }));

      function help(_x3) {
        return _help.apply(this, arguments);
      }

      return help;
    }()
    /**
     * Returns info about head block, chain_id, maintenance, participation,
     * current active witnesses and committee members.
     * @returns {Promise<any>} runtime info about the blockchain
     */

  }, {
    key: "info",
    value: function info() {
      return this.wsProvider.call([0, 'info', []]);
    }
    /**
     * Returns info such as client version, git version of graphene/fc, version of boost, openssl.
     * @returns {Promise<any>} compile time info and client and dependencies versions
     */

  }, {
    key: "about",
    value: function about() {
      return this.wsProvider.call([0, 'about', []]);
    }
    /**
     * Add nodes to the network
     * @param {string} nodes nodes for adding
     * @returns {Promise<void>}
     */

  }, {
    key: "networkAddNodes",
    value: function networkAddNodes(nodes) {
      return this.wsProvider.call([0, 'network_add_nodes', [vector(string).toRaw(nodes)]]);
    }
    /**
     * Get peers connected to network.
     * @returns {Promise<any[]>} peers connected to network
     */

  }, {
    key: "networkGetConnectedPeers",
    value: function networkGetConnectedPeers() {
      return this.wsProvider.call([0, 'network_get_connected_peers', []]);
    }
    /**
     * Checks whether the wallet has just been created and has not yet had a password set.
     * Calling `set_password` will transition the wallet to the locked state.
     * @returns {Promise<boolean>} true if the wallet is new
     */

  }, {
    key: "isNew",
    value: function isNew() {
      return this.wsProvider.call([0, 'is_new', []]);
    }
    /**
     * Checks whether the wallet is locked (is unable to use its private keys).
     * This state can be changed by calling `lock()` or `unlock()`.
     * @returns {Promise<boolean>} true if the wallet is locked
     */

  }, {
    key: "isLocked",
    value: function isLocked() {
      return this.wsProvider.call([0, 'is_locked', []]);
    }
    /**
     * Locks the wallet immediately.
     * @returns {Promise<void>}
     */

  }, {
    key: "lock",
    value: function lock() {
      return this.wsProvider.call([0, 'lock', []]);
    }
    /**
     * Unlocks the wallet.
     * The wallet remain unlocked until the `lock` is called or the program exits.
     * @param {string} password the password previously set with `set_password()`,
     * in the wallet it should be input interactively
     * @returns {Promise<void>}
     */

  }, {
    key: "unlock",
    value: function unlock(password) {
      return this.wsProvider.call([0, 'unlock', [string.toRaw(password)]]);
    }
    /**
     * Sets a new password on the wallet.
     * The wallet must be either 'new' or 'unlocked' to execute this command.
     * @param {string} password the password, should be input automatically in the wallet
     * @returns {Promise<void>}
     */

  }, {
    key: "setPassword",
    value: function setPassword(password) {
      return this.wsProvider.call([0, 'set_password', [string.toRaw(password)]]);
    }
    /**
     * Create new EdDSA keypair encoded in base58.
     * @returns {Promise<[string, string]>} new private and public key
     */

  }, {
    key: "createEddsaKeypair",
    value: function createEddsaKeypair() {
      return this.wsProvider.call([0, 'create_eddsa_keypair', []]);
    }
    /**
     * Dumps all private keys owned by the wallet.
     * The keys are printed in WIF format. You can import these keys into another wallet using `import_key()`
     * @returns {Promise<[string, string][]>} a map containing the private keys, indexed by their public key
     */

  }, {
    key: "dumpPrivateKeys",
    value: function dumpPrivateKeys() {
      return this.wsProvider.call([0, 'dump_private_keys', []]);
    }
    /**
     * Imports the private key for an existing account.
     * The private key must match either an owner key or an active key for the named account.
     * @see {@link WalletAPI['dumpPrivateKeys']}
     * @param {string} accountNameOrId the account owning the key
     * @param {string} privateKeyWif the private key, should be input interactively
     * @returns {Promise<boolean>} true if the key was imported
     */

  }, {
    key: "importKey",
    value: function importKey(accountNameOrId, privateKeyWif) {
      if (!(0, _validators.isAccountIdOrName)(accountNameOrId)) {
        return _promise["default"].reject(new Error('Accounts id or name should be string and valid'));
      }

      return this.wsProvider.call([0, 'import_key', [string.toRaw(accountNameOrId), privateKey.toRaw(privateKeyWif)]]);
    }
    /**
     * Imports accounts from a blockchain wallet file. Current wallet file must be unlocked to perform the import.
     * @param {string} filename the blockchain wallet file to import
     * @param {string} password the password to encrypt the blockchain wallet file
     * @returns {[string, boolean][]} a map containing the accounts found and whether imported
     */

  }, {
    key: "importAccounts",
    value: function importAccounts(filename, password) {
      return this.wsProvider.call([0, 'import_accounts', [string.toRaw(filename), string.toRaw(password)]]);
    }
    /**
     * Imports from a blockchain wallet file, find keys that were bound to a given account name on
     * the blockchain, rebind them to an account name on the chain.
     * Current wallet file must be unlocked to perform the import.
     * @param {string} filename the blockchain wallet file to import
     * @param {string} password the password to encrypt the blockchain wallet file
     * @param {string} srcAccountName name of the account on blockchain
     * @param {string} destAccountName name of the account on blockchain, can be same or different
     * to `src_account_name`
     * @returns {Promise<boolean>} whether the import has succeeded
     */

  }, {
    key: "importAccountKeys",
    value: function importAccountKeys(filename, password, srcAccountName, destAccountName) {
      if (!(0, _validators.isAccountName)(srcAccountName)) {
        return _promise["default"].reject(new Error('srcAccount name should be string and valid'));
      }

      if (!(0, _validators.isAccountName)(destAccountName)) {
        return _promise["default"].reject(new Error('destAccount name should be string and valid'));
      }

      return this.wsProvider.call([0, 'import_account_keys', [string.toRaw(filename), string.toRaw(password), string.toRaw(srcAccountName), string.toRaw(destAccountName)]]);
    }
    /**
     * This call will construct transaction(s) that will claim all balances controlled
     * by 'wif_keys' and deposit them into the given account. 'wif_key' should be input interactively
     * @param {string} accountNameOrId name or ID of an account that to claim balances to
     * @param {boolean} shouldDoBroadcastToNetwork true to broadcast the transaction on the network
     * @param {string} wifKeys private WIF keys of balance objects to claim balances from
     * @returns {Promise<SignedTransaction>} the signed version of the transaction
     */

  }, {
    key: "importBalance",
    value: function importBalance(accountNameOrId, shouldDoBroadcastToNetwork, wifKeys) {
      if (!(0, _validators.isAccountIdOrName)(accountNameOrId)) {
        return _promise["default"].reject(new Error('Accounts id or name should be string and valid'));
      }

      return this.wsProvider.call([0, 'import_balance', [string.toRaw(accountNameOrId), bool.toRaw(shouldDoBroadcastToNetwork), vector(privateKey).toRaw(wifKeys)]]);
    }
    /**
     * Suggests a safe brain key to use for creating your account. `create_account_with_brain_key()` requires you
     * to specify a 'brain key', a long passphrase that provides enough entropy to generate cyrptographic keys.
     * This function will suggest a suitably random string that should be easy to write down
     * (and, with effort, memorize).
     * @returns {Promise<any>} a suggested brain_key
     */

  }, {
    key: "suggestBrainKey",
    value: function suggestBrainKey() {
      return this.wsProvider.call([0, 'suggest_brain_key', []]);
    }
    /**
     * Derive any number of *possible* owner keys from a given brain key.
     * NOTE: These keys may or may not match with the owner keys of any account.
     * This function is merely intended to assist with account or key recovery.
     * @see {@link WalletAPI['suggestBrainKey']}
     * @param {string} brainKey brain key
     * @param {number} numberOfDesiredKeys number of desired keys
     * @returns {Promise<any[]>} A list of keys that are deterministically derived from the brainkey
     */

  }, {
    key: "deriveKeysFromBrainKey",
    value: function deriveKeysFromBrainKey(brainKey, numberOfDesiredKeys) {
      if (numberOfDesiredKeys < 1) return _promise["default"].reject(new Error('Number should be positive integer'));
      return this.wsProvider.call([0, 'derive_keys_from_brain_key', [string.toRaw(brainKey), int64.toRaw(numberOfDesiredKeys)]]);
    }
    /**
     * Determine whether a textual representation of a public key (in Base-58 format) is *currently* linked
     * to any *registered* (i.e. non-stealth) account on the blockchain.
     * @param {string} accountPublicKey public key
     * @returns {Promise<boolean>} Whether a public key is known
     */

  }, {
    key: "isPublicKeyRegistered",
    value: function isPublicKeyRegistered(accountPublicKey) {
      return this.wsProvider.call([0, 'is_public_key_registered', [publicKey.toRaw(accountPublicKey)]]);
    }
    /**
     * This method is used to convert a JSON transaction to it's transaction ID.
     * @param {any} tr the singed transaction
     * @returns {Promise<TransactionIdType>} transaction id string
     */

  }, {
    key: "getTransactionId",
    value: function getTransactionId(tr) {
      return this.wsProvider.call([0, 'get_transaction_id', [signedTransaction.toRaw(tr)]]);
    }
  }, {
    key: "getTransactionById",
    value: function getTransactionById(trId) {
      return this.wsProvider.call([0, 'get_transaction_by_id', [ripemd160.toRaw(trId)]]);
    }
  }, {
    key: "getTransaction",
    value: function getTransaction(blockNumber, trIndex) {
      return this.wsProvider.call([0, 'get_transaction', [uint64.toRaw(blockNumber), uint64.toRaw(trIndex)]]);
    }
    /**
     * Get the WIF private key corresponding to a public key. The private key must already be in the wallet.
     * @param {string} accountPublicKey public key of an account
     * @returns {Promise<string>} private key of this account
     */

  }, {
    key: "getPrivateKey",
    value: function getPrivateKey(accountPublicKey) {
      return this.wsProvider.call([0, 'get_private_key', [publicKey.toRaw(accountPublicKey)]]);
    }
    /**
     * Loads a specified Graphene wallet. The current wallet is closed before the new wallet is loaded.
     *
     * **WARNING:** This does not change the filename that will be used for future wallet writes,
     * so this may cause you to overwrite your original wallet unless you also call `setWalletFilename` method
     * @param {string} walletFilename the filename of the wallet JSON file to load.
     * If `wallet_filename` is empty, it reloads the existing wallet file
     * @returns {Promise<boolean>} true if the specified wallet is loaded
     */

  }, {
    key: "loadWalletFile",
    value: function loadWalletFile(walletFilename) {
      return this.wsProvider.call([0, 'load_wallet_file', [string.toRaw(walletFilename)]]);
    }
    /**
     * Transforms a brain key to reduce the chance of errors when re-entering the key from memory.
     * This takes a user-supplied brain key and normalizes it into the form used for generating private keys.
     * In particular, this upper-cases all ASCII characters and collapses multiple spaces into one.
     * @param {string} brainKey the brain key as supplied by the user
     * @returns {Promise<string>} the brain key in its normalized form
     */

  }, {
    key: "normalizeBrainKey",
    value: function normalizeBrainKey(brainKey) {
      return this.wsProvider.call([0, 'normalize_brain_key', [string.toRaw(brainKey)]]);
    }
    /**
     * Saves the current wallet to the given filename.
     *
     * **WARNING:** This does not change the wallet filename that will be used for future writes,
     * so think of this function as 'Save a Copy As...' instead of 'Save As...'.
     * Use `setWalletFilename` method to make the filename persist.
     * @param {string} walletFilename the filename of the new wallet JSON file to create or overwrite.
     * If `wallet_filename` is empty, save to the current filename
     * @returns {Promise<void>}
     */

  }, {
    key: "saveWalletFile",
    value: function saveWalletFile(walletFilename) {
      return this.wsProvider.call([0, 'save_wallet_file', [string.toRaw(walletFilename)]]);
    }
    /**
     * Lists all accounts controlled by this wallet.
     * This returns a list of the full account objects for all accounts whose private keys we possess.
     * @returns {Promise<any[]>} a list of account objects
     */

  }, {
    key: "listMyAccounts",
    value: function listMyAccounts() {
      return this.wsProvider.call([0, 'list_my_accounts', []]);
    }
    /**
     * Lists all accounts registered in the blockchain.
     * This returns a list of all account names and their account ids, sorted by account name.
     * Use the `lowerbound` and limit parameters to page through the list. To retrieve all accounts,
     * start by setting `lowerbound` to the empty string `""`, and then each iteration, pass
     * the last account name returned as the `lowerbound` for the next `listAccounts` call.
     * @param {string} lowerbound the name of the first account to return. If the named account does not exist,
     * the list will start at the account that comes after `lowerbound`
     * @param {number} limit limit the maximum number of accounts to return (max: 1000)
     * @returns {Promise<[string, string][]>} a list of accounts mapping account names to account ids
     */

  }, {
    key: "listAccounts",
    value: function listAccounts(lowerbound) {
      var limit = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : _constants.API_CONFIG.LIST_ACCOUNTS_DEFAULT_LIMIT;
      if (!(0, _validators.isAccountName)(lowerbound)) return _promise["default"].reject(new Error('Account name should be string and valid'));

      if (!limit > _constants.API_CONFIG.LIST_ACCOUNTS_MAX_LIMIT) {
        return _promise["default"].reject(new Error("Limit should be capped at ".concat(_constants.API_CONFIG.LIST_ACCOUNTS_MAX_LIMIT)));
      }

      return this.wsProvider.call([0, 'list_accounts', [string.toRaw(lowerbound), uint32.toRaw(limit)]]);
    }
    /**
     * List the balances of an account or a contract.
     * @param {string} accountNameOrId id the id of either an account or a contract
     * @returns {Promise<Asset[]>} a list of the given account/contract balances
     */

  }, {
    key: "listAccountBalances",
    value: function listAccountBalances(accountNameOrId) {
      if (!(0, _validators.isAccountIdOrName)(accountNameOrId)) {
        return _promise["default"].reject(new Error('Accounts id or name should be string and valid'));
      }

      return this.wsProvider.call([0, 'list_account_balances', [string.toRaw(accountNameOrId)]]);
    }
    /**
     * List the balances of an account or a contract.
     * @param {string} idOfAccount id the id of either an account or a contract
     * @returns {Promise<Asset[]>} a list of the given account/contract balances
     */

  }, {
    key: "listIdBalances",
    value: function listIdBalances(idOfAccount) {
      return this.wsProvider.call([0, 'list_id_balances', [accountId.toRaw(idOfAccount)]]);
    }
    /**
     * Registers a third party's account on the blockckain.
     * This function is used to register an account for which you do not own the private keys.
     * When acting as a registrar, an end user will generate their own private keys and send you the public keys.
     * The registrar will use this function to register the account on behalf of the end user.
     * @see {@link WalletAPI['createAccountWithBrainKey']}
     * @param {string} name the name of the account, must be unique on the blockchain.
     * Shorter names are more expensive to register; the rules are still in flux,
     * but in general names of more than 8 characters with at least one digit will be cheap
     * @param {string} activeKey the active key for the new account
     * @param {string} accountNameOrId the account which will pay the fee to register the user
     * @param {boolean} shouldDoBroadcastToNetwork true to broadcast the transaction on the network
     * @returns {Promise<SignedTransaction>} the signed transaction registering the account
     */

  }, {
    key: "registerAccount",
    value: function registerAccount(name, activeKey, accountNameOrId, shouldDoBroadcastToNetwork) {
      if (!(0, _validators.isAccountName)(name)) return _promise["default"].reject(new Error('Name should be string and valid'));

      if (!(0, _validators.isAccountIdOrName)(accountNameOrId)) {
        return _promise["default"].reject(new Error('Accounts id or name should be string and valid'));
      }

      return this.wsProvider.call([0, 'register_account', [string.toRaw(name), publicKey.toRaw(activeKey), string.toRaw(accountNameOrId), bool.toRaw(shouldDoBroadcastToNetwork)]]);
    }
    /**
     * Creates a new account and registers it on the blockchain.
     * @see WalletApi["suggestBrainKey"]
     * @param {string} brainKey the brain key used for generating the account's private keys
     *
     * @param {string} accountName
     * the name of the account, must be unique on the blockchain. Shorter names are more expensive to register; the
     * rules are still in flux, but in general names of more than 8 characters with at least one digit will be cheap.
     *
     * @param {string} registrarAccount the account which will pay the fee to register the user
     * @param {Object} [_optional]
     *
     * @param {string | null} [_optional.evmAddress]
     * the ethereum address of the account, enter null if you don't want to create
     *
     * @param {boolean} [_optional.broadcast] true to broadcast the transaction on the network
     * @param {boolean} [_optional.saveWallet] true to save in wallet
     * @returns {Promise<SignedTransaction>} the signed transaction registering the account
     *
     * @example
     * ```ts
     * echo.walletApi.createAccountWithBrainKey("brain_key", "new_acc", "nathan", {
     *   evmAddress: "E8fd4Db0C38d48493AD167A268683fAb7230a88A",
     *   broadcast: true,
     * });
     * ```
     */

  }, {
    key: "createAccountWithBrainKey",
    value: function () {
      var _createAccountWithBrainKey = (0, _asyncToGenerator2["default"])( /*#__PURE__*/_regenerator["default"].mark(function _callee3(brainKey, accountName, registrarAccount) {
        var _optional,
            evmAddress,
            broadcast,
            saveWallet,
            _args3 = arguments;

        return _regenerator["default"].wrap(function _callee3$(_context3) {
          while (1) {
            switch (_context3.prev = _context3.next) {
              case 0:
                _optional = _args3.length > 3 && _args3[3] !== undefined ? _args3[3] : {};
                evmAddress = _optional.evmAddress, broadcast = _optional.broadcast, saveWallet = _optional.saveWallet;

                if ((0, _validators.isAccountName)(accountName)) {
                  _context3.next = 4;
                  break;
                }

                return _context3.abrupt("return", _promise["default"].reject(new Error('Name should be string and valid')));

              case 4:
                if ((0, _validators.isAccountIdOrName)(registrarAccount)) {
                  _context3.next = 6;
                  break;
                }

                throw new Error('Accounts id or name should be string and valid');

              case 6:
                if (!(evmAddress && !(0, _validators.isEthereumAddress)(evmAddress))) {
                  _context3.next = 8;
                  break;
                }

                throw new Error('Invalid evm address format');

              case 8:
                return _context3.abrupt("return", this.wsProvider.call([0, 'create_account_with_brain_key', [brainKey, accountName, registrarAccount, evmAddress || null, broadcast || null, saveWallet || null]]));

              case 9:
              case "end":
                return _context3.stop();
            }
          }
        }, _callee3, this);
      }));

      function createAccountWithBrainKey(_x4, _x5, _x6) {
        return _createAccountWithBrainKey.apply(this, arguments);
      }

      return createAccountWithBrainKey;
    }()
    /**
     * Upload/Create a contract.
     * @param {string} accountNameOrId name of the account creating the contract
     * @param {string} contractCode code of the contract
     * @param {number|string|BigNumber} amount the amount of asset transferred to the contract
     * @param {string} assetType the type of the asset transferred to the contract
     * @param {string} supportedAssetId the asset that can be used to create/call the contract
     * (see https://echo-dev.io/developers/smart-contracts/solidity/introduction/#flag-of-supported-asset)
     * @param {boolean} useEthereumAssetAccuracy whether to use the ethereum asset accuracy
     * (see https://echo-dev.io/developers/smart-contracts/solidity/introduction/#flag-of-using-ethereum-accuracy)
     * @returns {Promise<any>} the signed transaction creating the contract
     */

  }, {
    key: "createContract",
    value: function () {
      var _createContract = (0, _asyncToGenerator2["default"])( /*#__PURE__*/_regenerator["default"].mark(function _callee4(accountNameOrId, contractCode, amount, assetType, supportedAssetId, useEthereumAssetAccuracy) {
        return _regenerator["default"].wrap(function _callee4$(_context4) {
          while (1) {
            switch (_context4.prev = _context4.next) {
              case 0:
                if ((0, _validators.isAccountIdOrName)(accountNameOrId)) {
                  _context4.next = 2;
                  break;
                }

                throw new Error('Accounts id or name should be string and valid');

              case 2:
                if ((0, _validators.isContractCode)(contractCode)) {
                  _context4.next = 4;
                  break;
                }

                throw new Error('Byte code should be string and valid');

              case 4:
                amount = (0, _validators.validateAmount)(amount);
                return _context4.abrupt("return", this.wsProvider.call([0, 'create_contract', [string.toRaw(accountNameOrId), string.toRaw(contractCode), string.toRaw(amount), assetId.toRaw(assetType), assetId.toRaw(supportedAssetId), bool.toRaw(useEthereumAssetAccuracy)]]));

              case 6:
              case "end":
                return _context4.stop();
            }
          }
        }, _callee4, this);
      }));

      function createContract(_x7, _x8, _x9, _x10, _x11, _x12) {
        return _createContract.apply(this, arguments);
      }

      return createContract;
    }()
    /**
     * Call a contract.
     * @param {string} accountNameOrId name of the account calling the contract
     * @param {string} idOfContract the id of the contract to call
     * @param {string} contractCode the hash of the method to call
     * @param {number|BigNumber|string} amount the amount of asset transferred to the contract
     * @param {string} assetType the type of the asset transferred to the contract
     * @returns {Promise<any>} the signed transaction calling the contract
     */

  }, {
    key: "callContract",
    value: function () {
      var _callContract = (0, _asyncToGenerator2["default"])( /*#__PURE__*/_regenerator["default"].mark(function _callee5(accountNameOrId, idOfContract, contractCode, amount, assetType) {
        return _regenerator["default"].wrap(function _callee5$(_context5) {
          while (1) {
            switch (_context5.prev = _context5.next) {
              case 0:
                if ((0, _validators.isAccountIdOrName)(accountNameOrId)) {
                  _context5.next = 2;
                  break;
                }

                throw new Error('Accounts id or name should be string and valid');

              case 2:
                if ((0, _validators.isContractCode)(contractCode)) {
                  _context5.next = 4;
                  break;
                }

                throw new Error('Byte code should be string and valid');

              case 4:
                amount = (0, _validators.validateAmount)(amount);
                return _context5.abrupt("return", this.wsProvider.call([0, 'call_contract', [string.toRaw(accountNameOrId), contractId.toRaw(idOfContract), string.toRaw(contractCode), string.toRaw(amount), assetId.toRaw(assetType)]]));

              case 6:
              case "end":
                return _context5.stop();
            }
          }
        }, _callee5, this);
      }));

      function callContract(_x13, _x14, _x15, _x16, _x17) {
        return _callContract.apply(this, arguments);
      }

      return callContract;
    }()
    /**
     * Fund feepool of contract.
     * @param {string} accountNameOrId name of the account which fund contract's feepool
     * @param {string} idOfContract the id of the contract's feepool
     * @param {number} amount the amount of asset transferred to the contract in default `asset_id_type()`
     * @param {boolean} shouldDoBroadcastToNetwork whether to broadcast the fund contract operation to the network
     * @returns {Promise<SignedTransaction>} the signed version of the transaction
     */

  }, {
    key: "contractFundFeePool",
    value: function contractFundFeePool(accountNameOrId, idOfContract, amount, shouldDoBroadcastToNetwork) {
      if (!(0, _validators.isAccountIdOrName)(accountNameOrId)) {
        return _promise["default"].reject(new Error('Accounts id or name should be string and valid'));
      }

      return this.wsProvider.call([0, 'contract_fund_fee_pool', [string.toRaw(accountNameOrId), contractId.toRaw(idOfContract), uint64.toRaw(amount), bool.toRaw(shouldDoBroadcastToNetwork)]]);
    }
    /**
     * Get the result of contract execution.
     * @param {string} contractResultId the id of the contract result
     * @returns {Promise<any>} the result of the contract
     */

  }, {
    key: "getContractResult",
    value: function getContractResult(contractResultId) {
      if (!(0, _validators.isContractResultId)(contractResultId)) {
        return _promise["default"].reject(new Error('Contract resultId should be string and valid'));
      }

      return this.wsProvider.call([0, 'get_contract_result', [string.toRaw(contractResultId)]]);
    }
    /**
     * Returns the most recent operations on the contract id.
     *
     * This returns a list of operation history objects, which describe activity on the contract.
     * @param {typeof contractId["__TInput__"]} _contractId the ID of the contract
     * @param {typeof uint32["__TInput__"]} limit the number of entries to return (starting from the most recent)
     * @returns {Promise<unknown[]>} a list of accounts mapping account names to account ids
     */

  }, {
    key: "getContractHistory",
    value: function () {
      var _getContractHistory = (0, _asyncToGenerator2["default"])( /*#__PURE__*/_regenerator["default"].mark(function _callee6(_contractId, limit) {
        return _regenerator["default"].wrap(function _callee6$(_context6) {
          while (1) {
            switch (_context6.prev = _context6.next) {
              case 0:
                return _context6.abrupt("return", this.wsProvider.call([0, 'get_contract_history', [contractId.toRaw(_contractId), uint32.toRaw(limit)]]));

              case 1:
              case "end":
                return _context6.stop();
            }
          }
        }, _callee6, this);
      }));

      function getContractHistory(_x18, _x19) {
        return _getContractHistory.apply(this, arguments);
      }

      return getContractHistory;
    }()
    /**
     * Returns the relative operations on the id contract from start number
     * @param {typeof contractId["__TInput__"]} _contractId the ID of the contract
     * @param {typeof uint32["__TInput__"]} stop Sequence number of earliest operation
     * @param {typeof uint32["__TInput__"]} limit the number of entries to return
     * @param {typeof uint32["__TInput__"]} start the sequence number where to start looping back throw the history
     * @returns {Promise<unknown[]>} a list of operation history objects
     */

  }, {
    key: "getRelativeContractHistory",
    value: function () {
      var _getRelativeContractHistory = (0, _asyncToGenerator2["default"])( /*#__PURE__*/_regenerator["default"].mark(function _callee7(_contractId, stop, limit, start) {
        return _regenerator["default"].wrap(function _callee7$(_context7) {
          while (1) {
            switch (_context7.prev = _context7.next) {
              case 0:
                return _context7.abrupt("return", this.wsProvider.call([0, 'get_relative_contract_history', [contractId.toRaw(_contractId), uint32.toRaw(stop), uint32.toRaw(limit), uint32.toRaw(start)]]));

              case 1:
              case "end":
                return _context7.stop();
            }
          }
        }, _callee7, this);
      }));

      function getRelativeContractHistory(_x20, _x21, _x22, _x23) {
        return _getRelativeContractHistory.apply(this, arguments);
      }

      return getRelativeContractHistory;
    }()
    /**
     * Transfer an amount from one account to another.
     * @param {string} fromAccountNameOrId the name or id of the account sending the funds
     * @param {string} toAccountNameOrId the name or id of the account receiving the funds
     * @param {string} amount the amount to send (in nominal units -- to send half of a BTS, specify 0.5)
     * @param {string} assetIdOrName the symbol or id of the asset to send
     * @param {boolean} shouldDoBroadcastToNetwork true to broadcast the transaction on the network
     * @returns {Promise<SignedTransaction>} the signed transaction transferring funds
     */

  }, {
    key: "transfer",
    value: function transfer(fromAccountNameOrId, toAccountNameOrId, amount, assetIdOrName, shouldDoBroadcastToNetwork) {
      if (!(0, _validators.isAccountIdOrName)(fromAccountNameOrId)) {
        return _promise["default"].reject(new Error('Accounts id or name should be string and valid'));
      }

      if (!(0, _validators.isAccountIdOrName)(toAccountNameOrId)) {
        return _promise["default"].reject(new Error('Accounts id or name should be string and valid'));
      }

      if (!(0, _validators.isValidAmount)(amount)) return _promise["default"].reject(new Error('Invalid number'));

      if (!(0, _validators.isAssetIdOrName)(assetIdOrName)) {
        return _promise["default"].reject(new Error('Assets id or name should be string and valid'));
      }

      return this.wsProvider.call([0, 'transfer', [string.toRaw(fromAccountNameOrId), string.toRaw(toAccountNameOrId), string.toRaw(amount), string.toRaw(assetIdOrName), bool.toRaw(shouldDoBroadcastToNetwork)]]);
    }
    /**
     * Transfer an amount from one account to address.
     * @param {string} fromAccountNameOrId the name or id of the account sending the funds
     * @param {string} address address in form of ripemd160 hash
     * @param {string} amount the amount to send (in nominal units -- to send half of a BTS, specify 0.5)
     * @param {string} assetIdOrName the symbol or id of the asset to send
     * @param {boolean} shouldDoBroadcastToNetwork true to broadcast the transaction on the network
     * @returns {Promise<SignedTransaction>} the signed transaction transferring funds
     */

  }, {
    key: "transferToAddress",
    value: function transferToAddress(fromAccountNameOrId, address, amount, assetIdOrName, shouldDoBroadcastToNetwork) {
      if (!(0, _validators.isAccountIdOrName)(fromAccountNameOrId)) {
        return _promise["default"].reject(new Error('Accounts id or name should be string and valid'));
      }

      if (!(0, _validators.isRipemd160)(address)) {
        return _promise["default"].reject(new Error('Address should be ripemd160 hash'));
      }

      if (!(0, _validators.isValidAmount)(amount)) return _promise["default"].reject(new Error('Invalid number'));

      if (!(0, _validators.isAssetIdOrName)(assetIdOrName)) {
        return _promise["default"].reject(new Error('Assets id or name should be string and valid'));
      }

      return this.wsProvider.call([0, 'transfer_to_address', [string.toRaw(fromAccountNameOrId), ripemd160.toRaw(address), string.toRaw(amount), string.toRaw(assetIdOrName), bool.toRaw(shouldDoBroadcastToNetwork)]]);
    }
    /**
     * This method works just like transfer, except it always broadcasts and
     * returns the transaction ID along with the signed transaction.
     * @param {string} fromAccountNameOrId the name or id of the account sending the funds
     * @param {string} toAccountNameOrId the name or id of the account receiving the funds
     * @param {string} amount the amount to send (in nominal units -- to send half of a BTS, specify 0.5)
     * @param {string} assetIdOrName the symbol or id of the asset to send
     * @returns {Promise<any[]>} the transaction ID along with the signed transaction
     */

  }, {
    key: "transfer2",
    value: function transfer2(fromAccountNameOrId, toAccountNameOrId, amount, assetIdOrName) {
      if (!(0, _validators.isAccountIdOrName)(fromAccountNameOrId)) {
        return _promise["default"].reject(new Error('Accounts id or name should be string and valid'));
      }

      if (!(0, _validators.isAccountIdOrName)(toAccountNameOrId)) {
        return _promise["default"].reject(new Error('Accounts id or name should be string and valid'));
      }

      if (!(0, _validators.isValidAmount)(amount)) return _promise["default"].reject(new Error('Invalid number'));

      if (!(0, _validators.isAssetIdOrName)(assetIdOrName)) {
        return _promise["default"].reject(new Error('Assets id or name should be string and valid'));
      }

      return this.wsProvider.call([0, 'transfer2', [string.toRaw(fromAccountNameOrId), string.toRaw(toAccountNameOrId), string.toRaw(amount), string.toRaw(assetIdOrName)]]);
    }
    /**
     * Whitelist and blacklist accounts, primarily for transacting in whitelisted assets.
     * Accounts can freely specify opinions about other accounts, in the form of either whitelisting or blacklisting
     * them. This information is used in chain validation only to determine whether an account is authorized to transact
     * in an asset type which enforces a whitelist, but third parties can use this information for other uses as well,
     * as long as it does not conflict with the use of whitelisted assets.
     *
     * An asset which enforces a whitelist specifies a list of accounts to maintain its whitelist, and a list of
     * accounts to maintain its blacklist. In order for a given account A to hold and transact in a whitelisted asset S,
     * A must be whitelisted by at least one of S's whitelist_authorities and blacklisted by none of S's
     * blacklist_authorities. If A receives a balance of S, and is later removed from the whitelist(s) which allowed it
     * to hold S, or added to any blacklist S specifies as authoritative, A's balance of S will be frozen until A's
     * authorization is reinstated.
     * @param {string} authorizingAccount the account who is doing the whitelisting
     * @param {string} accountToList the account being whitelisted
     * @param {number} newListingStatus the new whitelisting status
     * @param {boolean} shouldDoBroadcastToNetwork true to broadcast the transaction on the network
     * @returns {Promise<SignedTransaction>} the signed transaction changing the whitelisting status
     */

  }, {
    key: "whitelistAccount",
    value: function whitelistAccount(authorizingAccount, accountToList, newListingStatus, shouldDoBroadcastToNetwork) {
      if (!(0, _validators.isAccountIdOrName)(authorizingAccount)) {
        return _promise["default"].reject(new Error('Accounts id or name should be string and valid'));
      }

      if (!(0, _validators.isAccountIdOrName)(accountToList)) {
        return _promise["default"].reject(new Error('Accounts id or name should be string and valid'));
      }

      return this.wsProvider.call([0, 'whitelist_account', [string.toRaw(authorizingAccount), string.toRaw(accountToList), accountListing.toRaw(newListingStatus), bool.toRaw(shouldDoBroadcastToNetwork)]]);
    }
    /**
     * @method updateAccount
     * @param {string} account Id or account name
     * @param {any} newOptions variant options
     * @param {boolean} shouldDoBroadcastToNetwork true to broadcast the transaction on the network
     * @param {any} newActive new active
     * @param {string} newEchorandKey new echorand key
     * @returns {Promise<SignedTransaction>} the signed transaction
     */

  }, {
    key: "updateAccount",
    value: function updateAccount(account, newOptions, shouldDoBroadcastToNetwork, newActive, newEchorandKey) {
      if (!(0, _validators.isAccountIdOrName)(account)) {
        return _promise["default"].reject(new Error('Accounts id or name should be string and valid'));
      }

      if (!(0, _validators.isPublicKey)(newEchorandKey)) {
        return _promise["default"].reject(new Error('New echorand key should be string and valid'));
      }

      return this.wsProvider.call([0, 'update_account', [string.toRaw(account), variantObject.toRaw(newOptions), bool.toRaw(shouldDoBroadcastToNetwork), optional(authority).toRaw(newActive), optional(publicKey).toRaw(newEchorandKey)]]);
    }
    /**
     * Get information about a vesting balance object.
     * @param {string} accountNameOrId an account name, account ID, or vesting balance object ID
     * @returns {Promise<any[]>} vesting balance object with info
     */

  }, {
    key: "getVestingBalances",
    value: function getVestingBalances(accountNameOrId) {
      if (!(0, _validators.isAccountIdOrName)(accountNameOrId)) {
        return _promise["default"].reject(new Error('Accounts id or name should be string and valid'));
      }

      return this.wsProvider.call([0, 'get_vesting_balances', [string.toRaw(accountNameOrId)]]);
    }
    /**
     * Withdraw a vesting balance.
     * @param {string} witnessAccountNameOrId the account name of the witness, also accepts account ID or
     * vesting balance ID type
     * @param {string} amount the amount to withdraw
     * @param {string} assetSymbol the symbol of the asset to withdraw
     * @param {boolean} shouldDoBroadcastToNetwork true if you wish to broadcast the transaction
     * @returns {Promise<SignedTransaction>} the signed version of the transaction
     */

  }, {
    key: "withdrawVesting",
    value: function withdrawVesting(witnessAccountNameOrId, amount, assetSymbol, shouldDoBroadcastToNetwork) {
      if (!(0, _validators.isAccountIdOrName)(witnessAccountNameOrId)) {
        return _promise["default"].reject(new Error('Accounts id or name should be string and valid'));
      }

      if (!(0, _validators.isValidAmount)(amount)) {
        return _promise["default"].reject(new Error('Invalid amount'));
      }

      return this.wsProvider.call([0, 'withdraw_vesting', [string.toRaw(witnessAccountNameOrId), string.toRaw(amount), string.toRaw(assetSymbol), bool.toRaw(shouldDoBroadcastToNetwork)]]);
    }
    /**
     * Returns information about the given account.
     * @param {string} accountNameOrId returns information about the given account
     * @returns {Promise<any>} the public account data stored in the blockchain
     */

  }, {
    key: "getAccount",
    value: function getAccount(accountNameOrId) {
      if (!(0, _validators.isAccountIdOrName)(accountNameOrId)) {
        return _promise["default"].reject(new Error('Accounts id or name should be string and valid'));
      }

      return this.wsProvider.call([0, 'get_account', [string.toRaw(accountNameOrId)]]);
    }
    /**
     * Lookup the id of a named account.
     * @param {string} accountName the name of the account to look up
     * @returns {Promise<string>} the id of the named account
     */

  }, {
    key: "getAccountId",
    value: function getAccountId(accountName) {
      if (!(0, _validators.isAccountName)(accountName)) return _promise["default"].reject(new Error('Account name should be string and valid'));
      return this.wsProvider.call([0, 'get_account_id', [string.toRaw(accountName)]]);
    }
    /**
     * Returns the most recent operations on the named account.
     * This returns a list of operation history objects, which describe activity on the account.
     * @param {string} accountIdOrName the name or id of the account
     * @param {number} limit the number of entries to return (starting from the most recent)
     * @returns {Promise<any[]>} a list of operation history objects
     */

  }, {
    key: "getAccountHistory",
    value: function getAccountHistory(accountIdOrName) {
      var limit = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : _constants.API_CONFIG.ACCOUNT_HISTORY_DEFAULT_LIMIT;

      if (!(0, _validators.isAccountIdOrName)(accountIdOrName)) {
        return _promise["default"].reject(new Error('Accounts id or name should be string and valid'));
      }

      if (!limit > _constants.API_CONFIG.ACCOUNT_HISTORY_MAX_LIMIT) {
        return _promise["default"].reject(new Error("Limit should be capped at ".concat(_constants.API_CONFIG.ACCOUNT_HISTORY_MAX_LIMIT)));
      }

      return this.wsProvider.call([0, 'get_account_history', [string.toRaw(accountIdOrName), int64.toRaw(limit)]]);
    }
    /**
     * Returns the relative operations on the named account from start number.
     * @param {string} accountIdOrName the name or id of the account
     * @param {number} stop sequence number of earliest operation
     * @param {number} limit the number of entries to return (max 100)
     * @param {number} start the sequence number where to start looping back throw the history
     * @returns {Promise<any[]>} a list of operation history objects
     */

  }, {
    key: "getRelativeAccountHistory",
    value: function () {
      var _getRelativeAccountHistory = (0, _asyncToGenerator2["default"])( /*#__PURE__*/_regenerator["default"].mark(function _callee8(accountIdOrName) {
        var stop,
            limit,
            start,
            _args8 = arguments;
        return _regenerator["default"].wrap(function _callee8$(_context8) {
          while (1) {
            switch (_context8.prev = _context8.next) {
              case 0:
                stop = _args8.length > 1 && _args8[1] !== undefined ? _args8[1] : _constants.API_CONFIG.RELATIVE_ACCOUNT_HISTORY_STOP;
                limit = _args8.length > 2 && _args8[2] !== undefined ? _args8[2] : _constants.API_CONFIG.RELATIVE_ACCOUNT_HISTORY_DEFAULT_LIMIT;
                start = _args8.length > 3 && _args8[3] !== undefined ? _args8[3] : _constants.API_CONFIG.RELATIVE_ACCOUNT_HISTORY_START;

                if ((0, _validators.isAccountIdOrName)(accountIdOrName)) {
                  _context8.next = 5;
                  break;
                }

                return _context8.abrupt("return", _promise["default"].reject(new Error('Accounts id or name should be string and valid')));

              case 5:
                if (!(!limit > _constants.API_CONFIG.RELATIVE_ACCOUNT_HISTORY_MAX_LIMIT)) {
                  _context8.next = 7;
                  break;
                }

                return _context8.abrupt("return", _promise["default"].reject(new Error("Limit should be less ".concat(_constants.API_CONFIG.RELATIVE_ACCOUNT_HISTORY_MAX_LIMIT))));

              case 7:
                return _context8.abrupt("return", this.wsProvider.call([0, 'get_relative_account_history', [string.toRaw(accountIdOrName), uint64.toRaw(stop), int64.toRaw(limit), uint64.toRaw(start)]]));

              case 8:
              case "end":
                return _context8.stop();
            }
          }
        }, _callee8, this);
      }));

      function getRelativeAccountHistory(_x24) {
        return _getRelativeAccountHistory.apply(this, arguments);
      }

      return getRelativeAccountHistory;
    }()
    /**
     * Get the contract object from the database by it's id.
     * @param {string} idOfContract the id of the contract
     * @returns {Promise<any>} the contract object
     */

  }, {
    key: "getContractObject",
    value: function getContractObject(idOfContract) {
      return this.wsProvider.call([0, 'get_contract_object', [contractId.toRaw(idOfContract)]]);
    }
    /**
     * Get the contract information by the contract's id.
     * @param {string} idOfContract id of the contract
     * @returns {Promise<any>} the contract information
     */

  }, {
    key: "getContract",
    value: function getContract(idOfContract) {
      return this.wsProvider.call([0, 'get_contract', [contractId.toRaw(idOfContract)]]);
    }
    /**
     * Whitelist or blacklist contract pool.
     * @param {string} accountIdOrName is an owner of contract which perform whitelisting or blacklisting
     * @param {string} idOfContract whitelisting or blacklisting applying for this contract
     * @param {string} addToWhitelist leave it empty if you don't want to add some account to whitelist
     * @param {string} addToBlacklist leave it empty if you don't want to add some account to blacklist
     * @param {string} removeFromWhitelist leave it empty if you don't want to remove some account
     * from whitelist
     * @param {string} removeFromBlacklist leave it empty if you don't want to remove some account
     * from blacklist
     * @param {boolean} shouldDoBroadcastToNetwork true if you wish to broadcast the contract whitelist operation
     * @returns {Promise<SignedTransaction>} the signed version of the transaction
     */

  }, {
    key: "whitelistContractPool",
    value: function whitelistContractPool(accountIdOrName, idOfContract, addToWhitelist, addToBlacklist, removeFromWhitelist, removeFromBlacklist, shouldDoBroadcastToNetwork) {
      if (!(0, _validators.isAccountIdOrName)(accountIdOrName)) {
        return _promise["default"].reject(new Error('Accounts id or name should be string and valid'));
      }

      return this.wsProvider.call([0, 'whitelist_contract_pool', [string.toRaw(accountIdOrName), contractId.toRaw(idOfContract), vector(accountId).toRaw(addToWhitelist), vector(accountId).toRaw(addToBlacklist), vector(accountId).toRaw(removeFromWhitelist), vector(accountId).toRaw(removeFromBlacklist), bool.toRaw(shouldDoBroadcastToNetwork)]]);
    }
    /**
     * Call a contract. Same as `callContract` method but doesn't change the state.
     * @param {string} idOfContract the id of the contract to call
     * @param {string} caller contract id or account name or id calling the contract
     * @param {string} amount amount in ECHO. 1 ECHO is 100000000
     * @param {string} assetType the type of the asset transfered to the contract
     * @param {string} codeOfTheContract the hash of the method to call
     * @returns {Promise<string>}
     */

  }, {
    key: "callContractNoChangingState",
    value: function callContractNoChangingState(idOfContract, caller, amount, assetType, codeOfTheContract) {
      if (!(0, _validators.isAccountIdOrName)(caller)) {
        return _promise["default"].reject(new Error('Accounts id or name should be string and valid'));
      }

      if (!(0, _validators.isContractCode)(codeOfTheContract)) {
        return _promise["default"].reject(new Error('Byte code should be string and valid'));
      }

      return this.wsProvider.call([0, 'call_contract_no_changing_state', [contractId.toRaw(idOfContract), string.toRaw(caller), string.toRaw(amount), string.toRaw(assetType), string.toRaw(codeOfTheContract)]]);
    }
    /**
     * Get contract's feepool balance.
     * @param {string} idOfContract id for getting feepool balance
     * @returns {Promise<Asset>} contract's feepool balance
     */

  }, {
    key: "getContractPoolBalance",
    value: function getContractPoolBalance(idOfContract) {
      return this.wsProvider.call([0, 'get_contract_pool_balance', [contractId.toRaw(idOfContract)]]);
    }
    /**
     * Get contract's whitelist and blacklist.
     * @param {string} idOfContract id for getting whitelist and blacklist of feepool object
     * @returns {Promise<any>} whitelist and blacklist of contract pool object
     */

  }, {
    key: "getContractPoolWhitelist",
    value: function getContractPoolWhitelist(idOfContract) {
      return this.wsProvider.call([0, 'get_contract_pool_whitelist', [contractId.toRaw(idOfContract)]]);
    }
    /**
     * Returns information about generated eth address, if then exist and approved, for the given account id.
     * @param {string} accountIdOrName the id or name of the account to provide information about
     * @returns {Promise<string | undefined>} the public eth address data stored in the blockchain
     */

  }, {
    key: "getEthAddress",
    value: function getEthAddress(accountIdOrName) {
      if (!(0, _validators.isAccountIdOrName)(accountIdOrName)) {
        return _promise["default"].reject(new Error('Accounts id or name should be string and valid'));
      }

      return this.wsProvider.call([0, 'get_eth_address', [string.toRaw(accountIdOrName)]]);
    }
    /**
     * Returns all approved deposits, for the given account id.
     * @param {string} accountIdOrName the id or name of the account to provide information about
     * @param {"" | "eth" | "bts"} type the type of the deposits may be "", "eth" or "bts"
     * @returns {Promise<any[]>} the all public deposits data stored in the blockchain
     */

  }, {
    key: "getAccountDeposits",
    value: function getAccountDeposits(accountIdOrName, type) {
      if (!(0, _validators.isAccountIdOrName)(accountIdOrName)) {
        return _promise["default"].reject(new Error('Accounts id or name should be string and valid'));
      }

      return this.wsProvider.call([0, 'get_account_deposits', [string.toRaw(accountIdOrName), type]]);
    }
    /**
     * Creates a transaction to register `erc20_token` for sidechain.
     * @param {string} accountIdOrName the account who create erc20 token and become his owner
     * @param {string} ethereumTokenAddress the address of token erc20 token in ethereum network
     * @param {string} tokenName name of the token in echo network
     * @param {string} tokenSymbol symbol of the token in echo network
     * @param {number} decimals number of the digits after the comma of the token in echo network
     * @param {boolean} shouldDoBroadcastToNetwork true if you wish to broadcast the transaction
     * @returns {Promise<SignedTransaction>} the signed version of the transaction
     */

  }, {
    key: "registerErc20Token",
    value: function registerErc20Token(accountIdOrName, ethereumTokenAddress, tokenName, tokenSymbol, decimals, shouldDoBroadcastToNetwork) {
      if (!(0, _validators.isAccountIdOrName)(accountIdOrName)) {
        return _promise["default"].reject(new Error('Accounts id or name should be string and valid'));
      }

      if (!(0, _validators.isNotEmptyString)(tokenName)) return _promise["default"].reject(new Error('Name should be string and valid'));
      if (!(0, _validators.isNotEmptyString)(tokenSymbol)) return _promise["default"].reject(new Error('Name should be string and valid'));
      return this.wsProvider.call([0, 'register_erc20_token', [string.toRaw(accountIdOrName), ethAddress.toRaw(ethereumTokenAddress), string.toRaw(tokenName), string.toRaw(tokenSymbol), uint8.toRaw(decimals), bool.toRaw(shouldDoBroadcastToNetwork)]]);
    }
    /**
     * Returns information about erc20 token, if then exist.
     * @param {string} ethAddrOrId the ethereum address or ID of token in Ethereum network or contract id in
     * Echo network
     * @returns {Promise<unknown | null>} the public erc20 token data stored in the blockchain
     */

  }, {
    key: "getErc20Token",
    value: function () {
      var _getErc20Token = (0, _asyncToGenerator2["default"])( /*#__PURE__*/_regenerator["default"].mark(function _callee9(ethAddrOrId) {
        return _regenerator["default"].wrap(function _callee9$(_context9) {
          while (1) {
            switch (_context9.prev = _context9.next) {
              case 0:
                if (!(!(0, _validators.isEthAddressId)(ethAddrOrId) && !(0, _validators.isEthereumAddress)(ethAddrOrId))) {
                  _context9.next = 2;
                  break;
                }

                throw new Error('Invalid ethereum address or address id format');

              case 2:
                return _context9.abrupt("return", this.wsProvider.call([0, 'get_erc20_token', [ethAddrOrId]]));

              case 3:
              case "end":
                return _context9.stop();
            }
          }
        }, _callee9, this);
      }));

      function getErc20Token(_x25) {
        return _getErc20Token.apply(this, arguments);
      }

      return getErc20Token;
    }()
    /**
     * Check on exist erc20 token.
     * @param {string} idOfContract ID of the contract to get erc20 token
     * @returns {Promise<boolean>} true if erc20 token data stored in the blockchain, else false
     */

  }, {
    key: "checkErc20Token",
    value: function checkErc20Token(idOfContract) {
      return this.wsProvider.call([0, 'check_erc20_token', [contractId.toRaw(idOfContract)]]);
    }
    /**
     * Returns all approved deposits, for the given account id.
     * @param {string} accountIdOrName the id or name of the account to provide information about
     * @returns {Promise<any[]>} the all public erc20 deposits data stored in the blockchain
     */

  }, {
    key: "getErc20AccountDeposits",
    value: function getErc20AccountDeposits(accountIdOrName) {
      if (!(0, _validators.isAccountIdOrName)(accountIdOrName)) {
        return _promise["default"].reject(new Error('Accounts id or name should be string and valid'));
      }

      return this.wsProvider.call([0, 'get_erc20_account_deposits', [string.toRaw(accountIdOrName)]]);
    }
    /**
     * Returns all approved withdrawals, for the given account id.
     * @param {string} accountIdOrName the id or name of the account to provide information about
     * @returns {Promise<any[]>} the all public erc20 withdrawals data stored in the blockchain
     */

  }, {
    key: "getErc20AccountWithdrawals",
    value: function getErc20AccountWithdrawals(accountIdOrName) {
      if (!(0, _validators.isAccountIdOrName)(accountIdOrName)) {
        return _promise["default"].reject(new Error('Accounts id or name should be string and valid'));
      }

      return this.wsProvider.call([0, 'get_erc20_account_withdrawals', [string.toRaw(accountIdOrName)]]);
    }
    /**
     * Creates a transaction to withdraw `erc20_token`.
     * @param {string} accountIdOrName the account who withdraw erc20 token
     * @param {string} toEthereumAddress the Ethereum address where withdraw erc20 token
     * @param {string} idOferc20Token the erc20 token id in ECHO
     * @param {typeof uint256['__TInput__']} withdrawAmount the amount withdraw
     * @param {boolean} shouldDoBroadcastToNetwork true if you wish to broadcast the transaction
     * @returns {Promise<SignedTransaction>} the signed version of the transaction
     */

  }, {
    key: "withdrawErc20Token",
    value: function withdrawErc20Token(accountIdOrName, toEthereumAddress, idOferc20Token, withdrawAmount, shouldDoBroadcastToNetwork) {
      if (!(0, _validators.isAccountIdOrName)(accountIdOrName)) {
        return _promise["default"].reject(new Error('Accounts id or name should be string and valid'));
      }

      return this.wsProvider.call([0, 'withdraw_erc20_token', [string.toRaw(accountIdOrName), ethAddress.toRaw(toEthereumAddress), erc20TokenId.toRaw(idOferc20Token), uint256.toRaw(withdrawAmount), bool.toRaw(shouldDoBroadcastToNetwork)]]);
    }
    /**
      * Creates a transaction to transfer assets to Ethereum erc20_token.
      * @param {string} proposingAccount the account who make proposal.
      * @param {typeof timePointSec["__TOutput__"]} expirationTime
     * timestamp specifying when the proposal will either take effect or expire.
      * @param {unknown} erc20Data object of data for erc20 contract.
      * 	Should have fields code, args, address,name,symbol,decimals. Filed eth_accuracy is optional.
      * @param {boolean} broadcast true if you want to broadcast the transaction.
      * @returns {Promise<SignedTransaction>} the signed version of the transaction
      */

  }, {
    key: "proposeRegisterAssetInSidechain",
    value: function proposeRegisterAssetInSidechain(proposingAccount, expirationTime, erc20Data, broadcast) {
      if (!(0, _validators.isAccountId)(proposingAccount)) throw new Error('Account is invalid');
      return this.wsProvider.call([0, 'propose_register_asset_in_sidechain', [accountId.toRaw(proposingAccount), timePointSec.toRaw(expirationTime), string.toRaw(erc20Data), bool.toRaw(broadcast)]]);
    }
    /**
     * Creates a transaction to transfer assets to Ethereum erc20_token.
     * @param {string} account the account who withdraw erc20 token.
     * @param {string} to the Ethereum address where transfer erc20 token.
     * @param {string} amount the amount transfer.
     * @param {string} assetSymbol the asset symbol.
     * @param {boolean} broadcast true if you want to broadcast the transaction.
     * @returns {Promise<SignedTransaction>} the signed version of the transaction
     */

  }, {
    key: "transferToEthERC20",
    value: function () {
      var _transferToEthERC = (0, _asyncToGenerator2["default"])( /*#__PURE__*/_regenerator["default"].mark(function _callee10(account, to, amount, assetSymbol, broadcast) {
        return _regenerator["default"].wrap(function _callee10$(_context10) {
          while (1) {
            switch (_context10.prev = _context10.next) {
              case 0:
                if ((0, _validators.isAccountIdOrName)(account)) {
                  _context10.next = 2;
                  break;
                }

                throw new Error('Account is invalid');

              case 2:
                return _context10.abrupt("return", this.wsProvider.call([0, 'transfer_to_eth_erc20', [string.toRaw(account), string.toRaw(to), string.toRaw(amount), string.toRaw(assetSymbol), bool.toRaw(broadcast)]]));

              case 3:
              case "end":
                return _context10.stop();
            }
          }
        }, _callee10, this);
      }));

      function transferToEthERC20(_x26, _x27, _x28, _x29, _x30) {
        return _transferToEthERC.apply(this, arguments);
      }

      return transferToEthERC20;
    }()
    /**
     * Generate address of specified account
     * @param {string} accountIdOrName ID or name of the account
     * @param {string} label label for new account address
     * @param {boolean} shouldDoBroadcastToNetwork true if you wish to broadcast the transaction
     * @returns {Promise<SignedTransaction>} the signed version of the transaction
     */

  }, {
    key: "generateAccountAddress",
    value: function generateAccountAddress(accountIdOrName, label, shouldDoBroadcastToNetwork) {
      if (!(0, _validators.isAccountIdOrName)(accountIdOrName)) {
        return _promise["default"].reject(new Error('Accounts id or name should be string and valid'));
      }

      if (!(0, _validators.isNotEmptyString)(label)) return _promise["default"].reject(new Error('Label should be string and valid'));
      return this.wsProvider.call([0, 'generate_account_address', [string.toRaw(accountIdOrName), string.toRaw(label), bool.toRaw(shouldDoBroadcastToNetwork)]]);
    }
    /**
     * Get addresses of specified account
     * @param {string} accountNameOrId ID of the account
     * @param {number} startFrom number of block to start retrieve from
     * @param {number} limit maximum number of addresses to return
     * @returns {Promise<any[]>} Addresses owned by account in specified ids interval
     */

  }, {
    key: "getAccountAddresses",
    value: function () {
      var _getAccountAddresses = (0, _asyncToGenerator2["default"])( /*#__PURE__*/_regenerator["default"].mark(function _callee11(accountNameOrId, startFrom, limit) {
        return _regenerator["default"].wrap(function _callee11$(_context11) {
          while (1) {
            switch (_context11.prev = _context11.next) {
              case 0:
                if ((0, _validators.isAccountIdOrName)(accountNameOrId)) {
                  _context11.next = 2;
                  break;
                }

                throw new Error('Accounts id or name should be string and valid');

              case 2:
                return _context11.abrupt("return", this.wsProvider.call([0, 'get_account_addresses', [string.toRaw(accountNameOrId), uint64.toRaw(startFrom), uint64.toRaw(limit)]]));

              case 3:
              case "end":
                return _context11.stop();
            }
          }
        }, _callee11, this);
      }));

      function getAccountAddresses(_x31, _x32, _x33) {
        return _getAccountAddresses.apply(this, arguments);
      }

      return getAccountAddresses;
    }()
  }, {
    key: "getAccountAddressByLabel",
    value: function () {
      var _getAccountAddressByLabel = (0, _asyncToGenerator2["default"])( /*#__PURE__*/_regenerator["default"].mark(function _callee12(accountNameOrId, label) {
        return _regenerator["default"].wrap(function _callee12$(_context12) {
          while (1) {
            switch (_context12.prev = _context12.next) {
              case 0:
                if ((0, _validators.isAccountId)(accountNameOrId) || (0, _validators.isAccountName)(accountNameOrId)) {
                  _context12.next = 2;
                  break;
                }

                throw new Error('AccountNameOrId is invalid');

              case 2:
                if ((0, _validators.isString)(label)) {
                  _context12.next = 4;
                  break;
                }

                throw new Error('Label is invalid');

              case 4:
                return _context12.abrupt("return", this.wsProvider.call([0, 'get_account_address_by_label', [string.toRaw(accountNameOrId), string.toRaw(label)]]));

              case 5:
              case "end":
                return _context12.stop();
            }
          }
        }, _callee12, this);
      }));

      function getAccountAddressByLabel(_x34, _x35) {
        return _getAccountAddressByLabel.apply(this, arguments);
      }

      return getAccountAddressByLabel;
    }()
    /**
     * @param {String} address
     * @param {Integer_t["uint64"]["__TOutput__"]} stop
     * @param {Integer_t["uint32"]["__TOutput__"]} limit
     * @param {Integer_t["uint64"]["__TOutput__"]} start
     * @returns {Promise}
     */

  }, {
    key: "getAccountAddressHistory",
    value: function () {
      var _getAccountAddressHistory = (0, _asyncToGenerator2["default"])( /*#__PURE__*/_regenerator["default"].mark(function _callee13(_address, _start, _stop, _limit) {
        var address, stop, limit, start;
        return _regenerator["default"].wrap(function _callee13$(_context13) {
          while (1) {
            switch (_context13.prev = _context13.next) {
              case 0:
                address = serializers.chain.ripemd160.toRaw(_address);
                stop = _stop === undefined ? _constants.API_CONFIG.STOP_OPERATION_HISTORY_ID : operationHistoryId.toRaw(_stop);
                limit = _limit === undefined ? 100 : serializers.basic.integers.uint32.toRaw(_limit);
                start = _start === undefined ? _constants.API_CONFIG.START_OPERATION_HISTORY_ID : operationHistoryId.toRaw(_start);

                if (!(limit > 100)) {
                  _context13.next = 6;
                  break;
                }

                throw new Error('Limit is greater than 100');

              case 6:
                return _context13.abrupt("return", this.wsProvider.call([0, 'get_account_address_history', [address, start, stop, limit]]));

              case 7:
              case "end":
                return _context13.stop();
            }
          }
        }, _callee13, this);
      }));

      function getAccountAddressHistory(_x36, _x37, _x38, _x39) {
        return _getAccountAddressHistory.apply(this, arguments);
      }

      return getAccountAddressHistory;
    }()
  }, {
    key: "getAccountHistoryOperations",
    value: function () {
      var _getAccountHistoryOperations = (0, _asyncToGenerator2["default"])( /*#__PURE__*/_regenerator["default"].mark(function _callee14(idOfAccount, operationId) {
        var start,
            stop,
            limit,
            operationNumber,
            _args14 = arguments;
        return _regenerator["default"].wrap(function _callee14$(_context14) {
          while (1) {
            switch (_context14.prev = _context14.next) {
              case 0:
                start = _args14.length > 2 && _args14[2] !== undefined ? _args14[2] : _constants.API_CONFIG.START_OPERATION_HISTORY_ID;
                stop = _args14.length > 3 && _args14[3] !== undefined ? _args14[3] : _constants.API_CONFIG.STOP_OPERATION_HISTORY_ID;
                limit = _args14.length > 4 && _args14[4] !== undefined ? _args14[4] : _constants.API_CONFIG.ACCOUNT_HISTORY_OPERATIONS_DEFAULT_LIMIT;
                operationNumber = uint64.toRaw(operationId);

                if ((0, _validators.isAccountId)(idOfAccount)) {
                  _context14.next = 6;
                  break;
                }

                throw new Error('Account is invalid');

              case 6:
                if ((0, _validators.isOperationHistoryId)(start)) {
                  _context14.next = 8;
                  break;
                }

                throw new Error('Start parameter is invalid');

              case 8:
                if ((0, _validators.isOperationHistoryId)(stop)) {
                  _context14.next = 10;
                  break;
                }

                throw new Error('Stop parameter is invalid');

              case 10:
                if (!(!(0, _validators.isUInt64)(limit) || limit > _constants.API_CONFIG.ACCOUNT_HISTORY_OPERATIONS_MAX_LIMIT)) {
                  _context14.next = 12;
                  break;
                }

                throw new Error("Limit should be capped at ".concat(_constants.API_CONFIG.ACCOUNT_HISTORY_OPERATIONS_MAX_LIMIT));

              case 12:
                return _context14.abrupt("return", this.wsProvider.call([0, 'get_account_history_operations', [accountId.toRaw(idOfAccount), operationNumber, anyObjectId.toRaw(start), anyObjectId.toRaw(stop), uint32.toRaw(limit)]]));

              case 13:
              case "end":
                return _context14.stop();
            }
          }
        }, _callee14, this);
      }));

      function getAccountHistoryOperations(_x40, _x41) {
        return _getAccountHistoryOperations.apply(this, arguments);
      }

      return getAccountHistoryOperations;
    }()
    /**
     * @param {string} owner the id or name of the account to register address for
     * @param {string} evmAddress address that will be associated with owner account id
     * @param {boolean} broadcast true to broadcast the transaction on the netwo
     * @returns {Promise<[SignedTransaction, TransactionIdType]>}
     */

  }, {
    key: "registerEvmAddress",
    value: function () {
      var _registerEvmAddress = (0, _asyncToGenerator2["default"])( /*#__PURE__*/_regenerator["default"].mark(function _callee15(owner, evmAddress, broadcast) {
        return _regenerator["default"].wrap(function _callee15$(_context15) {
          while (1) {
            switch (_context15.prev = _context15.next) {
              case 0:
                if ((0, _validators.isAccountIdOrName)(owner)) {
                  _context15.next = 2;
                  break;
                }

                throw new Error('Owner id or name should be string and valid');

              case 2:
                return _context15.abrupt("return", this.wsProvider.call([0, 'register_evm_address', [string.toRaw(owner), ethAddress.toRaw(evmAddress), bool.toRaw(broadcast)]]));

              case 3:
              case "end":
                return _context15.stop();
            }
          }
        }, _callee15, this);
      }));

      function registerEvmAddress(_x42, _x43, _x44) {
        return _registerEvmAddress.apply(this, arguments);
      }

      return registerEvmAddress;
    }()
  }, {
    key: "getCurrentIncentivesInfo",
    value: function getCurrentIncentivesInfo() {
      return this.wsProvider.call([0, 'get_current_incentives_info', []]);
    }
  }, {
    key: "getIncentivesInfo",
    value: function getIncentivesInfo(blockStart, blockEnd) {
      if (!(0, _validators.isNumber)(blockStart)) {
        throw new Error('Invalid start block number');
      }

      if (!(0, _validators.isNumber)(blockEnd)) {
        throw new Error('Invalid end block number');
      }

      if (blockEnd < blockStart) {
        throw new Error('Block start should be equal or more then block end');
      }

      return this.wsProvider.call([0, 'get_incentives_info', [uint32.toRaw(blockStart), uint32.toRaw(blockEnd)]]);
    }
    /**
     * Get owner of specified address.
     * @param {string} address address in form of ripemd160 hash
     * @returns {Promise<string | undefined>} Account id of owner
     */

  }, {
    key: "getAccountByAddress",
    value: function getAccountByAddress(address) {
      return this.wsProvider.call([0, 'get_account_by_address', [ripemd160.toRaw(address)]]);
    }
    /**
     * Returns all approved withdrawals, for the given account id.
     * @param {string} accountIdOrName the id or name of the account to provide information about
     * @param {"" | "eth" | "bts"} type the type of the withdrawals may be "", "eth" or "bts"
     * @returns {Promise<any[]>} the all public withdrawals data stored in the blockchain
     */

  }, {
    key: "getAccountWithdrawals",
    value: function getAccountWithdrawals(accountIdOrName, type) {
      if (!(0, _validators.isAccountIdOrName)(accountIdOrName)) {
        return _promise["default"].reject(new Error('Accounts id or name should be string and valid'));
      }

      return this.wsProvider.call([0, 'get_account_withdrawals', [string.toRaw(accountIdOrName), type]]);
    }
    /**
     * Approve or disapprove a proposal.
     * @param {string} feePayingAccountId the account paying the fee for the op
     * @param {string} idOfProposal the proposal to modify
     * @param {any} delta[members contain approvals to create or remove.
     * In JSON you can leave empty members undefined]
     * @param {boolean} shouldDoBroadcastToNetwork true if you wish to broadcast the transaction
     * @returns {Promise<SignedTransaction>} the signed version of the transaction
     */

  }, {
    key: "approveProposal",
    value: function approveProposal(feePayingAccountId, idOfProposal, delta, shouldDoBroadcastToNetwork) {
      return this.wsProvider.call([0, 'approve_proposal', [accountId.toRaw(feePayingAccountId), proposalId.toRaw(idOfProposal), wallet.approvalDelta.toRaw(delta), bool.toRaw(shouldDoBroadcastToNetwork)]]);
    }
    /**
     * Generate ethereum address.
     * @param {string} accountIdOrName the name or id of the account
     * @param {boolean} shouldDoBroadcastToNetwork true if you wish to broadcast the transaction
     * @returns {Promise<SignedTransaction>} the signed version of the transaction
     */

  }, {
    key: "createEthAddress",
    value: function createEthAddress(accountIdOrName, shouldDoBroadcastToNetwork) {
      if (!(0, _validators.isAccountIdOrName)(accountIdOrName)) {
        return _promise["default"].reject(new Error('Accounts id or name should be string and valid'));
      }

      return this.wsProvider.call([0, 'create_eth_address', [string.toRaw(accountIdOrName), bool.toRaw(shouldDoBroadcastToNetwork)]]);
    }
    /**
     * Withdraw ethereum.
     * @param {string} accountIdOrName the name or id of the account
     * @param {string} ethOfAddress the address of token erc20 token in ethereum network
     * @param {number} value amount for withdraw
     * @param {boolean} shouldDoBroadcastToNetwork true if you wish to broadcast the transaction
     * @returns {Promise<SignedTransaction>} the signed version of the transaction
     */

  }, {
    key: "withdrawEth",
    value: function withdrawEth(accountIdOrName, ethOfAddress, value, shouldDoBroadcastToNetwork) {
      if (!(0, _validators.isAccountIdOrName)(accountIdOrName)) {
        return _promise["default"].reject(new Error('Accounts id or name should be string and valid'));
      }

      return this.wsProvider.call([0, 'withdraw_eth', [string.toRaw(accountIdOrName), ethAddress.toRaw(ethOfAddress), uint64.toRaw(value), bool.toRaw(shouldDoBroadcastToNetwork)]]);
    }
    /**
     * Flood the network.
     * @param {string} prefix prefix
     * @param {string} numberOfTransactions number of transactions to flood
     * @returns {Promise<void>}
     */

  }, {
    key: "floodNetwork",
    value: function floodNetwork(prefix, numberOfTransactions) {
      return this.wsProvider.call([0, 'flood_network', [string.toRaw(prefix), uint32.toRaw(numberOfTransactions)]]);
    }
    /**
     * Lists all assets registered on the blockchain.
     * To list all assets, pass the empty string `` for the lowerbound to start
     * at the beginning of the list, and iterate as necessary.
     * @param {string} lowerBoundSymbol the symbol of the first asset to include in the list
     * @param {number} limit the maximum number of assets to return (max: 100)
     * @return {Promise<Asset[]>} the list of asset objects, ordered by symbol
     */

  }, {
    key: "listAssets",
    value: function listAssets(lowerBoundSymbol) {
      var limit = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : _constants.API_CONFIG.LIST_ASSETS_DEFAULT_LIMIT;

      if (!limit > _constants.API_CONFIG.LIST_ASSETS_MAX_LIMIT) {
        return _promise["default"].reject(new Error("Limit should be capped at ".concat(_constants.API_CONFIG.LIST_ASSETS_MAX_LIMIT)));
      }

      return this.wsProvider.call([0, 'list_assets', [assetId.toRaw(lowerBoundSymbol), uint32.toRaw(limit)]]);
    }
    /**
     * Creates a new user-issued or market-issued asset. Many options can be changed later using `update_asset()`.
     * Right now this function is difficult to use because you must provide raw JSON data
     * structures for the options objects, and those include prices and asset ids.
     * @param {string} accountIdOrName the name or id of the account who will pay the fee and become the
     * issuer of the new asset. This can be updated later
     * @param {string} symbol the ticker symbol of the new asset
     * @param {number} precision the number of digits of precision to the right of the decimal point,
     * must be less than or equal to 12
     * @param {any} assetOption asset options required for all new assets.
     * Note that `core_exchange_rate` technically needs to store the asset ID of this new asset.
     * Since this ID is not known at the time this operation is created, create this price as though the new asset has
     * instance ID 1, and the chain will overwrite it with the new asset's ID.
     * @param {any} bitassetOpts options specific to BitAssets.
     * This may be null unless the `market_issued` flag is set in common.flags
     * @param {boolean} shouldDoBroadcastToNetwork true to broadcast the transaction on the network
     * @returns {Promise<SignedTransaction>} the signed transaction creating a new asset
     */

  }, {
    key: "createAsset",
    value: function createAsset(accountIdOrName, symbol, precision, assetOption, bitassetOpts, shouldDoBroadcastToNetwork) {
      if (!(0, _validators.isAccountIdOrName)(accountIdOrName)) {
        return _promise["default"].reject(new Error('Accounts id or name should be string and valid'));
      }

      if (!(0, _validators.isAssetName)(symbol)) return _promise["default"].reject(new Error('Assets symbol should be string and valid'));
      return this.wsProvider.call([0, 'create_asset', [string.toRaw(accountIdOrName), string.toRaw(symbol), uint8.toRaw(precision), options.toRaw(assetOption), optional(bitassetOptions).toRaw(bitassetOpts), bool.toRaw(shouldDoBroadcastToNetwork)]]);
    }
    /**
     * Update the core options on an asset.
     * There are a number of options which all assets in the network use.
     * This command is used to update these options for an existing asset.
     * This operation cannot be used to update BitAsset-specific options.
     * For these options, `updateBitasset` instead.
     * @param {string} assetIdOrName the name or id of the asset to update
     * @param {string} newIssuerIdOrName if changing the asset's issuer, the name or id of the new issuer.
     * null if you wish to remain the issuer of the asset
     * @param {any} newOptions the new asset_options object, which will entirely replace the existing
     * options
     * @param {boolean} shouldDoBroadcastToNetwork broadcast true to broadcast the transaction on the network
     * @returns {Promise<SignedTransaction>} the signed transaction updating the asset
     */

  }, {
    key: "updateAsset",
    value: function updateAsset(assetIdOrName, newIssuerIdOrName, newOptions, shouldDoBroadcastToNetwork) {
      if (!(0, _validators.isAssetIdOrName)(assetIdOrName)) {
        return _promise["default"].reject(new Error('Assets id or name should be string and valid'));
      }

      if (!(0, _validators.isAccountIdOrName)(newIssuerIdOrName)) {
        return _promise["default"].reject(new Error('Accounts id or name should be string and valid'));
      }

      return this.wsProvider.call([0, 'update_asset', [string.toRaw(assetIdOrName), string.toRaw(newIssuerIdOrName), options.toRaw(newOptions), bool.toRaw(shouldDoBroadcastToNetwork)]]);
    }
    /**
     * Update the options specific to a BitAsset.
     * BitAssets have some options which are not relevant to other asset types.
     * This operation is used to update those options an existing BitAsset
     * @see {@link WalletAPI['updateAsset']}
     * @param {string} assetIdOrName the name or id of the asset to update, which must be a market-issued asset
     * @param {any} newBitasset the new bitasset_options object, which will entirely replace the existing options
     * @param {boolean} shouldDoBroadcastToNetwork true to broadcast the transaction on the network
     * @returns {Promise<SignedTransaction>} the signed transaction updating the bitasset
     */

  }, {
    key: "updateBitasset",
    value: function updateBitasset(assetIdOrName, newBitasset, shouldDoBroadcastToNetwork) {
      if (!(0, _validators.isAssetIdOrName)(assetIdOrName)) {
        return _promise["default"].reject(new Error('Assets id or name should be string and valid'));
      }

      return this.wsProvider.call([0, 'update_bitasset', [string.toRaw(assetIdOrName), bitassetOptions.toRaw(newBitasset), bool.toRaw(shouldDoBroadcastToNetwork)]]);
    }
    /**
     * Update the set of feed-producing accounts for a BitAsset.
     * BitAssets have price feeds selected by taking the median values of recommendations from a set of feed producers.
     * This command is used to specify which accounts may produce feeds for a given BitAsset.
     * @param {string} assetIdOrName the name or id of the asset to update
     * @param {string[]} newFeedProducers a list of account names or ids which are authorized to produce feeds
     * for the asset. This list will completely replace the existing list
     * @param {boolean} shouldDoBroadcastToNetwork true to broadcast the transaction on the network
     * @returns {Promise<SignedTransaction>} the signed transaction updating the bitasset's feed producers
     */

  }, {
    key: "updateAssetFeedProducers",
    value: function updateAssetFeedProducers(assetIdOrName, newFeedProducers, shouldDoBroadcastToNetwork) {
      if (!(0, _validators.isAssetIdOrName)(assetIdOrName)) {
        return _promise["default"].reject(new Error('Assets id or name should be string and valid'));
      }

      if (!(0, _every["default"])(newFeedProducers).call(newFeedProducers, function (idOrName) {
        return !!(0, _validators.isAccountIdOrName)(idOrName);
      })) {
        return _promise["default"].reject(new Error('Accounts should contain valid account names or ids'));
      }

      return this.wsProvider.call([0, 'update_asset_feed_producers', [string.toRaw(assetIdOrName), vector(string).toRaw(newFeedProducers), bool.toRaw(shouldDoBroadcastToNetwork)]]);
    }
    /**
     * Publishes a price feed for the named asset.
     * Price feed providers use this command to publish their price feeds for market-issued assets. A price feed is
     * used to tune the market for a particular market-issued asset. For each value in the feed,
     * the median across all `committee_member` feeds for that asset is calculated and the market
     * for the asset is configured with the median of that value.
     *
     * The feed object in this command contains three prices: a call price limit, a short price limit,
     * and a settlement price. The call limit price is structured as (collateral asset) / (debt asset)
     * and the short limit price is structured as (asset for sale) / (collateral asset).
     * Note that the asset IDs are opposite to each other, so if we're publishing a feed for USD,
     * the call limit price will be ECHO/USD and the short limit price will be USD/ECHO. The settlement price may be
     * flipped either direction, as long as it is a ratio between the market-issued asset and its collateral.
     *
     * @param {string} accountIdOrName the account publishing the price feed
     * @param {string} assetIdOrName the name or id of the asset whose feed we're publishing
     * @param {any} coreEchangeRate object containing the three prices making up the feed
     * @param {boolean} shouldDoBroadcastToNetwork true to broadcast the transaction on the network
     * @returns {Promise<SignedTransaction>} the signed transaction updating the price feed for the given asset
     */

  }, {
    key: "publishAssetFeed",
    value: function publishAssetFeed(accountIdOrName, assetIdOrName, coreEchangeRate, shouldDoBroadcastToNetwork) {
      if (!(0, _validators.isAccountIdOrName)(accountIdOrName)) {
        return _promise["default"].reject(new Error('Accounts id or name should be string and valid'));
      }

      if (!(0, _validators.isAssetIdOrName)(assetIdOrName)) {
        return _promise["default"].reject(new Error('Assets id or name should be string and valid'));
      }

      return this.wsProvider.call([0, 'publish_asset_feed', [string.toRaw(accountIdOrName), string.toRaw(assetIdOrName), price.toRaw(coreEchangeRate), bool.toRaw(shouldDoBroadcastToNetwork)]]);
    }
    /**
     * Issue new shares of an asset.
     * @param {string} accountIdOrName the name or id of the account to receive the new shares
     * @param {string} amount the amount to issue, in nominal units
     * @param {string} assetTicker the ticker symbol of the asset to issue
     * @param {boolean} shouldDoBroadcastToNetwork true to broadcast the transaction on the network
     * @returns {Promise<SignedTransaction>} the signed transaction issuing the new shares
     */

  }, {
    key: "issueAsset",
    value: function issueAsset(accountIdOrName, amount, assetTicker, shouldDoBroadcastToNetwork) {
      if (!(0, _validators.isAccountIdOrName)(accountIdOrName)) {
        return _promise["default"].reject(new Error('Accounts id or name should be string and valid'));
      }

      if (!(0, _validators.isValidAmount)(amount)) return _promise["default"].reject(new Error('Invalid number'));
      return this.wsProvider.call([0, 'issue_asset', [string.toRaw(accountIdOrName), string.toRaw(amount), string.toRaw(assetTicker), bool.toRaw(shouldDoBroadcastToNetwork)]]);
    }
    /**
     * Returns information about the given asset.
     * @param {string} assetIdOrName the symbol or id of the asset in question
     * @returns {Promise<any>} the information about the asset stored in the block chain
     */

  }, {
    key: "getAsset",
    value: function getAsset(assetIdOrName) {
      if (!(0, _validators.isAssetIdOrName)(assetIdOrName)) {
        return _promise["default"].reject(new Error('Assets id or name should be string and valid'));
      }

      return this.wsProvider.call([0, 'get_asset', [string.toRaw(assetIdOrName)]]);
    }
    /**
     * Returns the BitAsset-specific data for a given asset.
     * Market-issued assets's behavior are determined both by their "BitAsset Data" and
     * their basic asset data, as returned by `get_asset()`.
     * @param {string} bitassetIdOrName the symbol or id of the BitAsset in question
     * @returns {Promise<any>} the BitAsset-specific data for this asset
     */

  }, {
    key: "getBitassetData",
    value: function getBitassetData(bitassetIdOrName) {
      if (!(0, _validators.isAssetIdOrName)(bitassetIdOrName)) {
        return _promise["default"].reject(new Error('Assets id or name should be string and valid'));
      }

      return this.wsProvider.call([0, 'get_bitasset_data', [string.toRaw(bitassetIdOrName)]]);
    }
    /**
     * Pay into the fee pool for the given asset.
     * User-issued assets can optionally have a pool of the core asset which is automatically used to pay transaction
     * fees for any transaction using that asset (using the asset's core exchange rate).
     * This command allows anyone to deposit the core asset into this fee pool.
     * @param {string} fromAccountIdOrName the name or id of the account sending the core asset
     * @param {string} assetIdOrName the name or id of the asset whose fee pool you wish to fund
     * @param {string} amount the amount of the core asset to deposit
     * @param {boolean} shouldDoBroadcastToNetwork true to broadcast the transaction on the network
     * @returns {Promise<SignedTransaction>} the signed transaction funding the fee pool
     */

  }, {
    key: "fundAssetFeePool",
    value: function fundAssetFeePool(fromAccountIdOrName, assetIdOrName, amount, shouldDoBroadcastToNetwork) {
      if (!(0, _validators.isAccountIdOrName)(fromAccountIdOrName)) {
        return _promise["default"].reject(new Error('Accounts id or name should be string and valid'));
      }

      if (!(0, _validators.isAssetIdOrName)(assetIdOrName)) {
        return _promise["default"].reject(new Error('Assets id or name should be string and valid'));
      }

      return this.wsProvider.call([0, 'fund_asset_fee_pool', [string.toRaw(fromAccountIdOrName), string.toRaw(assetIdOrName), string.toRaw(amount), bool.toRaw(shouldDoBroadcastToNetwork)]]);
    }
    /**
     * Burns the given user-issued asset.
     * This command burns the user-issued asset to reduce the amount in circulation.
    	 * You cannot burn market-issued assets.
    	 * @param {string} accountIdOrName the account containing the asset you wish to burn
     * @param {string} amount the amount to burn, in nominal units
     * @param {string} assetIdOrName the name or id of the asset to burn
     * @param {boolean} shouldDoBroadcastToNetwork true to broadcast the transaction on the network
     * @returns {Promise<SignedTransaction>} the signed transaction burning the asset
     */

  }, {
    key: "reserveAsset",
    value: function reserveAsset(accountIdOrName, amount, assetIdOrName, shouldDoBroadcastToNetwork) {
      if (!(0, _validators.isAccountIdOrName)(accountIdOrName)) {
        return _promise["default"].reject(new Error('Accounts id or name should be string and valid'));
      }

      if (!(0, _validators.isValidAmount)(amount)) return _promise["default"].reject(new Error('Invalid number'));

      if (!(0, _validators.isAssetIdOrName)(assetIdOrName)) {
        return _promise["default"].reject(new Error('Assets id or name should be string and valid'));
      }

      return this.wsProvider.call([0, 'reserve_asset', [string.toRaw(accountIdOrName), string.toRaw(amount), string.toRaw(assetIdOrName), bool.toRaw(shouldDoBroadcastToNetwork)]]);
    }
    /**
     * Returns information about the given committee member.
     * @param {string} accountIdOrName the name or id of the committee member account owner,
     * or the id of the committee member
     * @returns {Promise<any>} the information about the committee member stored in the block chain
     */

  }, {
    key: "getCommitteeMember",
    value: function getCommitteeMember(accountIdOrName) {
      if (!(0, _validators.isAccountIdOrName)(accountIdOrName)) {
        return _promise["default"].reject(new Error('Accounts id or name should be string and valid'));
      }

      return this.wsProvider.call([0, 'get_committee_member', [string.toRaw(accountIdOrName)]]);
    }
    /**
     * Lists all committee_members registered in the blockchain.
     * This returns a list of all account names that own committee_members, and the associated committee member id,
     * sorted by name. This lists committee_members whether they are currently voted in or not.
     * Use the `lowerbound` and limit parameters to page through the list. To retrieve all committee members,
     * start by setting `lowerbound` to the empty string `""`, and then each iteration, pass
     * the last committee member name returned as the `lowerbound` for the next `listCommitteeMembers` call.
     * @param {string} lowerBoundName the name of the first `committee_member` to return.
     * If the named `committee_member` does not exist, the list will start at the `committee_member`
     * that comes after `lowerbound`
     * @param {number} limit limit the maximum number of committee_members to return (max: 1000)
     * @returns {Promise<[string, string][]>} a list of committee_members mapping committee member names
     * to committee members' id
     */

  }, {
    key: "listCommitteeMembers",
    value: function listCommitteeMembers(lowerBoundName) {
      var limit = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : _constants.API_CONFIG.COMMITTEE_MEMBER_ACCOUNTS_DEFAULT_LIMIT;

      if (!limit > _constants.API_CONFIG.COMMITTEE_MEMBER_ACCOUNTS_MAX_LIMIT) {
        return _promise["default"].reject(new Error("Limit should be less ".concat(_constants.API_CONFIG.COMMITTEE_MEMBER_ACCOUNTS_MAX_LIMIT)));
      }

      return this.wsProvider.call([0, 'list_committee_members', [string.toRaw(lowerBoundName), uint64.toRaw(limit)]]);
    }
    /**
     * Creates a transaction to propose a parameter change.
     * Multiple parameters can be specified if an atomic change is desired.
     * @param {string} accountIdOrName the account paying the fee to propose the tx
     * @param {number} expirationTime timestamp specifying when the proposal will either take effect or expire
     * @param {any} changeValues the values to change; all other chain parameters are filled in with default values
     * @param {boolean} shouldDoBroadcastToNetwork true if you wish to broadcast the transaction
     * @returns {Promise<SignedTransaction>} the signed version of the transaction
     */

  }, {
    key: "proposeParameterChange",
    value: function proposeParameterChange(accountIdOrName, expirationTime, changeValues, shouldDoBroadcastToNetwork) {
      if (!(0, _validators.isAccountIdOrName)(accountIdOrName)) {
        return _promise["default"].reject(new Error('Accounts id or name should be string and valid'));
      }

      return this.wsProvider.call([0, 'propose_parameter_change', [string.toRaw(accountIdOrName), timePointSec.toRaw(expirationTime), variantObject.toRaw(changeValues), bool.toRaw(shouldDoBroadcastToNetwork)]]);
    }
    /**
     * Propose a fee change.
     * @param {string} accountIdOrName the account paying the fee to propose the tx
     * @param {number} expirationTime timestamp specifying when the proposal will either take effect or expire
     * @param {any} changedValues [map of operation type to new fee. Operations may be specified by name or ID.
     * The "scale" key changes the scale. All other operations will maintain current values]
     * @param {boolean} shouldDoBroadcastToNetwork true if you wish to broadcast the transaction
     * @returns {Promise<SignedTransaction>} the signed version of the transaction
     */

  }, {
    key: "proposeFeeChange",
    value: function proposeFeeChange(accountIdOrName, expirationTime, changedValues, shouldDoBroadcastToNetwork) {
      if (!(0, _validators.isAccountIdOrName)(accountIdOrName)) {
        return _promise["default"].reject(new Error('Accounts id or name should be string and valid'));
      }

      return this.wsProvider.call([0, 'propose_fee_change', [string.toRaw(accountIdOrName), timePointSec.toRaw(expirationTime), variantObject.toRaw(changedValues), bool.toRaw(shouldDoBroadcastToNetwork)]]);
    }
    /**
     * Change sidechain config.
     * @param {string} accountIdOrName the account id who changing side chain config
     * @param {any} changedValues the values to change
     * @param {boolean} shouldDoBroadcastToNetwork true if you wish to broadcast the transaction
     * @returns {Promise<SignedTransaction>} the signed version of the transaction
     */

  }, {
    key: "changeSidechainConfig",
    value: function changeSidechainConfig(accountIdOrName, changedValues, shouldDoBroadcastToNetwork) {
      if (!(0, _validators.isAccountIdOrName)(accountIdOrName)) {
        return _promise["default"].reject(new Error('Accounts id or name should be string and valid'));
      }

      return this.wsProvider.call([0, 'change_sidechain_config', [string.toRaw(accountIdOrName), config.toRaw(changedValues), bool.toRaw(shouldDoBroadcastToNetwork)]]);
    }
    /**
     * Returns info about a specified block.
     * @param {number} blockNum height of the block to retrieve
     * @return {Promise<any | undefined>} info about the block, or undefined if not found
     */

  }, {
    key: "getBlock",
    value: function getBlock(blockNum) {
      return this.wsProvider.call([0, 'get_block', [uint32.toRaw(blockNum)]]);
    }
    /**
     * Returns block virtual ops by number
     * @param {number} blockNum height of the block to retrieve
     * @return {Promise<any[]>} info about operation history object
     */

  }, {
    key: "getBlockVirtualOps",
    value: function getBlockVirtualOps(blockNum) {
      return this.wsProvider.call([0, 'get_block_virtual_ops', [uint32.toRaw(blockNum)]]);
    }
    /**
     * Returns the number of accounts registered on the blockchain.
     * @return {Promise<number | string>} the number of registered accounts
     */

  }, {
    key: "getAccountCount",
    value: function getAccountCount() {
      return this.wsProvider.call([0, 'get_account_count', []]);
    }
    /**
     * Returns the block chain's slowly-changing settings.
     * This object contains all of the properties of the blockchain that are fixed or that change only once
     * per maintenance interval (daily) such as the current list of committee_members, block interval, etc.
     * @see {@link WalletAPI['getDynamicGlobalProperties']} for frequently changing properties
     * @return {Promise<any>} the global properties
     */

  }, {
    key: "getGlobalProperties",
    value: function getGlobalProperties() {
      return this.wsProvider.call([0, 'get_global_properties', []]);
    }
    /**
     * Returns the block chain's rapidly-changing properties.
     * The returned object contains information that changes every block interval
     * such as the head block number, etc.
     * @see {@link WalletAPI['getGlobalProperties']} for less-frequently changing properties
     * @return {Promise<any>} the dynamic global properties
     */

  }, {
    key: "getDynamicGlobalProperties",
    value: function getDynamicGlobalProperties() {
      return this.wsProvider.call([0, 'get_dynamic_global_properties', []]);
    }
  }, {
    key: "getGitVersion",
    value: function getGitVersion() {
      return this.wsProvider.call([0, 'get_git_revision', []]);
    }
    /**
     * Returns the blockchain object corresponding to the given id.
     * This generic function can be used to retrieve any object from the blockchain that is assigned an ID.
     * @param {string} objectId the id of the object to return
     * @returns {Promise<any>} the requested object
     */

  }, {
    key: "getObject",
    value: function getObject(objectId) {
      return this.wsProvider.call([0, 'get_object', [anyObjectId.toRaw(objectId)]]);
    }
    /**
     * Create a new transaction builder.
     * @returns {Promise<number>} handle of the new transaction builder
     */

  }, {
    key: "beginBuilderTransaction",
    value: function beginBuilderTransaction() {
      return this.wsProvider.call([0, 'begin_builder_transaction', []]);
    }
    /**
     * Append a new operation to a transaction builder.
     * @param {number} transactionTypeHandle handle of the transaction builder
     * @param {string[]} newOperation the operation in JSON format
     * @returns {Promise<void>}
     */

  }, {
    key: "addOperationToBuilderTransaction",
    value: function addOperationToBuilderTransaction(transactionTypeHandle, newOperation) {
      return this.wsProvider.call([0, 'add_operation_to_builder_transaction', [uint16.toRaw(transactionTypeHandle), operation.toRaw(newOperation)]]);
    }
    /**
     * Replace an operation in a transaction builder with a new operation.
     * @param {number} transactionTypeHandle handle of the transaction builder
     * @param {number} unsignedOperation the index of the old operation in the builder to be replaced
     * @param {string[]} newOperation the new operation in JSON format
     * @returns {Promise<void>}
     */

  }, {
    key: "replaceOperationInBuilderTransaction",
    value: function replaceOperationInBuilderTransaction(transactionTypeHandle, unsignedOperation, newOperation) {
      return this.wsProvider.call([0, 'replace_operation_in_builder_transaction', [uint16.toRaw(transactionTypeHandle), uint64.toRaw(unsignedOperation), operation.toRaw(newOperation)]]);
    }
    /**
     * Calculate and update fees for the operations in a transaction builder.
     * @param {number} transactionTypeHandle handle of the transaction builder
     * @param {string} feeAsset name or ID of an asset that to be used to pay fees
     * @returns {Promise<Asset>} total fees
     */

  }, {
    key: "setFeesOnBuilderTransaction",
    value: function setFeesOnBuilderTransaction(transactionTypeHandle, feeAsset) {
      if (!(0, _validators.isAssetIdOrName)(feeAsset)) {
        return _promise["default"].reject(new Error('Assets id or name should be string and valid'));
      }

      return this.wsProvider.call([0, 'set_fees_on_builder_transaction', [uint16.toRaw(transactionTypeHandle), string.toRaw(feeAsset)]]);
    }
    /**
     * Show content of a transaction builder.
     * @param {number} transactionTypeHandle handle of the transaction builder
     * @returns {Promise<any>} a transaction
     */

  }, {
    key: "previewBuilderTransaction",
    value: function previewBuilderTransaction(transactionTypeHandle) {
      return this.wsProvider.call([0, 'preview_builder_transaction', [uint64.toRaw(transactionTypeHandle)]]);
    }
    /**
     * Sign the transaction in a transaction builder and optionally broadcast to the network.
     * @param {number} transactionTypeHandle handle of the transaction builder
     * @param {boolean} shouldDoBroadcastToNetwork whether to broadcast the signed transaction to the network
     * @returns {Promise<SignedTransaction>} a signed transaction
     */

  }, {
    key: "signBuilderTransaction",
    value: function signBuilderTransaction(transactionTypeHandle, shouldDoBroadcastToNetwork) {
      return this.wsProvider.call([0, 'sign_builder_transaction', [uint16.toRaw(transactionTypeHandle), bool.toRaw(shouldDoBroadcastToNetwork)]]);
    }
    /**
     * Create a proposal containing the operations in a transaction builder (create a new `PROPOSAL_CREATE` operation,
     * then replace the transaction builder with the new operation), then sign the transaction and optionally broadcast
     * to the network.
     * @param {number} transactionTypeHandle handle of the transaction builder
     * @param {string} expirationTime when the proposal will expire
     * @param {number} reviewPeriod review period of the proposal in seconds
     * @param {boolean} shouldDoBroadcastToNetwork whether to broadcast the signed transaction to the network
     * @returns {Promise<SignedTransaction>} a signed transaction
     */

  }, {
    key: "proposeBuilderTransaction",
    value: function proposeBuilderTransaction(transactionTypeHandle, expirationTime, reviewPeriod, shouldDoBroadcastToNetwork) {
      return this.wsProvider.call([0, 'propose_builder_transaction', [uint16.toRaw(transactionTypeHandle), timePointSec.toRaw(expirationTime), uint32.toRaw(reviewPeriod), bool.toRaw(shouldDoBroadcastToNetwork)]]);
    }
    /**
     * Create a proposal containing the operations in a transaction builder (create a new `PROPOSAL_CREATE` operation,
     * then replace the transaction builder with the new operation),
     * then sign the transaction and optionally broadcast to the network.
     * @param {number} transactionTypeHandle handle of the transaction builder
     * @param {string} accountIdOrName name or ID of the account who would pay fees for creating the proposal
     * @param {string} expirationTime when the proposal will expire
     * @param {number} reviewPeriod review period of the proposal in seconds
     * @param {boolean} shouldDoBroadcastToNetwork whether to broadcast the signed transaction to the network
     * @returns {Promise<any>} a signed transaction
     */

  }, {
    key: "proposeBuilderTransaction2",
    value: function proposeBuilderTransaction2(transactionTypeHandle, accountIdOrName, expirationTime, reviewPeriod, shouldDoBroadcastToNetwork) {
      if (!(0, _validators.isAccountIdOrName)(accountIdOrName)) {
        return _promise["default"].reject(new Error('Accounts id or name should be string and valid'));
      }

      return this.wsProvider.call([0, 'propose_builder_transaction2', [uint16.toRaw(transactionTypeHandle), string.toRaw(accountIdOrName), timePointSec.toRaw(expirationTime), uint32.toRaw(reviewPeriod), bool.toRaw(shouldDoBroadcastToNetwork)]]);
    }
    /**
     * Destroy a transaction builder.
     * @param {number} transactionTypeHandle handle of the transaction builder
     * @returns {Promise<void>}
     */

  }, {
    key: "removeBuilderTransaction",
    value: function removeBuilderTransaction(transactionTypeHandle) {
      return this.wsProvider.call([0, 'remove_builder_transaction', [uint16.toRaw(transactionTypeHandle)]]);
    }
    /**
     * Converts a signed_transaction in JSON form to its binary representation.
     * @param {any} tr the transaction to serialize
     * @returns {Promise<String>} the binary form of the transaction. It will not be hex encoded,
     * this returns a raw string that may have null characters embedded in it
     */

  }, {
    key: "serializeTransaction",
    value: function serializeTransaction(tr) {
      return this.wsProvider.call([0, 'serialize_transaction', [signedTransaction.toRaw(tr)]]);
    }
    /**
     * Signs a transaction.
     * Given a fully-formed transaction that is only lacking signatures, this signs
     * the transaction with the necessary keys and optionally broadcasts the transaction.
     * @param {any} tr the unsigned transaction
     * @param {boolean} shouldDoBroadcastToNetwork true if you wish to broadcast the transaction
     * @returns {Promise<SignedTransaction>} the signed version of the transaction
     */

  }, {
    key: "signTransaction",
    value: function signTransaction(tr, shouldDoBroadcastToNetwork) {
      return this.wsProvider.call([0, 'sign_transaction', [transaction.toRaw(tr), bool.toRaw(shouldDoBroadcastToNetwork)]]);
    }
    /**
     * Returns an uninitialized object representing a given blockchain operation.
     * This returns a default-initialized object of the given type; it can be used during early development of the
     * wallet when we don't yet have custom commands for creating all of the operations the blockchain supports.
     * Any operation the blockchain supports can be created using the transaction builder's
     * `addOperationToBuilderTransaction`, but to do that from the CLI you need to know what the JSON form of the
     * operation looks like. This will give you a template you can fill in. It's better than nothing.
     * @param {string} operationType the type of operation to return
     * @returns {Promise<Operation>} a default-constructed operation of the given type
     */

  }, {
    key: "getPrototypeOperation",
    value: function getPrototypeOperation(operationType) {
      if (!(0, _validators.isOperationPrototypeExists)(operationType)) {
        return _promise["default"].reject(new Error('This operation does not exists'));
      }

      return this.wsProvider.call([0, 'get_prototype_operation', [string.toRaw(operationType)]]);
    }
    /*
     * @method generateBtcDepositAddress
     * @param {String} accountNameOrId
     * @param {String} backupAddress
     * @param {Boolean} shouldDoBroadcastToNetwork
     * @returns {Promise<SignedTransaction>}
     */

  }, {
    key: "generateBtcDepositAddress",
    value: function generateBtcDepositAddress(accountIdOrName, backupAddress, shouldDoBroadcastToNetwork) {
      if (!((0, _validators.isAccountId)(accountIdOrName) || (0, _validators.isAccountName)(accountIdOrName))) {
        throw new Error('accounts id or name should be string and valid');
      }

      if (!(0, _validators.isBoolean)(shouldDoBroadcastToNetwork)) return _promise["default"].reject(new Error('broadcast should be a boolean'));
      return this.wsProvider.call([0, 'generate_btc_deposit_address', [accountIdOrName, backupAddress, shouldDoBroadcastToNetwork]]);
    }
    /**
     * @method getBtcAddress
     * @param {string} account
     * @returns {Promise<unknown[]>}
     */

  }, {
    key: "getBtcAddress",
    value: function getBtcAddress(account) {
      if (!(0, _validators.isAccountId)(account) || !(0, _validators.isAccountName)(account)) throw new Error('account should be valid');
      return this.wsProvider.call([0, 'get_btc_address', [account]]);
    }
    /**
     * @method getBtcDepositScript
     * @param {String} btcDepositAddress
     * @returns {Promise<String>}
     */

  }, {
    key: "getBtcDepositScript",
    value: function getBtcDepositScript(btcDepositAddress) {
      return this.wsProvider.call([0, 'get_btc_deposit_script', [btcDepositAddress]]);
    }
    /**
     * @method createBtcStakeAddress
     * @param {string} account
     * @param {string} userPubkey
     * @param {bool} broadcast
     * @returns {Promise<any>}
     */

  }, {
    key: "createBtcStakeAddress",
    value: function createBtcStakeAddress(accountNameOrId, userPubkey, broadcast) {
      if (!(0, _validators.isAccountIdOrName)(accountNameOrId)) {
        return _promise["default"].reject(new Error('Accounts id or name should be string and valid'));
      }

      return this.wsProvider.call([0, 'create_btc_stake_address', [string.toRaw(accountNameOrId), string.toRaw(userPubkey), bool.toRaw(broadcast)]]);
    }
    /**
     * @method getBtcStakeAddress
     * @param {string} accountNameOrId
     * @returns {Promise<any>}
     */

  }, {
    key: "getBtcStakeAddress",
    value: function getBtcStakeAddress(accountNameOrId) {
      if (!(0, _validators.isAccountIdOrName)(accountNameOrId)) {
        return _promise["default"].reject(new Error('Accounts id or name should be string and valid'));
      }

      return this.wsProvider.call([0, 'get_btc_stake_address', [string.toRaw(accountNameOrId)]]);
    }
    /**
     * @method withdrawBtc
     * @param {String} accountIdOrName
     * @param {String} addressToWithdraw
     * @param {Number} amount
     * @param {Boolean} shouldDoBroadcastToNetwork
     * @returns {Promise<SignedTransaction>}
     */

  }, {
    key: "withdrawBtc",
    value: function withdrawBtc(accountIdOrName, addressToWithdraw, amount, shouldDoBroadcastToNetwork) {
      if (!((0, _validators.isAccountId)(accountIdOrName) || (0, _validators.isAccountName)(accountIdOrName))) {
        throw new Error('accounts id or name should be string and valid');
      }

      if (!(0, _validators.isUInt64)(amount)) return _promise["default"].reject(new Error('amount should be a non negative integer'));
      if (!(0, _validators.isBoolean)(shouldDoBroadcastToNetwork)) return _promise["default"].reject(new Error('broadcast should be a boolean'));
      return this.wsProvider.call([0, 'withdraw_btc', [accountIdOrName, addressToWithdraw, amount, shouldDoBroadcastToNetwork]]);
    }
    /*
     * @method registerAccountWithApi
     * @param {String} name
     * @param {String} activeKey
     * @param {String} echorandKey
     * @param {String|null} evmAddress
     * @returns {Promise<void>}
     */

  }, {
    key: "registerAccountWithApi",
    value: function registerAccountWithApi(name, activeKey, echorandKey, evmAddress) {
      if (!(0, _validators.isAccountName)(name)) return _promise["default"].reject(new Error('new account name is invalid'));
      if (!(0, _validators.isPublicKey)(activeKey)) return _promise["default"].reject(new Error('active key is invalid'));
      if (!(0, _validators.isPublicKey)(echorandKey)) return _promise["default"].reject(new Error('echorand key is invalid'));
      return this.wsProvider.call([0, 'register_account_with_api', [name, activeKey, echorandKey, evmAddress]]);
    }
    /**
     * @method listFrozenBalances
     * @param {String} accountNameOrId
     * @returns {Promise<Array>}
     */

  }, {
    key: "listFrozenBalances",
    value: function listFrozenBalances(accountNameOrId) {
      if (!((0, _validators.isAccountName)(accountNameOrId) || (0, _validators.isAccountId)(accountNameOrId))) {
        return _promise["default"].reject(new Error('Account name or id is invalid'));
      }

      return this.wsProvider.call([0, 'list_frozen_balances', [accountNameOrId]]);
    }
    /**
     * @method transfer
     * @param {String} fromAccountNameOrId
     * @param {Number} amount
     * @param {String} assetIdOrName
     * @param {number} duration
     * @param {Boolean} shouldDoBroadcastToNetwork
     * @returns {Promise<SignedTransaction>}
     */

  }, {
    key: "freezeBalance",
    value: function freezeBalance(fromAccountNameOrId, amount, assetIdOrName, duration, shouldDoBroadcastToNetwork) {
      if (!(0, _validators.isAccountId)(fromAccountNameOrId) || (0, _validators.isAccountName)(fromAccountNameOrId)) {
        return _promise["default"].reject(new Error('Account name or id is invalid'));
      }

      if (!(0, _validators.isUInt64)(amount)) return _promise["default"].reject(new Error('amount should be a non negative integer'));

      if (!(0, _validators.isAssetId)(assetIdOrName) || (0, _validators.isAssetName)(assetIdOrName)) {
        return _promise["default"].reject(new Error('Account name or id is invalid'));
      }

      if (!(0, _validators.isUInt64)(duration)) return _promise["default"].reject(new Error('duration should be a non negative integer'));
      if (!(0, _validators.isBoolean)(shouldDoBroadcastToNetwork)) return _promise["default"].reject(new Error('Broadcast should be a boolean'));
      return this.wsProvider.call([0, 'freeze_balance', [fromAccountNameOrId, amount, assetIdOrName, duration, shouldDoBroadcastToNetwork]]);
    }
    /**
     * Sends the request to unfreeze frozen balance
     * @param {string} account the name or id of the freeze balance holder
     * @param {string[]} objects_to_unfreeze the ids of the objects with frozen balance you want to unfreeze which you
     * can get from method `listFrozenBalances`
     * @param {boolean} [broadcast] true to broadcast the transaction on the network
     * @returns {Promise<SignedTransaction>} the signed transaction requesting unfreezeing frozen balance
     * @example ```ts
     * echo.walletApi.requestUnfreezeBalance('nathan', ['1.9.0', '1.9.1'], true);
     * ```
     */

  }, {
    key: "requestUnfreezeBalance",
    value: function () {
      var _requestUnfreezeBalance = (0, _asyncToGenerator2["default"])( /*#__PURE__*/_regenerator["default"].mark(function _callee16(account, objectsToUnfreeze) {
        var broadcast,
            _args16 = arguments;
        return _regenerator["default"].wrap(function _callee16$(_context16) {
          while (1) {
            switch (_context16.prev = _context16.next) {
              case 0:
                broadcast = _args16.length > 2 && _args16[2] !== undefined ? _args16[2] : false;

                if ((0, _validators.isAccountIdOrName)(account)) {
                  _context16.next = 3;
                  break;
                }

                throw new Error('Invalid account id or name format');

              case 3:
                if ((0, _isArray["default"])(objectsToUnfreeze)) {
                  _context16.next = 5;
                  break;
                }

                throw new Error('Objects to unfreeze is not an array');

              case 5:
                if (!(0, _some["default"])(objectsToUnfreeze).call(objectsToUnfreeze, function (id) {
                  return !(0, _validators.isFrozenBalanceId)(id);
                })) {
                  _context16.next = 7;
                  break;
                }

                throw new Error('Invalid object to unfreeze id format');

              case 7:
                if (!(typeof broadcast !== 'boolean')) {
                  _context16.next = 9;
                  break;
                }

                throw new Error('Broadcast parameter should be boolean');

              case 9:
                return _context16.abrupt("return", this.wsProvider.call([0, 'request_unfreeze_balance', [account, objectsToUnfreeze, broadcast]]));

              case 10:
              case "end":
                return _context16.stop();
            }
          }
        }, _callee16, this);
      }));

      function requestUnfreezeBalance(_x45, _x46) {
        return _requestUnfreezeBalance.apply(this, arguments);
      }

      return requestUnfreezeBalance;
    }()
    /**
     * @method getCommitteeFrozenBalance
     * @param {String} ownerAccount
     * @returns {Promise<CommitteeFrozenBalance>}
     */

  }, {
    key: "getCommitteeFrozenBalance",
    value: function getCommitteeFrozenBalance(ownerAccount) {
      if (!(0, _validators.isAccountIdOrName)(ownerAccount)) {
        return _promise["default"].reject(new Error('Account name or id is invalid'));
      }

      return this.wsProvider.call([0, 'get_committee_frozen_balance', [string.toRaw(ownerAccount)]]);
    }
    /**
     * @method committeeFreezeBalance
     * @param {String} ownerAccount
     * @param {String} amount
     * @param {Boolean} broadcast
     * @returns {Promise<SignedTransaction>}
     */

  }, {
    key: "committeeFreezeBalance",
    value: function committeeFreezeBalance(ownerAccount, amount) {
      var broadcast = arguments.length > 2 && arguments[2] !== undefined ? arguments[2] : false;
      if (!(0, _validators.isAccountIdOrName)(ownerAccount)) return _promise["default"].reject(new Error('Account name or id is invalid'));
      if (!(0, _validators.isValidAmount)(amount)) return _promise["default"].reject(new Error('Invalid amount'));
      return this.wsProvider.call([0, 'committee_freeze_balance', [string.toRaw(ownerAccount), string.toRaw(amount), bool.toRaw(broadcast)]]);
    }
    /**
     * @method committeeWithdrawBalance
     * @param {String} ownerAccount
     * @param {String} amount
     * @param {Boolean} broadcast
     * @returns {Promise<SignedTransaction>}
     */

  }, {
    key: "committeeWithdrawBalance",
    value: function committeeWithdrawBalance(ownerAccount, amount) {
      var broadcast = arguments.length > 2 && arguments[2] !== undefined ? arguments[2] : false;
      if (!(0, _validators.isAccountIdOrName)(ownerAccount)) return _promise["default"].reject(new Error('Account name or id is invalid'));
      if (!(0, _validators.isValidAmount)(amount)) return _promise["default"].reject(new Error('Invalid amount'));
      return this.wsProvider.call([0, 'committee_withdraw_balance', [string.toRaw(ownerAccount), string.toRaw(amount), bool.toRaw(broadcast)]]);
    }
    /**
     * @method createVestingLinearPolicy
     * @param {String} creatorName name of the creator
     * @param {String} ownerName name of the owner
     * @param {string} amount the amount of vesting
     * @param {string} assetName the symbol of the asset
     * @param {import('../../serializers/basic/TimePointSec').TInput} beginTime
     * @param {number} vestingCliffSeconds vesting cliff in seconds
     * @param {number} vestingDurationSeconds vesting duration in seconds
     * @param {Boolean} broadcast
     * @returns {Promise<SignedTransaction>}
     */

  }, {
    key: "createVestingLinearPolicy",
    value: function createVestingLinearPolicy(creatorName, ownerName, amount, assetName, beginTime, vestingCliffSeconds, vestingDurationSeconds) {
      var broadcast = arguments.length > 7 && arguments[7] !== undefined ? arguments[7] : false;
      if (!(0, _validators.isAccountName)(creatorName)) return _promise["default"].reject(new Error('creator account name is invalid'));
      if (!(0, _validators.isAccountName)(ownerName)) return _promise["default"].reject(new Error('owner account name is invalid'));
      if (!(0, _validators.isValidAmount)(amount)) return _promise["default"].reject(new Error('Invalid amount'));

      if (!(0, _validators.isAssetName)(assetName)) {
        return _promise["default"].reject(new Error('Assets id or name should be string and valid'));
      }

      if (!(0, _validators.isUInt32)(vestingCliffSeconds)) {
        return _promise["default"].reject(new Error('Vesting cliff should be uint 32'));
      }

      if (!(0, _validators.isUInt32)(vestingDurationSeconds)) {
        return _promise["default"].reject(new Error('Vesting duration should be uint 32'));
      }

      return this.wsProvider.call([0, 'create_vesting_linear_policy', [string.toRaw(creatorName), string.toRaw(ownerName), string.toRaw(amount), string.toRaw(assetName), timePointSec.toRaw(beginTime), uint32.toRaw(vestingCliffSeconds), uint32.toRaw(vestingDurationSeconds), bool.toRaw(broadcast)]]);
    }
    /**
     * @method createVestingCddPolicy
     * @param {String} creatorName name of the creator
     * @param {String} ownerName name of the owner
     * @param {string} amount the amount of vesting
     * @param {string} assetName the symbol of the asset
     * @param {number} vestingCliffSeconds vesting cliff in seconds
     * @param {number} vestingDurationSeconds vesting duration in seconds
     * @param {Boolean} broadcast
     * @returns {Promise<SignedTransaction>}
     */

  }, {
    key: "createVestingCddPolicy",
    value: function createVestingCddPolicy(creatorName, ownerName, amount, assetName, vestingSeconds) {
      var broadcast = arguments.length > 5 && arguments[5] !== undefined ? arguments[5] : false;
      if (!(0, _validators.isAccountName)(creatorName)) return _promise["default"].reject(new Error('creator account name is invalid'));
      if (!(0, _validators.isAccountName)(ownerName)) return _promise["default"].reject(new Error('owner account name is invalid'));
      if (!(0, _validators.isValidAmount)(amount)) return _promise["default"].reject(new Error('Invalid amount'));

      if (!(0, _validators.isAssetName)(assetName)) {
        return _promise["default"].reject(new Error('Assets id or name should be string and valid'));
      }

      if (!(0, _validators.isUInt32)(vestingSeconds)) {
        return _promise["default"].reject(new Error('Vesting seconds should be uint 32'));
      }

      return this.wsProvider.call([0, 'create_vesting_cdd_policy', [string.toRaw(creatorName), string.toRaw(ownerName), string.toRaw(amount), string.toRaw(assetName), uint32.toRaw(vestingSeconds), bool.toRaw(broadcast)]]);
    }
    /**
     * @method createActivateCommitteeMemberProposal
     * @param {String} sender
     * @param {String} committeeToActivate
     * @param {Number} expirationTime
     * @param {Boolean} broadcast
     * @returns {Promise<SignedTransaction>}
     */

  }, {
    key: "createActivateCommitteeMemberProposal",
    value: function createActivateCommitteeMemberProposal(sender, committeeToActivate, expirationTime) {
      var broadcast = arguments.length > 3 && arguments[3] !== undefined ? arguments[3] : false;
      if (!(0, _validators.isAccountIdOrName)(sender)) return _promise["default"].reject(new Error('Account name or id is invalid'));
      if (!(0, _validators.isCommitteeMemberId)(committeeToActivate)) return _promise["default"].reject(new Error('Invalid committee member id'));
      return this.wsProvider.call([0, 'create_activate_committee_member_proposal', [accountId.toRaw(sender), committeeMemberId.toRaw(committeeToActivate), timePointSec.toRaw(expirationTime), bool.toRaw(broadcast)]]);
    }
    /**
     * @method createDeactivateCommitteeMemberProposal
     * @param {String} sender
     * @param {String} committeeTodeactivate
     * @param {Number} expirationTime
     * @param {Boolean} broadcast
     * @returns {Promise<SignedTransaction>}
     */

  }, {
    key: "createDeactivateCommitteeMemberProposal",
    value: function createDeactivateCommitteeMemberProposal(sender, committeeTodeactivate, expirationTime) {
      var broadcast = arguments.length > 3 && arguments[3] !== undefined ? arguments[3] : false;
      if (!(0, _validators.isAccountIdOrName)(sender)) return _promise["default"].reject(new Error('Account name or id is invalid'));

      if (!(0, _validators.isCommitteeMemberId)(committeeTodeactivate)) {
        return _promise["default"].reject(new Error('Invalid committee member id'));
      }

      return this.wsProvider.call([0, 'create_deactivate_committee_member_proposal', [accountId.toRaw(sender), committeeMemberId.toRaw(committeeTodeactivate), timePointSec.toRaw(expirationTime), bool.toRaw(broadcast)]]);
    }
    /**
     * @method updateCommitteeMember
     * @param {String} ownerAccount
     * @param {String} newUrl
     * @param {String} newEthAddress
     * @param {String} newBtcPublicKey
     * @param {Boolean} broadcast
     * @returns {Promise<SignedTransaction>}
     */

  }, {
    key: "updateCommitteeMember",
    value: function updateCommitteeMember(ownerAccount, newUrl, newEthAddress, newBtcPublicKey) {
      var broadcast = arguments.length > 4 && arguments[4] !== undefined ? arguments[4] : false;
      if (!(0, _validators.isAccountIdOrName)(ownerAccount)) return _promise["default"].reject(new Error('Account name or id is invalid'));

      if (newUrl && !(0, _validators.validateUrl)(newUrl) && newUrl !== '') {
        return _promise["default"].reject(new Error('Url should be string and valid'));
      }

      return this.wsProvider.call([0, 'update_committee_member', [accountId.toRaw(ownerAccount), string.toRaw(newUrl), string.toRaw(newEthAddress), string.toRaw(newBtcPublicKey), bool.toRaw(broadcast)]]);
    }
    /**
     * @method createCommitteeMember
     * @param {String} ownerAccount
     * @param {String} url
     * @param {String} ethereumAddress
     * @param {String} btcPublicKey
     * @param {Boolean} broadcast
     * @returns {Promise<SignedTransaction>}
     */

  }, {
    key: "createCommitteeMember",
    value: function createCommitteeMember(ownerAccount, url, amount, ethereumAddress, btcPublicKey) {
      var broadcast = arguments.length > 5 && arguments[5] !== undefined ? arguments[5] : false;
      if (!(0, _validators.isAccountIdOrName)(ownerAccount)) return _promise["default"].reject(new Error('Account name or id is invalid'));

      if (url && !(0, _validators.validateUrl)(url) && url !== '') {
        return _promise["default"].reject(new Error('Url should be string and valid'));
      }

      if (!(0, _validators.isValidAmount)(amount)) return _promise["default"].reject(new Error('Invalid number'));
      return this.wsProvider.call([0, 'create_committee_member', [accountId.toRaw(ownerAccount), string.toRaw(url), string.toRaw(amount), string.toRaw(ethereumAddress), string.toRaw(btcPublicKey), bool.toRaw(broadcast)]]);
    }
  }]);
  return WalletAPI;
}();

var _default = WalletAPI;
exports["default"] = _default;