"use strict";

var _sliceInstanceProperty2 = require("@babel/runtime-corejs3/core-js-stable/instance/slice");

var _Array$from = require("@babel/runtime-corejs3/core-js-stable/array/from");

var _Symbol = require("@babel/runtime-corejs3/core-js-stable/symbol");

var _getIteratorMethod = require("@babel/runtime-corejs3/core-js/get-iterator-method");

var _Array$isArray = require("@babel/runtime-corejs3/core-js-stable/array/is-array");

var _Object$defineProperty = require("@babel/runtime-corejs3/core-js-stable/object/define-property");

var _interopRequireDefault = require("@babel/runtime-corejs3/helpers/interopRequireDefault");

_Object$defineProperty(exports, "__esModule", {
  value: true
});

exports["default"] = void 0;

var _includes = _interopRequireDefault(require("@babel/runtime-corejs3/core-js-stable/instance/includes"));

var _isInteger = _interopRequireDefault(require("@babel/runtime-corejs3/core-js-stable/number/is-integer"));

var _keys = _interopRequireDefault(require("@babel/runtime-corejs3/core-js-stable/object/keys"));

var _now = _interopRequireDefault(require("@babel/runtime-corejs3/core-js-stable/date/now"));

var _map = _interopRequireDefault(require("@babel/runtime-corejs3/core-js-stable/instance/map"));

var _slice = _interopRequireDefault(require("@babel/runtime-corejs3/core-js-stable/instance/slice"));

var _setTimeout2 = _interopRequireDefault(require("@babel/runtime-corejs3/core-js-stable/set-timeout"));

var _bind = _interopRequireDefault(require("@babel/runtime-corejs3/core-js-stable/instance/bind"));

var _slicedToArray2 = _interopRequireDefault(require("@babel/runtime-corejs3/helpers/slicedToArray"));

var _classCallCheck2 = _interopRequireDefault(require("@babel/runtime-corejs3/helpers/classCallCheck"));

var _createClass2 = _interopRequireDefault(require("@babel/runtime-corejs3/helpers/createClass"));

var _immutable = require("immutable");

var _validators = require("../utils/validators");

var _constants = require("../constants");

function _createForOfIteratorHelper(o, allowArrayLike) { var it = typeof _Symbol !== "undefined" && _getIteratorMethod(o) || o["@@iterator"]; if (!it) { if (_Array$isArray(o) || (it = _unsupportedIterableToArray(o)) || allowArrayLike && o && typeof o.length === "number") { if (it) o = it; var i = 0; var F = function F() {}; return { s: F, n: function n() { if (i >= o.length) return { done: true }; return { done: false, value: o[i++] }; }, e: function e(_e) { throw _e; }, f: F }; } throw new TypeError("Invalid attempt to iterate non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method."); } var normalCompletion = true, didErr = false, err; return { s: function s() { it = it.call(o); }, n: function n() { var step = it.next(); normalCompletion = step.done; return step; }, e: function e(_e2) { didErr = true; err = _e2; }, f: function f() { try { if (!normalCompletion && it["return"] != null) it["return"](); } finally { if (didErr) throw err; } } }; }

function _unsupportedIterableToArray(o, minLen) { var _context5; if (!o) return; if (typeof o === "string") return _arrayLikeToArray(o, minLen); var n = _sliceInstanceProperty2(_context5 = Object.prototype.toString.call(o)).call(_context5, 8, -1); if (n === "Object" && o.constructor) n = o.constructor.name; if (n === "Map" || n === "Set") return _Array$from(o); if (n === "Arguments" || /^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(n)) return _arrayLikeToArray(o, minLen); }

function _arrayLikeToArray(arr, len) { if (len == null || len > arr.length) len = arr.length; for (var i = 0, arr2 = new Array(len); i < len; i++) { arr2[i] = arr[i]; } return arr2; }

/** @typedef {{ isUsed?: boolean, expirationTime?: number | null, minCleaningTime?: number } | null} Options */
var Cache = /*#__PURE__*/function () {
  /**
   * @constructor
   *
   * @param {Options} [opts]
   * Init cache and redux
   */
  function Cache(opts) {
    var _context;

    (0, _classCallCheck2["default"])(this, Cache);
    if (opts === null) opts = {
      isUsed: false
    };else if (opts === undefined) opts = {};
    var _opts = opts,
        isUsed = _opts.isUsed,
        blocksLimit = _opts.blocksLimit,
        expirationTime = _opts.expirationTime,
        minCleaningTime = _opts.minCleaningTime;
    this.isUsed = isUsed === undefined ? _constants.USE_CACHE_BY_DEFAULT : isUsed;
    this.expirationTime = expirationTime === undefined ? _constants.DEFAULT_CACHE_EXPIRATION_TIME : expirationTime;

    if (!(0, _includes["default"])(_context = [null, Number.POSITIVE_INFINITY, undefined]).call(_context, blocksLimit) && (!(0, _isInteger["default"])(blocksLimit) || blocksLimit < 0)) {
      throw new Error('Invalid "blockLimit" cache parameter');
    }

    this.blocksLimit = blocksLimit === undefined ? _constants.DEFAULT_BLOCKS_EXPIRATION_NUMBER : blocksLimit;
    this.minCleaningTime = minCleaningTime === undefined ? _constants.DEFAULT_MIN_CACHE_CLEANING_TIME : minCleaningTime;
    this.redux = {
      store: null
    };
    /** @type {{ time: number, map: string, key: string }[]} */

    this.expirations = [];
    this.blocksExpirations = [];
    this.timeout = null;
    this.reset();
  }
  /**
   * @method reset
   *
   * Reset cache and redux
   */


  (0, _createClass2["default"])(Cache, [{
    key: "reset",
    value: function reset() {
      this.subbedAccounts = new _immutable.Map();
      this.subbedCommittee = new _immutable.Map();
      this.getFullAccountsSubscriptions = new _immutable.Map();
      this.objectsById = new _immutable.Map();
      this.fullAccounts = new _immutable.Map();
      this.accountsByName = new _immutable.Map();
      this.accountsById = new _immutable.Map();
      this.accountsIdByKey = (0, _immutable.Map)();
      this.accountAddressesByAccountId = (0, _immutable.Map)();
      this.accountEthAddressByAccountId = (0, _immutable.Map)();
      this.accountBtcAddressByAccountId = (0, _immutable.Map)();
      this.assetByAssetId = new _immutable.Map();
      this.assetBySymbol = new _immutable.Map();
      this.dynamicAssetDataByDynamicAssetDataId = new _immutable.Map();
      this.bitAssetsByBitAssetId = new _immutable.Map();
      this.dynamicIdToAssetId = new _immutable.Map();
      this.bitAssetIdToAssetId = new _immutable.Map();
      this.contractsByContractId = new _immutable.Map();
      this.fullContractsByContractId = new _immutable.Map();
      this.contractResultsByContractResultId = new _immutable.Map();
      this.contractHistoryByContractId = new _immutable.Map();
      this.contractObjectByContractId = new _immutable.Map();
      this.blockHeadersByBlockNumber = (0, _immutable.Map)();
      this.blocks = new _immutable.Map();
      this.transactionsByBlockAndIndex = new _immutable.Map();
      this.committeeMembersByAccountId = new _immutable.Map();
      this.committeeMembersByCommitteeMemberId = new _immutable.Map();
      this.objectsByVoteId = new _immutable.Map();
      this.accountsBalanceByAccountId = new _immutable.Map();
      this.accountsBalanceByAccountName = new _immutable.Map();
      this.accountReferencesByAccountId = new _immutable.Map();
      this.balanceObjectsByBalanceId = new _immutable.Map();
      this.getAccountRefsOfAccountsCalls = new _immutable.Map();
      this.chainProperties = new _immutable.Map();
      this.globalProperties = new _immutable.Map();
      this.config = new _immutable.Map();
      this.chainId = null;
      this.dynamicGlobalProperties = new _immutable.Map();

      this._clearTimeout();

      this.expirations = [];

      this._resetRedux();
    }
  }, {
    key: "_copyCacheToRedux",
    value: function _copyCacheToRedux() {
      if (!this.redux.store) return;
      var keys = (0, _keys["default"])(this);

      var _iterator = _createForOfIteratorHelper(keys),
          _step;

      try {
        for (_iterator.s(); !(_step = _iterator.n()).done;) {
          var field = _step.value;
          var value = this[field];
          this.redux.store.dispatch({
            type: 'ECHO_SET_CACHE',
            payload: {
              field: field,
              value: value
            }
          });
        }
      } catch (err) {
        _iterator.e(err);
      } finally {
        _iterator.f();
      }
    }
  }, {
    key: "_removeExpired",
    value: function _removeExpired() {
      var _context2;

      var date = (0, _now["default"])();
      var expiredCount = 0;

      for (var i = 0; i < this.expirations.length; i += 1) {
        var _this$expirations$i = this.expirations[i],
            map = (0, _map["default"])(_this$expirations$i),
            key = _this$expirations$i.key,
            time = _this$expirations$i.time;
        if (time > date) break;
        this.set(map, this[map]["delete"](key));
        expiredCount += 1;
      }

      this.expirations = (0, _slice["default"])(_context2 = this.expirations).call(_context2, expiredCount);

      this._clearTimeout();

      if (this.expirations.length) {
        var _context3;

        var _this$expirations = (0, _slicedToArray2["default"])(this.expirations, 1),
            _time = _this$expirations[0].time;

        this.timeout = (0, _setTimeout2["default"])((0, _bind["default"])(_context3 = this._removeExpired).call(_context3, this), Math.max(_time - date, this.minCleaningTime));
      }
    }
  }, {
    key: "_clearLastBlock",
    value: function _clearLastBlock() {
      var key = this.blocksExpirations.shift();
      this.set('blocks', this.blocks["delete"](key));
    }
  }, {
    key: "_clearTimeout",
    value: function _clearTimeout() {
      clearTimeout(this.timeout);
      this.timeout = null;
    }
    /**
     * @method setInMap
     *
     * Set in cache and redux
     *
     * @param {Object} map
     * @param {String} key
     * @param {Object} value
     * @returns {Cache}
     */

  }, {
    key: "setInMap",
    value: function setInMap(map, key, value) {
      if (this.isUsed) {
        if (map === _constants.CACHE_MAPS.BLOCKS && this.blocksLimit !== null) {
          if (this.blocksLimit !== 0) {
            this.set(map, this.blocks.set(key, value));
            this.blocksExpirations.push(key);

            if (this.blocksExpirations.length > this.blocksLimit) {
              this._clearLastBlock();
            }
          }
        } else {
          this.set(map, this[map].set(key, value));

          if (this.expirationTime !== null) {
            var _context4;

            this.expirations.push({
              time: (0, _now["default"])() + this.expirationTime,
              map: map,
              key: key
            });
            if (!this.timeout) this.timeout = (0, _setTimeout2["default"])((0, _bind["default"])(_context4 = this._removeExpired).call(_context4, this), this.expirationTime);
          }
        }
      }

      return this;
    }
    /**
     * @method set
     *
     * Set field in cache and redux
     *
     * @param {String} field
     * @param {Object} value
     * @returns {Cache}
     */

  }, {
    key: "set",
    value: function set(field, value) {
      if (this.isUsed) {
        this[field] = value;

        if (this.redux.store) {
          this.redux.store.dispatch({
            type: 'ECHO_SET_CACHE',
            payload: {
              field: field,
              value: value
            }
          });
        }
      }

      return this;
    }
  }, {
    key: "_resetRedux",
    value: function _resetRedux() {
      if (this.redux.store) {
        this.redux.store.dispatch({
          type: 'ECHO_RESET_CACHE'
        });
      }
    }
    /**
     * @method removeRedux
     *
     * Reset redux object
     */

  }, {
    key: "removeRedux",
    value: function removeRedux() {
      this.redux.store = null;
    }
    /**
     * @method setStore
     *
     * Reset redux object
     *
     * @param {Object} store
     */

  }, {
    key: "setStore",
    value: function setStore(_ref) {
      var store = _ref.store;
      if ((0, _validators.isVoid)(store)) return;

      if (!(0, _validators.isObject)(store) || !(0, _validators.isFunction)(store.getState) || !(0, _validators.isFunction)(store.dispatch) || (0, _validators.isVoid)(store.getState())) {
        throw new Error('Expected the state and dispatch to be available');
      }

      this.redux.store = store;

      this._copyCacheToRedux();
    }
    /**
     * @method setStore
     *
     * Set redux store options
     *
     * @param {Object} options
     */

  }, {
    key: "setOptions",
    value: function setOptions(options) {
      if (!(0, _validators.isObject)(options)) return;

      try {
        this.setStore(options);
      } catch (error) {
        throw error;
      }
    }
  }]);
  return Cache;
}();

var _default = Cache;
exports["default"] = _default;