"use strict";

var _typeof = require("@babel/runtime-corejs3/helpers/typeof");

var _WeakMap = require("@babel/runtime-corejs3/core-js-stable/weak-map");

var _Object$defineProperty = require("@babel/runtime-corejs3/core-js-stable/object/define-property");

var _Object$getOwnPropertyDescriptor = require("@babel/runtime-corejs3/core-js-stable/object/get-own-property-descriptor");

var _interopRequireDefault = require("@babel/runtime-corejs3/helpers/interopRequireDefault");

_Object$defineProperty(exports, "__esModule", {
  value: true
});

exports["default"] = void 0;

var _promise = _interopRequireDefault(require("@babel/runtime-corejs3/core-js-stable/promise"));

var _map = _interopRequireDefault(require("@babel/runtime-corejs3/core-js-stable/instance/map"));

var _toConsumableArray2 = _interopRequireDefault(require("@babel/runtime-corejs3/helpers/toConsumableArray"));

var _classCallCheck2 = _interopRequireDefault(require("@babel/runtime-corejs3/helpers/classCallCheck"));

var _createClass2 = _interopRequireDefault(require("@babel/runtime-corejs3/helpers/createClass"));

var _wsConstants = require("../constants/ws-constants");

var Apis = _interopRequireWildcard(require("./apis"));

function _getRequireWildcardCache(nodeInterop) { if (typeof _WeakMap !== "function") return null; var cacheBabelInterop = new _WeakMap(); var cacheNodeInterop = new _WeakMap(); return (_getRequireWildcardCache = function _getRequireWildcardCache(nodeInterop) { return nodeInterop ? cacheNodeInterop : cacheBabelInterop; })(nodeInterop); }

function _interopRequireWildcard(obj, nodeInterop) { if (!nodeInterop && obj && obj.__esModule) { return obj; } if (obj === null || _typeof(obj) !== "object" && typeof obj !== "function") { return { "default": obj }; } var cache = _getRequireWildcardCache(nodeInterop); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = _Object$defineProperty && _Object$getOwnPropertyDescriptor; for (var key in obj) { if (key !== "default" && Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? _Object$getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { _Object$defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj["default"] = obj; if (cache) { cache.set(obj, newObj); } return newObj; }

/** @typedef {import("./providers").WsProvider} WsProvider */

/** @typedef {import("./providers").HttpProvider} HttpProvider */
var EchoApiEngine = /*#__PURE__*/function () {
  /**
   * @param {string[]} apis
   * @param {WsProvider | HttpProvider} provider
   */
  function EchoApiEngine(apis, provider) {
    (0, _classCallCheck2["default"])(this, EchoApiEngine);
    this.provider = provider;
    this[_wsConstants.CHAIN_API.DATABASE_API] = new Apis.DatabaseApi(this.provider);
    this[_wsConstants.CHAIN_API.ASSET_API] = new Apis.AssetApi(this.provider);
    this[_wsConstants.CHAIN_API.NETWORK_BROADCAST_API] = new Apis.NetworkApi(this.provider);
    this[_wsConstants.CHAIN_API.HISTORY_API] = new Apis.HistoryApi(this.provider);
    this[_wsConstants.CHAIN_API.REGISTRATION_API] = new Apis.RegistrationApi(this.provider);
    this[_wsConstants.CHAIN_API.LOGIN_API] = new Apis.LoginApi(this.provider);
    this[_wsConstants.CHAIN_API.NETWORK_NODE_API] = new Apis.NetworkNodeApi(this.provider);
    this[_wsConstants.CHAIN_API.ECHORAND_API] = new Apis.EchoRandApi(this.provider);
    this[_wsConstants.CHAIN_API.DID_API] = new Apis.EchoRandApi(this.provider);
    this.apis = (0, _toConsumableArray2["default"])(apis);
  }

  (0, _createClass2["default"])(EchoApiEngine, [{
    key: "init",
    value: function init() {
      var _context,
          _this = this;

      return _promise["default"].all((0, _map["default"])(_context = this.apis).call(_context, function (apiName) {
        return _this[apiName].init();
      }));
    }
  }]);
  return EchoApiEngine;
}();

exports["default"] = EchoApiEngine;