"use strict";

var _typeof = require("@babel/runtime-corejs3/helpers/typeof");

var _WeakMap = require("@babel/runtime-corejs3/core-js-stable/weak-map");

var _Object$defineProperty = require("@babel/runtime-corejs3/core-js-stable/object/define-property");

var _Object$getOwnPropertyDescriptor = require("@babel/runtime-corejs3/core-js-stable/object/get-own-property-descriptor");

var _interopRequireDefault = require("@babel/runtime-corejs3/helpers/interopRequireDefault");

_Object$defineProperty(exports, "__esModule", {
  value: true
});

exports.unsupportedMethods = exports["default"] = void 0;

var _regenerator = _interopRequireDefault(require("@babel/runtime-corejs3/regenerator"));

var _concat = _interopRequireDefault(require("@babel/runtime-corejs3/core-js-stable/instance/concat"));

var _includes = _interopRequireDefault(require("@babel/runtime-corejs3/core-js-stable/instance/includes"));

var _asyncToGenerator2 = _interopRequireDefault(require("@babel/runtime-corejs3/helpers/asyncToGenerator"));

var _classCallCheck2 = _interopRequireDefault(require("@babel/runtime-corejs3/helpers/classCallCheck"));

var _createClass2 = _interopRequireDefault(require("@babel/runtime-corejs3/helpers/createClass"));

var _axios = _interopRequireDefault(require("axios"));

var ConnectionType = _interopRequireWildcard(require("./connection-types"));

function _getRequireWildcardCache(nodeInterop) { if (typeof _WeakMap !== "function") return null; var cacheBabelInterop = new _WeakMap(); var cacheNodeInterop = new _WeakMap(); return (_getRequireWildcardCache = function _getRequireWildcardCache(nodeInterop) { return nodeInterop ? cacheNodeInterop : cacheBabelInterop; })(nodeInterop); }

function _interopRequireWildcard(obj, nodeInterop) { if (!nodeInterop && obj && obj.__esModule) { return obj; } if (obj === null || _typeof(obj) !== "object" && typeof obj !== "function") { return { "default": obj }; } var cache = _getRequireWildcardCache(nodeInterop); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = _Object$defineProperty && _Object$getOwnPropertyDescriptor; for (var key in obj) { if (key !== "default" && Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? _Object$getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { _Object$defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj["default"] = obj; if (cache) { cache.set(obj, newObj); } return newObj; }

var unsupportedMethods = [// methods with callbacks
'set_subscribe_callback', 'set_pending_transaction_callback', 'set_block_applied_callback', 'get_contract_logs', 'subscribe_contract_logs', // useless for http connection methods
'cancel_all_subscriptions', 'subscribe_contracts', 'unsubscribe_contract_logs'];
exports.unsupportedMethods = unsupportedMethods;

var HttpProvider = /*#__PURE__*/function () {
  function HttpProvider(url) {
    (0, _classCallCheck2["default"])(this, HttpProvider);
    this.url = url;
  }

  (0, _createClass2["default"])(HttpProvider, [{
    key: "connectionType",
    get: function get() {
      return ConnectionType.HTTP;
    }
  }, {
    key: "unsupportedMethods",
    get: function get() {
      var _context;

      return (0, _concat["default"])(_context = []).call(_context, unsupportedMethods);
    }
  }, {
    key: "call",
    value: function () {
      var _call = (0, _asyncToGenerator2["default"])( /*#__PURE__*/_regenerator["default"].mark(function _callee(method, params) {
        var _context2;

        return _regenerator["default"].wrap(function _callee$(_context3) {
          while (1) {
            switch (_context3.prev = _context3.next) {
              case 0:
                if (!(0, _includes["default"])(_context2 = this.unsupportedMethods).call(_context2, method)) {
                  _context3.next = 2;
                  break;
                }

                throw new Error("method ".concat(method, " not supported by http connection"));

              case 2:
                return _context3.abrupt("return", _axios["default"].post(this.url, {
                  jsonrpc: '2.0',
                  id: 0,
                  method: method,
                  params: params
                }).then(function (res) {
                  return res.data.result;
                }));

              case 3:
              case "end":
                return _context3.stop();
            }
          }
        }, _callee, this);
      }));

      function call(_x, _x2) {
        return _call.apply(this, arguments);
      }

      return call;
    }()
  }]);
  return HttpProvider;
}();

exports["default"] = HttpProvider;