"use strict";

var _typeof = require("@babel/runtime-corejs3/helpers/typeof");

var _Reflect$construct = require("@babel/runtime-corejs3/core-js-stable/reflect/construct");

var _WeakMap = require("@babel/runtime-corejs3/core-js-stable/weak-map");

var _Object$defineProperty = require("@babel/runtime-corejs3/core-js-stable/object/define-property");

var _Object$getOwnPropertyDescriptor = require("@babel/runtime-corejs3/core-js-stable/object/get-own-property-descriptor");

var _interopRequireDefault = require("@babel/runtime-corejs3/helpers/interopRequireDefault");

_Object$defineProperty(exports, "__esModule", {
  value: true
});

exports["default"] = void 0;

var _regenerator = _interopRequireDefault(require("@babel/runtime-corejs3/regenerator"));

var _asyncToGenerator2 = _interopRequireDefault(require("@babel/runtime-corejs3/helpers/asyncToGenerator"));

var _classCallCheck2 = _interopRequireDefault(require("@babel/runtime-corejs3/helpers/classCallCheck"));

var _createClass2 = _interopRequireDefault(require("@babel/runtime-corejs3/helpers/createClass"));

var _inherits2 = _interopRequireDefault(require("@babel/runtime-corejs3/helpers/inherits"));

var _possibleConstructorReturn2 = _interopRequireDefault(require("@babel/runtime-corejs3/helpers/possibleConstructorReturn"));

var _getPrototypeOf2 = _interopRequireDefault(require("@babel/runtime-corejs3/helpers/getPrototypeOf"));

var _events = require("events");

var ConnectionType = _interopRequireWildcard(require("./connection-types"));

var _reconnectionWebsocket = _interopRequireDefault(require("./reconnection-websocket"));

var _wsConstants = require("../../constants/ws-constants");

function _getRequireWildcardCache(nodeInterop) { if (typeof _WeakMap !== "function") return null; var cacheBabelInterop = new _WeakMap(); var cacheNodeInterop = new _WeakMap(); return (_getRequireWildcardCache = function _getRequireWildcardCache(nodeInterop) { return nodeInterop ? cacheNodeInterop : cacheBabelInterop; })(nodeInterop); }

function _interopRequireWildcard(obj, nodeInterop) { if (!nodeInterop && obj && obj.__esModule) { return obj; } if (obj === null || _typeof(obj) !== "object" && typeof obj !== "function") { return { "default": obj }; } var cache = _getRequireWildcardCache(nodeInterop); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = _Object$defineProperty && _Object$getOwnPropertyDescriptor; for (var key in obj) { if (key !== "default" && Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? _Object$getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { _Object$defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj["default"] = obj; if (cache) { cache.set(obj, newObj); } return newObj; }

function _createSuper(Derived) { var hasNativeReflectConstruct = _isNativeReflectConstruct(); return function _createSuperInternal() { var Super = (0, _getPrototypeOf2["default"])(Derived), result; if (hasNativeReflectConstruct) { var NewTarget = (0, _getPrototypeOf2["default"])(this).constructor; result = _Reflect$construct(Super, arguments, NewTarget); } else { result = Super.apply(this, arguments); } return (0, _possibleConstructorReturn2["default"])(this, result); }; }

function _isNativeReflectConstruct() { if (typeof Reflect === "undefined" || !_Reflect$construct) return false; if (_Reflect$construct.sham) return false; if (typeof Proxy === "function") return true; try { Boolean.prototype.valueOf.call(_Reflect$construct(Boolean, [], function () {})); return true; } catch (e) { return false; } }

var WsProvider = /*#__PURE__*/function (_EventEmitter) {
  (0, _inherits2["default"])(WsProvider, _EventEmitter);

  var _super = _createSuper(WsProvider);

  function WsProvider() {
    var _this;

    (0, _classCallCheck2["default"])(this, WsProvider);
    _this = _super.call(this);
    _this._ws_rpc = new _reconnectionWebsocket["default"]();
    _this._connected = false;
    _this._isFirstTime = true;
    _this.onOpenCb = null;
    _this.onCloseCb = null;
    _this.onErrorCb = null;
    return _this;
  }
  /**
   * On open callback
   */


  (0, _createClass2["default"])(WsProvider, [{
    key: "connected",
    get: function get() {
      return this._ws_rpc.connected;
    }
  }, {
    key: "connectionType",
    get: function get() {
      return ConnectionType.WS;
    }
  }, {
    key: "_onOpen",
    value: function _onOpen() {
      if (!this._ws_rpc) return;
      this._connected = true;

      if (this._isFirstTime) {
        this._isFirstTime = false;
      }

      if (this.onOpenCb) this.onOpenCb('open');
      this.emit(_wsConstants.STATUS.OPEN);
    }
    /**
     * On close callback
     */

  }, {
    key: "_onClose",
    value: function _onClose() {
      if (this._isFirstTime) this._isFirstTime = false;
      this._connected = false;
      if (this.onCloseCb) this.onCloseCb('close');
      this.emit(_wsConstants.STATUS.CLOSE);
    }
    /**
     * On error callback
     * @param error
     */

  }, {
    key: "_onError",
    value: function _onError(error) {
      if (this.onErrorCb) this.onErrorCb('error', error);
      this.emit(_wsConstants.STATUS.ERROR);
    }
    /**
     * init params and connect to chain
     * @param {String} url - remote node address,
     * should be (http|https|ws|wws)://(domain|ipv4|ipv6):port(?)/resource(?)?param=param(?).
     * @param {Object} options - connection params.
     * @param {Number} options.connectionTimeout - delay in ms between reconnection requests,
     * 		default call delay before reject it.
     * @param {Number} options.maxRetries - max count retries before close socket.
     * @param {Number} options.pingTimeout - delay time in ms between ping request
     * 		and socket disconnect.
     * @param {Number} options.pingDelay - delay between last recived message and start checking connection.
     * @param {Boolean} options.debug - debug mode status.
     * @returns {Promise}
     */

  }, {
    key: "connect",
    value: function () {
      var _connect = (0, _asyncToGenerator2["default"])( /*#__PURE__*/_regenerator["default"].mark(function _callee(url) {
        var _this2 = this;

        var options,
            _args = arguments;
        return _regenerator["default"].wrap(function _callee$(_context) {
          while (1) {
            switch (_context.prev = _context.next) {
              case 0:
                options = _args.length > 1 && _args[1] !== undefined ? _args[1] : {};
                this.url = url;
                this.options = {
                  connectionTimeout: options.connectionTimeout,
                  maxRetries: options.maxRetries,
                  pingTimeout: options.pingTimeout,
                  pingDelay: options.pingDelay,
                  debug: options.debug
                };
                this.apis = options.apis || _wsConstants.DEFAULT_CHAIN_APIS;
                this._connected = false;
                this._isFirstTime = true;
                if (options.onOpen && typeof options.onOpen === 'function') this.onOpenCb = options.onOpen;
                if (options.onClose && typeof options.onClose === 'function') this.onCloseCb = options.onClose;
                if (options.onError && typeof options.onError === 'function') this.onErrorCb = options.onError;
                if (!this._ws_rpc) this._ws_rpc = new _reconnectionWebsocket["default"]();

                this._ws_rpc.onOpen = function () {
                  return _this2._onOpen();
                };

                this._ws_rpc.onClose = function () {
                  return _this2._onClose();
                };

                this._ws_rpc.onError = function () {
                  return _this2._onError();
                };

                _context.next = 15;
                return this._ws_rpc.connect(url, this.options);

              case 15:
              case "end":
                return _context.stop();
            }
          }
        }, _callee, this);
      }));

      function connect(_x) {
        return _connect.apply(this, arguments);
      }

      return connect;
    }()
  }, {
    key: "call",
    value: function call(params) {
      var timeout = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : this.options.connectionTimeout;
      return this._ws_rpc.call(params, timeout);
    }
    /**
     * Reconnect to chain, can't be used after close
     * @returns {Promise}
     */

  }, {
    key: "reconnect",
    value: function () {
      var _reconnect = (0, _asyncToGenerator2["default"])( /*#__PURE__*/_regenerator["default"].mark(function _callee2() {
        var reconnectResult;
        return _regenerator["default"].wrap(function _callee2$(_context2) {
          while (1) {
            switch (_context2.prev = _context2.next) {
              case 0:
                if (this._ws_rpc) {
                  _context2.next = 2;
                  break;
                }

                throw new Error('Socket close.');

              case 2:
                _context2.next = 4;
                return this._ws_rpc.reconnect();

              case 4:
                reconnectResult = _context2.sent;
                return _context2.abrupt("return", reconnectResult);

              case 6:
              case "end":
                return _context2.stop();
            }
          }
        }, _callee2, this);
      }));

      function reconnect() {
        return _reconnect.apply(this, arguments);
      }

      return reconnect;
    }()
    /**
     * Close socket, delete subscribers
     * @returns {Promise}
     */

  }, {
    key: "close",
    value: function () {
      var _close = (0, _asyncToGenerator2["default"])( /*#__PURE__*/_regenerator["default"].mark(function _callee3() {
        return _regenerator["default"].wrap(function _callee3$(_context3) {
          while (1) {
            switch (_context3.prev = _context3.next) {
              case 0:
                if (!(this._ws_rpc && this._ws_rpc.ws)) {
                  _context3.next = 9;
                  break;
                }

                _context3.prev = 1;
                _context3.next = 4;
                return this._ws_rpc.close();

              case 4:
                _context3.next = 9;
                break;

              case 6:
                _context3.prev = 6;
                _context3.t0 = _context3["catch"](1);
                throw _context3.t0;

              case 9:
              case "end":
                return _context3.stop();
            }
          }
        }, _callee3, this, [[1, 6]]);
      }));

      function close() {
        return _close.apply(this, arguments);
      }

      return close;
    }()
    /**
     * Set debug option
     * @param {Boolean} status
     */

  }, {
    key: "setDebugOption",
    value: function setDebugOption(status) {
      this._ws_rpc.setDebugOption(status);
    }
  }]);
  return WsProvider;
}(_events.EventEmitter);

exports["default"] = WsProvider;