"use strict";

var _Object$keys = require("@babel/runtime-corejs3/core-js-stable/object/keys");

var _Object$getOwnPropertySymbols = require("@babel/runtime-corejs3/core-js-stable/object/get-own-property-symbols");

var _filterInstanceProperty = require("@babel/runtime-corejs3/core-js-stable/instance/filter");

var _Object$getOwnPropertyDescriptor = require("@babel/runtime-corejs3/core-js-stable/object/get-own-property-descriptor");

var _forEachInstanceProperty2 = require("@babel/runtime-corejs3/core-js-stable/instance/for-each");

var _Object$getOwnPropertyDescriptors = require("@babel/runtime-corejs3/core-js-stable/object/get-own-property-descriptors");

var _Object$defineProperties = require("@babel/runtime-corejs3/core-js-stable/object/define-properties");

var _Object$defineProperty = require("@babel/runtime-corejs3/core-js-stable/object/define-property");

var _interopRequireDefault = require("@babel/runtime-corejs3/helpers/interopRequireDefault");

_Object$defineProperty(exports, "__esModule", {
  value: true
});

exports["default"] = void 0;

var _promise = _interopRequireDefault(require("@babel/runtime-corejs3/core-js-stable/promise"));

var _stringify = _interopRequireDefault(require("@babel/runtime-corejs3/core-js-stable/json/stringify"));

var _splice = _interopRequireDefault(require("@babel/runtime-corejs3/core-js-stable/instance/splice"));

var _forEach = _interopRequireDefault(require("@babel/runtime-corejs3/core-js-stable/instance/for-each"));

var _setTimeout2 = _interopRequireDefault(require("@babel/runtime-corejs3/core-js-stable/set-timeout"));

var _includes = _interopRequireDefault(require("@babel/runtime-corejs3/core-js-stable/instance/includes"));

var _indexOf = _interopRequireDefault(require("@babel/runtime-corejs3/core-js-stable/instance/index-of"));

var _regenerator = _interopRequireDefault(require("@babel/runtime-corejs3/regenerator"));

var _slicedToArray2 = _interopRequireDefault(require("@babel/runtime-corejs3/helpers/slicedToArray"));

var _defineProperty2 = _interopRequireDefault(require("@babel/runtime-corejs3/helpers/defineProperty"));

var _asyncToGenerator2 = _interopRequireDefault(require("@babel/runtime-corejs3/helpers/asyncToGenerator"));

var _classCallCheck2 = _interopRequireDefault(require("@babel/runtime-corejs3/helpers/classCallCheck"));

var _createClass2 = _interopRequireDefault(require("@babel/runtime-corejs3/helpers/createClass"));

var _isomorphicWs = _interopRequireDefault(require("isomorphic-ws"));

var _wsConstants = require("../../constants/ws-constants");

var _validators = require("../../utils/validators");

function ownKeys(object, enumerableOnly) { var keys = _Object$keys(object); if (_Object$getOwnPropertySymbols) { var symbols = _Object$getOwnPropertySymbols(object); if (enumerableOnly) { symbols = _filterInstanceProperty(symbols).call(symbols, function (sym) { return _Object$getOwnPropertyDescriptor(object, sym).enumerable; }); } keys.push.apply(keys, symbols); } return keys; }

function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i] != null ? arguments[i] : {}; if (i % 2) { var _context10; _forEachInstanceProperty2(_context10 = ownKeys(Object(source), true)).call(_context10, function (key) { (0, _defineProperty2["default"])(target, key, source[key]); }); } else if (_Object$getOwnPropertyDescriptors) { _Object$defineProperties(target, _Object$getOwnPropertyDescriptors(source)); } else { var _context11; _forEachInstanceProperty2(_context11 = ownKeys(Object(source))).call(_context11, function (key) { _Object$defineProperty(target, key, _Object$getOwnPropertyDescriptor(source, key)); }); } } return target; }

var ReconnectionWebSocket = /*#__PURE__*/function () {
  function ReconnectionWebSocket() {
    (0, _classCallCheck2["default"])(this, ReconnectionWebSocket);
    this.onOpen = null;
    this.onClose = null;
    this.onError = null;
    this._currentRetry = 0;
    this._pingDelayId = null;
    this._options = {};
    this._cbId = 0;
    this._responseCbId = 0;
    this._cbs = {};
    this._subs = [];
    this._unsub = {};
  }
  /**
   * init params and connect to chain
   *
   * @param {string} url remote node address,
   * should be (http|https|ws|wws)://(domain|ipv4|ipv6):port(?)/resource(?)?param=param(?).
   *
   * @param {Object} options connection params.
   *
   * @param {number} options.connectionTimeout
   * delay in ms between reconnection requests, default call delay before reject it.
   *
   * @param {number} options.maxRetries - max count retries before close socket.
   * @param {number} options.pingTimeout - delay time in ms between ping request and socket disconnect.
   * @param {number} options.pingDelay - delay between last recived message and start checking connection.
   * @param {boolean} options.debug - debug mode status.
   * @returns {Promise<void>}
   */


  (0, _createClass2["default"])(ReconnectionWebSocket, [{
    key: "connected",
    get: function get() {
      return this.ws && this.ws.readyState === _isomorphicWs["default"].OPEN;
    }
  }, {
    key: "connect",
    value: function () {
      var _connect2 = (0, _asyncToGenerator2["default"])( /*#__PURE__*/_regenerator["default"].mark(function _callee(url) {
        var options,
            _args = arguments;
        return _regenerator["default"].wrap(function _callee$(_context) {
          while (1) {
            switch (_context.prev = _context.next) {
              case 0:
                options = _args.length > 1 && _args[1] !== undefined ? _args[1] : {};

                if (!this.connected) {
                  _context.next = 4;
                  break;
                }

                _context.next = 4;
                return this.close();

              case 4:
                this._options = {
                  connectionTimeout: (0, _validators.isVoid)(options.connectionTimeout) ? _wsConstants.CONNECTION_TIMEOUT : options.connectionTimeout,
                  maxRetries: (0, _validators.isVoid)(options.maxRetries) ? _wsConstants.MAX_RETRIES : options.maxRetries,
                  pingTimeout: (0, _validators.isVoid)(options.pingTimeout) ? _wsConstants.PING_TIMEOUT : options.pingTimeout,
                  pingDelay: (0, _validators.isVoid)(options.pingDelay) ? _wsConstants.PING_DELAY : options.pingDelay,
                  debug: (0, _validators.isVoid)(options.debug) ? _wsConstants.DEBUG : options.debug
                };
                this.url = url;
                this._isFirstConnection = true;
                this._currentRetry = 0;
                this._forceClosePromise = null;
                this._reconnectionTimeoutId = null;
                this._cbId = 0;
                this._responseCbId = 0;
                this._cbs = {};
                this._cbLogs = [];
                this._subs = [];
                this._unsub = {};
                return _context.abrupt("return", this._connect());

              case 17:
              case "end":
                return _context.stop();
            }
          }
        }, _callee, this);
      }));

      function connect(_x) {
        return _connect2.apply(this, arguments);
      }

      return connect;
    }()
    /**
     * inner connection method
     * @returns {Promise<void>}
     */

  }, {
    key: "_connect",
    value: function _connect() {
      var _this = this;

      this._debugLog('[ReconnectionWebSocket] >---- retry _connect');

      this._currentRetry += 1;
      return new _promise["default"](function (resolve, reject) {
        var ws = null;

        try {
          ws = new _isomorphicWs["default"](_this.url);
        } catch (error) {
          ws = null;

          if (_this._isFirstConnection) {
            _this._isFirstConnection = false;
            return reject(error);
          }
        }

        ws.onopen = function () {
          _this._currentRetry = 0;

          if (_this._isFirstConnection) {
            _this._isFirstConnection = false;
            resolve();
          }

          if (_this.onOpen) _this.onOpen();

          _this._setPingDelay();

          _this._debugLog('[ReconnectionWebSocket] >---- event ----->  ONOPEN');

          return true;
        };

        ws.onmessage = function (message) {
          if (ws !== _this.ws) {
            return false;
          }

          _this._responseHandler(JSON.parse(message.data));

          _this._debugLog('[ReconnectionWebSocket] >---- event ----->  ONMESSAGE');

          _this._setPingDelay();

          return true;
        };

        ws.onclose = function () {
          if (ws !== _this.ws) {
            return false;
          }

          if (_this._isFirstConnection) {
            _this._isFirstConnection = false;
            reject(new Error('Could\'t reach server or bad internet access'));
            return false;
          }

          _this._forceClose();

          return true;
        };

        ws.onerror = function (error) {
          if (ws !== _this.ws) {
            return false;
          }

          if (_this.onError) _this.onError(error);

          _this._debugLog('[ReconnectionWebSocket] >---- event ----->  ONERROR');

          return true;
        };

        _this.ws = ws;
        return ws;
      });
    }
    /**
     * connect to socket, can't be used after close
     * @returns {Promise}
     */

  }, {
    key: "reconnect",
    value: function () {
      var _reconnect = (0, _asyncToGenerator2["default"])( /*#__PURE__*/_regenerator["default"].mark(function _callee2() {
        return _regenerator["default"].wrap(function _callee2$(_context2) {
          while (1) {
            switch (_context2.prev = _context2.next) {
              case 0:
                if (this.ws) {
                  _context2.next = 2;
                  break;
                }

                throw new Error('Socket not exist.');

              case 2:
                this._debugLog('[ReconnectionWebSocket] >---- event ----->  FORCE RECONNECTING');

                _context2.next = 5;
                return this.connect(this.url, this._options);

              case 5:
              case "end":
                return _context2.stop();
            }
          }
        }, _callee2, this);
      }));

      function reconnect() {
        return _reconnect.apply(this, arguments);
      }

      return reconnect;
    }()
    /**
     * set debug option
     * @param {Boolean} status
     */

  }, {
    key: "setDebugOption",
    value: function setDebugOption(status) {
      this._options.debug = Boolean(status);
    }
    /**
     * call a method with params via RPC
     * @param {Array<any>} params
     * @param {Number} timeout - timeout before reject
     * @returns {Promise}
     */

  }, {
    key: "call",
    value: function call(params) {
      var _this2 = this;

      var timeout = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : this._options.connectionTimeout;

      if (!this.ws) {
        return _promise["default"].reject(new Error('Websocket is closed'));
      }

      if (this.ws.readyState !== _isomorphicWs["default"].OPEN) {
        return _promise["default"].reject(new Error("Websocket state error: ".concat(this.ws.readyState)));
      }

      var method = params[1];

      this._debugLog("[ReconnectionWebSocket] >---- call ----->  \"id\":".concat(this._cbId + 1), (0, _stringify["default"])(params));

      this._cbId += 1;

      if (method === 'set_subscribe_callback' || method === 'broadcast_transaction_with_callback' || method === 'set_pending_transaction_callback' || method === 'set_block_applied_callback' || method === 'set_consensus_message_callback' || method === 'submit_registration_solution' || method === 'get_contract_logs' || method === 'subscribe_contract_logs' || method === 'set_echorand_message_callback') {
        this._subs[this._cbId] = {
          callback: params[2][0]
        };
        params[2][0] = this._cbId;

        if (method === 'get_contract_logs') {
          this._cbLogs.push(this._cbId);
        }
      } else if (method === 'unsubscribe_from_accounts') {
        var _context3, _context4;

        if (typeof params[2][0] !== 'function') {
          throw new Error('First parameter of unsub must be the original callback');
        }

        var unSubCb = (0, _splice["default"])(_context3 = params[2]).call(_context3, 0, 1)[0];
        (0, _forEach["default"])(_context4 = this._subs).call(_context4, function (id) {
          if (id.callback === unSubCb) {
            _this2._unsub[_this2._cbId] = id;
          }
        });
      }

      var request = {
        method: 'call',
        params: params
      };
      request.id = this._cbId;
      return new _promise["default"](function (resolve, reject) {
        var timeoutId = (0, _setTimeout2["default"])(function () {
          reject(new Error("RPC call time is over Id: ".concat(request.id)));

          _this2._removePendingRequest(request.id);
        }, timeout);
        _this2._cbs[_this2._cbId] = {
          time: new Date(),
          resolve: method === 'subscribe_contract_logs' ? function () {
            return resolve(params[2][0]);
          } : resolve,
          reject: reject,
          timeoutId: timeoutId
        };

        _this2.ws.send((0, _stringify["default"])(request));
      });
    }
    /**
     * message handler
     * @param response
     */

  }, {
    key: "_responseHandler",
    value: function _responseHandler(response) {
      this._debugLog('[ReconnectionWebSocket] <---- reply ----<', (0, _stringify["default"])(response));

      var sub = false;
      var callback = null;

      if (response.method === 'notice') {
        sub = true;
        response = _objectSpread(_objectSpread({}, response), {}, {
          id: response.params[0]
        });
      }

      if (!sub) {
        callback = this._cbs[response.id];
        this._responseCbId = response.id;
      } else if (this._subs[response.id].callback instanceof Array) {
        var _this$_subs$response$ = (0, _slicedToArray2["default"])(this._subs[response.id].callback, 1);

        callback = _this$_subs$response$[0];
      } else if (typeof this._subs[response.id].callback === 'function') {
        // eslint-disable-next-line prefer-destructuring
        callback = this._subs[response.id].callback;
      }

      if (callback && !sub) {
        var _callback = callback,
            timeoutId = _callback.timeoutId;
        if (timeoutId) clearTimeout(timeoutId);

        if (response.error) {
          callback.reject(response.error);
        } else {
          callback.resolve(response.result);
        }

        this._removeSuccessfulRequest(response.id);
      } else if (callback && sub) {
        var _context5;

        callback(response.params[1]);

        if ((0, _includes["default"])(_context5 = this._cbLogs).call(_context5, response.id)) {
          var _context6, _context7;

          delete this._subs[response.id];
          var indexCb = (0, _indexOf["default"])(_context6 = this._cbLogs).call(_context6, response.id);
          (0, _splice["default"])(_context7 = this._cbLogs).call(_context7, indexCb);
        }
      } else {
        this._debugLog('[ReconnectionWebSocket] >---- warning ---->   Unknown websocket response', response);
      }
    }
    /**
     * get access to chain
     * @param {String} user
     * @param {String} password
     * @param {Number} timeout - timeout before reject
     * @returns {Promise}
     */

  }, {
    key: "login",
    value: function login(user, password) {
      var timeout = arguments.length > 2 && arguments[2] !== undefined ? arguments[2] : this._options.pingTimeout;
      return this.call([1, 'login', [user, password]], timeout);
    }
    /**
     * 	update ping delay timeout
     *  @private
     */

  }, {
    key: "_setPingDelay",
    value: function _setPingDelay() {
      var _this3 = this;

      this._clearPingDelay();

      this._pingDelayId = (0, _setTimeout2["default"])(function () {
        return _this3._ping();
      }, this._options.pingDelay);
    }
    /**
     * clear reconnection timeout
     * @private
     */

  }, {
    key: "_clearReconnectionTimeout",
    value: function _clearReconnectionTimeout() {
      if (this._reconnectionTimeoutId) {
        clearTimeout(this._reconnectionTimeoutId);
        this._reconnectionTimeoutId = null;
      }
    }
    /**
     * 	clear ping delay timeout
     *  @private
     */

  }, {
    key: "_clearPingDelay",
    value: function _clearPingDelay() {
      if (this._pingDelayId) {
        clearTimeout(this._pingDelayId);
        this._pingDelayId = null;
      }
    }
    /**
     * clear waiting calls
     * @private
     */

  }, {
    key: "_clearWaitingCallPromises",
    value: function _clearWaitingCallPromises() {
      var err = new Error(_wsConstants.CONNECTION_CLOSED_ERROR_MESSAGE);

      for (var cbId = this._responseCbId + 1; cbId <= this._cbId; cbId += 1) {
        if (this._cbs[cbId]) this._cbs[cbId].reject(err);
      }
    }
    /**
     * reset calls id
     * @private
     */

  }, {
    key: "_resetId",
    value: function _resetId() {
      this._cbId = 0;
    }
    /**
     * make call for transaction.js connection
     * @private
     */

  }, {
    key: "_ping",
    value: function () {
      var _ping2 = (0, _asyncToGenerator2["default"])( /*#__PURE__*/_regenerator["default"].mark(function _callee3() {
        return _regenerator["default"].wrap(function _callee3$(_context8) {
          while (1) {
            switch (_context8.prev = _context8.next) {
              case 0:
                _context8.prev = 0;
                _context8.next = 3;
                return this.login();

              case 3:
                _context8.next = 10;
                break;

              case 5:
                _context8.prev = 5;
                _context8.t0 = _context8["catch"](0);

                if (!(!this.ws || this.ws.readyState !== _isomorphicWs["default"].OPEN)) {
                  _context8.next = 9;
                  break;
                }

                return _context8.abrupt("return");

              case 9:
                this._forceClose();

              case 10:
              case "end":
                return _context8.stop();
            }
          }
        }, _callee3, this, [[0, 5]]);
      }));

      function _ping() {
        return _ping2.apply(this, arguments);
      }

      return _ping;
    }()
    /**
     * show debug logs
     * @private
     */

  }, {
    key: "_debugLog",
    value: function _debugLog() {
      var _console;

      if (!this._options.debug) return;

      (_console = console).log.apply(_console, arguments);
    }
    /**
     * remove pending request from map
     * @private
     */

  }, {
    key: "_removePendingRequest",
    value: function _removePendingRequest(id) {
      delete this._cbs[id];
      delete this._subs[id];
      delete this._unsub[id];
    }
    /**
     * remove successful request from map
     * @private
     */

  }, {
    key: "_removeSuccessfulRequest",
    value: function _removeSuccessfulRequest(id) {
      delete this._cbs[id];

      if (this._unsub[id]) {
        delete this._subs[this._unsub[id]];
        delete this._unsub[id];
      }
    }
  }, {
    key: "_forceClose",
    value: function _forceClose() {
      var _this4 = this;

      this._debugLog('[ReconnectionWebSocket] >---- _forceClose ');

      var ws = this.ws;
      this.ws = null;

      if (ws) {
        ws.onopen = function () {};

        ws.onclose = function () {};

        ws.onerror = function () {};

        ws.onmessage = function () {};

        ws.close();
      }

      this._clearWaitingCallPromises();

      this._clearPingDelay();

      this._clearReconnectionTimeout();

      this._resetId();

      if (this.onClose && this._currentRetry === 0) this.onClose();

      this._debugLog('[ReconnectionWebSocket] >---- event ----->  ONCLOSE');

      if (this._forceClosePromise) {
        this._forceClosePromise();

        this._forceClosePromise = null;
        return true;
      }

      if (this._currentRetry >= this._options.maxRetries) {
        return true;
      }

      this._reconnectionTimeoutId = (0, _setTimeout2["default"])( /*#__PURE__*/(0, _asyncToGenerator2["default"])( /*#__PURE__*/_regenerator["default"].mark(function _callee4() {
        return _regenerator["default"].wrap(function _callee4$(_context9) {
          while (1) {
            switch (_context9.prev = _context9.next) {
              case 0:
                _context9.prev = 0;
                _context9.next = 3;
                return _this4._connect();

              case 3:
                _context9.next = 7;
                break;

              case 5:
                _context9.prev = 5;
                _context9.t0 = _context9["catch"](0);

              case 7:
              case "end":
                return _context9.stop();
            }
          }
        }, _callee4, null, [[0, 5]]);
      })), this._options.connectionTimeout);
      return true;
    }
    /**
     *
     * @returns {Promise}
     */

  }, {
    key: "close",
    value: function close() {
      var _this5 = this;

      if (!this.ws || this.ws.readyState === _isomorphicWs["default"].CLOSING || this.ws.readyState === _isomorphicWs["default"].CLOSED) {
        return _promise["default"].reject(new Error('Socket already close'));
      }

      return new _promise["default"](function (resolve) {
        _this5._forceClosePromise = resolve;

        _this5._forceClose();
      });
    }
  }]);
  return ReconnectionWebSocket;
}();

exports["default"] = ReconnectionWebSocket;