"use strict";

var _Reflect$construct = require("@babel/runtime-corejs3/core-js-stable/reflect/construct");

var _Object$defineProperty = require("@babel/runtime-corejs3/core-js-stable/object/define-property");

var _interopRequireDefault = require("@babel/runtime-corejs3/helpers/interopRequireDefault");

_Object$defineProperty(exports, "__esModule", {
  value: true
});

exports["default"] = void 0;

var _regenerator = _interopRequireDefault(require("@babel/runtime-corejs3/regenerator"));

var _includes = _interopRequireDefault(require("@babel/runtime-corejs3/core-js-stable/instance/includes"));

var _bind = _interopRequireDefault(require("@babel/runtime-corejs3/core-js-stable/instance/bind"));

var _reduce = _interopRequireDefault(require("@babel/runtime-corejs3/core-js-stable/instance/reduce"));

var _concat = _interopRequireDefault(require("@babel/runtime-corejs3/core-js-stable/instance/concat"));

var _forEach = _interopRequireDefault(require("@babel/runtime-corejs3/core-js-stable/instance/for-each"));

var _find = _interopRequireDefault(require("@babel/runtime-corejs3/core-js-stable/instance/find"));

var _filter = _interopRequireDefault(require("@babel/runtime-corejs3/core-js-stable/instance/filter"));

var _every = _interopRequireDefault(require("@babel/runtime-corejs3/core-js-stable/instance/every"));

var _keys = _interopRequireDefault(require("@babel/runtime-corejs3/core-js-stable/instance/keys"));

var _slice = _interopRequireDefault(require("@babel/runtime-corejs3/core-js-stable/instance/slice"));

var _map = _interopRequireDefault(require("@babel/runtime-corejs3/core-js-stable/instance/map"));

var _promise = _interopRequireDefault(require("@babel/runtime-corejs3/core-js-stable/promise"));

var _toArray2 = _interopRequireDefault(require("@babel/runtime-corejs3/helpers/toArray"));

var _slicedToArray2 = _interopRequireDefault(require("@babel/runtime-corejs3/helpers/slicedToArray"));

var _toConsumableArray2 = _interopRequireDefault(require("@babel/runtime-corejs3/helpers/toConsumableArray"));

var _asyncToGenerator2 = _interopRequireDefault(require("@babel/runtime-corejs3/helpers/asyncToGenerator"));

var _classCallCheck2 = _interopRequireDefault(require("@babel/runtime-corejs3/helpers/classCallCheck"));

var _createClass2 = _interopRequireDefault(require("@babel/runtime-corejs3/helpers/createClass"));

var _inherits2 = _interopRequireDefault(require("@babel/runtime-corejs3/helpers/inherits"));

var _possibleConstructorReturn2 = _interopRequireDefault(require("@babel/runtime-corejs3/helpers/possibleConstructorReturn"));

var _getPrototypeOf2 = _interopRequireDefault(require("@babel/runtime-corejs3/helpers/getPrototypeOf"));

var _events = _interopRequireDefault(require("events"));

var _immutable = require("immutable");

var _wsConstants = require("../constants/ws-constants");

var _validators = require("../utils/validators");

var _constants = require("../constants");

var _helpers = require("../utils/helpers");

var _chainTypes = require("../constants/chain-types");

var _providers = require("./providers");

var _converters = require("../utils/converters");

function _createSuper(Derived) { var hasNativeReflectConstruct = _isNativeReflectConstruct(); return function _createSuperInternal() { var Super = (0, _getPrototypeOf2["default"])(Derived), result; if (hasNativeReflectConstruct) { var NewTarget = (0, _getPrototypeOf2["default"])(this).constructor; result = _Reflect$construct(Super, arguments, NewTarget); } else { result = Super.apply(this, arguments); } return (0, _possibleConstructorReturn2["default"])(this, result); }; }

function _isNativeReflectConstruct() { if (typeof Reflect === "undefined" || !_Reflect$construct) return false; if (_Reflect$construct.sham) return false; if (typeof Proxy === "function") return true; try { Boolean.prototype.valueOf.call(_Reflect$construct(Boolean, [], function () {})); return true; } catch (e) { return false; } }

/** @typedef {import("./engine").default} EchoApiEngine */

/** @typedef {import("../../types/interfaces/vm/types").Log} Log */
var Subscriber = /*#__PURE__*/function (_EventEmitter) {
  (0, _inherits2["default"])(Subscriber, _EventEmitter);

  var _super = _createSuper(Subscriber);

  /**
   *  @constructor
   */
  function Subscriber() {
    var _this;

    (0, _classCallCheck2["default"])(this, Subscriber);
    _this = _super.call(this);
    _this.subscriptions = {
      account: false,
      echorand: false,
      block: false,
      transaction: false
    };

    _this._clearSubscribers();

    return _this;
  }
  /**
   *  @method init
   *  @param {Cache} cache
   *  @param {EchoApiEngine} engine
   *  @param {API} api
   *
   *  @return {Promise.<undefined>}
   */


  (0, _createClass2["default"])(Subscriber, [{
    key: "init",
    value: function () {
      var _init = (0, _asyncToGenerator2["default"])( /*#__PURE__*/_regenerator["default"].mark(function _callee(cache, engine, api) {
        var _this2 = this,
            _context,
            _context2;

        var databaseApiAvailable, _context3, contracts;

        return _regenerator["default"].wrap(function _callee$(_context5) {
          while (1) {
            switch (_context5.prev = _context5.next) {
              case 0:
                this._engine = engine;

                if (!(engine.provider.connectionType !== _providers.ConnectionType.WS)) {
                  _context5.next = 3;
                  break;
                }

                throw new Error('Subscriber can only be created for ws connection');

              case 3:
                this._engine.provider.on(_wsConstants.STATUS.CLOSE, function () {
                  return _this2.callCbOnDisconnect();
                });

                this.cache = cache;
                this._wsApi = engine;
                this._api = api;
                databaseApiAvailable = (0, _includes["default"])(_context = this._engine.apis).call(_context, _wsConstants.CHAIN_API.DATABASE_API);

                if (!databaseApiAvailable) {
                  _context5.next = 11;
                  break;
                }

                _context5.next = 11;
                return this._wsApi.database.setSubscribeCallback((0, _bind["default"])(_context2 = this._onRespond).call(_context2, this), true);

              case 11:
                this.callCbOnConnect();

                if (databaseApiAvailable) {
                  _context5.next = 15;
                  break;
                }

                console.warn('unable to start subscriber cause database api is not available');
                return _context5.abrupt("return");

              case 15:
                if (!this.subscriptions.echorand) {
                  _context5.next = 18;
                  break;
                }

                _context5.next = 18;
                return this._setEchorandMessageCallback();

              case 18:
                if (!this.subscriptions.block) {
                  _context5.next = 21;
                  break;
                }

                _context5.next = 21;
                return this._setBlockApplyCallback();

              case 21:
                if (!(this.subscribers.account.length !== 0)) {
                  _context5.next = 24;
                  break;
                }

                _context5.next = 24;
                return this._setAccountSubscribe();

              case 24:
                if (!this.subscriptions.transaction) {
                  _context5.next = 27;
                  break;
                }

                _context5.next = 27;
                return this._setPendingTransactionCallback();

              case 27:
                if (this.subscribers.contract.length !== 0) {
                  contracts = (0, _reduce["default"])(_context3 = this.subscribers.contract).call(_context3, function (arr, c) {
                    var _context4;

                    return (0, _concat["default"])(_context4 = []).call(_context4, (0, _toConsumableArray2["default"])(arr), (0, _toConsumableArray2["default"])(c.contracts));
                  }, []);

                  this._setContractSubscribe(contracts);
                }

                _context5.next = 30;
                return this._subscribeCache();

              case 30:
              case "end":
                return _context5.stop();
            }
          }
        }, _callee, this);
      }));

      function init(_x, _x2, _x3) {
        return _init.apply(this, arguments);
      }

      return init;
    }()
    /**
     *  @method reset
     *
     *  @return {undefined}
     */

  }, {
    key: "reset",
    value: function reset() {
      var _context6,
          _this3 = this,
          _context7;

      this.subscriptions = {
        account: false,
        echorand: false,
        block: false,
        transaction: false
      };
      (0, _forEach["default"])(_context6 = this.subscribers.connect).call(_context6, function (cb) {
        _this3._engine.provider.removeListener(_wsConstants.STATUS.OPEN, cb);
      });
      (0, _forEach["default"])(_context7 = this.subscribers.disconnect).call(_context7, function (cb) {
        _this3._engine.provider.removeListener(_wsConstants.STATUS.CLOSE, cb);
      });

      this._clearSubscribers();
    }
  }, {
    key: "_clearSubscribers",
    value: function _clearSubscribers() {
      this.subscribers = {
        global: [],
        // "global" means all updates from setSubscribeCallback
        account: [],
        // { ids: [], callback: () => {} }
        committeeMember: [],
        // { ids: [], callback: () => {} }
        echorand: [],
        block: [],
        transaction: [],
        logs: {},
        // [contractId]: []
        contract: [],
        connect: [],
        disconnect: []
      };
    }
    /**
     *  @method callCbOnConnect
     *
     *  @return {undefined}
     */

  }, {
    key: "callCbOnConnect",
    value: function callCbOnConnect() {
      if (this.subscribers.connect.length) {
        var _context8;

        (0, _forEach["default"])(_context8 = this.subscribers.connect).call(_context8, function (cb) {
          return cb();
        });
      }
    }
    /**
     *  @method callCbOnDisconnect
     *
     *  @return {undefined}
     */

  }, {
    key: "callCbOnDisconnect",
    value: function callCbOnDisconnect() {
      if (this.subscribers.disconnect.length) {
        var _context9;

        (0, _forEach["default"])(_context9 = this.subscribers.disconnect).call(_context9, function (cb) {
          return cb();
        });
      }
    }
    /**
     *  @method cancelAllSubscribers
     *
     *  @return {undefined}
     */

  }, {
    key: "cancelAllSubscribers",
    value: function cancelAllSubscribers() {
      this.reset();
    }
    /**
     *  @method _updateObject
     *
     *  @param  {Object} object
     *
     *  @return {null}
     */

  }, {
    key: "_updateObject",
    value: function _updateObject(object) {
      var _context10,
          _context11,
          _context12,
          _context14,
          _this4 = this;

      // transaction.js is id param exists -> if no - transaction.js settle order params
      if (!object.id) {
        if (object.balance && object.owner && object.settlement_date) {
          this.emit('settle-order-update', object);
        }

        return null;
      }

      var subscribedAccounts = (0, _concat["default"])(_context10 = (0, _reduce["default"])(_context11 = this.subscribers.account).call(_context11, function (arr, _ref) {
        var accounts = _ref.accounts;
        return (0, _concat["default"])(arr).call(arr, accounts);
      }, [])).call(_context10, (0, _reduce["default"])(_context12 = this.cache.fullAccounts).call(_context12, function (arr, value, key) {
        var _context13;

        return (0, _concat["default"])(_context13 = []).call(_context13, (0, _toConsumableArray2["default"])(arr), [key]);
      }, []));
      var subscribedCommitteeMembers = (0, _reduce["default"])(_context14 = this.subscribers.committeeMember).call(_context14, function (arr, _ref2) {
        var ids = _ref2.ids;
        return (0, _concat["default"])(arr).call(arr, ids);
      }, []); // transaction.js interested by id type

      if ((0, _validators.isTransactionId)(object.id)) {
        return null;
      }

      if ((0, _validators.isAccountTransactionHistoryId)(object.id) && !(0, _includes["default"])(subscribedAccounts).call(subscribedAccounts, object.account)) {
        return null;
      }

      if ((0, _validators.isAccountBalanceId)(object.id) && !(0, _includes["default"])(subscribedAccounts).call(subscribedAccounts, object.owner) && !this.cache.fullAccounts.has(object.owner)) {
        return null;
      }

      if ((0, _validators.isOperationHistoryId)(object.id)) {
        var contractId = object.op[1].callee;
        var history = this.cache.contractHistoryByContractId.get(contractId) || [];

        if ((0, _find["default"])(history).call(history, function (h) {
          return h.get('id') === object.id;
        })) {
          return null;
        }

        history.unshift((0, _immutable.fromJS)(object));
        this.cache.setInMap(_constants.CACHE_MAPS.CONTRACT_HISTORY_BY_CONTRACT_ID, contractId, history);
        return null;
      }

      if ((0, _validators.isAccountAddressId)(object.id)) {
        var addressesList = this.cache.accountAddressesByAccountId.get(object.owner);

        if (!addressesList) {
          return null;
        }

        addressesList = addressesList.push((0, _immutable.fromJS)(object));
        this.cache.setInMap(_constants.CACHE_MAPS.ACCOUNT_ADDRESSES_BY_ACCOUNT_ID, object.owner, addressesList);
        return null;
      }

      if ((0, _validators.isEthAddressId)(object.id)) {
        var ethAddress = this.cache.accountEthAddressByAccountId.get(object.account);

        if (!ethAddress) {
          return null;
        }

        this.cache.setInMap(_constants.CACHE_MAPS.ACCOUNT_ETH_ADDRESS_BY_ACCOUNT_ID, object.account, (0, _immutable.fromJS)(object));
        return null;
      }

      if ((0, _validators.isBtcAddressId)(object.id)) {
        var btcAddress = this.cache.accountBtcAddressByAccountId.get(object.account);

        if (!btcAddress) {
          return null;
        }

        this.cache.setInMap(_constants.CACHE_MAPS.ACCOUNT_BTC_ADDRESS_BY_ACCOUNT_ID, object.account, (0, _immutable.fromJS)(object));
      }

      if ((0, _validators.isBlockSummaryId)(object.id)) {
        return null;
      }

      if ((0, _validators.isAccountStatisticsId)(object.id) && !(0, _includes["default"])(subscribedAccounts).call(subscribedAccounts, object.owner)) {
        return null;
      }

      if ((0, _validators.isCommitteeMemberId)(object.id) && !(0, _includes["default"])(subscribedCommitteeMembers).call(subscribedCommitteeMembers, object.id)) {
        return null;
      }

      if (/^0\.0\.[1-9]\d*$/.test(object.id) || /^5\.1\.[1-9]\d*$/.test(object.id)) {
        return null;
      } // transaction.js if dynamic global object


      if ((0, _validators.isDynamicGlobalObjectId)(object.id)) {
        var dynamicGlobalObject = new _immutable.Map(object);
        this.cache.set(_constants.CACHE_MAPS.DYNAMIC_GLOBAL_PROPERTIES, dynamicGlobalObject).setInMap(_constants.CACHE_MAPS.OBJECTS_BY_ID, object.id, dynamicGlobalObject);
      } // get object from cache by id


      var obj = this.cache.objectsById.get(object.id);
      var previous = obj || new _immutable.Map();
      obj = obj ? obj.mergeDeep((0, _immutable.fromJS)(object)) : (0, _immutable.fromJS)(object); // update dependencies by id type

      if ((0, _validators.isAccountBalanceId)(object.id)) {
        var owner = this.cache.fullAccounts.get(object.owner);

        if (!owner) {
          return null;
        }

        var balances = owner.get('balances');

        if (!balances) {
          owner = owner.set('balances', new _immutable.Map());
        }

        owner = owner.setIn(['balances', object.asset_type], object.id);
        this.cache.setInMap(_constants.CACHE_MAPS.FULL_ACCOUNTS, object.owner, owner).setInMap(_constants.CACHE_MAPS.OBJECTS_BY_ID, object.id, (0, _immutable.fromJS)(object));

        this._notifyAccountSubscribers(owner);
      }

      if ((0, _validators.isAccountStatisticsId)(object.id)) {
        try {
          var accountTransactionHistoryId = "2.".concat(_chainTypes.IMPLEMENTATION_OBJECT_TYPE_ID.ACCOUNT_TRANSACTION_HISTORY, ".0");
          var previousMostRecentOp = previous.get('most_recent_op', accountTransactionHistoryId);

          if (previousMostRecentOp !== object.most_recent_op) {
            this._api.getFullAccounts([object.owner], true, true)["catch"](_helpers.handleConnectionClosedError);
          }
        } catch (err) {//
        }
      }

      if ((0, _validators.isCommitteeMemberId)(object.id)) {
        this.cache.setInMap(_constants.CACHE_MAPS.COMMITTEE_MEMBERS_BY_ACCOUNT_ID, object.committee_member_account, obj).setInMap(_constants.CACHE_MAPS.COMMITTEE_MEMBERS_BY_COMMITTEE_MEMBER_ID, object.id, obj).setInMap(_constants.CACHE_MAPS.OBJECTS_BY_ID, object.id, obj).setInMap(_constants.CACHE_MAPS.OBJECTS_BY_VOTE_ID, object.vote_id, obj);
      }

      if ((0, _validators.isAccountId)(object.id)) {
        obj = obj.set('active', (0, _immutable.fromJS)(object.active));
        obj = obj.set('owner', (0, _immutable.fromJS)(object.owner));
        obj = obj.set('options', (0, _immutable.fromJS)(object.options));
        obj = obj.set('whitelisting_accounts', (0, _immutable.fromJS)(object.whitelisting_accounts));
        obj = obj.set('blacklisting_accounts', (0, _immutable.fromJS)(object.blacklisting_accounts));
        obj = obj.set('whitelisted_accounts', (0, _immutable.fromJS)(object.whitelisted_accounts));
        obj = obj.set('blacklisted_accounts', (0, _immutable.fromJS)(object.blacklisted_accounts));

        if (this.cache.objectsById.get(object.id)) {
          var mutableObj = obj.withMutations(function (map) {
            var fieldsToDelete = ['statistics', 'registrar_name', 'referrer_name', 'votes', 'balances', 'vesting_balances', 'proposals', 'assets'];
            (0, _forEach["default"])(fieldsToDelete).call(fieldsToDelete, function (field) {
              map["delete"](field);
            });
          });
          this.cache.setInMap(_constants.CACHE_MAPS.OBJECTS_BY_ID, object.id, mutableObj).setInMap(_constants.CACHE_MAPS.ACCOUNTS_BY_ID, object.id, mutableObj);
        }

        if (this.cache.fullAccounts.has(object.id)) {
          var _mutableObj = this.cache.fullAccounts.get(object.id).mergeDeep(obj);

          this.cache.setInMap(_constants.CACHE_MAPS.FULL_ACCOUNTS, object.id, _mutableObj);
        }

        this._notifyAccountSubscribers(obj);
      }

      if ((0, _validators.isAssetId)(object.id)) {
        var dynamic = obj.get('dynamic');

        if (!dynamic) {
          var dad = this.cache.objectsById.get(object.dynamic_asset_data_id);

          if (!dad) {
            dad = new _immutable.Map();
          }

          if (!dad.get('asset_id')) {
            dad = dad.set('asset_id', object.id);
          }

          this.cache.setInMap(_constants.CACHE_MAPS.OBJECTS_BY_ID, object.dynamic_asset_data_id, dad).setInMap(_constants.CACHE_MAPS.DYNAMIC_ASSET_DATA_BY_DYNAMIC_ASSET_DATA_ID, object.dynamic_asset_data_id, dad);
          obj = obj.set('dynamic', dad);
        }

        var bitasset = obj.get('bitasset');

        if (!bitasset && object.bitasset_data_id) {
          var bad = this.cache.objectsById.get(object.bitasset_data_id);

          if (!bad) {
            bad = new _immutable.Map();
          }

          if (!bad.get('asset_id')) {
            bad = bad.set('asset_id', object.id);
          }

          this.cache.setInMap(_constants.CACHE_MAPS.OBJECTS_BY_ID, object.bitasset_data_id, bad).setInMap(_constants.CACHE_MAPS.BIT_ASSETS_BY_BIT_ASSET_ID, object.bitasset_data_id, bad);
          obj = obj.set('bitasset', bad);
        }

        this.cache.setInMap(_constants.CACHE_MAPS.OBJECTS_BY_ID, object.id, obj).setInMap(_constants.CACHE_MAPS.ASSET_BY_ASSET_ID, object.id, obj).setInMap(_constants.CACHE_MAPS.ASSET_BY_SYMBOL, object.symbol, obj);
      }

      if ((0, _validators.isDynamicAssetDataId)(object.id)) {
        var assetId = this.cache.dynamicIdToAssetId.get(object.id);

        if (assetId) {
          var asset = this.cache.objectsById.get(assetId);

          if (asset && asset.set) {
            asset = asset.set('dynamic', obj);
            this.cache.setInMap(_constants.CACHE_MAPS.OBJECTS_BY_ID, assetId, asset).setInMap(_constants.CACHE_MAPS.ASSET_BY_ASSET_ID, assetId, asset).setInMap(_constants.CACHE_MAPS.ASSET_BY_SYMBOL, asset.get('symbol'), asset);
          }
        }

        this.cache.setInMap(_constants.CACHE_MAPS.OBJECTS_BY_ID, object.id, obj).setInMap(_constants.CACHE_MAPS.DYNAMIC_ASSET_DATA_BY_DYNAMIC_ASSET_DATA_ID, object.id, obj);
      }

      if ((0, _validators.isBitAssetId)(object.id)) {
        var _assetId = this.cache.bitAssetIdToAssetId.get(object.id);

        if (_assetId) {
          var _asset = this.cache.objectsById.get(_assetId);

          if (_asset) {
            _asset = _asset.set('bitasset', obj);
            this.emit(_constants.BITASSET_UPDATE, _asset);
            this.cache.setInMap(_constants.CACHE_MAPS.OBJECTS_BY_ID, _assetId, _asset).setInMap(_constants.CACHE_MAPS.ASSET_BY_ASSET_ID, _assetId, _asset).setInMap(_constants.CACHE_MAPS.ASSET_BY_SYMBOL, _asset.get('symbol'), _asset);
          }
        }

        this.cache.setInMap(_constants.CACHE_MAPS.OBJECTS_BY_ID, object.id, obj).setInMap(_constants.CACHE_MAPS.BIT_ASSETS_BY_BIT_ASSET_ID, object.id, obj);
      }

      if ((0, _validators.isProposalId)(object.id) && object.required_active_approvals) {
        var _context15, _context16;

        (0, _forEach["default"])(_context15 = (0, _concat["default"])(_context16 = object.required_active_approvals).call(_context16, object.required_owner_approvals)).call(_context15, function (id) {
          var impactedAccount = _this4.cache.fullAccounts.get(id);

          if (impactedAccount) {
            var proposals = impactedAccount.get('proposals', new _immutable.Set());

            if (!(0, _includes["default"])(proposals).call(proposals, object.id)) {
              proposals = proposals.add(object.id);
              impactedAccount = impactedAccount.set('proposals', proposals);

              _this4.cache.setInMap(_constants.CACHE_MAPS.FULL_ACCOUNTS, impactedAccount.get('id'), impactedAccount);

              _this4._updateObject(impactedAccount.toJS());

              _this4._notifyAccountSubscribers(impactedAccount);
            }
          }
        });
      }

      if ((0, _validators.isContractHistoryId)(object.id) || (0, _validators.isContractPoolId)(object.id)) {
        this._notifyContractSubscribers(obj);

        this._api.getFullContract(object.contract, true)["catch"](_helpers.handleConnectionClosedError);
      }

      return null;
    }
    /**
     *  @method _onRespond
     *
     *  @param  {Object} [messages]
     *
     *  @return {undefined}
     */

  }, {
    key: "_onRespond",
    value: function _onRespond(_ref3) {
      var _this5 = this,
          _context17;

      var _ref4 = (0, _slicedToArray2["default"])(_ref3, 1),
          messages = _ref4[0];

      var orders = [];
      var updates = (0, _filter["default"])(messages).call(messages, function (msg) {
        // transaction.js is object id
        if ((0, _validators.isObjectId)(msg)) {
          return false;
        }

        _this5._updateObject(msg);

        return true;
      }); // emit orders

      this.emit(_constants.CANCEL_LIMIT_ORDER, (0, _filter["default"])(orders).call(orders, function (_ref5) {
        var type = _ref5.type;
        return type === _constants.CANCEL_LIMIT_ORDER;
      }));
      this.emit(_constants.CLOSE_CALL_ORDER, (0, _filter["default"])(orders).call(orders, function (_ref6) {
        var type = _ref6.type;
        return type === _constants.CLOSE_CALL_ORDER;
      })); // inform external subscribers

      (0, _forEach["default"])(_context17 = this.subscribers.global).call(_context17, function (callback) {
        callback(updates);
      });
    }
    /**
     *  @method setOptions
     *
     *  @param {Object} options
     *
     *  @return {undefined}
     */

  }, {
    key: "setOptions",
    value: function setOptions(options) {
      this.options = options;
    }
  }, {
    key: "onAllUpdates",
    value: function onAllUpdates() {}
  }, {
    key: "onAccountUpdate",
    value: function onAccountUpdate() {}
    /**
     *  @method _echorandUpdate
     *
     *  @param  {Array} result
     *
     *  @return {undefined}
     */

  }, {
    key: "_echorandUpdate",
    value: function _echorandUpdate(result) {
      var _context18;

      (0, _forEach["default"])(_context18 = this.subscribers.echorand).call(_context18, function (callback) {
        callback(result);
      });
    }
    /**
     *  @method _setEchorandMessageCallback
     *
     *  @return {Promise.<undefined>}
     */

  }, {
    key: "_setEchorandMessageCallback",
    value: function () {
      var _setEchorandMessageCallback2 = (0, _asyncToGenerator2["default"])( /*#__PURE__*/_regenerator["default"].mark(function _callee2() {
        var _context19;

        return _regenerator["default"].wrap(function _callee2$(_context20) {
          while (1) {
            switch (_context20.prev = _context20.next) {
              case 0:
                _context20.next = 2;
                return this._wsApi.echorand.setEchorandMessageCallback((0, _bind["default"])(_context19 = this._echorandUpdate).call(_context19, this));

              case 2:
                this.subscriptions.echorand = true;

              case 3:
              case "end":
                return _context20.stop();
            }
          }
        }, _callee2, this);
      }));

      function _setEchorandMessageCallback() {
        return _setEchorandMessageCallback2.apply(this, arguments);
      }

      return _setEchorandMessageCallback;
    }()
    /**
     *  @method setEchorandSubscribe
     *
     *  @param  {Function} callback
     *
     *  @return {Promise.<undefined>}
     */

  }, {
    key: "setEchorandSubscribe",
    value: function () {
      var _setEchorandSubscribe = (0, _asyncToGenerator2["default"])( /*#__PURE__*/_regenerator["default"].mark(function _callee3(callback) {
        return _regenerator["default"].wrap(function _callee3$(_context21) {
          while (1) {
            switch (_context21.prev = _context21.next) {
              case 0:
                if ((0, _validators.isFunction)(callback)) {
                  _context21.next = 2;
                  break;
                }

                throw new Error('Callback is not a function');

              case 2:
                this.subscribers.echorand.push(callback);

                if (this.subscriptions.echorand) {
                  _context21.next = 6;
                  break;
                }

                _context21.next = 6;
                return this._setEchorandMessageCallback();

              case 6:
              case "end":
                return _context21.stop();
            }
          }
        }, _callee3, this);
      }));

      function setEchorandSubscribe(_x4) {
        return _setEchorandSubscribe.apply(this, arguments);
      }

      return setEchorandSubscribe;
    }()
    /**
     *  @method removeEchorandSubscribe
     *
     *  @param  {Function} callback
     *
     *  @return {undefined}
     */

  }, {
    key: "removeEchorandSubscribe",
    value: function removeEchorandSubscribe(callback) {
      var _context22;

      this.subscribers.echorand = (0, _filter["default"])(_context22 = this.subscribers.echorand).call(_context22, function (c) {
        return c !== callback;
      });
    }
    /**
     *  @method setGlobalSubscribe
     *
     *  @param  {Function} callback
     *
     *  @return {Promise.<undefined>}
     */

  }, {
    key: "setGlobalSubscribe",
    value: function setGlobalSubscribe(callback) {
      if (!(0, _validators.isFunction)(callback)) {
        throw new Error('Callback is not a function');
      }

      this.subscribers.global.push(callback);
    }
    /**
     *  @method removeGlobalSubscribe
     *
     *  @param  {Function} callback
     *
     *  @return {undefined}
     */

  }, {
    key: "removeGlobalSubscribe",
    value: function removeGlobalSubscribe(callback) {
      var _context23;

      this.subscribers.global = (0, _filter["default"])(_context23 = this.subscribers.global).call(_context23, function (c) {
        return c !== callback;
      });
    }
    /**
     *  @method _pendingTransactionUpdate
     *
     *  @param  {Array} result
     *
     *  @return {undefined}
     */

  }, {
    key: "_pendingTransactionUpdate",
    value: function _pendingTransactionUpdate(result) {
      var _context24;

      (0, _forEach["default"])(_context24 = this.subscribers.transaction).call(_context24, function (callback) {
        callback(result);
      });
    }
    /**
     *  @method _setPendingTransactionCallback
     *
     *  @return {Promise.<undefined>}
     */

  }, {
    key: "_setPendingTransactionCallback",
    value: function () {
      var _setPendingTransactionCallback2 = (0, _asyncToGenerator2["default"])( /*#__PURE__*/_regenerator["default"].mark(function _callee4() {
        var _context25;

        return _regenerator["default"].wrap(function _callee4$(_context26) {
          while (1) {
            switch (_context26.prev = _context26.next) {
              case 0:
                _context26.next = 2;
                return this._wsApi.database.setPendingTransactionCallback((0, _bind["default"])(_context25 = this._pendingTransactionUpdate).call(_context25, this));

              case 2:
                this.subscriptions.transaction = true;

              case 3:
              case "end":
                return _context26.stop();
            }
          }
        }, _callee4, this);
      }));

      function _setPendingTransactionCallback() {
        return _setPendingTransactionCallback2.apply(this, arguments);
      }

      return _setPendingTransactionCallback;
    }()
    /**
     *  @method setPendingTransactionSubscribe
     *
     *  @param  {Function} callback
     *
     *  @return {Promise.<undefined>}
     */

  }, {
    key: "setPendingTransactionSubscribe",
    value: function () {
      var _setPendingTransactionSubscribe = (0, _asyncToGenerator2["default"])( /*#__PURE__*/_regenerator["default"].mark(function _callee5(callback) {
        return _regenerator["default"].wrap(function _callee5$(_context27) {
          while (1) {
            switch (_context27.prev = _context27.next) {
              case 0:
                if ((0, _validators.isFunction)(callback)) {
                  _context27.next = 2;
                  break;
                }

                throw new Error('Callback is not a function');

              case 2:
                this.subscribers.transaction.push(callback);

                if (this.subscriptions.transaction) {
                  _context27.next = 6;
                  break;
                }

                _context27.next = 6;
                return this._setPendingTransactionCallback();

              case 6:
              case "end":
                return _context27.stop();
            }
          }
        }, _callee5, this);
      }));

      function setPendingTransactionSubscribe(_x5) {
        return _setPendingTransactionSubscribe.apply(this, arguments);
      }

      return setPendingTransactionSubscribe;
    }()
    /**
     *  @method removePendingTransactionSubscribe
     *
     *  @param  {Function} callback
     *
     *  @return {undefined}
     */

  }, {
    key: "removePendingTransactionSubscribe",
    value: function removePendingTransactionSubscribe(callback) {
      var _context28;

      this.subscribers.transaction = (0, _filter["default"])(_context28 = this.subscribers.transaction).call(_context28, function (c) {
        return c !== callback;
      });
    }
    /**
     *  @method _blockApplyUpdate
     *
     *  @param  {Array} result
     *
     *  @return {undefined}
     */

  }, {
    key: "_blockApplyUpdate",
    value: function _blockApplyUpdate(result) {
      var _context29;

      (0, _forEach["default"])(_context29 = this.subscribers.block).call(_context29, function (callback) {
        callback(result);
      });
    }
    /**
     *  @method _setBlockApplyCallback
     *
     *  @return {Promise.<undefined>}
     */

  }, {
    key: "_setBlockApplyCallback",
    value: function () {
      var _setBlockApplyCallback2 = (0, _asyncToGenerator2["default"])( /*#__PURE__*/_regenerator["default"].mark(function _callee6() {
        var _context30;

        return _regenerator["default"].wrap(function _callee6$(_context31) {
          while (1) {
            switch (_context31.prev = _context31.next) {
              case 0:
                _context31.next = 2;
                return this._wsApi.database.setBlockAppliedCallback((0, _bind["default"])(_context30 = this._blockApplyUpdate).call(_context30, this));

              case 2:
                this.subscriptions.block = true;

              case 3:
              case "end":
                return _context31.stop();
            }
          }
        }, _callee6, this);
      }));

      function _setBlockApplyCallback() {
        return _setBlockApplyCallback2.apply(this, arguments);
      }

      return _setBlockApplyCallback;
    }()
    /**
     *  @method setBlockApplySubscribe
     *
     *  @param  {Function} callback
     *
     *  @return {Promise.<undefined>}
     */

  }, {
    key: "setBlockApplySubscribe",
    value: function () {
      var _setBlockApplySubscribe = (0, _asyncToGenerator2["default"])( /*#__PURE__*/_regenerator["default"].mark(function _callee7(callback) {
        return _regenerator["default"].wrap(function _callee7$(_context32) {
          while (1) {
            switch (_context32.prev = _context32.next) {
              case 0:
                if ((0, _validators.isFunction)(callback)) {
                  _context32.next = 2;
                  break;
                }

                throw new Error('Callback is not a function');

              case 2:
                this.subscribers.block.push(callback);

                if (this.subscriptions.block) {
                  _context32.next = 6;
                  break;
                }

                _context32.next = 6;
                return this._setBlockApplyCallback();

              case 6:
              case "end":
                return _context32.stop();
            }
          }
        }, _callee7, this);
      }));

      function setBlockApplySubscribe(_x6) {
        return _setBlockApplySubscribe.apply(this, arguments);
      }

      return setBlockApplySubscribe;
    }()
    /**
     *  @method removeBlockApplySubscribe
     *
     *  @param  {Function} callback
     *
     *  @return {undefined}
     */

  }, {
    key: "removeBlockApplySubscribe",
    value: function removeBlockApplySubscribe(callback) {
      var _context33;

      this.subscribers.block = (0, _filter["default"])(_context33 = this.subscribers.block).call(_context33, function (c) {
        return c !== callback;
      });
    }
    /**
     *  @method _setAccountSubscribe
     *
     *  @return {Promise.<undefined>}
     */

  }, {
    key: "_setAccountSubscribe",
    value: function () {
      var _setAccountSubscribe2 = (0, _asyncToGenerator2["default"])( /*#__PURE__*/_regenerator["default"].mark(function _callee8() {
        var _context34;

        var array, result;
        return _regenerator["default"].wrap(function _callee8$(_context35) {
          while (1) {
            switch (_context35.prev = _context35.next) {
              case 0:
                array = (0, _reduce["default"])(_context34 = this.subscribers.account).call(_context34, function (accum, _ref7) {
                  var accounts = _ref7.accounts;
                  accum.push.apply(accum, (0, _toConsumableArray2["default"])(accounts));
                  return accum;
                }, []);
                result = new _immutable.Set(array);

                if (!(result.size === 0)) {
                  _context35.next = 4;
                  break;
                }

                return _context35.abrupt("return");

              case 4:
                _context35.next = 6;
                return this._api.getFullAccounts(result.toArray());

              case 6:
              case "end":
                return _context35.stop();
            }
          }
        }, _callee8, this);
      }));

      function _setAccountSubscribe() {
        return _setAccountSubscribe2.apply(this, arguments);
      }

      return _setAccountSubscribe;
    }()
    /**
     *  @method setAccountSubscribe
     *
     *  @param  {Function} callback
     *  @param  {Array.<String>} accounts
     *
     *  @return {Promise.<undefined>}
     */

  }, {
    key: "setAccountSubscribe",
    value: function () {
      var _setAccountSubscribe3 = (0, _asyncToGenerator2["default"])( /*#__PURE__*/_regenerator["default"].mark(function _callee9(callback, accounts) {
        return _regenerator["default"].wrap(function _callee9$(_context36) {
          while (1) {
            switch (_context36.prev = _context36.next) {
              case 0:
                if ((0, _validators.isFunction)(callback)) {
                  _context36.next = 2;
                  break;
                }

                throw new Error('Callback is not a function');

              case 2:
                if ((0, _validators.isArray)(accounts)) {
                  _context36.next = 4;
                  break;
                }

                throw new Error('Accounts should be an array');

              case 4:
                if (!(accounts.length < 1)) {
                  _context36.next = 6;
                  break;
                }

                throw new Error('Accounts length should be more then 0');

              case 6:
                if ((0, _every["default"])(accounts).call(accounts, function (id) {
                  return (0, _validators.isAccountId)(id);
                })) {
                  _context36.next = 8;
                  break;
                }

                throw new Error('Accounts should contain valid account ids');

              case 8:
                _context36.next = 10;
                return this._api.getFullAccounts(accounts);

              case 10:
                this.subscribers.account.push({
                  callback: callback,
                  accounts: accounts
                });

              case 11:
              case "end":
                return _context36.stop();
            }
          }
        }, _callee9, this);
      }));

      function setAccountSubscribe(_x7, _x8) {
        return _setAccountSubscribe3.apply(this, arguments);
      }

      return setAccountSubscribe;
    }()
    /**
     *  @method removeAccountSubscribe
     *
     *  @param  {Function} callback
     *
     *  @return {undefined}
     */

  }, {
    key: "removeAccountSubscribe",
    value: function removeAccountSubscribe(callback) {
      var _context37;

      this.subscribers.account = (0, _filter["default"])(_context37 = this.subscribers.account).call(_context37, function (_ref8) {
        var innerCallback = _ref8.callback;
        return innerCallback !== callback;
      });
    }
    /**
     *
     * @param {Map} obj
     * @private
     */

  }, {
    key: "_notifyAccountSubscribers",
    value: function _notifyAccountSubscribers(obj) {
      var length = this.subscribers.account.length;

      for (var i = 0; i < length; i += 1) {
        var _context38;

        if ((0, _includes["default"])(_context38 = this.subscribers.account[i].accounts).call(_context38, obj.get('id'))) {
          this.subscribers.account[i].callback(obj.toJS());
        }
      }
    }
    /**
     *  @method setStatusSubscribe
     *
     *  @param  {String} status from enum ['connect', 'disconnect']
     *  @param  {Function} callback
     *
     *  @return {undefined}
     */

  }, {
    key: "setStatusSubscribe",
    value: function setStatusSubscribe(status, callback) {
      var _context39;

      if (!(0, _includes["default"])(_context39 = ['connect', 'disconnect']).call(_context39, status)) {
        throw new Error('Invalid status');
      }

      if (!(0, _validators.isFunction)(callback)) {
        throw new Error('Callback is not a function');
      }

      if (status === 'connect') {
        this.subscribers.connect.push(callback);
      } else {
        this.subscribers.disconnect.push(callback);
      }
    }
    /**
     *  @method removeStatusSubscribe
     *
     *  @param  {String} status from enum ['connect', 'disconnect']
     *  @param  {Function} callback
     *
     *  @return {undefined}
     */

  }, {
    key: "removeStatusSubscribe",
    value: function removeStatusSubscribe(status, callback) {
      var _context40;

      if (!(0, _includes["default"])(_context40 = ['connect', 'disconnect']).call(_context40, status)) {
        throw new Error('Invalid status');
      }

      if (!(0, _validators.isFunction)(callback)) {
        throw new Error('Callback is not a function');
      }

      if (status === 'connect') {
        var _context41;

        if (this._engine.provider.connectionType === _providers.ConnectionType.WS) {
          this._engine.provider.removeListener(_wsConstants.STATUS.OPEN, callback);
        }

        this.subscribers.connect = (0, _filter["default"])(_context41 = this.subscribers.connect).call(_context41, function (c) {
          return c !== callback;
        });
      } else {
        var _context42;

        if (this._engine.provider.connectionType === _providers.ConnectionType.WS) {
          this._engine.provider.removeListener(_wsConstants.STATUS.CLOSE, callback);
        }

        this.subscribers.disconnect = (0, _filter["default"])(_context42 = this.subscribers.disconnect).call(_context42, function (c) {
          return c !== callback;
        });
      }
    }
    /**
     *  @method _subscribeContract
     *
     *  @param  {Array<String>} contractIds
     *
     *  @return {undefined}
     */

  }, {
    key: "_setContractSubscribe",
    value: function () {
      var _setContractSubscribe2 = (0, _asyncToGenerator2["default"])( /*#__PURE__*/_regenerator["default"].mark(function _callee10(contractIds) {
        return _regenerator["default"].wrap(function _callee10$(_context43) {
          while (1) {
            switch (_context43.prev = _context43.next) {
              case 0:
                _context43.next = 2;
                return this._wsApi.database.subscribeContracts(contractIds);

              case 2:
              case "end":
                return _context43.stop();
            }
          }
        }, _callee10, this);
      }));

      function _setContractSubscribe(_x9) {
        return _setContractSubscribe2.apply(this, arguments);
      }

      return _setContractSubscribe;
    }()
    /**
     *  @method setContractSubscribe
     *
     *  @param  {Array<String>} contracts
     *  @param  {Function} callback
     *
     *  @return {undefined}
     */

  }, {
    key: "setContractSubscribe",
    value: function () {
      var _setContractSubscribe3 = (0, _asyncToGenerator2["default"])( /*#__PURE__*/_regenerator["default"].mark(function _callee11(contracts, callback) {
        return _regenerator["default"].wrap(function _callee11$(_context44) {
          while (1) {
            switch (_context44.prev = _context44.next) {
              case 0:
                if ((0, _validators.isFunction)(callback)) {
                  _context44.next = 2;
                  break;
                }

                throw new Error('Callback is not a function');

              case 2:
                if ((0, _validators.isArray)(contracts)) {
                  _context44.next = 4;
                  break;
                }

                throw new Error('Contracts should be an array');

              case 4:
                if (!(contracts.length < 1)) {
                  _context44.next = 6;
                  break;
                }

                throw new Error('Contracts length should be more then 0');

              case 6:
                if ((0, _every["default"])(contracts).call(contracts, function (id) {
                  return (0, _validators.isContractId)(id);
                })) {
                  _context44.next = 8;
                  break;
                }

                throw new Error('Contracts should contain valid contract ids');

              case 8:
                _context44.next = 10;
                return this._setContractSubscribe(contracts);

              case 10:
                this.subscribers.contract.push({
                  callback: callback,
                  contracts: contracts
                });

              case 11:
              case "end":
                return _context44.stop();
            }
          }
        }, _callee11, this);
      }));

      function setContractSubscribe(_x10, _x11) {
        return _setContractSubscribe3.apply(this, arguments);
      }

      return setContractSubscribe;
    }()
    /**
     *  @method removeContractSubscribe
     *
     *  @param  {Function} callback
     *
     *  @return {undefined}
     */

  }, {
    key: "removeContractSubscribe",
    value: function removeContractSubscribe(callback) {
      var _context45;

      this.subscribers.contract = (0, _filter["default"])(_context45 = this.subscribers.contract).call(_context45, function (_ref9) {
        var innerCallback = _ref9.callback;
        return innerCallback !== callback;
      });
    }
    /**
     *
     * @param {Map} obj
     * @private
     */

  }, {
    key: "_notifyContractSubscribers",
    value: function _notifyContractSubscribers(obj) {
      var _context46;

      (0, _forEach["default"])(_context46 = this.subscribers.contract).call(_context46, function (_ref10) {
        var contracts = _ref10.contracts,
            callback = _ref10.callback;

        if ((0, _includes["default"])(contracts).call(contracts, obj.get('contract'))) {
          callback(obj.toJS());
        }
      });
    }
    /**
     * @method setContractLogsSubscribe
     * @param {(result: Log[]) => any} callback
     * @param {import('./api').ContractLogsFilterOptions_t} [options]
     * @return {Promise<number|string>}
     */

  }, {
    key: "setContractLogsSubscribe",
    value: function () {
      var _setContractLogsSubscribe = (0, _asyncToGenerator2["default"])( /*#__PURE__*/_regenerator["default"].mark(function _callee12(callback) {
        var options,
            _args12 = arguments;
        return _regenerator["default"].wrap(function _callee12$(_context47) {
          while (1) {
            switch (_context47.prev = _context47.next) {
              case 0:
                options = _args12.length > 1 && _args12[1] !== undefined ? _args12[1] : {};
                return _context47.abrupt("return", this._wsApi.database.subscribeContractLogs(callback, (0, _converters.toRawContractLogsFilterOptions)(options)));

              case 2:
              case "end":
                return _context47.stop();
            }
          }
        }, _callee12, this);
      }));

      function setContractLogsSubscribe(_x12) {
        return _setContractLogsSubscribe.apply(this, arguments);
      }

      return setContractLogsSubscribe;
    }()
    /**
     *  @method _subscribeCache
     *
     *  @return {undefined}
     */

  }, {
    key: "_subscribeCache",
    value: function () {
      var _subscribeCache2 = (0, _asyncToGenerator2["default"])( /*#__PURE__*/_regenerator["default"].mark(function _callee13() {
        var _context48,
            _context49,
            _context50,
            _this6 = this;

        var _this$cache$objectsBy, _this$cache$objectsBy2, objectIds, _this$cache$fullAccou, _this$cache$fullAccou2, fullAccountIds, _this$cache$fullContr, _this$cache$fullContr2, fullContractIds, objectByIdsPromise, fullAccountsPromise, fullContractPromises, _context51;

        return _regenerator["default"].wrap(function _callee13$(_context52) {
          while (1) {
            switch (_context52.prev = _context52.next) {
              case 0:
                _this$cache$objectsBy = (0, _keys["default"])(_context48 = this.cache.objectsById).call(_context48), _this$cache$objectsBy2 = (0, _toArray2["default"])(_this$cache$objectsBy), objectIds = (0, _slice["default"])(_this$cache$objectsBy2).call(_this$cache$objectsBy2, 0);
                _this$cache$fullAccou = (0, _keys["default"])(_context49 = this.cache.fullAccounts).call(_context49), _this$cache$fullAccou2 = (0, _toArray2["default"])(_this$cache$fullAccou), fullAccountIds = (0, _slice["default"])(_this$cache$fullAccou2).call(_this$cache$fullAccou2, 0);
                _this$cache$fullContr = (0, _keys["default"])(_context50 = this.cache.fullContractsByContractId).call(_context50), _this$cache$fullContr2 = (0, _toArray2["default"])(_this$cache$fullContr), fullContractIds = (0, _slice["default"])(_this$cache$fullContr2).call(_this$cache$fullContr2, 0);
                objectByIdsPromise = this._api.getObjects(objectIds, true);
                fullAccountsPromise = this._api.getFullAccounts(fullAccountIds, true, true);
                fullContractPromises = (0, _map["default"])(fullContractIds).call(fullContractIds, function (id) {
                  return _this6._api.getFullContract(id, true);
                });
                _context52.prev = 6;
                _context52.next = 9;
                return _promise["default"].all((0, _concat["default"])(_context51 = [objectByIdsPromise, fullAccountsPromise]).call(_context51, (0, _toConsumableArray2["default"])(fullContractPromises)));

              case 9:
                _context52.next = 14;
                break;

              case 11:
                _context52.prev = 11;
                _context52.t0 = _context52["catch"](6);
                console.error('[Subscriber] >---- error ----> Couldn\'t resubscribe cache');

              case 14:
              case "end":
                return _context52.stop();
            }
          }
        }, _callee13, this, [[6, 11]]);
      }));

      function _subscribeCache() {
        return _subscribeCache2.apply(this, arguments);
      }

      return _subscribeCache;
    }()
  }]);
  return Subscriber;
}(_events["default"]);

var _default = Subscriber;
exports["default"] = _default;