"use strict";

var _sliceInstanceProperty = require("@babel/runtime-corejs3/core-js-stable/instance/slice");

var _Array$from = require("@babel/runtime-corejs3/core-js-stable/array/from");

var _Symbol = require("@babel/runtime-corejs3/core-js-stable/symbol");

var _getIteratorMethod = require("@babel/runtime-corejs3/core-js/get-iterator-method");

var _Array$isArray = require("@babel/runtime-corejs3/core-js-stable/array/is-array");

var _Object$keys = require("@babel/runtime-corejs3/core-js-stable/object/keys");

var _Object$getOwnPropertySymbols = require("@babel/runtime-corejs3/core-js-stable/object/get-own-property-symbols");

var _filterInstanceProperty = require("@babel/runtime-corejs3/core-js-stable/instance/filter");

var _Object$getOwnPropertyDescriptor = require("@babel/runtime-corejs3/core-js-stable/object/get-own-property-descriptor");

var _forEachInstanceProperty = require("@babel/runtime-corejs3/core-js-stable/instance/for-each");

var _Object$getOwnPropertyDescriptors = require("@babel/runtime-corejs3/core-js-stable/object/get-own-property-descriptors");

var _Object$defineProperties = require("@babel/runtime-corejs3/core-js-stable/object/define-properties");

var _Object$defineProperty = require("@babel/runtime-corejs3/core-js-stable/object/define-property");

var _interopRequireDefault = require("@babel/runtime-corejs3/helpers/interopRequireDefault");

_Object$defineProperty(exports, "__esModule", {
  value: true
});

exports["default"] = void 0;

var _map = _interopRequireDefault(require("@babel/runtime-corejs3/core-js-stable/map"));

var _keys = _interopRequireDefault(require("@babel/runtime-corejs3/core-js-stable/instance/keys"));

var _promise = _interopRequireDefault(require("@babel/runtime-corejs3/core-js-stable/promise"));

var _concat = _interopRequireDefault(require("@babel/runtime-corejs3/core-js-stable/instance/concat"));

var _map2 = _interopRequireDefault(require("@babel/runtime-corejs3/core-js-stable/instance/map"));

var _now = _interopRequireDefault(require("@babel/runtime-corejs3/core-js-stable/date/now"));

var _regenerator = _interopRequireDefault(require("@babel/runtime-corejs3/regenerator"));

var _defineProperty2 = _interopRequireDefault(require("@babel/runtime-corejs3/helpers/defineProperty"));

var _toConsumableArray2 = _interopRequireDefault(require("@babel/runtime-corejs3/helpers/toConsumableArray"));

var _asyncToGenerator2 = _interopRequireDefault(require("@babel/runtime-corejs3/helpers/asyncToGenerator"));

var _slicedToArray2 = _interopRequireDefault(require("@babel/runtime-corejs3/helpers/slicedToArray"));

var _classCallCheck2 = _interopRequireDefault(require("@babel/runtime-corejs3/helpers/classCallCheck"));

var _createClass2 = _interopRequireDefault(require("@babel/runtime-corejs3/helpers/createClass"));

var _bignumber = _interopRequireDefault(require("bignumber.js"));

var _lodash = require("lodash");

var _api = _interopRequireDefault(require("./api"));

var _validators = require("../utils/validators");

var _privateKey2 = _interopRequireDefault(require("../crypto/private-key"));

var _publicKey = _interopRequireDefault(require("../crypto/public-key"));

var _signature = _interopRequireDefault(require("../crypto/signature"));

var _constants = require("../constants");

var _apiConfig = require("../constants/api-config");

var _serializers = require("../serializers");

function ownKeys(object, enumerableOnly) { var keys = _Object$keys(object); if (_Object$getOwnPropertySymbols) { var symbols = _Object$getOwnPropertySymbols(object); if (enumerableOnly) { symbols = _filterInstanceProperty(symbols).call(symbols, function (sym) { return _Object$getOwnPropertyDescriptor(object, sym).enumerable; }); } keys.push.apply(keys, symbols); } return keys; }

function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i] != null ? arguments[i] : {}; if (i % 2) { var _context13; _forEachInstanceProperty(_context13 = ownKeys(Object(source), true)).call(_context13, function (key) { (0, _defineProperty2["default"])(target, key, source[key]); }); } else if (_Object$getOwnPropertyDescriptors) { _Object$defineProperties(target, _Object$getOwnPropertyDescriptors(source)); } else { var _context14; _forEachInstanceProperty(_context14 = ownKeys(Object(source))).call(_context14, function (key) { _Object$defineProperty(target, key, _Object$getOwnPropertyDescriptor(source, key)); }); } } return target; }

function _createForOfIteratorHelper(o, allowArrayLike) { var it = typeof _Symbol !== "undefined" && _getIteratorMethod(o) || o["@@iterator"]; if (!it) { if (_Array$isArray(o) || (it = _unsupportedIterableToArray(o)) || allowArrayLike && o && typeof o.length === "number") { if (it) o = it; var i = 0; var F = function F() {}; return { s: F, n: function n() { if (i >= o.length) return { done: true }; return { done: false, value: o[i++] }; }, e: function e(_e) { throw _e; }, f: F }; } throw new TypeError("Invalid attempt to iterate non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method."); } var normalCompletion = true, didErr = false, err; return { s: function s() { it = it.call(o); }, n: function n() { var step = it.next(); normalCompletion = step.done; return step; }, e: function e(_e2) { didErr = true; err = _e2; }, f: function f() { try { if (!normalCompletion && it["return"] != null) it["return"](); } finally { if (didErr) throw err; } } }; }

function _unsupportedIterableToArray(o, minLen) { var _context12; if (!o) return; if (typeof o === "string") return _arrayLikeToArray(o, minLen); var n = _sliceInstanceProperty(_context12 = Object.prototype.toString.call(o)).call(_context12, 8, -1); if (n === "Object" && o.constructor) n = o.constructor.name; if (n === "Map" || n === "Set") return _Array$from(o); if (n === "Arguments" || /^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(n)) return _arrayLikeToArray(o, minLen); }

function _arrayLikeToArray(arr, len) { if (len == null || len > arr.length) len = arr.length; for (var i = 0, arr2 = new Array(len); i < len; i++) { arr2[i] = arr[i]; } return arr2; }

/** @typedef {import("../constants").OperationId} OperationId */

/** @typedef {[number,{[key:string]:any}]} _Operation */
var Transaction = /*#__PURE__*/function () {
  /** @param {Api} api */
  function Transaction(api) {
    (0, _classCallCheck2["default"])(this, Transaction);
    this.api = api;
    /**
     * @private
     * @type {Array<_Operation>}
     */

    this._operations = [];
    /**
     * @private
     * @type {Array<{ privateKey:PrivateKey, publicKey:PublicKey }>}
     */

    this._signers = [];
    /**
     * @private
     * @type {Array<Signature>}
     */

    this._signatures = [];
    /**
     * @private
     * @type {number}
     */

    this._expiration = undefined;
  }

  (0, _createClass2["default"])(Transaction, [{
    key: "refBlockNum",
    get:
    /**
     * @type {number}
     */
    function get() {
      return this._refBlockNum;
    }
    /** @param {number|undefined} value */
    ,
    set: function set(value) {
      (0, _validators.validatePositiveSafeInteger)(value);
      if (value > 0xffff) throw new Error('number is not safe');
      this._refBlockNum = value;
    }
    /**
     * @readonly
     * @type {number}
     */

  }, {
    key: "refBlockPrefix",
    get: function get() {
      return this._refBlockPrefix;
    }
    /** @param {string|number|undefined} value */
    ,
    set: function set(value) {
      if ((0, _validators.isHex)(value)) {
        this._refBlockPrefix = Buffer.from(value, 'hex').readUInt32LE(4);
        return;
      }

      if ((0, _validators.isUInt32)(value)) {
        this._refBlockPrefix = value;
        return;
      }

      throw new Error('invalid refBlockPrefix format');
    }
    /** @param {string|undefined} value */

  }, {
    key: "chainId",
    get:
    /**
     * @readonly
     * @type {string}
     */
    function get() {
      return this._chainId;
    }
    /**
     * @readonly
     * @type {Array<_Operation>}
     */
    ,
    set: function set(value) {
      if ((0, _validators.isHex)(value) && value.length === _constants.CHAIN_CONFIG.CHAIN_ID_LENGTH) {
        this._chainId = value;
        return;
      }

      throw new Error('invalid chainId format or length');
    }
  }, {
    key: "operations",
    get: function get() {
      return (0, _lodash.cloneDeep)(this._operations);
    }
    /**
     * @readonly
     * @type {boolean}
     */

  }, {
    key: "finalized",
    get: function get() {
      return this._refBlockNum !== undefined && this._refBlockPrefix !== undefined && !!this._chainId && this.hasAllFees;
    }
    /** @type {Api} */

  }, {
    key: "api",
    get: function get() {
      if (!this._api) throw new Error('Api instance does not exist, check your connection');
      return this._api;
    }
    /** @param {Api} value */
    ,
    set: function set(value) {
      if (value && !(value instanceof _api["default"])) throw new Error('value is not a Api instance');
      /**
       * @private
       * @type {Api}
       */

      this._api = value;
    }
    /** @type {number|undefined} */

  }, {
    key: "expiration",
    get: function get() {
      return this._expiration;
    }
    /** @param {number|undefined} value */
    ,
    set: function set(value) {
      if (typeof value !== 'number') throw new Error('expiration is not a number'); // TODO: more validators

      this._expiration = value;
    }
    /**
     * @readonly
     * @type {boolean}
     */

  }, {
    key: "hasAllFees",
    get: function get() {
      var _iterator = _createForOfIteratorHelper(this.operations),
          _step;

      try {
        for (_iterator.s(); !(_step = _iterator.n()).done;) {
          var _step$value = (0, _slicedToArray2["default"])(_step.value, 2),
              fee = _step$value[1].fee;

          if (fee === undefined || fee.amount === undefined) return false;
        }
      } catch (err) {
        _iterator.e(err);
      } finally {
        _iterator.f();
      }

      return true;
    }
  }, {
    key: "checkNotFinalized",
    value: function checkNotFinalized() {
      if (this.finalized) throw new Error('already finalized');
    }
  }, {
    key: "checkFinalized",
    value: function checkFinalized() {
      if (!this.finalized) throw new Error('transaction is not finalized');
    }
  }, {
    key: "getGlobalChainData",
    value: function () {
      var _getGlobalChainData = (0, _asyncToGenerator2["default"])( /*#__PURE__*/_regenerator["default"].mark(function _callee() {
        var globalChainData;
        return _regenerator["default"].wrap(function _callee$(_context) {
          while (1) {
            switch (_context.prev = _context.next) {
              case 0:
                if (!(this.refBlockPrefix && this.refBlockNum)) {
                  _context.next = 2;
                  break;
                }

                return _context.abrupt("return", {
                  refBlockNum: this.refBlockNum,
                  refBlockPrefix: this.refBlockPrefix
                });

              case 2:
                _context.next = 4;
                return this.api.getObject(_constants.DYNAMIC_GLOBAL_OBJECT_ID, true);

              case 4:
                globalChainData = _context.sent;
                return _context.abrupt("return", {
                  refBlockNum: globalChainData.head_block_number,
                  refBlockPrefix: globalChainData.head_block_id
                });

              case 6:
              case "end":
                return _context.stop();
            }
          }
        }, _callee, this);
      }));

      function getGlobalChainData() {
        return _getGlobalChainData.apply(this, arguments);
      }

      return getGlobalChainData;
    }()
    /**
     * @param {OperationId} operationId
     * @param {{ [key: string]: any }} [props]
     * @returns {Transaction}
     */

  }, {
    key: "addOperation",
    value: function addOperation(operationId) {
      var props = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : {};
      this.checkNotFinalized();
      if (operationId === undefined) throw new Error('operation identifier is missing');

      if (typeof operationId !== 'number') {
        throw new Error('operation id is not a number');
      }

      (0, _validators.validateUnsignedSafeInteger)(operationId, 'operationId');
      if (!(0, _validators.isObject)(props)) throw new Error('argument "props" is not a object');
      var feeAssetIdIsMissing = !props.fee || props.fee.asset_id === undefined;
      var feeAmountIsMissing = !props.fee || props.fee.amount === undefined;

      var raw = _serializers.operation.toRaw([operationId, props], true);

      if (feeAssetIdIsMissing) delete raw[1].fee.asset_id;
      if (feeAmountIsMissing) delete raw[1].fee.amount;

      this._operations.push(raw);

      return this;
    }
    /**
     * @param {string} [assetId='1.3.0']
     * @returns {Promise<void>}
     */

  }, {
    key: "setRequiredFees",
    value: function () {
      var _setRequiredFees = (0, _asyncToGenerator2["default"])( /*#__PURE__*/_regenerator["default"].mark(function _callee4() {
        var _context2,
            _this = this;

        var assetId,
            operationTypes,
            operationsByNotDefaultFee,
            defaultAssetOperations,
            addOperationToAsset,
            _iterator2,
            _step2,
            op,
            notDefaultAssetsIds,
            _args4 = arguments;

        return _regenerator["default"].wrap(function _callee4$(_context5) {
          while (1) {
            switch (_context5.prev = _context5.next) {
              case 0:
                assetId = _args4.length > 0 && _args4[0] !== undefined ? _args4[0] : _constants.ECHO_ASSET_ID;
                this.checkNotFinalized();
                operationTypes = this._operations;

                if (!(operationTypes.length === 0)) {
                  _context5.next = 5;
                  break;
                }

                throw new Error('no operations');

              case 5:
                /** @type Map<string,Array<_Operation>> */
                operationsByNotDefaultFee = new _map["default"]();
                defaultAssetOperations = [];

                addOperationToAsset = function addOperationToAsset(notDefaultAssetId, operationProps) {
                  if (notDefaultAssetId === _constants.ECHO_ASSET_ID) {
                    defaultAssetOperations.push(operationProps);
                    return;
                  }

                  var arr = operationsByNotDefaultFee.get(notDefaultAssetId);
                  if (!arr) operationsByNotDefaultFee.set(notDefaultAssetId, [operationProps]);else arr.push(operationProps);
                };

                _iterator2 = _createForOfIteratorHelper(operationTypes);

                try {
                  for (_iterator2.s(); !(_step2 = _iterator2.n()).done;) {
                    op = _step2.value;
                    if (op[1].fee === undefined || op[1].fee.asset_id === undefined) addOperationToAsset(assetId, op);else if (op[1].fee.amount === undefined) addOperationToAsset(op[1].fee.asset_id, op);
                  }
                } catch (err) {
                  _iterator2.e(err);
                } finally {
                  _iterator2.f();
                }

                notDefaultAssetsIds = (0, _toConsumableArray2["default"])((0, _keys["default"])(operationsByNotDefaultFee).call(operationsByNotDefaultFee));
                _context5.next = 13;
                return _promise["default"].all((0, _concat["default"])(_context2 = [(0, _asyncToGenerator2["default"])( /*#__PURE__*/_regenerator["default"].mark(function _callee2() {
                  var fees, opIndex, fee, _fee;

                  return _regenerator["default"].wrap(function _callee2$(_context3) {
                    while (1) {
                      switch (_context3.prev = _context3.next) {
                        case 0:
                          if (!(defaultAssetOperations.length === 0)) {
                            _context3.next = 2;
                            break;
                          }

                          return _context3.abrupt("return");

                        case 2:
                          _context3.next = 4;
                          return _this.api.getRequiredFees(defaultAssetOperations);

                        case 4:
                          fees = _context3.sent;

                          for (opIndex = 0; opIndex < fees.length; opIndex += 1) {
                            fee = fees[opIndex];

                            if (fee.fee) {
                              _fee = fee;
                              fee = _fee.fee;
                            }

                            defaultAssetOperations[opIndex][1].fee = {
                              asset_id: fee.asset_id,
                              amount: fee.amount
                            };
                          }

                        case 6:
                        case "end":
                          return _context3.stop();
                      }
                    }
                  }, _callee2);
                }))()]).call(_context2, (0, _toConsumableArray2["default"])((0, _map2["default"])(notDefaultAssetsIds).call(notDefaultAssetsIds, /*#__PURE__*/function () {
                  var _ref2 = (0, _asyncToGenerator2["default"])( /*#__PURE__*/_regenerator["default"].mark(function _callee3(notDefaultAssetId) {
                    var ops, _yield$Promise$all, _yield$Promise$all2, fees, feePool, totalFees, opIndex, fee, _fee2;

                    return _regenerator["default"].wrap(function _callee3$(_context4) {
                      while (1) {
                        switch (_context4.prev = _context4.next) {
                          case 0:
                            ops = operationsByNotDefaultFee.get(notDefaultAssetId);
                            /** @type {Array<{asset_id:string, amount:number}>} */

                            _context4.next = 3;
                            return _promise["default"].all([_this.api.getRequiredFees(ops, notDefaultAssetId), _this.api.getFeePool(notDefaultAssetId)]);

                          case 3:
                            _yield$Promise$all = _context4.sent;
                            _yield$Promise$all2 = (0, _slicedToArray2["default"])(_yield$Promise$all, 2);
                            fees = _yield$Promise$all2[0];
                            feePool = _yield$Promise$all2[1];
                            totalFees = new _bignumber["default"](0);

                            for (opIndex = 0; opIndex < fees.length; opIndex += 1) {
                              fee = fees[opIndex];

                              if (fee.fee) {
                                _fee2 = fee;
                                fee = _fee2.fee;
                              }

                              ops[opIndex][1].fee = {
                                asset_id: fee.asset_id,
                                amount: fee.amount
                              };
                              totalFees.plus(fee.amount);
                            }

                            if (!totalFees.gt(feePool)) {
                              _context4.next = 11;
                              break;
                            }

                            throw new Error('fee pool overflow');

                          case 11:
                          case "end":
                            return _context4.stop();
                        }
                      }
                    }, _callee3);
                  }));

                  return function (_x) {
                    return _ref2.apply(this, arguments);
                  };
                }()))));

              case 13:
                return _context5.abrupt("return", this);

              case 14:
              case "end":
                return _context5.stop();
            }
          }
        }, _callee4, this);
      }));

      function setRequiredFees() {
        return _setRequiredFees.apply(this, arguments);
      }

      return setRequiredFees;
    }()
    /**
     * @param {PrivateKey|Buffer} privateKey
     * @param {PublicKey} [publicKey]
     * @returns {Transaction}
     */

  }, {
    key: "addSigner",
    value: function addSigner(privateKey) {
      var publicKey = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : privateKey.toPublicKey();
      if (Buffer.isBuffer(privateKey)) privateKey = _privateKey2["default"].fromBuffer(privateKey);
      if (!(privateKey instanceof _privateKey2["default"])) throw new Error('private key is not instance of PrivateKey class');
      if (!(publicKey instanceof _publicKey["default"])) throw new Error('public key is not instance of PublicKey class');
      var privateKeyHex = privateKey.toHex();

      var _iterator3 = _createForOfIteratorHelper(this._signers),
          _step3;

      try {
        for (_iterator3.s(); !(_step3 = _iterator3.n()).done;) {
          var signer = _step3.value;
          if (signer.privateKey.toHex() === privateKeyHex) return this;
        }
      } catch (err) {
        _iterator3.e(err);
      } finally {
        _iterator3.f();
      }

      this._signers.push({
        privateKey: privateKey,
        publicKey: publicKey
      });

      return this;
    }
    /**
     * @param {PrivateKey=} _privateKey
     */

  }, {
    key: "sign",
    value: function () {
      var _sign = (0, _asyncToGenerator2["default"])( /*#__PURE__*/_regenerator["default"].mark(function _callee5(_privateKey) {
        var _context6;

        var _yield$this$getGlobal, refBlockNum, refBlockPrefix, transactionBuffer, chainBuffer, bufferToSign;

        return _regenerator["default"].wrap(function _callee5$(_context7) {
          while (1) {
            switch (_context7.prev = _context7.next) {
              case 0:
                if (_privateKey !== undefined) this.addSigner(_privateKey);

                if (this.finalized) {
                  _context7.next = 16;
                  break;
                }

                _context7.next = 4;
                return this.getGlobalChainData();

              case 4:
                _yield$this$getGlobal = _context7.sent;
                refBlockNum = _yield$this$getGlobal.refBlockNum;
                refBlockPrefix = _yield$this$getGlobal.refBlockPrefix;

                if (this.hasAllFees) {
                  _context7.next = 10;
                  break;
                }

                _context7.next = 10;
                return this.setRequiredFees();

              case 10:
                if (!this.refBlockNum) {
                  this.refBlockNum = refBlockNum;
                }

                if (!this.refBlockPrefix) {
                  this.refBlockPrefix = refBlockPrefix;
                }

                if (this.chainId) {
                  _context7.next = 16;
                  break;
                }

                _context7.next = 15;
                return this.api.getChainId();

              case 15:
                this.chainId = _context7.sent;

              case 16:
                if (this.expiration === undefined) this.expiration = Math.ceil((0, _now["default"])() / 1e3) + _apiConfig.EXPIRATION_SECONDS;
                transactionBuffer = _serializers.transaction.serialize({
                  ref_block_num: this.refBlockNum,
                  ref_block_prefix: this.refBlockPrefix,
                  expiration: this.expiration,
                  operations: this.operations,
                  extensions: []
                });
                chainBuffer = Buffer.from(this.chainId, 'hex');
                bufferToSign = (0, _concat["default"])(Buffer).call(Buffer, [chainBuffer, Buffer.from(transactionBuffer)]);
                this._signatures = (0, _map2["default"])(_context6 = this._signers).call(_context6, function (_ref3) {
                  var privateKey = _ref3.privateKey;
                  return _signature["default"].signBuffer(bufferToSign, privateKey);
                });

              case 21:
              case "end":
                return _context7.stop();
            }
          }
        }, _callee5, this);
      }));

      function sign(_x2) {
        return _sign.apply(this, arguments);
      }

      return sign;
    }()
    /**
     * @returns {Promise<{ publicKeys:Array<string> }>}
     */

  }, {
    key: "getPotentialSignatures",
    value: function () {
      var _getPotentialSignatures = (0, _asyncToGenerator2["default"])( /*#__PURE__*/_regenerator["default"].mark(function _callee6() {
        var _context8;

        var transactionObject, publicKeys;
        return _regenerator["default"].wrap(function _callee6$(_context9) {
          while (1) {
            switch (_context9.prev = _context9.next) {
              case 0:
                transactionObject = this.finalized ? this.transactionObject : _serializers.transaction.toRaw({
                  ref_block_num: 0,
                  ref_block_prefix: 0,
                  expiration: this.expiration === undefined ? 0 : this.expiration,
                  operations: (0, _map2["default"])(_context8 = this.operations).call(_context8, function (_ref4) {
                    var _ref5 = (0, _slicedToArray2["default"])(_ref4, 2),
                        id = _ref5[0],
                        op = _ref5[1];

                    return [id, _objectSpread({
                      fee: {
                        asset_id: _constants.ECHO_ASSET_ID,
                        amount: 0
                      }
                    }, op)];
                  }),
                  extensions: []
                });
                _context9.next = 3;
                return this.api.getPotentialSignatures(transactionObject);

              case 3:
                publicKeys = _context9.sent;
                return _context9.abrupt("return", {
                  publicKeys: publicKeys
                });

              case 5:
              case "end":
                return _context9.stop();
            }
          }
        }, _callee6, this);
      }));

      function getPotentialSignatures() {
        return _getPotentialSignatures.apply(this, arguments);
      }

      return getPotentialSignatures;
    }()
    /**
     , add	 * @readonly
     * @type {import('../serializer/transaction-type').SignedTransactionObject}
     */

  }, {
    key: "transactionObject",
    get: function get() {
      var _context10;

      this.checkFinalized();
      return _serializers.signedTransaction.toRaw({
        ref_block_num: this.refBlockNum,
        ref_block_prefix: this.refBlockPrefix,
        expiration: this.expiration,
        operations: this.operations,
        extensions: [],
        signatures: (0, _map2["default"])(_context10 = this._signatures).call(_context10, function (signature) {
          return signature.toBuffer();
        }),
        signed_with_echorand_key: false
      });
    }
  }, {
    key: "serialize",
    value: function serialize() {
      return _serializers.transaction.serialize(this.transactionObject);
    }
  }, {
    key: "signedTransactionSerializer",
    value: function signedTransactionSerializer() {
      return _serializers.signedTransaction.serialize(this.transactionObject);
    }
    /**
     * @param {()=>* =} wasBroadcastedCallback
     * @returns {Promise<*>}
     */

  }, {
    key: "broadcast",
    value: function () {
      var _broadcast = (0, _asyncToGenerator2["default"])( /*#__PURE__*/_regenerator["default"].mark(function _callee7(wasBroadcastedCallback) {
        return _regenerator["default"].wrap(function _callee7$(_context11) {
          while (1) {
            switch (_context11.prev = _context11.next) {
              case 0:
                if (this.finalized) {
                  _context11.next = 3;
                  break;
                }

                _context11.next = 3;
                return this.sign();

              case 3:
                return _context11.abrupt("return", this.api.broadcastTransactionWithCallback(this.transactionObject, wasBroadcastedCallback));

              case 4:
              case "end":
                return _context11.stop();
            }
          }
        }, _callee7, this);
      }));

      function broadcast(_x3) {
        return _broadcast.apply(this, arguments);
      }

      return broadcast;
    }()
  }]);
  return Transaction;
}();

var _default = Transaction;
exports["default"] = _default;