"use strict";

var _typeof = require("@babel/runtime-corejs3/helpers/typeof");

var _WeakMap = require("@babel/runtime-corejs3/core-js-stable/weak-map");

var _Object$defineProperty = require("@babel/runtime-corejs3/core-js-stable/object/define-property");

var _Object$getOwnPropertyDescriptor = require("@babel/runtime-corejs3/core-js-stable/object/get-own-property-descriptor");

var _interopRequireDefault = require("@babel/runtime-corejs3/helpers/interopRequireDefault");

_Object$defineProperty(exports, "__esModule", {
  value: true
});

_Object$defineProperty(exports, "BigNumber", {
  enumerable: true,
  get: function get() {
    return _bignumber["default"];
  }
});

exports.CACHE_MAPS = void 0;

_Object$defineProperty(exports, "Contract", {
  enumerable: true,
  get: function get() {
    return _Contract["default"];
  }
});

exports.ED25519 = void 0;

_Object$defineProperty(exports, "Echo", {
  enumerable: true,
  get: function get() {
    return _echo["default"];
  }
});

_Object$defineProperty(exports, "Method", {
  enumerable: true,
  get: function get() {
    return _Method["default"];
  }
});

exports.PublicKeyECDSA = exports.PublicKey = exports.PrivateKeyECDSA = exports.PrivateKey = exports.OPERATIONS_IDS = void 0;

_Object$defineProperty(exports, "Signature", {
  enumerable: true,
  get: function get() {
    return _signature["default"];
  }
});

_Object$defineProperty(exports, "Transaction", {
  enumerable: true,
  get: function get() {
    return _transaction["default"];
  }
});

exports.crypto = exports.converters = exports.constants = exports.aes = void 0;

_Object$defineProperty(exports, "decode", {
  enumerable: true,
  get: function get() {
    return _decoders["default"];
  }
});

exports["default"] = void 0;

_Object$defineProperty(exports, "echoReducer", {
  enumerable: true,
  get: function get() {
    return _reducer["default"];
  }
});

_Object$defineProperty(exports, "encode", {
  enumerable: true,
  get: function get() {
    return _encoders["default"];
  }
});

_Object$defineProperty(exports, "generateInterface", {
  enumerable: true,
  get: function get() {
    return _contract.generateInterface;
  }
});

_Object$defineProperty(exports, "handleConnectionClosedError", {
  enumerable: true,
  get: function get() {
    return _helpers.handleConnectionClosedError;
  }
});

exports.validators = exports.serializers = exports.hash = void 0;

var _bignumber = _interopRequireDefault(require("bignumber.js"));

var _echo = _interopRequireWildcard(require("./echo"));

var constants = _interopRequireWildcard(require("./constants"));

exports.constants = constants;

var crypto = _interopRequireWildcard(require("./crypto"));

exports.crypto = crypto;

var _transaction = _interopRequireDefault(require("./echo/transaction"));

var _reducer = _interopRequireDefault(require("./redux/reducer"));

var validators = _interopRequireWildcard(require("./utils/validators"));

exports.validators = validators;

var converters = _interopRequireWildcard(require("./utils/converters"));

exports.converters = converters;

var serializers = _interopRequireWildcard(require("./serializers"));

exports.serializers = serializers;

var _signature = _interopRequireDefault(require("./crypto/signature"));

var _Contract = _interopRequireDefault(require("./contract/Contract"));

var _encoders = _interopRequireDefault(require("./contract/encoders"));

var _decoders = _interopRequireDefault(require("./contract/decoders"));

var _Method = _interopRequireDefault(require("./contract/Method"));

var _contract = require("./contract");

var _helpers = require("./utils/helpers");

function _getRequireWildcardCache(nodeInterop) { if (typeof _WeakMap !== "function") return null; var cacheBabelInterop = new _WeakMap(); var cacheNodeInterop = new _WeakMap(); return (_getRequireWildcardCache = function _getRequireWildcardCache(nodeInterop) { return nodeInterop ? cacheNodeInterop : cacheBabelInterop; })(nodeInterop); }

function _interopRequireWildcard(obj, nodeInterop) { if (!nodeInterop && obj && obj.__esModule) { return obj; } if (obj === null || _typeof(obj) !== "object" && typeof obj !== "function") { return { "default": obj }; } var cache = _getRequireWildcardCache(nodeInterop); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = _Object$defineProperty && _Object$getOwnPropertyDescriptor; for (var key in obj) { if (key !== "default" && Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? _Object$getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { _Object$defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj["default"] = obj; if (cache) { cache.set(obj, newObj); } return newObj; }

/* Chain */
require('buffer');

var OPERATIONS_IDS = constants.OPERATIONS_IDS,
    CACHE_MAPS = constants.CACHE_MAPS;
exports.CACHE_MAPS = CACHE_MAPS;
exports.OPERATIONS_IDS = OPERATIONS_IDS;
var aes = crypto.aes,
    hash = crypto.hash,
    PrivateKeyECDSA = crypto.PrivateKeyECDSA,
    PublicKeyECDSA = crypto.PublicKeyECDSA,
    PrivateKey = crypto.PrivateKey,
    PublicKey = crypto.PublicKey,
    ED25519 = crypto.ED25519;
exports.ED25519 = ED25519;
exports.PublicKey = PublicKey;
exports.PrivateKey = PrivateKey;
exports.PublicKeyECDSA = PublicKeyECDSA;
exports.PrivateKeyECDSA = PrivateKeyECDSA;
exports.hash = hash;
exports.aes = aes;
var _default = _echo.echo;
exports["default"] = _default;