"use strict";

var _Object$defineProperty = require("@babel/runtime-corejs3/core-js-stable/object/define-property");

var _interopRequireDefault = require("@babel/runtime-corejs3/helpers/interopRequireDefault");

_Object$defineProperty(exports, "__esModule", {
  value: true
});

exports["default"] = void 0;

var _every = _interopRequireDefault(require("@babel/runtime-corejs3/core-js-stable/instance/every"));

var _reduce = _interopRequireDefault(require("@babel/runtime-corejs3/core-js-stable/instance/reduce"));

var _immutable = require("immutable");

var _validators = require("../utils/validators");

var DEFAULT_FIELDS = (0, _immutable.Map)({
  subbedAccounts: new _immutable.Map(),
  subbedCommittee: new _immutable.Map(),
  getFullAccountsSubscriptions: new _immutable.Map(),
  objectsById: new _immutable.Map(),
  fullAccounts: new _immutable.Map(),
  accountsByName: new _immutable.Map(),
  accountsById: new _immutable.Map(),
  accountsIdByKey: (0, _immutable.Map)(),
  accountAddressesByAccountId: (0, _immutable.Map)(),
  accountEthAddressByAccountId: (0, _immutable.Map)(),
  accountBtcAddressByAccountId: (0, _immutable.Map)(),
  assetByAssetId: new _immutable.Map(),
  assetBySymbol: new _immutable.Map(),
  contractsByContractId: new _immutable.Map(),
  fullContractsByContractId: new _immutable.Map(),
  contractResultsByContractResultId: new _immutable.Map(),
  blockHeadersByBlockNumber: (0, _immutable.Map)(),
  blocks: new _immutable.Map(),
  transactionsByBlockAndIndex: new _immutable.Map(),
  committeeMembersByAccountId: new _immutable.Map(),
  committeeMembersByCommitteeMemberId: new _immutable.Map(),
  objectsByVoteId: new _immutable.Map(),
  accountsBalanceByAccountId: new _immutable.Map(),
  accountsBalanceByAccountName: new _immutable.Map(),
  accountReferencesByAccountId: new _immutable.Map(),
  bitAssetsByBitAssetId: new _immutable.Map(),
  dynamicAssetDataByDynamicAssetDataId: new _immutable.Map(),
  dynamicIdToAssetId: new _immutable.Map(),
  bitAssetIdToAssetId: new _immutable.Map(),
  balanceObjectsByBalanceId: new _immutable.Map(),
  getAccountRefsOfAccountsCalls: new _immutable.Map(),
  fetchingGetFullAccounts: new _immutable.Map(),
  chainProperties: null,
  globalProperties: null,
  config: null,
  chainId: null,
  dynamicGlobalProperties: null
});
/**
 *
 * @param {Array|undefined|null} caches
 * @returns {Function}
 */

var _default = function _default(caches) {
  if (!(0, _validators.isVoid)(caches)) {
    if ((0, _validators.isArray)(caches) && (0, _every["default"])(caches).call(caches, function (c) {
      return (0, _validators.isString)(c);
    })) {
      DEFAULT_FIELDS = new _immutable.Map((0, _reduce["default"])(caches).call(caches, function (obj, c) {
        if (DEFAULT_FIELDS.has(c)) {
          obj[c] = DEFAULT_FIELDS.get(c);
        }

        return obj;
      }, {}));
    } else {
      throw new Error('Caches is invalid');
    }
  }

  return function () {
    var state = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : DEFAULT_FIELDS;

    var _ref = arguments.length > 1 ? arguments[1] : undefined,
        type = _ref.type,
        _ref$payload = _ref.payload,
        payload = _ref$payload === void 0 ? {} : _ref$payload;

    switch (type) {
      case 'ECHO_SET_CACHE':
        return state.has(payload.field) ? state.set(payload.field, payload.value) : state;

      case 'ECHO_RESET_CACHE':
        return DEFAULT_FIELDS;

      default:
        return state;
    }
  };
};

exports["default"] = _default;