"use strict";

var _Object$defineProperty = require("@babel/runtime-corejs3/core-js-stable/object/define-property");

var _interopRequireDefault = require("@babel/runtime-corejs3/helpers/interopRequireDefault");

_Object$defineProperty(exports, "__esModule", {
  value: true
});

exports["default"] = void 0;

var _classCallCheck2 = _interopRequireDefault(require("@babel/runtime-corejs3/helpers/classCallCheck"));

var _createClass2 = _interopRequireDefault(require("@babel/runtime-corejs3/helpers/createClass"));

var _bytebuffer = _interopRequireDefault(require("bytebuffer"));

function notImplementedSerialization() {
  throw new Error('serialization is not implemented');
}
/**
 * @abstract
 * @template TInput
 * @template TOutput
 */


var ISerializer = /*#__PURE__*/function () {
  function ISerializer() {
    (0, _classCallCheck2["default"])(this, ISerializer);

    /**
     * @abstract
     * @type {TInput}
     */
    this.__TInput__ = undefined;
    /**
     * @abstract
     * @type {TOutput}
     */

    this.__TOutput__ = undefined;
  }
  /**
   * @abstract
   * @param {TInput} value
   * @param {ByteBuffer} bytebuffer
   */
  // eslint-disable-next-line no-unused-vars


  (0, _createClass2["default"])(ISerializer, [{
    key: "appendToByteBuffer",
    value: function appendToByteBuffer(value, bytebuffer) {
      notImplementedSerialization();
    }
    /**
     * @abstract
     * @param {TInput} value
     * @returns {TOutput}
     */
    // eslint-disable-next-line no-unused-vars

  }, {
    key: "toRaw",
    value: function toRaw(value) {
      notImplementedSerialization();
    }
    /**
     * @abstract
     * @param {Buffer} buffer
     * @param {number} [offset]
     * @returns {{ res: TOutput, newOffset: number }}
     */
    // eslint-disable-next-line no-unused-vars

  }, {
    key: "readFromBuffer",
    value: function readFromBuffer(buffer, offset) {
      notImplementedSerialization();
    }
    /** @param {TInput} value */

  }, {
    key: "validate",
    value: function validate(value) {
      this.toRaw(value);
    }
    /**
     * @param {TInput} value
     * @returns {Buffer}
     */

  }, {
    key: "serialize",
    value: function serialize(value) {
      var bytebuffer = new _bytebuffer["default"](_bytebuffer["default"].DEFAULT_CAPACITY, _bytebuffer["default"].LITTLE_ENDIAN);
      this.appendToByteBuffer(value, bytebuffer); // in browsers library "bytebuffer" returns ArrayBuffer instead of Buffer

      /** @type {Buffer | ArrayBuffer} */

      var result = bytebuffer.copy(0, bytebuffer.offset).toBuffer();
      if (Buffer.isBuffer(result)) return result;
      return Buffer.from(result);
    }
    /**
     * @param {Buffer} buffer
     * @returns {TOutput}
     */

  }, {
    key: "deserialize",
    value: function deserialize(buffer) {
      if (!Buffer.isBuffer(buffer)) throw new Error('invalid buffer type');

      var _this$readFromBuffer = this.readFromBuffer(buffer),
          res = _this$readFromBuffer.res,
          newOffset = _this$readFromBuffer.newOffset;

      if (newOffset !== buffer.length) throw new Error('excess info in the end of the buffer');
      return res;
    }
  }]);
  return ISerializer;
}();
/**
 * @template {ISerializer} T
 * @typedef {T['__TInput__']} SerializerInput
 */

/**
 * @template {ISerializer} T
 * @typedef {T['__TOutput__']} SerializerOutput
 */


exports["default"] = ISerializer;