"use strict";

var _Reflect$construct = require("@babel/runtime-corejs3/core-js-stable/reflect/construct");

var _Object$defineProperty = require("@babel/runtime-corejs3/core-js-stable/object/define-property");

var _interopRequireDefault = require("@babel/runtime-corejs3/helpers/interopRequireDefault");

_Object$defineProperty(exports, "__esModule", {
  value: true
});

exports["default"] = void 0;

var _classCallCheck2 = _interopRequireDefault(require("@babel/runtime-corejs3/helpers/classCallCheck"));

var _createClass2 = _interopRequireDefault(require("@babel/runtime-corejs3/helpers/createClass"));

var _inherits2 = _interopRequireDefault(require("@babel/runtime-corejs3/helpers/inherits"));

var _possibleConstructorReturn2 = _interopRequireDefault(require("@babel/runtime-corejs3/helpers/possibleConstructorReturn"));

var _getPrototypeOf2 = _interopRequireDefault(require("@babel/runtime-corejs3/helpers/getPrototypeOf"));

var _ISerializer2 = _interopRequireDefault(require("../ISerializer"));

var _integers = require("./integers");

function _createSuper(Derived) { var hasNativeReflectConstruct = _isNativeReflectConstruct(); return function _createSuperInternal() { var Super = (0, _getPrototypeOf2["default"])(Derived), result; if (hasNativeReflectConstruct) { var NewTarget = (0, _getPrototypeOf2["default"])(this).constructor; result = _Reflect$construct(Super, arguments, NewTarget); } else { result = Super.apply(this, arguments); } return (0, _possibleConstructorReturn2["default"])(this, result); }; }

function _isNativeReflectConstruct() { if (typeof Reflect === "undefined" || !_Reflect$construct) return false; if (_Reflect$construct.sham) return false; if (typeof Proxy === "function") return true; try { Boolean.prototype.valueOf.call(_Reflect$construct(Boolean, [], function () {})); return true; } catch (e) { return false; } }

/** @typedef {import("bytebuffer")} ByteBuffer */

/** @typedef {boolean} TInput */

/** @typedef {boolean} TOutput */

/** @augments {ISerializer<TInput, TOutput>} */
var BoolSerializer = /*#__PURE__*/function (_ISerializer) {
  (0, _inherits2["default"])(BoolSerializer, _ISerializer);

  var _super = _createSuper(BoolSerializer);

  function BoolSerializer() {
    (0, _classCallCheck2["default"])(this, BoolSerializer);
    return _super.apply(this, arguments);
  }

  (0, _createClass2["default"])(BoolSerializer, [{
    key: "toRaw",
    value:
    /**
     * @param {TInput} value
     * @returns {TOutput}
     */
    function toRaw(value) {
      if (typeof value !== 'boolean') throw new Error('invalid bool type');
      return value;
    }
    /**
     * @param {TInput} value
     * @param {ByteBuffer} bytebuffer
     */

  }, {
    key: "appendToByteBuffer",
    value: function appendToByteBuffer(value, bytebuffer) {
      var raw = this.toRaw(value);

      _integers.uint8.appendToByteBuffer(raw ? 1 : 0, bytebuffer);
    }
    /**
     * @param {Buffer} buffer
     * @param {number} [offset]
     * @returns {{ res: TOutput, newOffset: number }}
     */

  }, {
    key: "readFromBuffer",
    value: function readFromBuffer(buffer, offset) {
      var newOffset = offset + 1;
      var _byte = buffer[offset];
      if (_byte > 0x01) throw new Error('invalid bool byte');
      return {
        res: _byte === 0x01,
        newOffset: newOffset
      };
    }
  }]);
  return BoolSerializer;
}(_ISerializer2["default"]);

exports["default"] = BoolSerializer;