"use strict";

var _Reflect$construct = require("@babel/runtime-corejs3/core-js-stable/reflect/construct");

var _Object$defineProperty = require("@babel/runtime-corejs3/core-js-stable/object/define-property");

var _interopRequireDefault = require("@babel/runtime-corejs3/helpers/interopRequireDefault");

_Object$defineProperty(exports, "__esModule", {
  value: true
});

exports["default"] = void 0;

var _concat = _interopRequireDefault(require("@babel/runtime-corejs3/core-js-stable/instance/concat"));

var _slice = _interopRequireDefault(require("@babel/runtime-corejs3/core-js-stable/instance/slice"));

var _classCallCheck2 = _interopRequireDefault(require("@babel/runtime-corejs3/helpers/classCallCheck"));

var _createClass2 = _interopRequireDefault(require("@babel/runtime-corejs3/helpers/createClass"));

var _inherits2 = _interopRequireDefault(require("@babel/runtime-corejs3/helpers/inherits"));

var _possibleConstructorReturn2 = _interopRequireDefault(require("@babel/runtime-corejs3/helpers/possibleConstructorReturn"));

var _getPrototypeOf2 = _interopRequireDefault(require("@babel/runtime-corejs3/helpers/getPrototypeOf"));

var _ISerializer2 = _interopRequireDefault(require("../ISerializer"));

var _integers = require("./integers");

function _createSuper(Derived) { var hasNativeReflectConstruct = _isNativeReflectConstruct(); return function _createSuperInternal() { var Super = (0, _getPrototypeOf2["default"])(Derived), result; if (hasNativeReflectConstruct) { var NewTarget = (0, _getPrototypeOf2["default"])(this).constructor; result = _Reflect$construct(Super, arguments, NewTarget); } else { result = Super.apply(this, arguments); } return (0, _possibleConstructorReturn2["default"])(this, result); }; }

function _isNativeReflectConstruct() { if (typeof Reflect === "undefined" || !_Reflect$construct) return false; if (_Reflect$construct.sham) return false; if (typeof Proxy === "function") return true; try { Boolean.prototype.valueOf.call(_Reflect$construct(Boolean, [], function () {})); return true; } catch (e) { return false; } }

/** @typedef {import("bytebuffer")} ByteBuffer */

/** @typedef {Buffer | string} TInput */

/** @augments {ISerializer<TInput, string>} */
var BytesSerializer = /*#__PURE__*/function (_ISerializer) {
  (0, _inherits2["default"])(BytesSerializer, _ISerializer);

  var _super = _createSuper(BytesSerializer);

  /** @param {number} [bytesCount] */

  /** @param {boolean} [isNeed0xPrefix] */
  function BytesSerializer(bytesCount) {
    var _this;

    var isNeed0xPrefix = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : false;
    (0, _classCallCheck2["default"])(this, BytesSerializer);
    _this = _super.call(this);
    _this._isNeed0xPrefix = isNeed0xPrefix;

    if (bytesCount !== undefined) {
      try {
        if (bytesCount < 0) throw new Error('bytes serializer size is negative');
        /**
         * @private
         * @type {number | undefined}
         */

        _this._bytesCount = _integers.varint32.toRaw(bytesCount);
      } catch (error) {
        throw new Error("bytes serializer length: ".concat(error.message));
      }
    }

    return _this;
  }
  /**
   * @param {TInput} value
   * @returns {string}
   */


  (0, _createClass2["default"])(BytesSerializer, [{
    key: "bytesCount",
    get:
    /**
     * @readonly
     * @type {number | undefined}
     */
    function get() {
      return this._bytesCount;
    }
    /**
    * @readonly
    * @type {boolean}
    */

  }, {
    key: "isNeed0xPrefix",
    get: function get() {
      return this._isNeed0xPrefix;
    }
  }, {
    key: "toRaw",
    value: function toRaw(value) {
      var _context;

      if (typeof value === 'string') {
        value = value.replace('0x', '');
        if (!/^([\da-fA-F]{2})*$/.test(value)) throw new Error('invalid hex format');
        value = Buffer.from(value.toLowerCase(), 'hex');
      } else if (!Buffer.isBuffer(value)) throw new Error('invalid bytes type');

      if (this.bytesCount !== undefined && value.length !== this.bytesCount) throw new Error('invalid bytes count');
      return (0, _concat["default"])(_context = "".concat(this.isNeed0xPrefix ? '0x' : '')).call(_context, value.toString('hex'));
    }
    /**
     * @param {TInput} value
     * @param {ByteBuffer} bytebuffer
     */

  }, {
    key: "appendToByteBuffer",
    value: function appendToByteBuffer(value, bytebuffer) {
      var raw = this.toRaw(value);
      if (this.bytesCount === undefined) _integers.varint32.appendToByteBuffer(raw.length / 2, bytebuffer);
      bytebuffer.append(Buffer.from(raw, 'hex').toString('binary'), 'binary');
    }
    /**
     * @param {buffer} buffer
     * @param {number} [offset]
     * @returns {{ res: string, newOffset: number }}
     */

  }, {
    key: "readFromBuffer",
    value: function readFromBuffer(buffer) {
      var offset = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : 0;
      var lengthIsStatic = this.bytesCount !== undefined;

      var _ref = lengthIsStatic ? {
        res: this.bytesCount,
        newOffset: offset
      } : _integers.varint32.readFromBuffer(buffer, offset),
          length = _ref.res,
          from = _ref.newOffset;

      var bytes = (0, _slice["default"])(buffer).call(buffer, from, from + length);
      if (bytes.length !== length) throw new Error('unexpected end of buffer');
      return {
        res: this.toRaw(bytes),
        newOffset: from + length
      };
    }
  }]);
  return BytesSerializer;
}(_ISerializer2["default"]);

exports["default"] = BytesSerializer;