"use strict";

var _Reflect$construct = require("@babel/runtime-corejs3/core-js-stable/reflect/construct");

var _Object$defineProperty = require("@babel/runtime-corejs3/core-js-stable/object/define-property");

var _interopRequireDefault = require("@babel/runtime-corejs3/helpers/interopRequireDefault");

_Object$defineProperty(exports, "__esModule", {
  value: true
});

exports["default"] = void 0;

var _slice = _interopRequireDefault(require("@babel/runtime-corejs3/core-js-stable/instance/slice"));

var _classCallCheck2 = _interopRequireDefault(require("@babel/runtime-corejs3/helpers/classCallCheck"));

var _createClass2 = _interopRequireDefault(require("@babel/runtime-corejs3/helpers/createClass"));

var _inherits2 = _interopRequireDefault(require("@babel/runtime-corejs3/helpers/inherits"));

var _possibleConstructorReturn2 = _interopRequireDefault(require("@babel/runtime-corejs3/helpers/possibleConstructorReturn"));

var _getPrototypeOf2 = _interopRequireDefault(require("@babel/runtime-corejs3/helpers/getPrototypeOf"));

var _integers = require("./integers");

var _ISerializer2 = _interopRequireDefault(require("../ISerializer"));

function _createSuper(Derived) { var hasNativeReflectConstruct = _isNativeReflectConstruct(); return function _createSuperInternal() { var Super = (0, _getPrototypeOf2["default"])(Derived), result; if (hasNativeReflectConstruct) { var NewTarget = (0, _getPrototypeOf2["default"])(this).constructor; result = _Reflect$construct(Super, arguments, NewTarget); } else { result = Super.apply(this, arguments); } return (0, _possibleConstructorReturn2["default"])(this, result); }; }

function _isNativeReflectConstruct() { if (typeof Reflect === "undefined" || !_Reflect$construct) return false; if (_Reflect$construct.sham) return false; if (typeof Proxy === "function") return true; try { Boolean.prototype.valueOf.call(_Reflect$construct(Boolean, [], function () {})); return true; } catch (e) { return false; } }

/** @typedef {import("bytebuffer")} ByteBuffer */

/** @augments {ISerializer<string, string>} */
var StringSerializer = /*#__PURE__*/function (_ISerializer) {
  (0, _inherits2["default"])(StringSerializer, _ISerializer);

  var _super = _createSuper(StringSerializer);

  function StringSerializer() {
    (0, _classCallCheck2["default"])(this, StringSerializer);
    return _super.apply(this, arguments);
  }

  (0, _createClass2["default"])(StringSerializer, [{
    key: "toRaw",
    value:
    /**
     * @param {string} value
     * @returns {string}
     */
    function toRaw(value) {
      if (typeof value !== 'string') throw new Error('value is not a string');
      return value;
    }
    /**
     * @param {string} value
     * @param {ByteBuffer} bytebuffer
     */

  }, {
    key: "appendToByteBuffer",
    value: function appendToByteBuffer(value, bytebuffer) {
      var raw = this.toRaw(value);

      _integers.varint32.appendToByteBuffer(raw.length, bytebuffer);

      bytebuffer.append(raw, 'binary');
    }
    /**
     * @param {Buffer} buffer
     * @param {number} [offset]
     * @returns {{ res: string, newOffset: number }}
     */

  }, {
    key: "readFromBuffer",
    value: function readFromBuffer(buffer) {
      var offset = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : 0;

      var _varint32$readFromBuf = _integers.varint32.readFromBuffer(buffer, offset),
          length = _varint32$readFromBuf.res,
          from = _varint32$readFromBuf.newOffset;

      var bytes = (0, _slice["default"])(buffer).call(buffer, from, from + length);
      return {
        res: this.toRaw(bytes.toString()),
        newOffset: from + length
      };
    }
  }]);
  return StringSerializer;
}(_ISerializer2["default"]);

exports["default"] = StringSerializer;