"use strict";

var _Reflect$construct = require("@babel/runtime-corejs3/core-js-stable/reflect/construct");

var _Object$defineProperty = require("@babel/runtime-corejs3/core-js-stable/object/define-property");

var _interopRequireDefault = require("@babel/runtime-corejs3/helpers/interopRequireDefault");

_Object$defineProperty(exports, "__esModule", {
  value: true
});

exports["default"] = void 0;

var _classCallCheck2 = _interopRequireDefault(require("@babel/runtime-corejs3/helpers/classCallCheck"));

var _createClass2 = _interopRequireDefault(require("@babel/runtime-corejs3/helpers/createClass"));

var _inherits2 = _interopRequireDefault(require("@babel/runtime-corejs3/helpers/inherits"));

var _possibleConstructorReturn2 = _interopRequireDefault(require("@babel/runtime-corejs3/helpers/possibleConstructorReturn"));

var _getPrototypeOf2 = _interopRequireDefault(require("@babel/runtime-corejs3/helpers/getPrototypeOf"));

var _integers = require("./integers");

var _ISerializer2 = _interopRequireDefault(require("../ISerializer"));

function _createSuper(Derived) { var hasNativeReflectConstruct = _isNativeReflectConstruct(); return function _createSuperInternal() { var Super = (0, _getPrototypeOf2["default"])(Derived), result; if (hasNativeReflectConstruct) { var NewTarget = (0, _getPrototypeOf2["default"])(this).constructor; result = _Reflect$construct(Super, arguments, NewTarget); } else { result = Super.apply(this, arguments); } return (0, _possibleConstructorReturn2["default"])(this, result); }; }

function _isNativeReflectConstruct() { if (typeof Reflect === "undefined" || !_Reflect$construct) return false; if (_Reflect$construct.sham) return false; if (typeof Proxy === "function") return true; try { Boolean.prototype.valueOf.call(_Reflect$construct(Boolean, [], function () {})); return true; } catch (e) { return false; } }

/** @typedef {import("bytebuffer]")} ByteBuffer */

/** @typedef {import("./integers").UInt32Serializer} UInt32Serializer */

/**
 * @template {ISerializer} T
 * @typedef {import("../ISerializer").SerializerInput<T>} SerializerInput
 */

/** @typedef {SerializerInput<UInt32Serializer> | Date} TInput */

/** @typedef {string} TOutput */

/**
 * @param {Date} date
 * @returns {number}
 */
function getSeconds(date) {
  return Math.floor(date.getTime() / 1000);
}
/** @augments {ISerializer<TInput, TOutput>} */


var TimePointSecSerializer = /*#__PURE__*/function (_ISerializer) {
  (0, _inherits2["default"])(TimePointSecSerializer, _ISerializer);

  var _super = _createSuper(TimePointSecSerializer);

  function TimePointSecSerializer() {
    (0, _classCallCheck2["default"])(this, TimePointSecSerializer);
    return _super.apply(this, arguments);
  }

  (0, _createClass2["default"])(TimePointSecSerializer, [{
    key: "toRaw",
    value:
    /**
     * @param {TInput} value
     * @returns {TOutput}
     */
    function toRaw(value) {
      if (typeof value === 'string' && /^\d{4}-[01]\d-[0-3]\dT[0-2]\d:[0-5]\d:[0-5]\d$/.test(value)) {
        value = new Date("".concat(value, ".000Z"));
      }

      if (!(value instanceof Date)) value = new Date(_integers.uint32.toRaw(value) * 1e3);
      return value.toISOString().split('.')[0];
    }
    /**
     * @param {TInput} value
     * @param {ByteBuffer} bytebuffer
     */

  }, {
    key: "appendToByteBuffer",
    value: function appendToByteBuffer(value, bytebuffer) {
      var raw = this.toRaw(value);
      var totalSeconds = getSeconds(new Date("".concat(raw, ".000Z")));

      _integers.uint32.appendToByteBuffer(totalSeconds, bytebuffer);
    }
    /**
     * @param {Buffer} buffer
     * @param {number} [offset]
     * @returns {{ res: TOutput, newOffset: number }}
     */

  }, {
    key: "readFromBuffer",
    value: function readFromBuffer(buffer) {
      var offset = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : 0;

      var _uint32$readFromBuffe = _integers.uint32.readFromBuffer(buffer, offset),
          seconds = _uint32$readFromBuffe.res,
          newOffset = _uint32$readFromBuffe.newOffset;

      return {
        res: this.toRaw(seconds),
        newOffset: newOffset
      };
    }
  }]);
  return TimePointSecSerializer;
}(_ISerializer2["default"]);

exports["default"] = TimePointSecSerializer;