"use strict";

var _Reflect$construct = require("@babel/runtime-corejs3/core-js-stable/reflect/construct");

var _sliceInstanceProperty2 = require("@babel/runtime-corejs3/core-js-stable/instance/slice");

var _Array$from = require("@babel/runtime-corejs3/core-js-stable/array/from");

var _Symbol = require("@babel/runtime-corejs3/core-js-stable/symbol");

var _getIteratorMethod = require("@babel/runtime-corejs3/core-js/get-iterator-method");

var _Array$isArray = require("@babel/runtime-corejs3/core-js-stable/array/is-array");

var _Object$defineProperty = require("@babel/runtime-corejs3/core-js-stable/object/define-property");

var _interopRequireDefault = require("@babel/runtime-corejs3/helpers/interopRequireDefault");

_Object$defineProperty(exports, "__esModule", {
  value: true
});

exports["default"] = void 0;

var _isSafeInteger = _interopRequireDefault(require("@babel/runtime-corejs3/core-js-stable/number/is-safe-integer"));

var _maxSafeInteger = _interopRequireDefault(require("@babel/runtime-corejs3/core-js-stable/number/max-safe-integer"));

var _slice = _interopRequireDefault(require("@babel/runtime-corejs3/core-js-stable/instance/slice"));

var _toConsumableArray2 = _interopRequireDefault(require("@babel/runtime-corejs3/helpers/toConsumableArray"));

var _classCallCheck2 = _interopRequireDefault(require("@babel/runtime-corejs3/helpers/classCallCheck"));

var _createClass2 = _interopRequireDefault(require("@babel/runtime-corejs3/helpers/createClass"));

var _inherits2 = _interopRequireDefault(require("@babel/runtime-corejs3/helpers/inherits"));

var _possibleConstructorReturn2 = _interopRequireDefault(require("@babel/runtime-corejs3/helpers/possibleConstructorReturn"));

var _getPrototypeOf2 = _interopRequireDefault(require("@babel/runtime-corejs3/helpers/getPrototypeOf"));

var _bignumber = _interopRequireDefault(require("bignumber.js"));

var _ISerializer2 = _interopRequireDefault(require("../../ISerializer"));

function _createForOfIteratorHelper(o, allowArrayLike) { var it = typeof _Symbol !== "undefined" && _getIteratorMethod(o) || o["@@iterator"]; if (!it) { if (_Array$isArray(o) || (it = _unsupportedIterableToArray(o)) || allowArrayLike && o && typeof o.length === "number") { if (it) o = it; var i = 0; var F = function F() {}; return { s: F, n: function n() { if (i >= o.length) return { done: true }; return { done: false, value: o[i++] }; }, e: function e(_e) { throw _e; }, f: F }; } throw new TypeError("Invalid attempt to iterate non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method."); } var normalCompletion = true, didErr = false, err; return { s: function s() { it = it.call(o); }, n: function n() { var step = it.next(); normalCompletion = step.done; return step; }, e: function e(_e2) { didErr = true; err = _e2; }, f: function f() { try { if (!normalCompletion && it["return"] != null) it["return"](); } finally { if (didErr) throw err; } } }; }

function _unsupportedIterableToArray(o, minLen) { var _context; if (!o) return; if (typeof o === "string") return _arrayLikeToArray(o, minLen); var n = _sliceInstanceProperty2(_context = Object.prototype.toString.call(o)).call(_context, 8, -1); if (n === "Object" && o.constructor) n = o.constructor.name; if (n === "Map" || n === "Set") return _Array$from(o); if (n === "Arguments" || /^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(n)) return _arrayLikeToArray(o, minLen); }

function _arrayLikeToArray(arr, len) { if (len == null || len > arr.length) len = arr.length; for (var i = 0, arr2 = new Array(len); i < len; i++) { arr2[i] = arr[i]; } return arr2; }

function _createSuper(Derived) { var hasNativeReflectConstruct = _isNativeReflectConstruct(); return function _createSuperInternal() { var Super = (0, _getPrototypeOf2["default"])(Derived), result; if (hasNativeReflectConstruct) { var NewTarget = (0, _getPrototypeOf2["default"])(this).constructor; result = _Reflect$construct(Super, arguments, NewTarget); } else { result = Super.apply(this, arguments); } return (0, _possibleConstructorReturn2["default"])(this, result); }; }

function _isNativeReflectConstruct() { if (typeof Reflect === "undefined" || !_Reflect$construct) return false; if (_Reflect$construct.sham) return false; if (typeof Proxy === "function") return true; try { Boolean.prototype.valueOf.call(_Reflect$construct(Boolean, [], function () {})); return true; } catch (e) { return false; } }

/** @typedef {number | BigNumber | string} TInput */

/**
 * @abstract
 * @template {string | number} TOutput
 * @augments {ISerializer<TInput, TOutput>}
 */
var IIntSerializer = /*#__PURE__*/function (_ISerializer) {
  (0, _inherits2["default"])(IIntSerializer, _ISerializer);

  var _super = _createSuper(IIntSerializer);

  /**
   * @param {number} bitsCount
   * @param {boolean} [isUint]
   */
  function IIntSerializer(bitsCount) {
    var _this;

    var isUint = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : false;
    (0, _classCallCheck2["default"])(this, IIntSerializer);
    _this = _super.call(this);

    if (!(0, _isSafeInteger["default"])(bitsCount) || bitsCount < 0) {
      throw new Error('bits count is not unsigned safe integer');
    }

    if (bitsCount % 8 !== 0) throw new Error('invalid bits count');
    if (bitsCount === 0) throw new Error('bits');
    /** @private */

    _this._bitsCount = bitsCount;
    /**
     * @private
     * @type {boolean}
     */

    _this._isUint = isUint;
    /** @private */

    _this._maxAbsValue = new _bignumber["default"](2).pow(bitsCount - (_this.isUint ? 0 : 1)).minus(1);
    return _this;
  }
  /**
   * @param {TInput} value
   * @returns {TOutput}
   */


  (0, _createClass2["default"])(IIntSerializer, [{
    key: "bitsCount",
    get:
    /**
     * @readonly
     * @type {number}
     */
    function get() {
      return this._bitsCount;
    }
    /**
     * @readonly
     * @type {BigNumber}
     */

  }, {
    key: "maxAbsValue",
    get: function get() {
      return this._maxAbsValue;
    }
  }, {
    key: "isUint",
    get: function get() {
      return this._isUint;
    }
  }, {
    key: "toRaw",
    value: function toRaw(value) {
      if (typeof value === 'number') {
        if (Math.abs(value) > _maxSafeInteger["default"]) throw new Error('loss of accuracy, use bignumber.js');
        value = new _bignumber["default"](value);
      } else if (typeof value === 'string') value = new _bignumber["default"](value);

      if (!_bignumber["default"].isBigNumber(value)) throw new Error('value is not a number');
      if (!value.isInteger()) throw new Error('value is not a integer');
      if (value.abs().gt(this._maxAbsValue)) throw new Error("int".concat(this._bitsCount, " overflow"));
      return this.bitsCount < 53 ? value.toNumber() : value.toString();
    }
    /**
     * @param {Buffer} buffer
     * @param {number} [offset]
     * @returns {{ res: TOutput, newOffset: number }}
     */

  }, {
    key: "readFromBuffer",
    value: function readFromBuffer(buffer) {
      var offset = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : 0;
      var bytesCount = this.bitsCount / 8;
      var newOffset = offset + bytesCount;
      if (buffer.length < newOffset) throw new Error('unexpected buffer end');
      var bytes = (0, _toConsumableArray2["default"])((0, _slice["default"])(buffer).call(buffer, offset, newOffset));
      var result = new _bignumber["default"](0);
      var isNegative = this.isUint ? false : bytes[bytesCount - 1];
      var multiplier = new _bignumber["default"](1);

      var _iterator = _createForOfIteratorHelper(bytes),
          _step;

      try {
        for (_iterator.s(); !(_step = _iterator.n()).done;) {
          var _byte = _step.value;
          result = result.plus(new _bignumber["default"](isNegative ? 0xff - _byte : _byte).times(multiplier));
          multiplier = multiplier.times(Math.pow(2, 8));
        }
      } catch (err) {
        _iterator.e(err);
      } finally {
        _iterator.f();
      }

      if (isNegative) result = result.plus(1).times(-1);
      return {
        res: this.toRaw(result),
        newOffset: newOffset
      };
    }
  }]);
  return IIntSerializer;
}(_ISerializer2["default"]);

exports["default"] = IIntSerializer;