"use strict";

var _Reflect$construct = require("@babel/runtime-corejs3/core-js-stable/reflect/construct");

var _Object$defineProperty = require("@babel/runtime-corejs3/core-js-stable/object/define-property");

var _interopRequireDefault = require("@babel/runtime-corejs3/helpers/interopRequireDefault");

_Object$defineProperty(exports, "__esModule", {
  value: true
});

exports["default"] = void 0;

var _classCallCheck2 = _interopRequireDefault(require("@babel/runtime-corejs3/helpers/classCallCheck"));

var _createClass2 = _interopRequireDefault(require("@babel/runtime-corejs3/helpers/createClass"));

var _inherits2 = _interopRequireDefault(require("@babel/runtime-corejs3/helpers/inherits"));

var _possibleConstructorReturn2 = _interopRequireDefault(require("@babel/runtime-corejs3/helpers/possibleConstructorReturn"));

var _getPrototypeOf2 = _interopRequireDefault(require("@babel/runtime-corejs3/helpers/getPrototypeOf"));

var _bignumber = _interopRequireDefault(require("bignumber.js"));

var _IIntSerializer2 = _interopRequireDefault(require("./IIntSerializer"));

function _createSuper(Derived) { var hasNativeReflectConstruct = _isNativeReflectConstruct(); return function _createSuperInternal() { var Super = (0, _getPrototypeOf2["default"])(Derived), result; if (hasNativeReflectConstruct) { var NewTarget = (0, _getPrototypeOf2["default"])(this).constructor; result = _Reflect$construct(Super, arguments, NewTarget); } else { result = Super.apply(this, arguments); } return (0, _possibleConstructorReturn2["default"])(this, result); }; }

function _isNativeReflectConstruct() { if (typeof Reflect === "undefined" || !_Reflect$construct) return false; if (_Reflect$construct.sham) return false; if (typeof Proxy === "function") return true; try { Boolean.prototype.valueOf.call(_Reflect$construct(Boolean, [], function () {})); return true; } catch (e) { return false; } }

/** @typedef {import("bytebuffer")} ByteBuffer */

/** @typedef {import("../../ISerializer").default} ISerializer */

/**
 * @template {ISerializer} T
 * @typedef {import("../../ISerializer").SerializerInput<T>} SerializerInput
 */

/** @augments {IIntSerializer<number>} */
var VarInt32Serializer = /*#__PURE__*/function (_IIntSerializer) {
  (0, _inherits2["default"])(VarInt32Serializer, _IIntSerializer);

  var _super = _createSuper(VarInt32Serializer);

  function VarInt32Serializer() {
    (0, _classCallCheck2["default"])(this, VarInt32Serializer);
    return _super.call(this, 32);
  }
  /**
   * @param {SerializerInput<VarInt32Serializer>} value
   * @param {ByteBuffer} bytebuffer
   */


  (0, _createClass2["default"])(VarInt32Serializer, [{
    key: "appendToByteBuffer",
    value: function appendToByteBuffer(value, bytebuffer) {
      var raw = this.toRaw(value);
      if (raw < 0) throw new Error('negative varint32 serialization is not implemented');
      bytebuffer.writeVarint32(raw);
    }
    /**
     * @param {Buffer} buffer
     * @param {number} [offset]
     * @returns {{ res: number, newOffset: number }}
     */

  }, {
    key: "readFromBuffer",
    value: function readFromBuffer(buffer) {
      var offset = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : 0;
      var result = new _bignumber["default"](0);
      var multiplier = new _bignumber["default"](1);
      var newOffset = offset;

      while (true) {
        var _byte = buffer.readUInt8(newOffset);

        var isEnd = _byte < 0x80;
        result = result.plus(new _bignumber["default"](_byte - (isEnd ? 0 : 0x80)).times(multiplier));
        multiplier = multiplier.times(Math.pow(2, 7));
        newOffset += 1;
        if (isEnd) break;
      }

      return {
        res: this.toRaw(result),
        newOffset: newOffset
      };
    }
  }]);
  return VarInt32Serializer;
}(_IIntSerializer2["default"]);

exports["default"] = VarInt32Serializer;