"use strict";

var _Object$keys = require("@babel/runtime-corejs3/core-js-stable/object/keys");

var _Object$getOwnPropertySymbols = require("@babel/runtime-corejs3/core-js-stable/object/get-own-property-symbols");

var _filterInstanceProperty = require("@babel/runtime-corejs3/core-js-stable/instance/filter");

var _Object$getOwnPropertyDescriptor = require("@babel/runtime-corejs3/core-js-stable/object/get-own-property-descriptor");

var _forEachInstanceProperty = require("@babel/runtime-corejs3/core-js-stable/instance/for-each");

var _Object$getOwnPropertyDescriptors = require("@babel/runtime-corejs3/core-js-stable/object/get-own-property-descriptors");

var _Object$defineProperties = require("@babel/runtime-corejs3/core-js-stable/object/define-properties");

var _Object$defineProperty = require("@babel/runtime-corejs3/core-js-stable/object/define-property");

var _interopRequireDefault = require("@babel/runtime-corejs3/helpers/interopRequireDefault");

_Object$defineProperty(exports, "__esModule", {
  value: true
});

exports.signedBlockSerializer = exports.signedBlockHeaderSerializer = exports.rand = exports.blockSignatureSerializer = exports.blockHeaderSerializer = void 0;

var _defineProperty2 = _interopRequireDefault(require("@babel/runtime-corejs3/helpers/defineProperty"));

var _collections = require("./collections");

var _integers = require("./basic/integers");

var _basic = require("./basic");

var _chain = require("./chain");

var _transaction = require("./transaction");

var _protocol = require("./chain/id/protocol");

var _id = require("./chain/id");

function ownKeys(object, enumerableOnly) { var keys = _Object$keys(object); if (_Object$getOwnPropertySymbols) { var symbols = _Object$getOwnPropertySymbols(object); if (enumerableOnly) { symbols = _filterInstanceProperty(symbols).call(symbols, function (sym) { return _Object$getOwnPropertyDescriptor(object, sym).enumerable; }); } keys.push.apply(keys, symbols); } return keys; }

function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i] != null ? arguments[i] : {}; if (i % 2) { var _context; _forEachInstanceProperty(_context = ownKeys(Object(source), true)).call(_context, function (key) { (0, _defineProperty2["default"])(target, key, source[key]); }); } else if (_Object$getOwnPropertyDescriptors) { _Object$defineProperties(target, _Object$getOwnPropertyDescriptors(source)); } else { var _context2; _forEachInstanceProperty(_context2 = ownKeys(Object(source))).call(_context2, function (key) { _Object$defineProperty(target, key, _Object$getOwnPropertyDescriptor(source, key)); }); } } return target; }

var rand = _chain.sha256;
exports.rand = rand;
var blockSignatureSerializer = (0, _collections.struct)({
  _bba_sign: (0, _basic.bytes)(64),
  _delegate: _integers.uint32,
  _fallback: _integers.uint32,
  _leader: _integers.uint64,
  _producer: _integers.uint32,
  _step: _integers.uint32,
  _value: _integers.uint8
});
exports.blockSignatureSerializer = blockSignatureSerializer;
var blockHeaderSerializer = (0, _collections.struct)({
  previous: _id.blockId,
  round: _integers.uint64,
  attempt: _integers.uint8,
  timestamp: _basic.timePointSec,
  account: _protocol.accountId,
  delegate: _protocol.accountId,
  transaction_merkle_root: _chain.checksum,
  vm_root: (0, _collections.vector)(_basic.string),
  prev_signatures: (0, _collections.vector)(blockSignatureSerializer),
  extensions: _chain.extensions
});
exports.blockHeaderSerializer = blockHeaderSerializer;
var signedBlockHeaderSerializer = (0, _collections.struct)(_objectSpread(_objectSpread({}, blockHeaderSerializer.serializers), {}, {
  ed_signature: (0, _basic.bytes)(64),
  rand: rand,
  cert: (0, _collections.vector)(blockSignatureSerializer)
}));
exports.signedBlockHeaderSerializer = signedBlockHeaderSerializer;
var signedBlockSerializer = (0, _collections.struct)(_objectSpread(_objectSpread({}, signedBlockHeaderSerializer.serializers), {}, {
  transactions: (0, _collections.vector)(_transaction.processedTransactionSerializer)
}));
exports.signedBlockSerializer = signedBlockSerializer;