"use strict";

var _Reflect$construct = require("@babel/runtime-corejs3/core-js-stable/reflect/construct");

var _Object$defineProperty = require("@babel/runtime-corejs3/core-js-stable/object/define-property");

var _interopRequireDefault = require("@babel/runtime-corejs3/helpers/interopRequireDefault");

_Object$defineProperty(exports, "__esModule", {
  value: true
});

exports["default"] = void 0;

var _slice = _interopRequireDefault(require("@babel/runtime-corejs3/core-js-stable/instance/slice"));

var _classCallCheck2 = _interopRequireDefault(require("@babel/runtime-corejs3/helpers/classCallCheck"));

var _createClass2 = _interopRequireDefault(require("@babel/runtime-corejs3/helpers/createClass"));

var _inherits2 = _interopRequireDefault(require("@babel/runtime-corejs3/helpers/inherits"));

var _possibleConstructorReturn2 = _interopRequireDefault(require("@babel/runtime-corejs3/helpers/possibleConstructorReturn"));

var _getPrototypeOf2 = _interopRequireDefault(require("@babel/runtime-corejs3/helpers/getPrototypeOf"));

var _ISerializer2 = _interopRequireDefault(require("../ISerializer"));

var _publicKey = _interopRequireDefault(require("../../crypto/public-key"));

function _createSuper(Derived) { var hasNativeReflectConstruct = _isNativeReflectConstruct(); return function _createSuperInternal() { var Super = (0, _getPrototypeOf2["default"])(Derived), result; if (hasNativeReflectConstruct) { var NewTarget = (0, _getPrototypeOf2["default"])(this).constructor; result = _Reflect$construct(Super, arguments, NewTarget); } else { result = Super.apply(this, arguments); } return (0, _possibleConstructorReturn2["default"])(this, result); }; }

function _isNativeReflectConstruct() { if (typeof Reflect === "undefined" || !_Reflect$construct) return false; if (_Reflect$construct.sham) return false; if (typeof Proxy === "function") return true; try { Boolean.prototype.valueOf.call(_Reflect$construct(Boolean, [], function () {})); return true; } catch (e) { return false; } }

/** @typedef {import("bytebuffer")} ByteBuffer */

/** @typedef {PublicKey | string} TInput */

/** @typedef {string} TOutput */

/** @augments {ISerializer<TInput, TOutput>} */
var PublicKeySerializer = /*#__PURE__*/function (_ISerializer) {
  (0, _inherits2["default"])(PublicKeySerializer, _ISerializer);

  var _super = _createSuper(PublicKeySerializer);

  function PublicKeySerializer() {
    (0, _classCallCheck2["default"])(this, PublicKeySerializer);
    return _super.apply(this, arguments);
  }

  (0, _createClass2["default"])(PublicKeySerializer, [{
    key: "toRaw",
    value:
    /**
     * @param {TInput} value
     * @param {string} [addressPrefix]
     * @returns {TOutput}
     */
    function toRaw(value, addressPrefix) {
      if (typeof value === 'string') {
        value = _publicKey["default"].fromStringOrThrow(value, addressPrefix);
      }

      if (!(value instanceof _publicKey["default"])) throw new Error('invalid publicKey type');
      return value.toPublicKeyString(addressPrefix);
    }
    /**
     * @param {TInput} value
     * @param {ByteBuffer} bytebuffer
     * @param {string} [addressPrefix]
     */

  }, {
    key: "appendToByteBuffer",
    value: function appendToByteBuffer(value, bytebuffer, addressPrefix) {
      var raw = this.toRaw(value, addressPrefix);

      var publicKey = _publicKey["default"].fromStringOrThrow(raw, addressPrefix);

      bytebuffer.append(publicKey.toBuffer().toString('binary'), 'binary');
    }
    /**
     * @param {Buffer} buffer
     * @param {number} [offset]
     * @returns {{ res: TOutput, newOffset: number }}
     */

  }, {
    key: "readFromBuffer",
    value: function readFromBuffer(buffer) {
      var offset = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : 0;
      var length = 32;
      var newOffset = offset + length;
      if (newOffset > buffer.length) throw new Error('unexpected end of buffer');
      var bytes = (0, _slice["default"])(buffer).call(buffer, offset, newOffset);
      return {
        res: _publicKey["default"].fromBuffer(bytes).toString(),
        newOffset: newOffset
      };
    }
  }]);
  return PublicKeySerializer;
}(_ISerializer2["default"]);

exports["default"] = PublicKeySerializer;