"use strict";

var _typeof = require("@babel/runtime-corejs3/helpers/typeof");

var _Reflect$construct = require("@babel/runtime-corejs3/core-js-stable/reflect/construct");

var _WeakMap = require("@babel/runtime-corejs3/core-js-stable/weak-map");

var _Object$defineProperty = require("@babel/runtime-corejs3/core-js-stable/object/define-property");

var _Object$getOwnPropertyDescriptor = require("@babel/runtime-corejs3/core-js-stable/object/get-own-property-descriptor");

var _interopRequireDefault = require("@babel/runtime-corejs3/helpers/interopRequireDefault");

_Object$defineProperty(exports, "__esModule", {
  value: true
});

exports["default"] = void 0;

var _map = _interopRequireDefault(require("@babel/runtime-corejs3/core-js-stable/instance/map"));

var _slicedToArray2 = _interopRequireDefault(require("@babel/runtime-corejs3/helpers/slicedToArray"));

var _classCallCheck2 = _interopRequireDefault(require("@babel/runtime-corejs3/helpers/classCallCheck"));

var _createClass2 = _interopRequireDefault(require("@babel/runtime-corejs3/helpers/createClass"));

var _inherits2 = _interopRequireDefault(require("@babel/runtime-corejs3/helpers/inherits"));

var _possibleConstructorReturn2 = _interopRequireDefault(require("@babel/runtime-corejs3/helpers/possibleConstructorReturn"));

var _getPrototypeOf2 = _interopRequireDefault(require("@babel/runtime-corejs3/helpers/getPrototypeOf"));

var ByteBuffer = _interopRequireWildcard(require("bytebuffer"));

var _bignumber = _interopRequireDefault(require("bignumber.js"));

var _integers = require("../../basic/integers");

var _ISerializer2 = _interopRequireDefault(require("../../ISerializer"));

var _validators = require("../../../utils/validators");

function _getRequireWildcardCache(nodeInterop) { if (typeof _WeakMap !== "function") return null; var cacheBabelInterop = new _WeakMap(); var cacheNodeInterop = new _WeakMap(); return (_getRequireWildcardCache = function _getRequireWildcardCache(nodeInterop) { return nodeInterop ? cacheNodeInterop : cacheBabelInterop; })(nodeInterop); }

function _interopRequireWildcard(obj, nodeInterop) { if (!nodeInterop && obj && obj.__esModule) { return obj; } if (obj === null || _typeof(obj) !== "object" && typeof obj !== "function") { return { "default": obj }; } var cache = _getRequireWildcardCache(nodeInterop); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = _Object$defineProperty && _Object$getOwnPropertyDescriptor; for (var key in obj) { if (key !== "default" && Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? _Object$getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { _Object$defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj["default"] = obj; if (cache) { cache.set(obj, newObj); } return newObj; }

function _createSuper(Derived) { var hasNativeReflectConstruct = _isNativeReflectConstruct(); return function _createSuperInternal() { var Super = (0, _getPrototypeOf2["default"])(Derived), result; if (hasNativeReflectConstruct) { var NewTarget = (0, _getPrototypeOf2["default"])(this).constructor; result = _Reflect$construct(Super, arguments, NewTarget); } else { result = Super.apply(this, arguments); } return (0, _possibleConstructorReturn2["default"])(this, result); }; }

function _isNativeReflectConstruct() { if (typeof Reflect === "undefined" || !_Reflect$construct) return false; if (_Reflect$construct.sham) return false; if (typeof Proxy === "function") return true; try { Boolean.prototype.valueOf.call(_Reflect$construct(Boolean, [], function () {})); return true; } catch (e) { return false; } }

/** @typedef {string} TInput */

/** @typedef {string} TOutput */

/** @augments {ISerializer<TInput, TOutput>} */
var AnyObjectIdSerializer = /*#__PURE__*/function (_ISerializer) {
  (0, _inherits2["default"])(AnyObjectIdSerializer, _ISerializer);

  var _super = _createSuper(AnyObjectIdSerializer);

  function AnyObjectIdSerializer() {
    (0, _classCallCheck2["default"])(this, AnyObjectIdSerializer);
    return _super.apply(this, arguments);
  }

  (0, _createClass2["default"])(AnyObjectIdSerializer, [{
    key: "toRaw",
    value:
    /**
     * @param {TInput} value
     * @returns {TOutput}
     */
    function toRaw(value) {
      if (typeof value !== 'string') throw new Error('value is not a string');
      if (!_validators.idRegex.test(value)) throw new Error('invalid id format'); // FIXME: write size validators

      return value;
    }
    /**
     * @param {TInput} value
     * @param {ByteBuffer} bytebuffer
     */

  }, {
    key: "appendToByteBuffer",
    value: function appendToByteBuffer(value, bytebuffer) {
      var _context;

      this.validate(value);

      var _value$split$map = (0, _map["default"])(_context = value.split('.')).call(_context, function (str) {
        return ByteBuffer.Long.fromString(str, true);
      }),
          _value$split$map2 = (0, _slicedToArray2["default"])(_value$split$map, 3),
          reservedSpaceId = _value$split$map2[0],
          objectTypeId = _value$split$map2[1],
          instanceId = _value$split$map2[2];

      var _long = reservedSpaceId.shiftLeft(56).or(objectTypeId.shiftLeft(48).or(instanceId));

      _integers.uint64.appendToByteBuffer(new _bignumber["default"](_long.toString()), bytebuffer);
    }
    /**
     * @param {Buffer} buffer
     * @param {number} [offset]
     * @returns {{ res: TOutput, newOffset: number }}
     */

  }, {
    key: "readFromBuffer",
    value: function readFromBuffer(buffer) {
      var _context2;

      var offset = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : 0;

      var _uint64$readFromBuffe = _integers.uint64.readFromBuffer(buffer, offset),
          serializedId = _uint64$readFromBuffe.res,
          newOffset = _uint64$readFromBuffe.newOffset;

      var bn = new _bignumber["default"](serializedId);
      var reservedSpaceId = bn.idiv('0x100000000000000');
      var objectTypeId = bn.mod('0x100000000000000').idiv(0x1000000000000);
      var instanceId = bn.mod(0x1000000000000);
      var fullId = (0, _map["default"])(_context2 = [reservedSpaceId, objectTypeId, instanceId]).call(_context2, function (part) {
        return part.toString(10);
      }).join('.');
      return {
        res: this.toRaw(fullId),
        newOffset: newOffset
      };
    }
  }]);
  return AnyObjectIdSerializer;
}(_ISerializer2["default"]);

exports["default"] = AnyObjectIdSerializer;