"use strict";

var _Reflect$construct = require("@babel/runtime-corejs3/core-js-stable/reflect/construct");

var _sliceInstanceProperty = require("@babel/runtime-corejs3/core-js-stable/instance/slice");

var _Array$from = require("@babel/runtime-corejs3/core-js-stable/array/from");

var _Symbol = require("@babel/runtime-corejs3/core-js-stable/symbol");

var _getIteratorMethod = require("@babel/runtime-corejs3/core-js/get-iterator-method");

var _Array$isArray2 = require("@babel/runtime-corejs3/core-js-stable/array/is-array");

var _Object$defineProperty = require("@babel/runtime-corejs3/core-js-stable/object/define-property");

var _interopRequireDefault = require("@babel/runtime-corejs3/helpers/interopRequireDefault");

_Object$defineProperty(exports, "__esModule", {
  value: true
});

exports["default"] = void 0;

var _includes = _interopRequireDefault(require("@babel/runtime-corejs3/core-js-stable/instance/includes"));

var _values = _interopRequireDefault(require("@babel/runtime-corejs3/core-js-stable/object/values"));

var _isArray = _interopRequireDefault(require("@babel/runtime-corejs3/core-js-stable/array/is-array"));

var _some = _interopRequireDefault(require("@babel/runtime-corejs3/core-js-stable/instance/some"));

var _concat = _interopRequireDefault(require("@babel/runtime-corejs3/core-js-stable/instance/concat"));

var _slicedToArray2 = _interopRequireDefault(require("@babel/runtime-corejs3/helpers/slicedToArray"));

var _classCallCheck2 = _interopRequireDefault(require("@babel/runtime-corejs3/helpers/classCallCheck"));

var _createClass2 = _interopRequireDefault(require("@babel/runtime-corejs3/helpers/createClass"));

var _inherits2 = _interopRequireDefault(require("@babel/runtime-corejs3/helpers/inherits"));

var _possibleConstructorReturn2 = _interopRequireDefault(require("@babel/runtime-corejs3/helpers/possibleConstructorReturn"));

var _getPrototypeOf2 = _interopRequireDefault(require("@babel/runtime-corejs3/helpers/getPrototypeOf"));

var _defineProperty2 = _interopRequireDefault(require("@babel/runtime-corejs3/helpers/defineProperty"));

var _integers = require("../../basic/integers");

var _chainTypes = require("../../../constants/chain-types");

var _ISerializer2 = _interopRequireDefault(require("../../ISerializer"));

var _constants = require("../../../constants");

var _objectTypeIds2;

function _createForOfIteratorHelper(o, allowArrayLike) { var it = typeof _Symbol !== "undefined" && _getIteratorMethod(o) || o["@@iterator"]; if (!it) { if (_Array$isArray2(o) || (it = _unsupportedIterableToArray(o)) || allowArrayLike && o && typeof o.length === "number") { if (it) o = it; var i = 0; var F = function F() {}; return { s: F, n: function n() { if (i >= o.length) return { done: true }; return { done: false, value: o[i++] }; }, e: function e(_e) { throw _e; }, f: F }; } throw new TypeError("Invalid attempt to iterate non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method."); } var normalCompletion = true, didErr = false, err; return { s: function s() { it = it.call(o); }, n: function n() { var step = it.next(); normalCompletion = step.done; return step; }, e: function e(_e2) { didErr = true; err = _e2; }, f: function f() { try { if (!normalCompletion && it["return"] != null) it["return"](); } finally { if (didErr) throw err; } } }; }

function _unsupportedIterableToArray(o, minLen) { var _context6; if (!o) return; if (typeof o === "string") return _arrayLikeToArray(o, minLen); var n = _sliceInstanceProperty(_context6 = Object.prototype.toString.call(o)).call(_context6, 8, -1); if (n === "Object" && o.constructor) n = o.constructor.name; if (n === "Map" || n === "Set") return _Array$from(o); if (n === "Arguments" || /^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(n)) return _arrayLikeToArray(o, minLen); }

function _arrayLikeToArray(arr, len) { if (len == null || len > arr.length) len = arr.length; for (var i = 0, arr2 = new Array(len); i < len; i++) { arr2[i] = arr[i]; } return arr2; }

function _createSuper(Derived) { var hasNativeReflectConstruct = _isNativeReflectConstruct(); return function _createSuperInternal() { var Super = (0, _getPrototypeOf2["default"])(Derived), result; if (hasNativeReflectConstruct) { var NewTarget = (0, _getPrototypeOf2["default"])(this).constructor; result = _Reflect$construct(Super, arguments, NewTarget); } else { result = Super.apply(this, arguments); } return (0, _possibleConstructorReturn2["default"])(this, result); }; }

function _isNativeReflectConstruct() { if (typeof Reflect === "undefined" || !_Reflect$construct) return false; if (_Reflect$construct.sham) return false; if (typeof Proxy === "function") return true; try { Boolean.prototype.valueOf.call(_Reflect$construct(Boolean, [], function () {})); return true; } catch (e) { return false; } }

/** @typedef {import("bytebuffer")} ByteBuffer */

/**
 * @template {ISerializer} T
 * @typedef {import("../../ISerializer").SerializerInput<T>} SerializerInput
 */

/** @typedef {import("../../basic/integers").VarInt32Serializer} VarInt32Serializer */

/** @typedef {import("../../../constants").ProtocolObjectTypeId} ProtocolObjectTypeId */

/** @typedef {import("../../../constants/chain-types").ReservedSpaceId} ReservedSpaceId */

/** @typedef {import("../../../constants/chain-types").ImplementationObjectTypeId} ImplementationObjectTypeId */

/**
 * @template {ReservedSpaceId} T
 * @typedef {{ 0: never, 1: ProtocolObjectTypeId, 2: ImplementationObjectTypeId }[T]} ObjectTypeId
 */

/** @typedef {string | SerializerInput<VarInt32Serializer>} TInput */
var objectIdPureRegexp = /^\d+\.\d+\.\d+$/;

var _objectTypeIds = (_objectTypeIds2 = {}, (0, _defineProperty2["default"])(_objectTypeIds2, _chainTypes.RESERVED_SPACE_ID.RELATIVE_PROTOCOL, {}), (0, _defineProperty2["default"])(_objectTypeIds2, _chainTypes.RESERVED_SPACE_ID.PROTOCOL, _constants.PROTOCOL_OBJECT_TYPE_ID), (0, _defineProperty2["default"])(_objectTypeIds2, _chainTypes.RESERVED_SPACE_ID.IMPLEMENTATION, _chainTypes.IMPLEMENTATION_OBJECT_TYPE_ID), _objectTypeIds2);
/**
 * @template {ReservedSpaceId} T
 * @augments {ISerializer<TInput, string>}
 */


var ObjectIdSerializer = /*#__PURE__*/function (_ISerializer) {
  (0, _inherits2["default"])(ObjectIdSerializer, _ISerializer);

  var _super = _createSuper(ObjectIdSerializer);

  /**
   * @param {T} reservedSpaceId
   * @param {ObjectTypeId<T> | ObjectTypeId<T>[]} objectsTypesIds
   */
  function ObjectIdSerializer(reservedSpaceId, objectsTypesIds) {
    var _context;

    var _this;

    (0, _classCallCheck2["default"])(this, ObjectIdSerializer);
    if (!(0, _includes["default"])(_context = (0, _values["default"])(_chainTypes.RESERVED_SPACE_ID)).call(_context, reservedSpaceId)) throw new Error('invalid reserved space id');
    _this = _super.call(this);
    /**
     * @private
     * @type {T}
     */

    _this._reservedSpaceId = reservedSpaceId;
    if (!(0, _isArray["default"])(objectsTypesIds)) objectsTypesIds = [objectsTypesIds];

    var _iterator = _createForOfIteratorHelper(objectsTypesIds),
        _step;

    try {
      for (_iterator.s(); !(_step = _iterator.n()).done;) {
        var _context2;

        var objectTypeId = _step.value;
        var availableObjectTypeIds = _objectTypeIds[_this.reservedSpaceId];

        if (!(0, _includes["default"])(_context2 = (0, _values["default"])(availableObjectTypeIds)).call(_context2, objectTypeId)) {
          throw new Error("invalid object typeof id ".concat(objectTypeId));
        }
      }
      /**
       * @private
       * @type {ObjectTypeId<T>[]}
       */

    } catch (err) {
      _iterator.e(err);
    } finally {
      _iterator.f();
    }

    _this._objectsTypesIds = objectsTypesIds;
    return _this;
  }
  /**
   * @param {TInput} value
   * @returns {string}
   */


  (0, _createClass2["default"])(ObjectIdSerializer, [{
    key: "reservedSpaceId",
    get:
    /**
     * @readonly
     * @type {T}
     */
    function get() {
      return this._reservedSpaceId;
    }
    /**
     * @readonly
     * @type {ObjectTypeId<T>[]}
     */

  }, {
    key: "objectsTypesIds",
    get: function get() {
      return this._objectsTypesIds;
    }
  }, {
    key: "toRaw",
    value: function toRaw(value) {
      var _context4, _context5;

      if (typeof value === 'string') {
        var _context3;

        if (!objectIdPureRegexp.test(value)) throw new Error('invalid object id format');

        var _value$split = value.split('.'),
            _value$split2 = (0, _slicedToArray2["default"])(_value$split, 3),
            actualReservedSpaceIdString = _value$split2[0],
            actualObjectTypeIdString = _value$split2[1],
            actualInstanceIdString = _value$split2[2];

        if (actualReservedSpaceIdString !== this.reservedSpaceId.toString()) {
          throw new Error('invalid reserved space id');
        }

        if (!(0, _some["default"])(_context3 = this.objectsTypesIds).call(_context3, function (objectTypeId) {
          return actualObjectTypeIdString === objectTypeId.toString();
        })) {
          throw new Error('invalid object type id');
        }

        value = actualInstanceIdString;
      }

      if (this.objectsTypesIds.length !== 1) throw new Error('unable to automatically set object type id');
      /** @type {ReturnType<VarInt32Serializer['toRaw']>} */

      var rawInstanceId;

      try {
        rawInstanceId = _integers.varint32.toRaw(value);
      } catch (error) {
        throw new Error("instance id: ".concat(error.message));
      }

      return (0, _concat["default"])(_context4 = (0, _concat["default"])(_context5 = "".concat(this.reservedSpaceId, ".")).call(_context5, this.objectsTypesIds[0], ".")).call(_context4, rawInstanceId);
    }
    /**
     * @param {TInput} value
     * @param {ByteBuffer} bytebuffer
     */

  }, {
    key: "appendToByteBuffer",
    value: function appendToByteBuffer(value, bytebuffer) {
      var raw = this.toRaw(value);

      _integers.varint32.appendToByteBuffer(raw.split('.')[2], bytebuffer);
    }
    /**
     * @param {Buffer} buffer
     * @param {number} [offset]
     * @returns {{ res: string, newOffset: number }}
     */

  }, {
    key: "readFromBuffer",
    value: function readFromBuffer(buffer) {
      var offset = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : 0;

      var _varint32$readFromBuf = _integers.varint32.readFromBuffer(buffer, offset),
          instanceId = _varint32$readFromBuf.res,
          newOffset = _varint32$readFromBuf.newOffset;

      return {
        res: this.toRaw(instanceId),
        newOffset: newOffset
      };
    }
  }]);
  return ObjectIdSerializer;
}(_ISerializer2["default"]);

exports["default"] = ObjectIdSerializer;