"use strict";

var _Object$defineProperty = require("@babel/runtime-corejs3/core-js-stable/object/define-property");

var _interopRequireDefault = require("@babel/runtime-corejs3/helpers/interopRequireDefault");

_Object$defineProperty(exports, "__esModule", {
  value: true
});

exports.withdrawErc20TokenId = exports.vestingBalanceId = exports.stakeBtcVoutId = exports.stakeBtcScriptId = exports.proposalId = exports.operationHistoryId = exports.frozenBalanceId = exports.evmAddressId = exports.ethWithdrawId = exports.ethTransactionReceipt = exports.ethDepositId = exports.ethBlock = exports.erc20TokenId = exports.didObjectId = exports.depositErc20TokenId = exports.contractId = exports.committeeMemberId = exports.btcWithdrawId = exports.btcTransaction = exports.btcDepositId = exports.btcBlock = exports.btcAggregatingId = exports.btcAddressId = exports.balanceId = exports.assetId = exports.accountId = void 0;

var _ObjectId = _interopRequireDefault(require("./ObjectId"));

var _chainTypes = require("../../../constants/chain-types");

var _constants = require("../../../constants");

var accountId = new _ObjectId["default"](_chainTypes.RESERVED_SPACE_ID.PROTOCOL, _constants.PROTOCOL_OBJECT_TYPE_ID.ACCOUNT);
exports.accountId = accountId;
var assetId = new _ObjectId["default"](_chainTypes.RESERVED_SPACE_ID.PROTOCOL, _constants.PROTOCOL_OBJECT_TYPE_ID.ASSET);
exports.assetId = assetId;
var committeeMemberId = new _ObjectId["default"](_chainTypes.RESERVED_SPACE_ID.PROTOCOL, _constants.PROTOCOL_OBJECT_TYPE_ID.COMMITTEE_MEMBER);
exports.committeeMemberId = committeeMemberId;
var proposalId = new _ObjectId["default"](_chainTypes.RESERVED_SPACE_ID.PROTOCOL, _constants.PROTOCOL_OBJECT_TYPE_ID.PROPOSAL);
exports.proposalId = proposalId;
var operationHistoryId = new _ObjectId["default"](_chainTypes.RESERVED_SPACE_ID.PROTOCOL, _constants.PROTOCOL_OBJECT_TYPE_ID.OPERATION_HISTORY);
exports.operationHistoryId = operationHistoryId;
var vestingBalanceId = new _ObjectId["default"](_chainTypes.RESERVED_SPACE_ID.PROTOCOL, _constants.PROTOCOL_OBJECT_TYPE_ID.VESTING_BALANCE);
exports.vestingBalanceId = vestingBalanceId;
var balanceId = new _ObjectId["default"](_chainTypes.RESERVED_SPACE_ID.PROTOCOL, _constants.PROTOCOL_OBJECT_TYPE_ID.BALANCE);
exports.balanceId = balanceId;
var frozenBalanceId = new _ObjectId["default"](_chainTypes.RESERVED_SPACE_ID.PROTOCOL, _constants.PROTOCOL_OBJECT_TYPE_ID.FROZEN_BALANCE);
exports.frozenBalanceId = frozenBalanceId;
var contractId = new _ObjectId["default"](_chainTypes.RESERVED_SPACE_ID.PROTOCOL, _constants.PROTOCOL_OBJECT_TYPE_ID.CONTRACT);
exports.contractId = contractId;
var ethDepositId = new _ObjectId["default"](_chainTypes.RESERVED_SPACE_ID.PROTOCOL, _constants.PROTOCOL_OBJECT_TYPE_ID.SIDECHAIN_ETH_DEPOSIT);
exports.ethDepositId = ethDepositId;
var ethWithdrawId = new _ObjectId["default"](_chainTypes.RESERVED_SPACE_ID.PROTOCOL, _constants.PROTOCOL_OBJECT_TYPE_ID.SIDECHAIN_ETH_WITHDRAW);
exports.ethWithdrawId = ethWithdrawId;
var erc20TokenId = new _ObjectId["default"](_chainTypes.RESERVED_SPACE_ID.PROTOCOL, _constants.PROTOCOL_OBJECT_TYPE_ID.ERC20_TOKEN);
exports.erc20TokenId = erc20TokenId;
var depositErc20TokenId = new _ObjectId["default"](_chainTypes.RESERVED_SPACE_ID.PROTOCOL, _constants.PROTOCOL_OBJECT_TYPE_ID.ERC20_DEPOSIT_TOKEN);
exports.depositErc20TokenId = depositErc20TokenId;
var withdrawErc20TokenId = new _ObjectId["default"](_chainTypes.RESERVED_SPACE_ID.PROTOCOL, _constants.PROTOCOL_OBJECT_TYPE_ID.ERC20_WITHDRAW_TOKEN);
exports.withdrawErc20TokenId = withdrawErc20TokenId;
var btcAddressId = new _ObjectId["default"](_chainTypes.RESERVED_SPACE_ID.PROTOCOL, _constants.PROTOCOL_OBJECT_TYPE_ID.BTC_ADDRESS);
exports.btcAddressId = btcAddressId;
var btcDepositId = new _ObjectId["default"](_chainTypes.RESERVED_SPACE_ID.PROTOCOL, _constants.PROTOCOL_OBJECT_TYPE_ID.BTC_DEPOSIT);
exports.btcDepositId = btcDepositId;
var btcWithdrawId = new _ObjectId["default"](_chainTypes.RESERVED_SPACE_ID.PROTOCOL, _constants.PROTOCOL_OBJECT_TYPE_ID.BTC_WITHDRAW);
exports.btcWithdrawId = btcWithdrawId;
var btcAggregatingId = new _ObjectId["default"](_chainTypes.RESERVED_SPACE_ID.PROTOCOL, _constants.PROTOCOL_OBJECT_TYPE_ID.BTC_AGGREGATING);
exports.btcAggregatingId = btcAggregatingId;
var evmAddressId = new _ObjectId["default"](_chainTypes.RESERVED_SPACE_ID.PROTOCOL, _constants.PROTOCOL_OBJECT_TYPE_ID.EVM_ADDRESS);
exports.evmAddressId = evmAddressId;
var didObjectId = new _ObjectId["default"](_chainTypes.RESERVED_SPACE_ID.PROTOCOL, _constants.PROTOCOL_OBJECT_TYPE_ID.DID_OBJECT);
exports.didObjectId = didObjectId;
var stakeBtcScriptId = new _ObjectId["default"](_chainTypes.RESERVED_SPACE_ID.PROTOCOL, _constants.PROTOCOL_OBJECT_TYPE_ID.STAKE_BTC_SCRIPT);
exports.stakeBtcScriptId = stakeBtcScriptId;
var stakeBtcVoutId = new _ObjectId["default"](_chainTypes.RESERVED_SPACE_ID.PROTOCOL, _constants.PROTOCOL_OBJECT_TYPE_ID.STAKE_BTC_VOUT);
exports.stakeBtcVoutId = stakeBtcVoutId;
var btcBlock = new _ObjectId["default"](_chainTypes.RESERVED_SPACE_ID.PROTOCOL, _constants.PROTOCOL_OBJECT_TYPE_ID.BTC_BLOCK);
exports.btcBlock = btcBlock;
var btcTransaction = new _ObjectId["default"](_chainTypes.RESERVED_SPACE_ID.PROTOCOL, _constants.PROTOCOL_OBJECT_TYPE_ID.BTC_TX);
exports.btcTransaction = btcTransaction;
var ethBlock = new _ObjectId["default"](_chainTypes.RESERVED_SPACE_ID.PROTOCOL, _constants.PROTOCOL_OBJECT_TYPE_ID.ETH_BLOCK);
exports.ethBlock = ethBlock;
var ethTransactionReceipt = new _ObjectId["default"](_chainTypes.RESERVED_SPACE_ID.PROTOCOL, _constants.PROTOCOL_OBJECT_TYPE_ID.ETH_TX_RECEIPT);
exports.ethTransactionReceipt = ethTransactionReceipt;