"use strict";

var _typeof = require("@babel/runtime-corejs3/helpers/typeof");

var _WeakMap = require("@babel/runtime-corejs3/core-js-stable/weak-map");

var _Object$defineProperty = require("@babel/runtime-corejs3/core-js-stable/object/define-property");

var _Object$getOwnPropertyDescriptor = require("@babel/runtime-corejs3/core-js-stable/object/get-own-property-descriptor");

var _interopRequireDefault = require("@babel/runtime-corejs3/helpers/interopRequireDefault");

_Object$defineProperty(exports, "__esModule", {
  value: true
});

_Object$defineProperty(exports, "PrivateKeySerializer", {
  enumerable: true,
  get: function get() {
    return _PrivateKey["default"];
  }
});

_Object$defineProperty(exports, "PublicKeySerializer", {
  enumerable: true,
  get: function get() {
    return _PublicKey["default"];
  }
});

_Object$defineProperty(exports, "accountOperationsExtensionsSerializer", {
  enumerable: true,
  get: function get() {
    return _extensions.accountOperationsExtensionsSerializer;
  }
});

_Object$defineProperty(exports, "asset", {
  enumerable: true,
  get: function get() {
    return _asset["default"];
  }
});

exports.checksum = void 0;

_Object$defineProperty(exports, "extensions", {
  enumerable: true,
  get: function get() {
    return _extensions["default"];
  }
});

_Object$defineProperty(exports, "futureExtension", {
  enumerable: true,
  get: function get() {
    return _future_extension["default"];
  }
});

exports.weight = exports.sha256With0xPrefix = exports.sha256 = exports.ripemd160 = exports.publicKey = exports.privateKey = exports.ids = void 0;

var ids = _interopRequireWildcard(require("./id"));

exports.ids = ids;

var _PublicKey = _interopRequireDefault(require("./PublicKey"));

var _PrivateKey = _interopRequireDefault(require("./PrivateKey"));

var _basic = require("../basic");

var _integers = require("../basic/integers");

var _asset = _interopRequireDefault(require("./asset"));

var _extensions = _interopRequireWildcard(require("./extensions"));

var _future_extension = _interopRequireDefault(require("./future_extension"));

function _getRequireWildcardCache(nodeInterop) { if (typeof _WeakMap !== "function") return null; var cacheBabelInterop = new _WeakMap(); var cacheNodeInterop = new _WeakMap(); return (_getRequireWildcardCache = function _getRequireWildcardCache(nodeInterop) { return nodeInterop ? cacheNodeInterop : cacheBabelInterop; })(nodeInterop); }

function _interopRequireWildcard(obj, nodeInterop) { if (!nodeInterop && obj && obj.__esModule) { return obj; } if (obj === null || _typeof(obj) !== "object" && typeof obj !== "function") { return { "default": obj }; } var cache = _getRequireWildcardCache(nodeInterop); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = _Object$defineProperty && _Object$getOwnPropertyDescriptor; for (var key in obj) { if (key !== "default" && Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? _Object$getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { _Object$defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj["default"] = obj; if (cache) { cache.set(obj, newObj); } return newObj; }

var publicKey = new _PublicKey["default"]();
exports.publicKey = publicKey;
var privateKey = new _PrivateKey["default"]();
exports.privateKey = privateKey;
var weight = _integers.uint16;
exports.weight = weight;
var ripemd160 = (0, _basic.bytes)(20);
exports.ripemd160 = ripemd160;
var sha256 = (0, _basic.bytes)(32);
exports.sha256 = sha256;
var sha256With0xPrefix = (0, _basic.bytes)(32, true);
exports.sha256With0xPrefix = sha256With0xPrefix;
var checksum = ripemd160;
exports.checksum = checksum;