"use strict";

var _Object$defineProperty = require("@babel/runtime-corejs3/core-js-stable/object/define-property");

_Object$defineProperty(exports, "__esModule", {
  value: true
});

exports.sidechainBtcTransaction = exports["default"] = exports.btcTransactionDetailsSerializer = void 0;

var _collections = require("../../collections");

var _basic = require("../../basic");

var _chain = require("../../chain");

var _integers = require("../../basic/integers");

var prevOut = (0, _collections.struct)({
  tx_id: _chain.sha256,
  index: _basic.integers.uint32,
  amount: _basic.integers.uint64
});
var btcTransactionDetailsSerializer = (0, _collections.struct)({
  block_number: _basic.integers.uint64,
  out: prevOut
});
exports.btcTransactionDetailsSerializer = btcTransactionDetailsSerializer;
var script = (0, _collections.vector)(_integers.uint8);
var wintess = (0, _collections.vector)((0, _collections.vector)(_integers.uint8));
var txIn = (0, _collections.struct)({
  outpoint: prevOut,
  unlock_script: script,
  witness: wintess,
  sequence: _integers.uint32
});
var p2shPwsh = _basic.string;
var txOut = (0, _collections.struct)({
  amount: _integers.uint64,
  index: _integers.uint32,
  lock_script: script,
  address: p2shPwsh
});
var txIns = (0, _collections.vector)(txIn);
var txOuts = (0, _collections.vector)(txOut);
var sidechainBtcTransaction = (0, _collections.struct)({
  version: _integers.uint32,
  marker: _integers.uint8,
  flag: _integers.uint8,
  inputs: txIns,
  tx_outs: txOuts,
  nlocktime: _integers.uint32
});
exports.sidechainBtcTransaction = sidechainBtcTransaction;
var _default = {
  btcTransactionDetailsSerializer: btcTransactionDetailsSerializer
};
exports["default"] = _default;