"use strict";

var _Reflect$construct = require("@babel/runtime-corejs3/core-js-stable/reflect/construct");

var _Object$defineProperty = require("@babel/runtime-corejs3/core-js-stable/object/define-property");

var _interopRequireDefault = require("@babel/runtime-corejs3/helpers/interopRequireDefault");

_Object$defineProperty(exports, "__esModule", {
  value: true
});

exports["default"] = void 0;

var _classCallCheck2 = _interopRequireDefault(require("@babel/runtime-corejs3/helpers/classCallCheck"));

var _createClass2 = _interopRequireDefault(require("@babel/runtime-corejs3/helpers/createClass"));

var _inherits2 = _interopRequireDefault(require("@babel/runtime-corejs3/helpers/inherits"));

var _possibleConstructorReturn2 = _interopRequireDefault(require("@babel/runtime-corejs3/helpers/possibleConstructorReturn"));

var _getPrototypeOf2 = _interopRequireDefault(require("@babel/runtime-corejs3/helpers/getPrototypeOf"));

var _basic = require("../basic");

var _ISerializer2 = _interopRequireDefault(require("../ISerializer"));

function _createSuper(Derived) { var hasNativeReflectConstruct = _isNativeReflectConstruct(); return function _createSuperInternal() { var Super = (0, _getPrototypeOf2["default"])(Derived), result; if (hasNativeReflectConstruct) { var NewTarget = (0, _getPrototypeOf2["default"])(this).constructor; result = _Reflect$construct(Super, arguments, NewTarget); } else { result = Super.apply(this, arguments); } return (0, _possibleConstructorReturn2["default"])(this, result); }; }

function _isNativeReflectConstruct() { if (typeof Reflect === "undefined" || !_Reflect$construct) return false; if (_Reflect$construct.sham) return false; if (typeof Proxy === "function") return true; try { Boolean.prototype.valueOf.call(_Reflect$construct(Boolean, [], function () {})); return true; } catch (e) { return false; } }

/** @typedef {import("bytebuffer")} ByteBuffer */

/**
 * @template {ISerializer} T
 * @typedef {import("../ISerializer").SerializerInput<T>} SerializerInput
 */

/**
 * @template {ISerializer} T
 * @typedef {import("../ISerializer").SerializerOutput<T>} SerializerOutput
 */

/**
 * @template {ISerializer} T
 * @typedef {undefined | SerializerInput<T>} TInput
 */

/**
 * @template {ISerializer} T
 * @typedef {undefined | SerializerOutput<T>} TOutput
 */

/**
 * @template {ISerializer} T
 * @augments {ISerializer<TInput<T>, TOutput<T>>}
 */
var OptionalSerializer = /*#__PURE__*/function (_ISerializer) {
  (0, _inherits2["default"])(OptionalSerializer, _ISerializer);

  var _super = _createSuper(OptionalSerializer);

  /** @param {T} serializer */
  function OptionalSerializer(serializer) {
    var _this;

    (0, _classCallCheck2["default"])(this, OptionalSerializer);
    _this = _super.call(this);
    /**
     * @private
     * @type {T}
     */

    _this._serializer = serializer;
    return _this;
  }
  /**
   * @template {boolean} TProvided
   * @param {TProvided extends true ? SerializerInput<T> : undefined} value
   */


  (0, _createClass2["default"])(OptionalSerializer, [{
    key: "serializer",
    get:
    /**
     * @readonly
     * @type {T}
     */
    function get() {
      return this._serializer;
    }
  }, {
    key: "toRaw",
    value: function toRaw(value) {
      if (value === undefined || value === null) return undefined;

      try {
        return this.serializer.toRaw(value);
      } catch (error) {
        throw new Error("optional type: ".concat(error.message));
      }
    }
    /**
     * @param {TInput<T>} value
     * @param {ByteBuffer} bytebuffer
     */

  }, {
    key: "appendToByteBuffer",
    value: function appendToByteBuffer(value, bytebuffer) {
      var raw = this.toRaw(value);

      _basic.bool.appendToByteBuffer(raw !== undefined, bytebuffer);

      if (raw !== undefined) this.serializer.appendToByteBuffer(raw, bytebuffer);
    }
    /**
     * @param {Buffer} buffer
     * @param {number} [offset]
     * @returns {{ res: TOutput<T>, newOffset: number }}
     */

  }, {
    key: "readFromBuffer",
    value: function readFromBuffer(buffer) {
      var offset = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : 0;

      var _bool$readFromBuffer = _basic.bool.readFromBuffer(buffer, offset),
          isProvided = _bool$readFromBuffer.res,
          from = _bool$readFromBuffer.newOffset;

      if (!isProvided) return {
        res: undefined,
        newOffset: from
      };
      return this.serializer.readFromBuffer(buffer, from);
    }
  }]);
  return OptionalSerializer;
}(_ISerializer2["default"]);

exports["default"] = OptionalSerializer;