"use strict";

var _Reflect$construct = require("@babel/runtime-corejs3/core-js-stable/reflect/construct");

var _Object$defineProperty = require("@babel/runtime-corejs3/core-js-stable/object/define-property");

var _interopRequireDefault = require("@babel/runtime-corejs3/helpers/interopRequireDefault");

_Object$defineProperty(exports, "__esModule", {
  value: true
});

exports["default"] = void 0;

var _classCallCheck2 = _interopRequireDefault(require("@babel/runtime-corejs3/helpers/classCallCheck"));

var _createClass2 = _interopRequireDefault(require("@babel/runtime-corejs3/helpers/createClass"));

var _inherits2 = _interopRequireDefault(require("@babel/runtime-corejs3/helpers/inherits"));

var _possibleConstructorReturn2 = _interopRequireDefault(require("@babel/runtime-corejs3/helpers/possibleConstructorReturn"));

var _getPrototypeOf2 = _interopRequireDefault(require("@babel/runtime-corejs3/helpers/getPrototypeOf"));

var _ISerializer2 = _interopRequireDefault(require("../ISerializer"));

function _createSuper(Derived) { var hasNativeReflectConstruct = _isNativeReflectConstruct(); return function _createSuperInternal() { var Super = (0, _getPrototypeOf2["default"])(Derived), result; if (hasNativeReflectConstruct) { var NewTarget = (0, _getPrototypeOf2["default"])(this).constructor; result = _Reflect$construct(Super, arguments, NewTarget); } else { result = Super.apply(this, arguments); } return (0, _possibleConstructorReturn2["default"])(this, result); }; }

function _isNativeReflectConstruct() { if (typeof Reflect === "undefined" || !_Reflect$construct) return false; if (_Reflect$construct.sham) return false; if (typeof Proxy === "function") return true; try { Boolean.prototype.valueOf.call(_Reflect$construct(Boolean, [], function () {})); return true; } catch (e) { return false; } }

/** @typedef {import("bytebuffer")} ByteBuffer */

/**
 * @template {ISerializer} T
 * @typedef {import("../ISerializer").SerializerInput<T>} SerializerInput
 */

/**
 * @template {ISerializer} T
 * @typedef {import("../ISerializer").SerializerOutput<T>} SerializerOutput
 */

/**
 * @template {ISerializer} TFirst
 * @template {ISerializer} TSecond
 * @typedef {[SerializerInput<TFirst>, SerializerInput<TSecond>]} TInput
 */

/**
 * @template {ISerializer} TFirst
 * @template {ISerializer} TSecond
 * @typedef {[SerializerOutput<TFirst>, SerializerOutput<TSecond>]} TOutput
 */

/**
 * @template {ISerializer} TFirst
 * @template {ISerializer} TSecond
 * @augments {ISerializer<TInput<TFirst, TSecond>, TOutput<TFirst, TSecond>>}
 */
var PairSerializer = /*#__PURE__*/function (_ISerializer) {
  (0, _inherits2["default"])(PairSerializer, _ISerializer);

  var _super = _createSuper(PairSerializer);

  /**
   * @param {TFirst} firstSerializer
   * @param {TSecond} secondSerializer
   */
  function PairSerializer(firstSerializer, secondSerializer) {
    var _this;

    (0, _classCallCheck2["default"])(this, PairSerializer);
    if (!(firstSerializer instanceof _ISerializer2["default"])) throw new Error('key is not serializer');
    if (!(firstSerializer instanceof _ISerializer2["default"])) throw new Error('value is not serializer');
    _this = _super.call(this);
    /**
     * @private
     * @type {TFirst}
     */

    _this._firstSerializer = firstSerializer;
    /**
     * @private
     * @type {TSecond}
     */

    _this._secondSerializer = secondSerializer;
    return _this;
  }
  /**
   * @param {TInput<TFirst, TSecond>} value
   * @returns {TOutput<TFirst, TSecond>}
   */


  (0, _createClass2["default"])(PairSerializer, [{
    key: "firstSerializer",
    get: function get() {
      return this._firstSerializer;
    }
  }, {
    key: "secondSerializer",
    get: function get() {
      return this._secondSerializer;
    }
  }, {
    key: "toRaw",
    value: function toRaw(value) {
      var raw = new Array(2);

      try {
        raw[0] = this.firstSerializer.toRaw(value[0]);
      } catch (error) {
        throw new Error("pair[0]: ".concat(error.message));
      }

      try {
        raw[1] = this.secondSerializer.toRaw(value[1]);
      } catch (error) {
        throw new Error("pair[1]: ".concat(error.message));
      }

      return raw;
    }
    /**
     * @param {TInput<TFirst, TSecond>} value
     * @param {ByteBuffer} bytebuffer
     */

  }, {
    key: "appendToByteBuffer",
    value: function appendToByteBuffer(value, bytebuffer) {
      var raw = this.toRaw(value);
      this.firstSerializer.appendToByteBuffer(raw[0], bytebuffer);
      this.secondSerializer.appendToByteBuffer(raw[1], bytebuffer);
    }
    /**
     * @param {Buffer} buffer
     * @param {number} [offset]
     * @returns {{ res: TOutput<TFirst, TSecond>, newOffset: number }}
     */

  }, {
    key: "readFromBuffer",
    value: function readFromBuffer(buffer) {
      var offset = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : 0;

      var _this$firstSerializer = this.firstSerializer.readFromBuffer(buffer, offset),
          firstElement = _this$firstSerializer.res,
          intermediateOffset = _this$firstSerializer.newOffset;

      var _this$secondSerialize = this.secondSerializer.readFromBuffer(buffer, intermediateOffset),
          secondElement = _this$secondSerialize.res,
          newOffset = _this$secondSerialize.newOffset;

      return {
        res: [firstElement, secondElement],
        newOffset: newOffset
      };
    }
  }]);
  return PairSerializer;
}(_ISerializer2["default"]);

exports["default"] = PairSerializer;