"use strict";

var _Reflect$construct = require("@babel/runtime-corejs3/core-js-stable/reflect/construct");

var _Object$defineProperty = require("@babel/runtime-corejs3/core-js-stable/object/define-property");

var _interopRequireDefault = require("@babel/runtime-corejs3/helpers/interopRequireDefault");

_Object$defineProperty(exports, "__esModule", {
  value: true
});

exports["default"] = void 0;

var _set = _interopRequireDefault(require("@babel/runtime-corejs3/core-js-stable/set"));

var _concat = _interopRequireDefault(require("@babel/runtime-corejs3/core-js-stable/instance/concat"));

var _toConsumableArray2 = _interopRequireDefault(require("@babel/runtime-corejs3/helpers/toConsumableArray"));

var _classCallCheck2 = _interopRequireDefault(require("@babel/runtime-corejs3/helpers/classCallCheck"));

var _createClass2 = _interopRequireDefault(require("@babel/runtime-corejs3/helpers/createClass"));

var _get2 = _interopRequireDefault(require("@babel/runtime-corejs3/helpers/get"));

var _inherits2 = _interopRequireDefault(require("@babel/runtime-corejs3/helpers/inherits"));

var _possibleConstructorReturn2 = _interopRequireDefault(require("@babel/runtime-corejs3/helpers/possibleConstructorReturn"));

var _getPrototypeOf2 = _interopRequireDefault(require("@babel/runtime-corejs3/helpers/getPrototypeOf"));

var _assert = require("assert");

var _Vector = _interopRequireDefault(require("./Vector"));

function _createSuper(Derived) { var hasNativeReflectConstruct = _isNativeReflectConstruct(); return function _createSuperInternal() { var Super = (0, _getPrototypeOf2["default"])(Derived), result; if (hasNativeReflectConstruct) { var NewTarget = (0, _getPrototypeOf2["default"])(this).constructor; result = _Reflect$construct(Super, arguments, NewTarget); } else { result = Super.apply(this, arguments); } return (0, _possibleConstructorReturn2["default"])(this, result); }; }

function _isNativeReflectConstruct() { if (typeof Reflect === "undefined" || !_Reflect$construct) return false; if (_Reflect$construct.sham) return false; if (typeof Proxy === "function") return true; try { Boolean.prototype.valueOf.call(_Reflect$construct(Boolean, [], function () {})); return true; } catch (e) { return false; } }

/** @typedef {import("bytebuffer")} ByteBuffer */

/**
 * @template {ISerializer} T
 * @typedef {import("../ISerializer").SerializerInput<T>} SerializerInput
 */

/**
 * @template {ISerializer} T
 * @typedef {import("../ISerializer").SerializerOutput<T>} SerializerOutput
 */

/**
 * @template {ISerializer} T
 * @typedef {SerializerInput<T>[] | Set<SerializerInput<T>> | undefined} TInput
 */

/**
 * @template {ISerializer} T
 * @augments {VectorSerializer<T>}
 */
var SetSerializer = /*#__PURE__*/function (_VectorSerializer) {
  (0, _inherits2["default"])(SetSerializer, _VectorSerializer);

  var _super = _createSuper(SetSerializer);

  function SetSerializer() {
    (0, _classCallCheck2["default"])(this, SetSerializer);
    return _super.apply(this, arguments);
  }

  (0, _createClass2["default"])(SetSerializer, [{
    key: "toRaw",
    value:
    /**
     * @param {TInput<T>} value
     * @returns {SerializerOutput<VectorSerializer<T>>}
     */
    function toRaw(value) {
      var errorField = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : 'set';
      (0, _assert.ok)(typeof errorField === 'string');
      if (value === undefined) value = [];
      if (value instanceof _set["default"]) value = (0, _toConsumableArray2["default"])(value);
      /** @type {ReturnType<VectorSerializer<T>['toRaw']>} */

      var raw;

      try {
        raw = (0, _get2["default"])((0, _getPrototypeOf2["default"])(SetSerializer.prototype), "toRaw", this).call(this, value);
      } catch (error) {
        var _context;

        throw new Error((0, _concat["default"])(_context = "".concat(errorField, ": ")).call(_context, error.message));
      }
      /** @type {string[]} */


      var serializedElements = new Array(raw.length);

      for (var i = 0; i < raw.length; i += 1) {
        serializedElements[i] = this.serializer.serialize(raw[i]).toString('hex');

        for (var j = 0; j < i; j += 1) {
          if (serializedElements[i] === serializedElements[j]) {
            var _context2, _context3;

            throw new Error((0, _concat["default"])(_context2 = (0, _concat["default"])(_context3 = "".concat(errorField, " element with index ")).call(_context3, i, " is equals to the other one with index ")).call(_context2, j));
          }
        }
      }

      return raw;
    }
    /**
     * @param {Buffer} buffer
     * @param {number} [offset]
     * @returns {{ res: SerializerOutput<VectorSerializer<T>>, newOffset: number }}
     */

  }, {
    key: "readFromBuffer",
    value: function readFromBuffer(buffer) {
      var offset = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : 0;

      var _get$call = (0, _get2["default"])((0, _getPrototypeOf2["default"])(SetSerializer.prototype), "readFromBuffer", this).call(this, buffer, offset),
          res = _get$call.res,
          newOffset = _get$call.newOffset; // `this.toRaw` is used here to transaction.js duplicates


      return {
        res: this.toRaw(res),
        newOffset: newOffset
      };
    }
  }]);
  return SetSerializer;
}(_Vector["default"]);

exports["default"] = SetSerializer;