"use strict";

var _Reflect$construct = require("@babel/runtime-corejs3/core-js-stable/reflect/construct");

var _Object$keys = require("@babel/runtime-corejs3/core-js-stable/object/keys");

var _Object$getOwnPropertySymbols = require("@babel/runtime-corejs3/core-js-stable/object/get-own-property-symbols");

var _filterInstanceProperty = require("@babel/runtime-corejs3/core-js-stable/instance/filter");

var _Object$getOwnPropertyDescriptor = require("@babel/runtime-corejs3/core-js-stable/object/get-own-property-descriptor");

var _forEachInstanceProperty = require("@babel/runtime-corejs3/core-js-stable/instance/for-each");

var _Object$getOwnPropertyDescriptors = require("@babel/runtime-corejs3/core-js-stable/object/get-own-property-descriptors");

var _Object$defineProperties = require("@babel/runtime-corejs3/core-js-stable/object/define-properties");

var _Object$defineProperty = require("@babel/runtime-corejs3/core-js-stable/object/define-property");

var _interopRequireDefault = require("@babel/runtime-corejs3/helpers/interopRequireDefault");

_Object$defineProperty(exports, "__esModule", {
  value: true
});

exports["default"] = void 0;

var _concat = _interopRequireDefault(require("@babel/runtime-corejs3/core-js-stable/instance/concat"));

var _isArray = _interopRequireDefault(require("@babel/runtime-corejs3/core-js-stable/array/is-array"));

var _slicedToArray2 = _interopRequireDefault(require("@babel/runtime-corejs3/helpers/slicedToArray"));

var _defineProperty2 = _interopRequireDefault(require("@babel/runtime-corejs3/helpers/defineProperty"));

var _typeof2 = _interopRequireDefault(require("@babel/runtime-corejs3/helpers/typeof"));

var _classCallCheck2 = _interopRequireDefault(require("@babel/runtime-corejs3/helpers/classCallCheck"));

var _createClass2 = _interopRequireDefault(require("@babel/runtime-corejs3/helpers/createClass"));

var _inherits2 = _interopRequireDefault(require("@babel/runtime-corejs3/helpers/inherits"));

var _possibleConstructorReturn2 = _interopRequireDefault(require("@babel/runtime-corejs3/helpers/possibleConstructorReturn"));

var _getPrototypeOf2 = _interopRequireDefault(require("@babel/runtime-corejs3/helpers/getPrototypeOf"));

var _ISerializer2 = _interopRequireDefault(require("../ISerializer"));

var _integers = require("../basic/integers");

function ownKeys(object, enumerableOnly) { var keys = _Object$keys(object); if (_Object$getOwnPropertySymbols) { var symbols = _Object$getOwnPropertySymbols(object); if (enumerableOnly) { symbols = _filterInstanceProperty(symbols).call(symbols, function (sym) { return _Object$getOwnPropertyDescriptor(object, sym).enumerable; }); } keys.push.apply(keys, symbols); } return keys; }

function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i] != null ? arguments[i] : {}; if (i % 2) { var _context3; _forEachInstanceProperty(_context3 = ownKeys(Object(source), true)).call(_context3, function (key) { (0, _defineProperty2["default"])(target, key, source[key]); }); } else if (_Object$getOwnPropertyDescriptors) { _Object$defineProperties(target, _Object$getOwnPropertyDescriptors(source)); } else { var _context4; _forEachInstanceProperty(_context4 = ownKeys(Object(source))).call(_context4, function (key) { _Object$defineProperty(target, key, _Object$getOwnPropertyDescriptor(source, key)); }); } } return target; }

function _createSuper(Derived) { var hasNativeReflectConstruct = _isNativeReflectConstruct(); return function _createSuperInternal() { var Super = (0, _getPrototypeOf2["default"])(Derived), result; if (hasNativeReflectConstruct) { var NewTarget = (0, _getPrototypeOf2["default"])(this).constructor; result = _Reflect$construct(Super, arguments, NewTarget); } else { result = Super.apply(this, arguments); } return (0, _possibleConstructorReturn2["default"])(this, result); }; }

function _isNativeReflectConstruct() { if (typeof Reflect === "undefined" || !_Reflect$construct) return false; if (_Reflect$construct.sham) return false; if (typeof Proxy === "function") return true; try { Boolean.prototype.valueOf.call(_Reflect$construct(Boolean, [], function () {})); return true; } catch (e) { return false; } }

/** @typedef {import("bytebuffer")} ByteBuffer */

/** @typedef {import("../basic/integers/VarInt32").default} VarInt32Serializer */

/**
 * @template {ISerializer} T
 * @typedef {import("../ISerializer").SerializerInput<T>} SerializerInput
 */

/**
 * @template {ISerializer} T
 * @typedef {import("../ISerializer").SerializerOutput<T>} SerializerOutput
 */

/** @typedef {{ [key: number]: ISerializer }} Variants */

/**
 * @template {Variants} T
 * @template {number} TVariant
 * @typedef {[TVariant, TVariant extends keyof T ? SerializerInput<T[TVariant]> : never]} TInput
 */

/**
 * @template {Variants} T
 * @template {number} TVariant
 * @typedef {[TVariant, TVariant extends keyof T ? SerializerOutput<T[TVariant]> : never]} TOutput
 */

/**
 * @template {Variants} T
 * @augments {ISerializer<TInput<T, number>, TOutput<T, number>>}
 */
var StaticVariantSerializer = /*#__PURE__*/function (_ISerializer) {
  (0, _inherits2["default"])(StaticVariantSerializer, _ISerializer);

  var _super = _createSuper(StaticVariantSerializer);

  /** @param {Readonly<T>} serializers */
  function StaticVariantSerializer(serializers) {
    var _this;

    (0, _classCallCheck2["default"])(this, StaticVariantSerializer);
    _this = _super.call(this);
    if (!serializers || (0, _typeof2["default"])(serializers) !== 'object') throw new Error('types variable is not an object');

    for (var key in serializers) {
      if (!Object.prototype.hasOwnProperty.call(serializers, key)) continue;

      try {
        _integers.varint32.validate(key);
      } catch (error) {
        var _context;

        throw new Error((0, _concat["default"])(_context = "invalid key ".concat(key, ": ")).call(_context, error.message));
      }

      var serializer = serializers[key];
      if (!(serializer instanceof _ISerializer2["default"])) throw new Error("variant with key ".concat(key, " is not a serializer"));
    }
    /**
     * @private
     * @type {Readonly<T>}
     */


    _this._serializers = _objectSpread({}, serializers);
    return _this;
  }
  /**
   * @template {number} TVariant
   * @param {TInput<T, TVariant>} value
   * @returns {TOutput<T, TVariant>}
   */


  (0, _createClass2["default"])(StaticVariantSerializer, [{
    key: "serializers",
    get:
    /**
     * @readonly
     * @type {Readonly<T>}
     */
    function get() {
      return _objectSpread({}, this._serializers);
    }
  }, {
    key: "toRaw",
    value: function toRaw(value) {
      if (!(0, _isArray["default"])(value)) throw new Error('value is not an array');

      var _value = (0, _slicedToArray2["default"])(value, 2),
          key = _value[0],
          variant = _value[1];
      /** @type {SerializerOutput<VarInt32Serializer>} */


      var rawKey;

      try {
        rawKey = _integers.varint32.toRaw(key);
      } catch (error) {
        throw new Error("static variant invalid key: ".concat(error.message));
      }

      var serializer = this.serializers[rawKey];
      if (!serializer) throw new Error("serializer with key ".concat(rawKey, " not found"));

      try {
        return [rawKey, serializer.toRaw(variant)];
      } catch (error) {
        var _context2;

        throw new Error((0, _concat["default"])(_context2 = "static variant with key ".concat(rawKey, ": ")).call(_context2, error.message));
      }
    }
    /**
     * @template {number} TVariant
     * @param {TInput<T, TVariant>} value
     * @param {ByteBuffer} bytebuffer
     */

  }, {
    key: "appendToByteBuffer",
    value: function appendToByteBuffer(value, bytebuffer) {
      var _this$toRaw = this.toRaw(value),
          _this$toRaw2 = (0, _slicedToArray2["default"])(_this$toRaw, 2),
          key = _this$toRaw2[0],
          variant = _this$toRaw2[1];

      _integers.varint32.appendToByteBuffer(key, bytebuffer);

      var serializer = this.serializers[key];
      serializer.appendToByteBuffer(variant, bytebuffer);
    }
    /**
     * @template {number} TVariant
     * @param {Buffer} buffer
     * @param {number} [offset]
     * @returns {{ res: TOutput<T, TVariant>, newOffset: number }}
     */

  }, {
    key: "readFromBuffer",
    value: function readFromBuffer(buffer) {
      var offset = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : 0;

      var _varint32$readFromBuf = _integers.varint32.readFromBuffer(buffer, offset),
          key = _varint32$readFromBuf.res,
          from = _varint32$readFromBuf.newOffset;

      var serializer = this.serializers[key];
      if (!serializer) throw new Error("serializer with key ".concat(key, " not found"));

      var _serializer$readFromB = serializer.readFromBuffer(buffer, from),
          variant = _serializer$readFromB.res,
          newOffset = _serializer$readFromB.newOffset;

      return {
        res: [key, variant],
        newOffset: newOffset
      };
    }
  }]);
  return StaticVariantSerializer;
}(_ISerializer2["default"]);

exports["default"] = StaticVariantSerializer;