"use strict";

var _Reflect$construct = require("@babel/runtime-corejs3/core-js-stable/reflect/construct");

var _Object$defineProperty = require("@babel/runtime-corejs3/core-js-stable/object/define-property");

var _interopRequireDefault = require("@babel/runtime-corejs3/helpers/interopRequireDefault");

_Object$defineProperty(exports, "__esModule", {
  value: true
});

exports["default"] = void 0;

var _concat = _interopRequireDefault(require("@babel/runtime-corejs3/core-js-stable/instance/concat"));

var _typeof2 = _interopRequireDefault(require("@babel/runtime-corejs3/helpers/typeof"));

var _classCallCheck2 = _interopRequireDefault(require("@babel/runtime-corejs3/helpers/classCallCheck"));

var _createClass2 = _interopRequireDefault(require("@babel/runtime-corejs3/helpers/createClass"));

var _inherits2 = _interopRequireDefault(require("@babel/runtime-corejs3/helpers/inherits"));

var _possibleConstructorReturn2 = _interopRequireDefault(require("@babel/runtime-corejs3/helpers/possibleConstructorReturn"));

var _getPrototypeOf2 = _interopRequireDefault(require("@babel/runtime-corejs3/helpers/getPrototypeOf"));

var _ISerializer2 = _interopRequireDefault(require("../ISerializer"));

function _createSuper(Derived) { var hasNativeReflectConstruct = _isNativeReflectConstruct(); return function _createSuperInternal() { var Super = (0, _getPrototypeOf2["default"])(Derived), result; if (hasNativeReflectConstruct) { var NewTarget = (0, _getPrototypeOf2["default"])(this).constructor; result = _Reflect$construct(Super, arguments, NewTarget); } else { result = Super.apply(this, arguments); } return (0, _possibleConstructorReturn2["default"])(this, result); }; }

function _isNativeReflectConstruct() { if (typeof Reflect === "undefined" || !_Reflect$construct) return false; if (_Reflect$construct.sham) return false; if (typeof Proxy === "function") return true; try { Boolean.prototype.valueOf.call(_Reflect$construct(Boolean, [], function () {})); return true; } catch (e) { return false; } }

/** @typedef {import("bytebuffer")} ByteBuffer */

/**
 * @template {ISerializer} T
 * @typedef {import("../ISerializer").SerializerInput<T>} SerializerInput
 */

/**
 * @template {ISerializer} T
 * @typedef {import("../ISerializer").SerializerOutput<T>} SerializerOutput
 */

/** @typedef {{ [key: string]: ISerializer }} SerializersMap */

/**
 * @template {SerializersMap} T
 * @typedef {{ [key in keyof T]: SerializerInput<T[key]> }} TInput
 */

/**
 * @template {SerializersMap} T
 * @typedef {{ [key in keyof T]: SerializerOutput<T[key]> }} TOutput
 */

/**
 * @template {SerializersMap} T
 * @augments {ISerializer<TInput<T>, TOutput<T>>}
 */
var StructSerializer = /*#__PURE__*/function (_ISerializer) {
  (0, _inherits2["default"])(StructSerializer, _ISerializer);

  var _super = _createSuper(StructSerializer);

  /** @param {Readonly<T>} serializers */
  function StructSerializer(serializers) {
    var _this;

    (0, _classCallCheck2["default"])(this, StructSerializer);

    if ((0, _typeof2["default"])(serializers) !== 'object' || serializers === null) {
      throw new Error('property "serializers" is not a object');
    }

    for (var key in serializers) {
      if (!Object.prototype.hasOwnProperty.call(serializers, key)) continue;
      var serializer = serializers[key];

      if (!(serializer instanceof _ISerializer2["default"])) {
        throw new Error("field \"".concat(key, "\" is not a serializer"));
      }
    }

    _this = _super.call(this);
    /**
     * @private
     * @type {Object<string,Type>}
     */

    _this._serializers = serializers;
    return _this;
  }
  /**
   * @param {TInput<T>} value
   * @returns {TOutput<T>}
   */


  (0, _createClass2["default"])(StructSerializer, [{
    key: "serializers",
    get:
    /**
     * @readonly
     * @type {Readonly<T>}
     */
    function get() {
      return this._serializers;
    }
  }, {
    key: "toRaw",
    value: function toRaw(value) {
      if ((0, _typeof2["default"])(value) !== 'object' || value === null) throw new Error('serializable struct is not a object');
      /** @type {TOutput<T>} */

      var result = {};

      for (var key in this.serializers) {
        if (!Object.prototype.hasOwnProperty.call(this.serializers, key)) continue;
        var serializer = this.serializers[key];

        try {
          result[key] = serializer.toRaw(value[key]);
        } catch (error) {
          var _context;

          throw new Error((0, _concat["default"])(_context = "struct key \"".concat(key, "\": ")).call(_context, error.message));
        }
      }

      return result;
    }
    /**
     * @param {TInput<T>} value
     * @param {ByteBuffer} bytebuffer
     */

  }, {
    key: "appendToByteBuffer",
    value: function appendToByteBuffer(value, bytebuffer) {
      var raw = this.toRaw(value);

      for (var key in this.serializers) {
        if (!Object.prototype.hasOwnProperty.call(this.serializers, key)) continue;
        var serializer = this.serializers[key];
        serializer.appendToByteBuffer(raw[key], bytebuffer);
      }
    }
    /**
     * @param {Buffer} buffer
     * @param {number} [offset]
     * @returns {{ res: TOutput<T>, newOffset: number }}
     */

  }, {
    key: "readFromBuffer",
    value: function readFromBuffer(buffer) {
      var offset = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : 0;
      var result = {};
      var it = offset;

      for (var key in this.serializers) {
        if (!Object.prototype.hasOwnProperty.call(this.serializers, key)) continue;
        var serializer = this.serializers[key];

        var _serializer$readFromB = serializer.readFromBuffer(buffer, it),
            element = _serializer$readFromB.res,
            newOffset = _serializer$readFromB.newOffset;

        it = newOffset;
        result[key] = element;
      }

      return {
        res: result,
        newOffset: it
      };
    }
  }]);
  return StructSerializer;
}(_ISerializer2["default"]);

exports["default"] = StructSerializer;