"use strict";

var _Reflect$construct = require("@babel/runtime-corejs3/core-js-stable/reflect/construct");

var _Object$defineProperty = require("@babel/runtime-corejs3/core-js-stable/object/define-property");

var _interopRequireDefault = require("@babel/runtime-corejs3/helpers/interopRequireDefault");

_Object$defineProperty(exports, "__esModule", {
  value: true
});

exports["default"] = void 0;

var _sort = _interopRequireDefault(require("@babel/runtime-corejs3/core-js-stable/instance/sort"));

var _keys = _interopRequireDefault(require("@babel/runtime-corejs3/core-js-stable/object/keys"));

var _find = _interopRequireDefault(require("@babel/runtime-corejs3/core-js-stable/instance/find"));

var _map = _interopRequireDefault(require("@babel/runtime-corejs3/core-js-stable/instance/map"));

var _concat = _interopRequireDefault(require("@babel/runtime-corejs3/core-js-stable/instance/concat"));

var _slicedToArray2 = _interopRequireDefault(require("@babel/runtime-corejs3/helpers/slicedToArray"));

var _typeof2 = _interopRequireDefault(require("@babel/runtime-corejs3/helpers/typeof"));

var _classCallCheck2 = _interopRequireDefault(require("@babel/runtime-corejs3/helpers/classCallCheck"));

var _createClass2 = _interopRequireDefault(require("@babel/runtime-corejs3/helpers/createClass"));

var _inherits2 = _interopRequireDefault(require("@babel/runtime-corejs3/helpers/inherits"));

var _possibleConstructorReturn2 = _interopRequireDefault(require("@babel/runtime-corejs3/helpers/possibleConstructorReturn"));

var _getPrototypeOf2 = _interopRequireDefault(require("@babel/runtime-corejs3/helpers/getPrototypeOf"));

var _ISerializer2 = _interopRequireDefault(require("../ISerializer"));

var _ = require(".");

function _createSuper(Derived) { var hasNativeReflectConstruct = _isNativeReflectConstruct(); return function _createSuperInternal() { var Super = (0, _getPrototypeOf2["default"])(Derived), result; if (hasNativeReflectConstruct) { var NewTarget = (0, _getPrototypeOf2["default"])(this).constructor; result = _Reflect$construct(Super, arguments, NewTarget); } else { result = Super.apply(this, arguments); } return (0, _possibleConstructorReturn2["default"])(this, result); }; }

function _isNativeReflectConstruct() { if (typeof Reflect === "undefined" || !_Reflect$construct) return false; if (_Reflect$construct.sham) return false; if (typeof Proxy === "function") return true; try { Boolean.prototype.valueOf.call(_Reflect$construct(Boolean, [], function () {})); return true; } catch (e) { return false; } }

/** @typedef {import("bytebuffer")} ByteBuffer */

/**
 * @template {ISerializer} T
 * @typedef {import("../ISerializer").SerializerInput<T>} SerializerInput
 */

/**
 * @template {ISerializer} T
 * @typedef {import("../ISerializer").SerializerOutput<T>} SerializerOutput
 */

/** @typedef {{ [key: string]: ISerializer }} SerializersMap */

/** @typedef {{ [key: string]: ISerializer | ISerializer[] }} SerializersMapWithVariants */

/** @typedef {{
 * 	keyIndexInStructure: number,
 * 	serializersData: [string, ISerializer][],
 * }} ExtraSerializer
 */

/** @typedef {ExtraSerializer[]} ExtraSerializers

/** @typedef {ExtraSerializer['serializersData'][number][0]} ExtraSerializerKey

/**
 * @template {SerializersMap} T
 * @template {ExtraSerializers} V
 * @typedef {{
 * 	[key in keyof T]: SerializerInput<T[key]
 *  & { [key in ExtraSerializerKey]: SerializerInput<V[number]['serializersData'][number][1]>>
 * }} TInput
 */

/**
 * @template {SerializersMap} T
 * @template {ExtraSerializers} V
 * @typedef {{
 * 	[key in keyof T]: SerializerOutput<T[key]
 * 	& { [key in ExtraSerializerKey]: SerializerInput<V[number]['serializersData'][number][1]>>
 * }} TOutput
 */

/**
 * @template {SerializersMap} T
 * @template {ExtraSerializers} V
 * @augments {ISerializer<TInput<T, V>, TOutput<T, V>>}
 */
var StructWithVariantKeysSerializer = /*#__PURE__*/function (_ISerializer) {
  (0, _inherits2["default"])(StructWithVariantKeysSerializer, _ISerializer);

  var _super = _createSuper(StructWithVariantKeysSerializer);

  /**
   * @param {Readonly<T>} serializers
   * @param {Readonly<V>} extraSerializers
   */
  function StructWithVariantKeysSerializer(serializers, extraSerializers) {
    var _this;

    (0, _classCallCheck2["default"])(this, StructWithVariantKeysSerializer);

    if ((0, _typeof2["default"])(serializers) !== 'object' || serializers === null) {
      throw new Error('property "serializers" is not a object');
    }

    for (var key in serializers) {
      if (!Object.prototype.hasOwnProperty.call(serializers, key)) continue;
      var serializer = serializers[key];

      if (!(serializer instanceof _ISerializer2["default"])) {
        throw new Error("field \"".concat(key, "\" is not a serializer"));
      }
    }

    _this = _super.call(this);
    /**
     * @private
     * @type {Object<string,Type>}
     */

    _this._serializers = serializers;
    _this._extraSerializers = (0, _sort["default"])(extraSerializers).call(extraSerializers, function (el1, el2) {
      return el1.keyIndexInStructure - el2.keyIndexInStructure;
    });
    return _this;
  }
  /**
   * @param {TInput<T, V>} value
   * @param {[string, ISerializer][]} serializersData
   * @returns {[string, number]}
   */


  (0, _createClass2["default"])(StructWithVariantKeysSerializer, [{
    key: "serializers",
    get:
    /**
     * @readonly
     * @type {Readonly<T>}
     */
    function get() {
      return this._serializers;
    }
    /**
     * @readonly
     * @type {Readonly<V>}
     */

  }, {
    key: "extraSerializers",
    get: function get() {
      return this._extraSerializers;
    }
  }, {
    key: "findSerializerKeyInVariant",
    value: function findSerializerKeyInVariant(value, serializersData) {
      var variantKey;
      var index;

      for (var i = 0; i < serializersData.length; i += 1) {
        var currentKey = serializersData[i][0];

        if (value[currentKey]) {
          variantKey = currentKey;
          index = i;
          break;
        }
      }

      return [variantKey, index];
    }
    /**
     * @param {TInput<T, V>} value
     * @returns {TOutput<T, V>}
     */

  }, {
    key: "toRaw",
    value: function toRaw(value) {
      if ((0, _typeof2["default"])(value) !== 'object' || value === null) throw new Error('serializable struct is not a object');
      /** @type {TOutput<T>} */

      var result = {};
      var iterator = 0;
      var serializersKeys = (0, _keys["default"])(this.serializers);

      for (var i = 0; i < serializersKeys.length + this.extraSerializers.length; i += 1) {
        var _context;

        // eslint-disable-next-line no-loop-func
        var variantKeySerializer = (0, _find["default"])(_context = this.extraSerializers).call(_context, function (el) {
          return el.keyIndexInStructure === iterator;
        });

        if (variantKeySerializer) {
          var _context2;

          var serializersData = variantKeySerializer.serializersData;

          var _this$findSerializerK = this.findSerializerKeyInVariant(value, serializersData),
              _this$findSerializerK2 = (0, _slicedToArray2["default"])(_this$findSerializerK, 2),
              variantKey = _this$findSerializerK2[0],
              index = _this$findSerializerK2[1];

          var _staticVariant$toRaw = (0, _.staticVariant)((0, _map["default"])(_context2 = variantKeySerializer.serializersData).call(_context2, function (el) {
            return el[1];
          })).toRaw([index, value[variantKey]]),
              _staticVariant$toRaw2 = (0, _slicedToArray2["default"])(_staticVariant$toRaw, 2),
              rawKey = _staticVariant$toRaw2[0],
              rawValue = _staticVariant$toRaw2[1];

          var resultKey = variantKeySerializer.serializersData[rawKey][0];
          result[resultKey] = rawValue;
          iterator += 1;
        }

        if (i >= serializersKeys.length) {
          iterator += 1;
          continue;
        }

        var key = serializersKeys[i];
        if (!Object.prototype.hasOwnProperty.call(this.serializers, key)) continue;
        var serializer = this.serializers[key];

        try {
          result[key] = serializer.toRaw(value[key]);
        } catch (error) {
          var _context3;

          throw new Error((0, _concat["default"])(_context3 = "struct key \"".concat(key, "\": ")).call(_context3, error.message));
        }

        iterator += 1;
      }

      return result;
    }
    /**
     * @param {TInput<T, V>} value
     * @param {ByteBuffer} bytebuffer
     */

  }, {
    key: "appendToByteBuffer",
    value: function appendToByteBuffer(value, bytebuffer) {
      var raw = this.toRaw(value);
      var iterator = 0;
      var serializersKeys = (0, _keys["default"])(this.serializers);

      for (var i = 0; i < serializersKeys.length + this.extraSerializers.length; i += 1) {
        var _context4;

        // eslint-disable-next-line no-loop-func
        var variantKeySerializer = (0, _find["default"])(_context4 = this.extraSerializers).call(_context4, function (el) {
          return el.keyIndexInStructure === iterator;
        });

        if (variantKeySerializer) {
          var _context5;

          var serializersData = variantKeySerializer.serializersData;

          var _this$findSerializerK3 = this.findSerializerKeyInVariant(value, serializersData),
              _this$findSerializerK4 = (0, _slicedToArray2["default"])(_this$findSerializerK3, 2),
              variantKey = _this$findSerializerK4[0],
              index = _this$findSerializerK4[1];

          (0, _.staticVariant)((0, _map["default"])(_context5 = variantKeySerializer.serializersData).call(_context5, function (el) {
            return el[1];
          })).appendToByteBuffer([index, value[variantKey]], bytebuffer);
          iterator += 1;
        }

        if (i >= serializersKeys.length) {
          iterator += 1;
          continue;
        }

        var key = serializersKeys[i];
        if (!Object.prototype.hasOwnProperty.call(this.serializers, key)) continue;
        var serializer = this.tserializers[key];
        serializer.appendToByteBuffer(raw[key], bytebuffer);
        iterator += 1;
      }
    }
    /**
     * @param {Buffer} buffer
     * @param {number} [offset]
     * @returns {{ res: TOutput<T, V>, newOffset: number }}
     */

  }, {
    key: "readFromBuffer",
    value: function readFromBuffer(buffer) {
      var offset = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : 0;
      var result = {};
      var it = offset;
      var iterator = 0;
      var serializersKeys = (0, _keys["default"])(this.serializers);

      for (var i = 0; i < serializersKeys.length + this.extraSerializers.length; i += 1) {
        var _context6;

        // eslint-disable-next-line no-loop-func
        var variantKeySerializer = (0, _find["default"])(_context6 = this.extraSerializers).call(_context6, function (el) {
          return el.keyIndexInStructure === iterator;
        });

        if (variantKeySerializer) {
          var _context7;

          var _staticVariant$readFr = (0, _.staticVariant)((0, _map["default"])(_context7 = variantKeySerializer.serializersData).call(_context7, function (el) {
            return el[1];
          })).readFromBuffer(buffer, it),
              res = _staticVariant$readFr.res,
              _newOffset = _staticVariant$readFr.newOffset;

          it = _newOffset;

          var _res = (0, _slicedToArray2["default"])(res, 2),
              rawKey = _res[0],
              variant = _res[1];

          var resultKey = variantKeySerializer.serializersData[rawKey][0];
          result[resultKey] = variant;
          iterator += 1;
        }

        if (i >= serializersKeys.length) {
          iterator += 1;
          continue;
        }

        var key = serializersKeys[i];
        var serializer = this.serializers[key];
        if (!Object.prototype.hasOwnProperty.call(this.serializers, key)) continue;

        var _serializer$readFromB = serializer.readFromBuffer(buffer, it),
            element = _serializer$readFromB.res,
            newOffset = _serializer$readFromB.newOffset;

        it = newOffset;
        result[key] = element;
        iterator += 1;
      }

      return {
        res: result,
        newOffset: it
      };
    }
  }]);
  return StructWithVariantKeysSerializer;
}(_ISerializer2["default"]);

exports["default"] = StructWithVariantKeysSerializer;