"use strict";

var _Reflect$construct = require("@babel/runtime-corejs3/core-js-stable/reflect/construct");

var _sliceInstanceProperty = require("@babel/runtime-corejs3/core-js-stable/instance/slice");

var _Array$from = require("@babel/runtime-corejs3/core-js-stable/array/from");

var _Symbol = require("@babel/runtime-corejs3/core-js-stable/symbol");

var _getIteratorMethod = require("@babel/runtime-corejs3/core-js/get-iterator-method");

var _Array$isArray2 = require("@babel/runtime-corejs3/core-js-stable/array/is-array");

var _Object$defineProperty = require("@babel/runtime-corejs3/core-js-stable/object/define-property");

var _interopRequireDefault = require("@babel/runtime-corejs3/helpers/interopRequireDefault");

_Object$defineProperty(exports, "__esModule", {
  value: true
});

exports["default"] = void 0;

var _isArray = _interopRequireDefault(require("@babel/runtime-corejs3/core-js-stable/array/is-array"));

var _concat = _interopRequireDefault(require("@babel/runtime-corejs3/core-js-stable/instance/concat"));

var _fill = _interopRequireDefault(require("@babel/runtime-corejs3/core-js-stable/instance/fill"));

var _classCallCheck2 = _interopRequireDefault(require("@babel/runtime-corejs3/helpers/classCallCheck"));

var _createClass2 = _interopRequireDefault(require("@babel/runtime-corejs3/helpers/createClass"));

var _inherits2 = _interopRequireDefault(require("@babel/runtime-corejs3/helpers/inherits"));

var _possibleConstructorReturn2 = _interopRequireDefault(require("@babel/runtime-corejs3/helpers/possibleConstructorReturn"));

var _getPrototypeOf2 = _interopRequireDefault(require("@babel/runtime-corejs3/helpers/getPrototypeOf"));

var _ISerializer2 = _interopRequireDefault(require("../ISerializer"));

var _integers = require("../basic/integers");

function _createForOfIteratorHelper(o, allowArrayLike) { var it = typeof _Symbol !== "undefined" && _getIteratorMethod(o) || o["@@iterator"]; if (!it) { if (_Array$isArray2(o) || (it = _unsupportedIterableToArray(o)) || allowArrayLike && o && typeof o.length === "number") { if (it) o = it; var i = 0; var F = function F() {}; return { s: F, n: function n() { if (i >= o.length) return { done: true }; return { done: false, value: o[i++] }; }, e: function e(_e) { throw _e; }, f: F }; } throw new TypeError("Invalid attempt to iterate non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method."); } var normalCompletion = true, didErr = false, err; return { s: function s() { it = it.call(o); }, n: function n() { var step = it.next(); normalCompletion = step.done; return step; }, e: function e(_e2) { didErr = true; err = _e2; }, f: function f() { try { if (!normalCompletion && it["return"] != null) it["return"](); } finally { if (didErr) throw err; } } }; }

function _unsupportedIterableToArray(o, minLen) { var _context4; if (!o) return; if (typeof o === "string") return _arrayLikeToArray(o, minLen); var n = _sliceInstanceProperty(_context4 = Object.prototype.toString.call(o)).call(_context4, 8, -1); if (n === "Object" && o.constructor) n = o.constructor.name; if (n === "Map" || n === "Set") return _Array$from(o); if (n === "Arguments" || /^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(n)) return _arrayLikeToArray(o, minLen); }

function _arrayLikeToArray(arr, len) { if (len == null || len > arr.length) len = arr.length; for (var i = 0, arr2 = new Array(len); i < len; i++) { arr2[i] = arr[i]; } return arr2; }

function _createSuper(Derived) { var hasNativeReflectConstruct = _isNativeReflectConstruct(); return function _createSuperInternal() { var Super = (0, _getPrototypeOf2["default"])(Derived), result; if (hasNativeReflectConstruct) { var NewTarget = (0, _getPrototypeOf2["default"])(this).constructor; result = _Reflect$construct(Super, arguments, NewTarget); } else { result = Super.apply(this, arguments); } return (0, _possibleConstructorReturn2["default"])(this, result); }; }

function _isNativeReflectConstruct() { if (typeof Reflect === "undefined" || !_Reflect$construct) return false; if (_Reflect$construct.sham) return false; if (typeof Proxy === "function") return true; try { Boolean.prototype.valueOf.call(_Reflect$construct(Boolean, [], function () {})); return true; } catch (e) { return false; } }

/** @typedef {import("bytebuffer")} ByteBuffer */

/**
 * @template {ISerializer} T
 * @typedef {import("../ISerializer").SerializerInput<T>} SerializerInput
 */

/**
 * @template {ISerializer} T
 * @typedef {import("../ISerializer").SerializerOutput<T>} SerializerOutput
 */

/**
 * @template {ISerializer} T
 * @typedef {SerializerInput<T>[]} TInput
 */

/**
 * @template {ISerializer} T
 * @augments {ISerializer<TInput<T>, TOutput<T>>}
 */
var VectorSerializer = /*#__PURE__*/function (_ISerializer) {
  (0, _inherits2["default"])(VectorSerializer, _ISerializer);

  var _super = _createSuper(VectorSerializer);

  /** @param {T} serializer */
  function VectorSerializer(serializer) {
    var _this;

    (0, _classCallCheck2["default"])(this, VectorSerializer);
    _this = _super.call(this);
    if (!(serializer instanceof _ISerializer2["default"])) throw new Error('vector element type is not serializer');
    /**
     * @private
     * @type {T}
     */

    _this._serializer = serializer;
    return _this;
  }
  /**
   * @param {TInput<T>} value
   * @returns {TOutput<T>}
   */


  (0, _createClass2["default"])(VectorSerializer, [{
    key: "serializer",
    get:
    /**
     * @readonly
     * @type {T}
     */
    function get() {
      return this._serializer;
    }
  }, {
    key: "toRaw",
    value: function toRaw(value) {
      var errorField = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : 'vector';
      if (!(0, _isArray["default"])(value)) throw new Error("".concat(errorField, " is not an array"));
      var raw = new Array(value.length);

      for (var i = 0; i < value.length; i += 1) {
        try {
          var element = value[i];
          raw[i] = this.serializer.toRaw(element);
        } catch (error) {
          var _context, _context2;

          throw new Error((0, _concat["default"])(_context = (0, _concat["default"])(_context2 = "".concat(errorField, " element with index ")).call(_context2, i, ": ")).call(_context, error.message));
        }
      }

      return raw;
    }
    /**
     * @param {TInput<T>} value
     * @param {ByteBuffer} bytebuffer
     * @param {boolean} writeLength
     */

  }, {
    key: "appendToByteBuffer",
    value: function appendToByteBuffer(value, bytebuffer) {
      var writeLength = arguments.length > 2 && arguments[2] !== undefined ? arguments[2] : true;
      if (typeof writeLength !== 'boolean') throw new Error('property "writeLength" is not a boolean');
      var raw = this.toRaw(value);
      if (writeLength) _integers.varint32.appendToByteBuffer(raw.length, bytebuffer);

      var _iterator = _createForOfIteratorHelper(raw),
          _step;

      try {
        for (_iterator.s(); !(_step = _iterator.n()).done;) {
          var element = _step.value;
          this.serializer.appendToByteBuffer(element, bytebuffer);
        }
      } catch (err) {
        _iterator.e(err);
      } finally {
        _iterator.f();
      }
    }
    /**
     * @param {Buffer} buffer
     * @param {number} [offset]
     * @returns {{ res: TOutput<T>, newOffset: number }}
     */

  }, {
    key: "readFromBuffer",
    value: function readFromBuffer(buffer) {
      var _context3;

      var offset = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : 0;

      var _varint32$readFromBuf = _integers.varint32.readFromBuffer(buffer, offset),
          length = _varint32$readFromBuf.res,
          from = _varint32$readFromBuf.newOffset;

      var result = (0, _fill["default"])(_context3 = new Array(length)).call(_context3, null);
      var it = from;

      for (var i = 0; i < length; i += 1) {
        var _this$serializer$read = this.serializer.readFromBuffer(buffer, it),
            element = _this$serializer$read.res,
            nextIt = _this$serializer$read.newOffset;

        it = nextIt;
        result[i] = element;
      }

      return {
        res: result,
        newOffset: it
      };
    }
  }]);
  return VectorSerializer;
}(_ISerializer2["default"]);

exports["default"] = VectorSerializer;