"use strict";

var _typeof = require("@babel/runtime-corejs3/helpers/typeof");

var _Reflect$construct = require("@babel/runtime-corejs3/core-js-stable/reflect/construct");

var _Object$keys = require("@babel/runtime-corejs3/core-js-stable/object/keys");

var _Object$getOwnPropertySymbols = require("@babel/runtime-corejs3/core-js-stable/object/get-own-property-symbols");

var _filterInstanceProperty = require("@babel/runtime-corejs3/core-js-stable/instance/filter");

var _Object$getOwnPropertyDescriptor = require("@babel/runtime-corejs3/core-js-stable/object/get-own-property-descriptor");

var _forEachInstanceProperty = require("@babel/runtime-corejs3/core-js-stable/instance/for-each");

var _Object$getOwnPropertyDescriptors = require("@babel/runtime-corejs3/core-js-stable/object/get-own-property-descriptors");

var _Object$defineProperties = require("@babel/runtime-corejs3/core-js-stable/object/define-properties");

var _Object$defineProperty = require("@babel/runtime-corejs3/core-js-stable/object/define-property");

var _WeakMap = require("@babel/runtime-corejs3/core-js-stable/weak-map");

var _interopRequireDefault = require("@babel/runtime-corejs3/helpers/interopRequireDefault");

_Object$defineProperty(exports, "__esModule", {
  value: true
});

exports["default"] = void 0;

var _classCallCheck2 = _interopRequireDefault(require("@babel/runtime-corejs3/helpers/classCallCheck"));

var _createClass2 = _interopRequireDefault(require("@babel/runtime-corejs3/helpers/createClass"));

var _inherits2 = _interopRequireDefault(require("@babel/runtime-corejs3/helpers/inherits"));

var _possibleConstructorReturn2 = _interopRequireDefault(require("@babel/runtime-corejs3/helpers/possibleConstructorReturn"));

var _getPrototypeOf2 = _interopRequireDefault(require("@babel/runtime-corejs3/helpers/getPrototypeOf"));

var _defineProperty2 = _interopRequireDefault(require("@babel/runtime-corejs3/helpers/defineProperty"));

var _collections = require("./collections");

var _ISerializer2 = _interopRequireDefault(require("./ISerializer"));

var _constants = require("../constants");

var protocol = _interopRequireWildcard(require("./protocol"));

var _operationProps;

function _getRequireWildcardCache(nodeInterop) { if (typeof _WeakMap !== "function") return null; var cacheBabelInterop = new _WeakMap(); var cacheNodeInterop = new _WeakMap(); return (_getRequireWildcardCache = function _getRequireWildcardCache(nodeInterop) { return nodeInterop ? cacheNodeInterop : cacheBabelInterop; })(nodeInterop); }

function _interopRequireWildcard(obj, nodeInterop) { if (!nodeInterop && obj && obj.__esModule) { return obj; } if (obj === null || _typeof(obj) !== "object" && typeof obj !== "function") { return { "default": obj }; } var cache = _getRequireWildcardCache(nodeInterop); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = _Object$defineProperty && _Object$getOwnPropertyDescriptor; for (var key in obj) { if (key !== "default" && Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? _Object$getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { _Object$defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj["default"] = obj; if (cache) { cache.set(obj, newObj); } return newObj; }

function ownKeys(object, enumerableOnly) { var keys = _Object$keys(object); if (_Object$getOwnPropertySymbols) { var symbols = _Object$getOwnPropertySymbols(object); if (enumerableOnly) { symbols = _filterInstanceProperty(symbols).call(symbols, function (sym) { return _Object$getOwnPropertyDescriptor(object, sym).enumerable; }); } keys.push.apply(keys, symbols); } return keys; }

function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i] != null ? arguments[i] : {}; if (i % 2) { var _context; _forEachInstanceProperty(_context = ownKeys(Object(source), true)).call(_context, function (key) { (0, _defineProperty2["default"])(target, key, source[key]); }); } else if (_Object$getOwnPropertyDescriptors) { _Object$defineProperties(target, _Object$getOwnPropertyDescriptors(source)); } else { var _context2; _forEachInstanceProperty(_context2 = ownKeys(Object(source))).call(_context2, function (key) { _Object$defineProperty(target, key, _Object$getOwnPropertyDescriptor(source, key)); }); } } return target; }

function _createSuper(Derived) { var hasNativeReflectConstruct = _isNativeReflectConstruct(); return function _createSuperInternal() { var Super = (0, _getPrototypeOf2["default"])(Derived), result; if (hasNativeReflectConstruct) { var NewTarget = (0, _getPrototypeOf2["default"])(this).constructor; result = _Reflect$construct(Super, arguments, NewTarget); } else { result = Super.apply(this, arguments); } return (0, _possibleConstructorReturn2["default"])(this, result); }; }

function _isNativeReflectConstruct() { if (typeof Reflect === "undefined" || !_Reflect$construct) return false; if (_Reflect$construct.sham) return false; if (typeof Proxy === "function") return true; try { Boolean.prototype.valueOf.call(_Reflect$construct(Boolean, [], function () {})); return true; } catch (e) { return false; } }

var operationProps = (_operationProps = {}, (0, _defineProperty2["default"])(_operationProps, _constants.OPERATIONS_IDS.TRANSFER, protocol.transfer["default"]), (0, _defineProperty2["default"])(_operationProps, _constants.OPERATIONS_IDS.ACCOUNT_CREATE, protocol.account.create), (0, _defineProperty2["default"])(_operationProps, _constants.OPERATIONS_IDS.ACCOUNT_UPDATE, protocol.account.update), (0, _defineProperty2["default"])(_operationProps, _constants.OPERATIONS_IDS.ACCOUNT_WHITELIST, protocol.account.whitelist), (0, _defineProperty2["default"])(_operationProps, _constants.OPERATIONS_IDS.ASSET_CREATE, protocol.asset.create), (0, _defineProperty2["default"])(_operationProps, _constants.OPERATIONS_IDS.ASSET_UPDATE, protocol.asset.update), (0, _defineProperty2["default"])(_operationProps, _constants.OPERATIONS_IDS.ASSET_UPDATE_BITASSET, protocol.asset.updateBitasset), (0, _defineProperty2["default"])(_operationProps, _constants.OPERATIONS_IDS.ASSET_UPDATE_FEED_PRODUCERS, protocol.asset.updateFeedProducers), (0, _defineProperty2["default"])(_operationProps, _constants.OPERATIONS_IDS.ASSET_ISSUE, protocol.asset.issue), (0, _defineProperty2["default"])(_operationProps, _constants.OPERATIONS_IDS.ASSET_RESERVE, protocol.asset.reserve), (0, _defineProperty2["default"])(_operationProps, _constants.OPERATIONS_IDS.ASSET_FUND_FEE_POOL, protocol.asset.fundFeePool), (0, _defineProperty2["default"])(_operationProps, _constants.OPERATIONS_IDS.ASSET_PUBLISH_FEED, protocol.asset.publishFeed), (0, _defineProperty2["default"])(_operationProps, _constants.OPERATIONS_IDS.PROPOSAL_CREATE, protocol.proposal.create), (0, _defineProperty2["default"])(_operationProps, _constants.OPERATIONS_IDS.PROPOSAL_UPDATE, protocol.proposal.update), (0, _defineProperty2["default"])(_operationProps, _constants.OPERATIONS_IDS.PROPOSAL_DELETE, protocol.proposal["delete"]), (0, _defineProperty2["default"])(_operationProps, _constants.OPERATIONS_IDS.COMMITTEE_MEMBER_CREATE, protocol.committeeMember.create), (0, _defineProperty2["default"])(_operationProps, _constants.OPERATIONS_IDS.COMMITTEE_MEMBER_UPDATE, protocol.committeeMember.update), (0, _defineProperty2["default"])(_operationProps, _constants.OPERATIONS_IDS.COMMITTEE_MEMBER_UPDATE_GLOBAL_PARAMETERS, protocol.committeeMember.updateGlobalParameters), (0, _defineProperty2["default"])(_operationProps, _constants.OPERATIONS_IDS.COMMITTEE_MEMBER_ACTIVATE, protocol.committeeMember.activate), (0, _defineProperty2["default"])(_operationProps, _constants.OPERATIONS_IDS.COMMITTEE_MEMBER_DEACTIVATE, protocol.committeeMember.deactivate), (0, _defineProperty2["default"])(_operationProps, _constants.OPERATIONS_IDS.COMMITTEE_FROZEN_BALANCE_DEPOSIT, protocol.committeeFrozenBalance.deposit), (0, _defineProperty2["default"])(_operationProps, _constants.OPERATIONS_IDS.COMMITTEE_FROZEN_BALANCE_WITHDRAW, protocol.committeeFrozenBalance.withdraw), (0, _defineProperty2["default"])(_operationProps, _constants.OPERATIONS_IDS.VESTING_BALANCE_CREATE, protocol.vesting.balanceCreate), (0, _defineProperty2["default"])(_operationProps, _constants.OPERATIONS_IDS.VESTING_BALANCE_WITHDRAW, protocol.vesting.balanceWithdraw), (0, _defineProperty2["default"])(_operationProps, _constants.OPERATIONS_IDS.BALANCE_CLAIM, protocol.balance.claim), (0, _defineProperty2["default"])(_operationProps, _constants.OPERATIONS_IDS.BALANCE_FREEZE, protocol.balance.freeze), (0, _defineProperty2["default"])(_operationProps, _constants.OPERATIONS_IDS.BALANCE_UNFREEZE, protocol.balance.unfreeze), (0, _defineProperty2["default"])(_operationProps, _constants.OPERATIONS_IDS.REQUEST_BALANCE_UNFREEZE, protocol.balance.requestUnfreeze), (0, _defineProperty2["default"])(_operationProps, _constants.OPERATIONS_IDS.OVERRIDE_TRANSFER, protocol.transfer.override), (0, _defineProperty2["default"])(_operationProps, _constants.OPERATIONS_IDS.ASSET_CLAIM_FEES, protocol.asset.claimFees), (0, _defineProperty2["default"])(_operationProps, _constants.OPERATIONS_IDS.CONTRACT_CREATE, protocol.contract.create), (0, _defineProperty2["default"])(_operationProps, _constants.OPERATIONS_IDS.CONTRACT_CALL, protocol.contract.call), (0, _defineProperty2["default"])(_operationProps, _constants.OPERATIONS_IDS.CONTRACT_INTERNAL_CREATE, protocol.contract.internalCreate), (0, _defineProperty2["default"])(_operationProps, _constants.OPERATIONS_IDS.CONTRACT_INTERNAL_CALL, protocol.contract.internalCall), (0, _defineProperty2["default"])(_operationProps, _constants.OPERATIONS_IDS.CONTRACT_SELFDESTRUCT, protocol.contract.selfdestruct), (0, _defineProperty2["default"])(_operationProps, _constants.OPERATIONS_IDS.CONTRACT_UPDATE, protocol.contract.update), (0, _defineProperty2["default"])(_operationProps, _constants.OPERATIONS_IDS.ACCOUNT_ADDRESS_CREATE, protocol.account.addressCreate), (0, _defineProperty2["default"])(_operationProps, _constants.OPERATIONS_IDS.TRANSFER_TO_ADDRESS, protocol.transfer.toAddress), (0, _defineProperty2["default"])(_operationProps, _constants.OPERATIONS_IDS.SIDECHAIN_ISSUE, protocol.sidechain.issue), (0, _defineProperty2["default"])(_operationProps, _constants.OPERATIONS_IDS.SIDECHAIN_BURN, protocol.sidechain.burn), (0, _defineProperty2["default"])(_operationProps, _constants.OPERATIONS_IDS.SIDECHAIN_ETH_SPV_CREATE, protocol.sidechain.eth.spvCreate), (0, _defineProperty2["default"])(_operationProps, _constants.OPERATIONS_IDS.SIDECHAIN_ETH_SPV_ADD_MISSED_TX_RECEIPT, protocol.sidechain.eth.spvAddMissedTxReceipt), (0, _defineProperty2["default"])(_operationProps, _constants.OPERATIONS_IDS.SIDECHAIN_ETH_CREATE_ADDRESS, protocol.sidechain.eth.createAddress), (0, _defineProperty2["default"])(_operationProps, _constants.OPERATIONS_IDS.SIDECHAIN_ETH_APPROVE_ADDRESS, protocol.sidechain.eth.approveAddress), (0, _defineProperty2["default"])(_operationProps, _constants.OPERATIONS_IDS.SIDECHAIN_ETH_DEPOSIT, protocol.sidechain.eth.deposit), (0, _defineProperty2["default"])(_operationProps, _constants.OPERATIONS_IDS.SIDECHAIN_ETH_SEND_DEPOSIT, protocol.sidechain.eth.sendDeposit), (0, _defineProperty2["default"])(_operationProps, _constants.OPERATIONS_IDS.SIDECHAIN_ETH_WITHDRAW, protocol.sidechain.eth.withdraw), (0, _defineProperty2["default"])(_operationProps, _constants.OPERATIONS_IDS.SIDECHAIN_ETH_SEND_WITHDRAW, protocol.sidechain.eth.sendWithdraw), (0, _defineProperty2["default"])(_operationProps, _constants.OPERATIONS_IDS.SIDECHAIN_ETH_APPROVE_WITHDRAW, protocol.sidechain.eth.approveWithdraw), (0, _defineProperty2["default"])(_operationProps, _constants.OPERATIONS_IDS.SIDECHAIN_ETH_UPDATE_CONTRACT_ADDRESS, protocol.sidechain.eth.updateContractAddress), (0, _defineProperty2["default"])(_operationProps, _constants.OPERATIONS_IDS.CONTRACT_FUND_POOL, protocol.contract.fundPool), (0, _defineProperty2["default"])(_operationProps, _constants.OPERATIONS_IDS.CONTRACT_WHITELIST, protocol.contract.whitelist), (0, _defineProperty2["default"])(_operationProps, _constants.OPERATIONS_IDS.SIDECHAIN_ERC20_REGISTER_CONTRACT_OPERATION, protocol.sidechain.erc20.registerContractOperation), (0, _defineProperty2["default"])(_operationProps, _constants.OPERATIONS_IDS.SIDECHAIN_ERC20_REGISTER_TOKEN, protocol.sidechain.erc20.registerToken), (0, _defineProperty2["default"])(_operationProps, _constants.OPERATIONS_IDS.SIDECHAIN_ERC20_DEPOSIT_TOKEN, protocol.sidechain.erc20.depositToken), (0, _defineProperty2["default"])(_operationProps, _constants.OPERATIONS_IDS.SIDECHAIN_ERC20_SEND_DEPOSIT_TOKEN, protocol.sidechain.erc20.sendDepositToken), (0, _defineProperty2["default"])(_operationProps, _constants.OPERATIONS_IDS.SIDECHAIN_ERC20_WITHDRAW_TOKEN, protocol.sidechain.erc20.withdrawToken), (0, _defineProperty2["default"])(_operationProps, _constants.OPERATIONS_IDS.SIDECHAIN_ERC20_SEND_WITHDRAW_TOKEN, protocol.sidechain.erc20.sendWithdrawToken), (0, _defineProperty2["default"])(_operationProps, _constants.OPERATIONS_IDS.SIDECHAIN_ERC20_APPROVE_TOKEN_WITHDRAW, protocol.sidechain.erc20.approveTokenWithdraw), (0, _defineProperty2["default"])(_operationProps, _constants.OPERATIONS_IDS.SIDECHAIN_ERC20_ISSUE, protocol.sidechain.erc20.issue), (0, _defineProperty2["default"])(_operationProps, _constants.OPERATIONS_IDS.SIDECHAIN_ERC20_BURN, protocol.sidechain.erc20.burn), (0, _defineProperty2["default"])(_operationProps, _constants.OPERATIONS_IDS.SIDECHAIN_ERC20_TRANSFER_ASSET, protocol.sidechain.erc20.transferAsset), (0, _defineProperty2["default"])(_operationProps, _constants.OPERATIONS_IDS.SIDECHAIN_BTC_CREATE_ADDRESS, protocol.sidechain.btc.createAddress), (0, _defineProperty2["default"])(_operationProps, _constants.OPERATIONS_IDS.SIDECHAIN_BTC_DEPOSIT, protocol.sidechain.btc.deposit), (0, _defineProperty2["default"])(_operationProps, _constants.OPERATIONS_IDS.SIDECHAIN_BTC_WITHDRAW, protocol.sidechain.btc.withdraw), (0, _defineProperty2["default"])(_operationProps, _constants.OPERATIONS_IDS.SIDECHAIN_BTC_AGGREGATE, protocol.sidechain.btc.aggregate), (0, _defineProperty2["default"])(_operationProps, _constants.OPERATIONS_IDS.SIDECHAIN_BTC_APPROVE_AGGREGATE, protocol.sidechain.btc.approveAggregate), (0, _defineProperty2["default"])(_operationProps, _constants.OPERATIONS_IDS.SIDECHAIN_BTC_SPV_CREATE, protocol.sidechain.btc.spvCreate), (0, _defineProperty2["default"])(_operationProps, _constants.OPERATIONS_IDS.SIDECHAIN_BTC_SPV_ADD_MISSED_TX_RECEIPT, protocol.sidechain.btc.spvAddMissedTxReceipt), (0, _defineProperty2["default"])(_operationProps, _constants.OPERATIONS_IDS.SIDECHAIN_SPV_EXCHANGE_EXCESS_FUNDS, protocol.sidechain.spvExchangeExcessFunds), (0, _defineProperty2["default"])(_operationProps, _constants.OPERATIONS_IDS.SIDECHAIN_STAKE_ETH_UPDATE, protocol.sidechain.eth.stakeUpdate), (0, _defineProperty2["default"])(_operationProps, _constants.OPERATIONS_IDS.SIDECHAIN_BTC_CREATE_STAKE_SCRIPT, protocol.sidechain.btc.createStakeScript), (0, _defineProperty2["default"])(_operationProps, _constants.OPERATIONS_IDS.SIDECHAIN_STAKE_BTC_UPDATE, protocol.sidechain.btc.stakeUpdate), (0, _defineProperty2["default"])(_operationProps, _constants.OPERATIONS_IDS.BLOCK_REWARD, protocol.blockReward), (0, _defineProperty2["default"])(_operationProps, _constants.OPERATIONS_IDS.EVM_ADDRESS_REGISTER, protocol.evmAddress), (0, _defineProperty2["default"])(_operationProps, _constants.OPERATIONS_IDS.DID_CREATE_OPERATION, protocol.did.create), (0, _defineProperty2["default"])(_operationProps, _constants.OPERATIONS_IDS.DID_UPDATE_OPERATION, protocol.did.update), (0, _defineProperty2["default"])(_operationProps, _constants.OPERATIONS_IDS.DID_DELETE_OPERATION, protocol.did["delete"]), _operationProps);
var operationSerializer = (0, _collections.staticVariant)(operationProps);
/** @augments {ISerializer<any, any>} */

var OperationSerializer = /*#__PURE__*/function (_ISerializer) {
  (0, _inherits2["default"])(OperationSerializer, _ISerializer);

  var _super = _createSuper(OperationSerializer);

  function OperationSerializer() {
    (0, _classCallCheck2["default"])(this, OperationSerializer);
    return _super.apply(this, arguments);
  }

  (0, _createClass2["default"])(OperationSerializer, [{
    key: "toRaw",
    value:
    /**
     * @param {any} value
     * @param {boolean} withUnrequiredFee
     */
    function toRaw(value, withUnrequiredFee) {
      var input = value;

      if (withUnrequiredFee) {
        input[1] = _objectSpread(_objectSpread({}, input[1]), {}, {
          fee: _objectSpread({
            asset_id: _constants.ECHO_ASSET_ID,
            amount: 0
          }, input[1].fee)
        });
      }

      return operationSerializer.toRaw(input);
    }
    /**
     * @param {any} value
     * @param {ByteBuffer} bytebuffer
     */

  }, {
    key: "appendToByteBuffer",
    value: function appendToByteBuffer(value, bytebuffer) {
      return operationSerializer.appendToByteBuffer(value, bytebuffer);
    }
    /**
     * @param {Buffer} buffer
     * @param {number} [offset]
     * @returns {{ res: any, newOffset: number }}
     */

  }, {
    key: "readFromBuffer",
    value: function readFromBuffer(buffer) {
      var offset = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : 0;
      return operationSerializer.readFromBuffer(buffer, offset);
    }
  }]);
  return OperationSerializer;
}(_ISerializer2["default"]);

exports["default"] = OperationSerializer;