"use strict";

var _Object$defineProperty = require("@babel/runtime-corejs3/core-js-stable/object/define-property");

var _interopRequireDefault = require("@babel/runtime-corejs3/helpers/interopRequireDefault");

_Object$defineProperty(exports, "__esModule", {
  value: true
});

exports.sidechainFinesSerializer = exports.sidechainERC20ConfigSerializer = exports.sidechainConfigSerializer = exports.ethTopicSerializer = exports.ethMethodSerializer = void 0;

var _collections = require("../../collections");

var _basic = require("../../basic");

var _integers = require("../../basic/integers");

var _ethAddress = _interopRequireDefault(require("../../protocol/ethAddress"));

var _protocol = require("../../chain/id/protocol");

var ethMethodSerializer = (0, _collections.struct)({
  method: _basic.string,
  gas: _integers.uint64
});
exports.ethMethodSerializer = ethMethodSerializer;
var ethTopicSerializer = (0, _basic.bytes)(64);
exports.ethTopicSerializer = ethTopicSerializer;
var sidechainFinesSerializer = (0, _collections.struct)({
  generate_eth_address: _integers.int64
});
exports.sidechainFinesSerializer = sidechainFinesSerializer;
var sidechainConfigSerializer = (0, _collections.struct)({
  eth_contract_address: _ethAddress["default"],
  eth_committee_update_method: ethMethodSerializer,
  eth_gen_address_method: ethMethodSerializer,
  eth_withdraw_method: ethMethodSerializer,
  eth_update_addr_method: ethMethodSerializer,
  eth_update_contract_address: ethMethodSerializer,
  eth_withdraw_token_method: ethMethodSerializer,
  eth_collect_tokens_method: ethMethodSerializer,
  eth_committee_updated_topic: ethTopicSerializer,
  eth_gen_address_topic: ethTopicSerializer,
  eth_deposit_topic: ethTopicSerializer,
  eth_withdraw_topic: ethTopicSerializer,
  erc20_deposit_topic: ethTopicSerializer,
  erc20_withdraw_topic: ethTopicSerializer,
  ETH_asset_id: _protocol.assetId,
  BTC_asset_id: _protocol.assetId,
  fines: sidechainFinesSerializer,
  gas_price: _integers.uint64,
  satoshis_per_byte: _integers.uint32,
  coefficient_waiting_blocks: _integers.uint32,
  btc_deposit_withdrawal_min: _integers.uint64,
  btc_deposit_withdrawal_fee: _integers.uint64,
  eth_blocks_lag: _integers.uint32,
  eth_withdrawal_fee: _integers.uint64,
  eth_withdrawal_min: _integers.uint64,
  london_fork_block: _integers.uint256,
  muir_glacier_fork_block: _integers.uint256,
  constantinople_fork_block: _integers.uint256,
  byzantium_fork_block: _integers.uint256,
  homestead_fork_block: _integers.uint256,
  difficulty_duration_limit: _integers.uint256,
  difficulty_bound_divisor: _integers.uint256,
  minimum_difficulty: _integers.uint256
});
exports.sidechainConfigSerializer = sidechainConfigSerializer;
var sidechainERC20ConfigSerializer = (0, _collections.struct)({
  create_token_fee: _integers.uint64,
  transfer_topic: ethTopicSerializer,
  check_balance_method: ethMethodSerializer,
  burn_method: ethMethodSerializer,
  issue_method: ethMethodSerializer
});
exports.sidechainERC20ConfigSerializer = sidechainERC20ConfigSerializer;