"use strict";

var _Reflect$construct = require("@babel/runtime-corejs3/core-js-stable/reflect/construct");

var _Object$defineProperty = require("@babel/runtime-corejs3/core-js-stable/object/define-property");

var _interopRequireDefault = require("@babel/runtime-corejs3/helpers/interopRequireDefault");

_Object$defineProperty(exports, "__esModule", {
  value: true
});

exports["default"] = void 0;

var _map = _interopRequireDefault(require("@babel/runtime-corejs3/core-js-stable/instance/map"));

var _parseInt = _interopRequireDefault(require("@babel/runtime-corejs3/core-js-stable/number/parse-int"));

var _concat = _interopRequireDefault(require("@babel/runtime-corejs3/core-js-stable/instance/concat"));

var _typeof2 = _interopRequireDefault(require("@babel/runtime-corejs3/helpers/typeof"));

var _slicedToArray2 = _interopRequireDefault(require("@babel/runtime-corejs3/helpers/slicedToArray"));

var _classCallCheck2 = _interopRequireDefault(require("@babel/runtime-corejs3/helpers/classCallCheck"));

var _createClass2 = _interopRequireDefault(require("@babel/runtime-corejs3/helpers/createClass"));

var _inherits2 = _interopRequireDefault(require("@babel/runtime-corejs3/helpers/inherits"));

var _possibleConstructorReturn2 = _interopRequireDefault(require("@babel/runtime-corejs3/helpers/possibleConstructorReturn"));

var _getPrototypeOf2 = _interopRequireDefault(require("@babel/runtime-corejs3/helpers/getPrototypeOf"));

var _integers = require("../basic/integers");

var _ISerializer2 = _interopRequireDefault(require("../ISerializer"));

var _validators = require("../../utils/validators");

function _createSuper(Derived) { var hasNativeReflectConstruct = _isNativeReflectConstruct(); return function _createSuperInternal() { var Super = (0, _getPrototypeOf2["default"])(Derived), result; if (hasNativeReflectConstruct) { var NewTarget = (0, _getPrototypeOf2["default"])(this).constructor; result = _Reflect$construct(Super, arguments, NewTarget); } else { result = Super.apply(this, arguments); } return (0, _possibleConstructorReturn2["default"])(this, result); }; }

function _isNativeReflectConstruct() { if (typeof Reflect === "undefined" || !_Reflect$construct) return false; if (_Reflect$construct.sham) return false; if (typeof Proxy === "function") return true; try { Boolean.prototype.valueOf.call(_Reflect$construct(Boolean, [], function () {})); return true; } catch (e) { return false; } }

/** @typedef {import("bytebuffer")} ByteBuffer */

/** @typedef {string | { type: number, id: number }} TInput */

/** @typedef {string} TOutput */

/** @augments {ISerializer<TInput, TOutput>} */
var VoteIdSerializer = /*#__PURE__*/function (_ISerializer) {
  (0, _inherits2["default"])(VoteIdSerializer, _ISerializer);

  var _super = _createSuper(VoteIdSerializer);

  function VoteIdSerializer() {
    (0, _classCallCheck2["default"])(this, VoteIdSerializer);
    return _super.apply(this, arguments);
  }

  (0, _createClass2["default"])(VoteIdSerializer, [{
    key: "toRaw",
    value:
    /**
     * @param {TInput} value
     * @returns {TOutput}
     */
    function toRaw(value) {
      var _context2;

      if (typeof value === 'string') {
        var _context;

        if (!/^\d+:\d+$/.test(value)) throw new Error('invalid voteId format');

        var _value$split$map = (0, _map["default"])(_context = value.split(':')).call(_context, function (str) {
          return (0, _parseInt["default"])(str, 10);
        }),
            _value$split$map2 = (0, _slicedToArray2["default"])(_value$split$map, 2),
            _type = _value$split$map2[0],
            _id = _value$split$map2[1];

        value = {
          type: _type,
          id: _id
        };
      } else if ((0, _typeof2["default"])(value) !== 'object' || value === null) throw new Error('invalid voteId type');

      var _value = value,
          type = _value.type,
          id = _value.id;
      (0, _validators.validateUnsignedSafeInteger)(type, 'vote type');
      (0, _validators.validateUnsignedSafeInteger)(id, 'vote id');
      if (type > 0xff) throw new Error('invalid type');
      if (id > 0xffffff) throw new Error('invalid id');
      return (0, _concat["default"])(_context2 = "".concat(type, ":")).call(_context2, id);
    }
    /**
     * @param {TInput} value
     * @param {ByteBuffer} bytebuffer
     */

  }, {
    key: "appendToByteBuffer",
    value: function appendToByteBuffer(value, bytebuffer) {
      var _context3;

      var _this$toRaw$split$map = (0, _map["default"])(_context3 = this.toRaw(value).split(':')).call(_context3, function (str) {
        return (0, _parseInt["default"])(str, 10);
      }),
          _this$toRaw$split$map2 = (0, _slicedToArray2["default"])(_this$toRaw$split$map, 2),
          type = _this$toRaw$split$map2[0],
          id = _this$toRaw$split$map2[1]; // eslint-disable-next-line no-bitwise


      _integers.uint32.appendToByteBuffer(id << 8 | type, bytebuffer);
    }
    /**
     * @param {Buffer} buffer
     * @param {number} [offset]
     * @returns {{ res: TOutput, newOffset: number }}
     */

  }, {
    key: "readFromBuffer",
    value: function readFromBuffer(buffer) {
      var offset = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : 0;

      var _uint32$readFromBuffe = _integers.uint32.readFromBuffer(buffer, offset),
          num = _uint32$readFromBuffe.res,
          newOffset = _uint32$readFromBuffe.newOffset; // eslint-disable-next-line no-bitwise


      var type = num % 0x100,
          id = num >> 8;
      return {
        res: this.toRaw({
          type: type,
          id: id
        }),
        newOffset: newOffset
      };
    }
  }]);
  return VoteIdSerializer;
}(_ISerializer2["default"]);

exports["default"] = VoteIdSerializer;