"use strict";

var _typeof = require("@babel/runtime-corejs3/helpers/typeof");

var _WeakMap = require("@babel/runtime-corejs3/core-js-stable/weak-map");

var _Object$defineProperty = require("@babel/runtime-corejs3/core-js-stable/object/define-property");

var _Object$getOwnPropertyDescriptor = require("@babel/runtime-corejs3/core-js-stable/object/get-own-property-descriptor");

var _interopRequireDefault = require("@babel/runtime-corejs3/helpers/interopRequireDefault");

_Object$defineProperty(exports, "__esModule", {
  value: true
});

_Object$defineProperty(exports, "ACCOUNT_LISTING", {
  enumerable: true,
  get: function get() {
    return _account_listing.ACCOUNT_LISTING;
  }
});

_Object$defineProperty(exports, "AccountListingSerializer", {
  enumerable: true,
  get: function get() {
    return _account_listing["default"];
  }
});

exports.accountWhitelistOperationPropsSerializer = exports.accountUpdateOperationPropsSerializer = exports.accountOptionsSerializer = exports.accountListing = exports.accountCreateOperationPropsSerializer = exports.accountAddressCreateOperationPropsSerializer = void 0;

var _account_listing = _interopRequireWildcard(require("./account_listing"));

var _authority = _interopRequireDefault(require("../authority"));

var _basic = require("../../basic");

var _integers = require("../../basic/integers");

var _chain = require("../../chain");

var _protocol = require("../../chain/id/protocol");

var _collections = require("../../collections");

var _ethAddress = _interopRequireDefault(require("../ethAddress"));

function _getRequireWildcardCache(nodeInterop) { if (typeof _WeakMap !== "function") return null; var cacheBabelInterop = new _WeakMap(); var cacheNodeInterop = new _WeakMap(); return (_getRequireWildcardCache = function _getRequireWildcardCache(nodeInterop) { return nodeInterop ? cacheNodeInterop : cacheBabelInterop; })(nodeInterop); }

function _interopRequireWildcard(obj, nodeInterop) { if (!nodeInterop && obj && obj.__esModule) { return obj; } if (obj === null || _typeof(obj) !== "object" && typeof obj !== "function") { return { "default": obj }; } var cache = _getRequireWildcardCache(nodeInterop); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = _Object$defineProperty && _Object$getOwnPropertyDescriptor; for (var key in obj) { if (key !== "default" && Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? _Object$getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { _Object$defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj["default"] = obj; if (cache) { cache.set(obj, newObj); } return newObj; }

var accountListing = new _account_listing["default"]();
exports.accountListing = accountListing;
var accountOptionsSerializer = (0, _collections.struct)({
  delegating_account: _protocol.accountId,
  delegate_share: _integers.uint16,
  extensions: _chain.extensions
});
exports.accountOptionsSerializer = accountOptionsSerializer;
var accountCreateOperationPropsSerializer = (0, _collections.struct)({
  fee: _chain.asset,
  registrar: _protocol.accountId,
  name: _basic.string,
  active: _authority["default"],
  echorand_key: _chain.publicKey,
  evm_address: (0, _collections.optional)(_ethAddress["default"]),
  options: accountOptionsSerializer,
  // TODO: extensions serializer
  extensions: _chain.accountOperationsExtensionsSerializer
});
exports.accountCreateOperationPropsSerializer = accountCreateOperationPropsSerializer;
var accountUpdateOperationPropsSerializer = (0, _collections.struct)({
  fee: _chain.asset,
  account: _protocol.accountId,
  active: (0, _collections.optional)(_authority["default"]),
  echorand_key: (0, _collections.optional)(_chain.publicKey),
  new_options: (0, _collections.optional)(accountOptionsSerializer),
  // TODO: extensions serializer
  extensions: _chain.accountOperationsExtensionsSerializer
});
exports.accountUpdateOperationPropsSerializer = accountUpdateOperationPropsSerializer;
var accountWhitelistOperationPropsSerializer = (0, _collections.struct)({
  fee: _chain.asset,
  authorizing_account: _protocol.accountId,
  account_to_list: _protocol.accountId,
  new_listing: _integers.uint8,
  extensions: _chain.extensions
});
exports.accountWhitelistOperationPropsSerializer = accountWhitelistOperationPropsSerializer;
var accountAddressCreateOperationPropsSerializer = (0, _collections.struct)({
  fee: _chain.asset,
  owner: _protocol.accountId,
  label: _basic.string,
  extensions: _chain.extensions
});
exports.accountAddressCreateOperationPropsSerializer = accountAddressCreateOperationPropsSerializer;