"use strict";

var _Object$defineProperty = require("@babel/runtime-corejs3/core-js-stable/object/define-property");

_Object$defineProperty(exports, "__esModule", {
  value: true
});

exports.priceSerializer = exports.priceFeedSerializer = exports.bitassetOptionsSerializer = exports.assetUpdateOperationPropsSerializer = exports.assetUpdateFeedProducersOperationPropsSerializer = exports.assetUpdateBitassetOperationPropsSerializer = exports.assetReserveOperationPropsSerializer = exports.assetPublishFeedOperationPropsSerializer = exports.assetOptionsSerializer = exports.assetIssueOperationPropsSerializer = exports.assetFundFeePoolOperationPropsSerializer = exports.assetCreateOperationPropsSerializer = exports.assetClaimFeesOperationPropsSerializer = void 0;

var _collections = require("../collections");

var _chain = require("../chain");

var _protocol = require("../chain/id/protocol");

var _basic = require("../basic");

var _integers = require("../basic/integers");

var priceSerializer = (0, _collections.struct)({
  base: _chain.asset,
  quote: _chain.asset
});
exports.priceSerializer = priceSerializer;
var assetOptionsSerializer = (0, _collections.struct)({
  max_supply: _integers.int64,
  issuer_permissions: _integers.uint16,
  flags: _integers.uint16,
  core_exchange_rate: priceSerializer,
  whitelist_authorities: (0, _collections.set)(_protocol.accountId),
  blacklist_authorities: (0, _collections.set)(_protocol.accountId),
  description: _basic.string,
  extensions: _chain.extensions
});
exports.assetOptionsSerializer = assetOptionsSerializer;
var bitassetOptionsSerializer = (0, _collections.struct)({
  feed_lifetime_sec: _integers.uint32,
  minimum_feeds: _integers.uint8,
  short_backing_asset: _protocol.assetId,
  extensions: _chain.extensions
});
exports.bitassetOptionsSerializer = bitassetOptionsSerializer;
var assetCreateOperationPropsSerializer = (0, _collections.struct)({
  fee: _chain.asset,
  issuer: _protocol.accountId,
  symbol: _basic.string,
  precision: _integers.uint8,
  common_options: assetOptionsSerializer,
  bitasset_options: (0, _collections.optional)(bitassetOptionsSerializer),
  extensions: _chain.extensions
});
exports.assetCreateOperationPropsSerializer = assetCreateOperationPropsSerializer;
var assetUpdateOperationPropsSerializer = (0, _collections.struct)({
  fee: _chain.asset,
  issuer: _protocol.accountId,
  asset_to_update: _protocol.assetId,
  new_issuer: (0, _collections.optional)(_protocol.accountId),
  new_options: (0, _collections.optional)(assetOptionsSerializer),
  extensions: _chain.extensions
});
exports.assetUpdateOperationPropsSerializer = assetUpdateOperationPropsSerializer;
var assetUpdateBitassetOperationPropsSerializer = (0, _collections.struct)({
  fee: _chain.asset,
  issuer: _protocol.accountId,
  asset_to_update: _protocol.assetId,
  new_options: bitassetOptionsSerializer,
  extensions: _chain.extensions
});
exports.assetUpdateBitassetOperationPropsSerializer = assetUpdateBitassetOperationPropsSerializer;
var assetUpdateFeedProducersOperationPropsSerializer = (0, _collections.struct)({
  fee: _chain.asset,
  issuer: _protocol.accountId,
  asset_to_update: _protocol.assetId,
  new_feed_producers: (0, _collections.set)(_protocol.accountId),
  extensions: _chain.extensions
});
exports.assetUpdateFeedProducersOperationPropsSerializer = assetUpdateFeedProducersOperationPropsSerializer;
var assetIssueOperationPropsSerializer = (0, _collections.struct)({
  fee: _chain.asset,
  issuer: _protocol.accountId,
  asset_to_issue: _chain.asset,
  issue_to_account: _protocol.accountId,
  extensions: _chain.extensions
});
exports.assetIssueOperationPropsSerializer = assetIssueOperationPropsSerializer;
var assetReserveOperationPropsSerializer = (0, _collections.struct)({
  fee: _chain.asset,
  payer: _protocol.accountId,
  amount_to_reserve: _chain.asset,
  extensions: _chain.extensions
});
exports.assetReserveOperationPropsSerializer = assetReserveOperationPropsSerializer;
var assetFundFeePoolOperationPropsSerializer = (0, _collections.struct)({
  fee: _chain.asset,
  from_account: _protocol.accountId,
  asset_id: _protocol.assetId,
  amount: _integers.int64,
  extensions: _chain.extensions
});
exports.assetFundFeePoolOperationPropsSerializer = assetFundFeePoolOperationPropsSerializer;
var priceFeedSerializer = (0, _collections.struct)({
  settlement_price: priceSerializer,
  core_exchange_rate: priceSerializer,
  maintenance_collateral_ratio: _integers.uint16,
  maximum_short_squeeze_ratio: _integers.uint16
});
exports.priceFeedSerializer = priceFeedSerializer;
var assetPublishFeedOperationPropsSerializer = (0, _collections.struct)({
  fee: _chain.asset,
  publisher: _protocol.accountId,
  asset_id: _protocol.assetId,
  core_exchange_rate: priceSerializer,
  extensions: _chain.extensions
});
exports.assetPublishFeedOperationPropsSerializer = assetPublishFeedOperationPropsSerializer;
var assetClaimFeesOperationPropsSerializer = (0, _collections.struct)({
  fee: _chain.asset,
  issuer: _protocol.accountId,
  amount_to_claim: _chain.asset,
  extensions: _chain.extensions
});
exports.assetClaimFeesOperationPropsSerializer = assetClaimFeesOperationPropsSerializer;