"use strict";

var _Object$defineProperty = require("@babel/runtime-corejs3/core-js-stable/object/define-property");

_Object$defineProperty(exports, "__esModule", {
  value: true
});

exports.requestBalanceUnfreezeOperation = exports.balanceUnfreezeOperationPropsSerializer = exports.balanceFreezeOperationPropsSerializer = exports.balanceClaimOperationPropsSerializer = void 0;

var _chain = require("../chain");

var _protocol = require("../chain/id/protocol");

var _collections = require("../collections");

var _integers = require("../basic/integers");

var balanceClaimOperationPropsSerializer = (0, _collections.struct)({
  fee: _chain.asset,
  deposit_to_account: _protocol.accountId,
  balance_to_claim: _protocol.balanceId,
  balance_owner_key: _chain.publicKey,
  total_claimed: _chain.asset,
  extensions: _chain.extensions
});
exports.balanceClaimOperationPropsSerializer = balanceClaimOperationPropsSerializer;
var balanceFreezeOperationPropsSerializer = (0, _collections.struct)({
  fee: _chain.asset,
  account: _protocol.accountId,
  amount: _chain.asset,
  duration: _integers.uint16,
  extensions: _chain.extensions
});
exports.balanceFreezeOperationPropsSerializer = balanceFreezeOperationPropsSerializer;
var balanceUnfreezeOperationPropsSerializer = (0, _collections.struct)({
  fee: _chain.asset,
  account: _protocol.accountId,
  amount: _chain.asset,
  extensions: _chain.extensions
});
exports.balanceUnfreezeOperationPropsSerializer = balanceUnfreezeOperationPropsSerializer;
var requestBalanceUnfreezeOperation = (0, _collections.struct)({
  fee: _chain.asset,
  account: _protocol.accountId,
  objects_to_unfreeze: (0, _collections.vector)(_protocol.frozenBalanceId),
  extensions: _chain.extensions
});
exports.requestBalanceUnfreezeOperation = requestBalanceUnfreezeOperation;