"use strict";

var _typeof = require("@babel/runtime-corejs3/helpers/typeof");

var _mapInstanceProperty = require("@babel/runtime-corejs3/core-js-stable/instance/map");

var _WeakMap = require("@babel/runtime-corejs3/core-js-stable/weak-map");

var _Object$defineProperty = require("@babel/runtime-corejs3/core-js-stable/object/define-property");

var _Object$getOwnPropertyDescriptor = require("@babel/runtime-corejs3/core-js-stable/object/get-own-property-descriptor");

var _interopRequireDefault = require("@babel/runtime-corejs3/helpers/interopRequireDefault");

_Object$defineProperty(exports, "__esModule", {
  value: true
});

exports["default"] = void 0;

var _protocol = require("../chain/id/protocol");

var _collections = require("../collections");

var _fee_schedule = _interopRequireDefault(require("./fee_schedule"));

var _integers = require("../basic/integers");

var _plugins = require("../plugins");

var _chain = require("../chain");

var _penalties = require("../spv/penalties");

var economy = _interopRequireWildcard(require("./economy"));

function _getRequireWildcardCache(nodeInterop) { if (typeof _WeakMap !== "function") return null; var cacheBabelInterop = new _WeakMap(); var cacheNodeInterop = new _WeakMap(); return (_getRequireWildcardCache = function _getRequireWildcardCache(nodeInterop) { return nodeInterop ? cacheNodeInterop : cacheBabelInterop; })(nodeInterop); }

function _interopRequireWildcard(obj, nodeInterop) { if (!nodeInterop && obj && obj.__esModule) { return obj; } if (obj === null || _typeof(obj) !== "object" && typeof obj !== "function") { return { "default": obj }; } var cache = _getRequireWildcardCache(nodeInterop); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = _Object$defineProperty && _Object$getOwnPropertyDescriptor; for (var key in obj) { if (key !== "default" && Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? _Object$getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { _Object$defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj["default"] = obj; if (cache) { cache.set(obj, newObj); } return newObj; }

var chainParametersSerializer = (0, _collections.struct)({
  current_fees: _fee_schedule["default"],
  maintenance_interval: _integers.uint32,
  maintenance_duration_seconds: _integers.uint8,
  balance_unfreezing_time: _integers.uint32,
  committee_proposal_review_period: _integers.uint32,
  maximum_transaction_size: _integers.uint32,
  maximum_block_size: _integers.uint32,
  maximum_time_until_expiration: _integers.uint32,
  maximum_proposal_lifetime: _integers.uint32,
  maximum_asset_whitelist_authorities: _integers.uint8,
  maximum_asset_feed_publishers: _integers.uint8,
  maximum_authority_membership: _integers.uint16,
  max_authority_depth: _integers.uint8,
  committee_frozen_balance_to_activate: _integers.uint64,
  committee_maintenance_intervals_to_deposit: _integers.uint64,
  committee_balance_unfreeze_duration_seconds: _integers.uint32,
  x86_64_maximum_contract_size: _integers.uint64,
  frozen_balances_multipliers: (0, _mapInstanceProperty(_collections))(_integers.uint16, _integers.uint32),
  echorand_config: _plugins.echorand.config,
  sidechain_config: _plugins.sidechain.config,
  erc20_config: _plugins.sidechain.erc20Config,
  gas_price: (0, _collections.struct)({
    price: _integers.uint64,
    gas_amount: _integers.uint64
  }),
  valid_fee_asset: (0, _collections.set)(_protocol.assetId),
  economy_config: economy.config,
  spv_penalties_config: _penalties.spvPenaltiesConfig,
  extensions: _chain.extensions
});
var _default = chainParametersSerializer;
exports["default"] = _default;