"use strict";

var _Object$defineProperty = require("@babel/runtime-corejs3/core-js-stable/object/define-property");

var _interopRequireDefault = require("@babel/runtime-corejs3/helpers/interopRequireDefault");

_Object$defineProperty(exports, "__esModule", {
  value: true
});

exports.committeeMemberUpdateOperationPropsSerializer = exports.committeeMemberUpdateGlobalParametersOperationPropsSerializer = exports.committeeMemberDeactivateOperationPropsSerializer = exports.committeeMemberCreateOperationPropsSerializer = exports.committeeMemberActivateOperationPropsSerializer = void 0;

var _ethAddress = _interopRequireDefault(require("./ethAddress"));

var _btcPublicKey = _interopRequireDefault(require("./btcPublicKey"));

var _basic = require("../basic");

var _chain = require("../chain");

var _protocol = require("../chain/id/protocol");

var _collections = require("../collections");

var _chain_parameters = _interopRequireDefault(require("./chain_parameters"));

var committeeMemberCreateOperationPropsSerializer = (0, _collections.struct)({
  fee: _chain.asset,
  committee_member_account: _protocol.accountId,
  url: _basic.string,
  eth_address: _ethAddress["default"],
  btc_public_key: _btcPublicKey["default"],
  deposit: _chain.asset,
  extensions: _chain.extensions
});
exports.committeeMemberCreateOperationPropsSerializer = committeeMemberCreateOperationPropsSerializer;
var committeeMemberUpdateOperationPropsSerializer = (0, _collections.struct)({
  fee: _chain.asset,
  committee_member: _protocol.committeeMemberId,
  committee_member_account: _protocol.accountId,
  new_url: (0, _collections.optional)(_basic.string),
  new_eth_address: (0, _collections.optional)(_ethAddress["default"]),
  new_btc_public_key: (0, _collections.optional)(_btcPublicKey["default"]),
  extensions: _chain.extensions
});
exports.committeeMemberUpdateOperationPropsSerializer = committeeMemberUpdateOperationPropsSerializer;
var committeeMemberUpdateGlobalParametersOperationPropsSerializer = (0, _collections.struct)({
  fee: _chain.asset,
  new_parameters: _chain_parameters["default"],
  extensions: _chain.extensions
});
exports.committeeMemberUpdateGlobalParametersOperationPropsSerializer = committeeMemberUpdateGlobalParametersOperationPropsSerializer;
var committeeMemberActivateOperationPropsSerializer = (0, _collections.struct)({
  fee: _chain.asset,
  committee_to_activate: _protocol.committeeMemberId,
  extensions: _chain.extensions
});
exports.committeeMemberActivateOperationPropsSerializer = committeeMemberActivateOperationPropsSerializer;
var committeeMemberDeactivateOperationPropsSerializer = (0, _collections.struct)({
  fee: _chain.asset,
  committee_to_deactivate: _protocol.committeeMemberId,
  extensions: _chain.extensions
});
exports.committeeMemberDeactivateOperationPropsSerializer = committeeMemberDeactivateOperationPropsSerializer;