"use strict";

var _Object$keys = require("@babel/runtime-corejs3/core-js-stable/object/keys");

var _Object$getOwnPropertySymbols = require("@babel/runtime-corejs3/core-js-stable/object/get-own-property-symbols");

var _filterInstanceProperty = require("@babel/runtime-corejs3/core-js-stable/instance/filter");

var _Object$getOwnPropertyDescriptor = require("@babel/runtime-corejs3/core-js-stable/object/get-own-property-descriptor");

var _forEachInstanceProperty = require("@babel/runtime-corejs3/core-js-stable/instance/for-each");

var _Object$getOwnPropertyDescriptors = require("@babel/runtime-corejs3/core-js-stable/object/get-own-property-descriptors");

var _Object$defineProperties = require("@babel/runtime-corejs3/core-js-stable/object/define-properties");

var _Object$defineProperty = require("@babel/runtime-corejs3/core-js-stable/object/define-property");

var _interopRequireDefault = require("@babel/runtime-corejs3/helpers/interopRequireDefault");

_Object$defineProperty(exports, "__esModule", {
  value: true
});

exports.contractWhitelistOperationPropsSerializer = exports.contractUpdateOperationPropsSerializer = exports.contractSelfdestructOperationPropsSerializer = exports.contractInternalCreateOperationPropsSerializer = exports.contractInternalCallOperationPropsSerializer = exports.contractFundPoolOperationPropsSerializer = exports.contractCreateOperationPropsSerializer = exports.contractCallOperationPropsSerializer = exports.contractBaseOperationPropsSerializer = void 0;

var _defineProperty2 = _interopRequireDefault(require("@babel/runtime-corejs3/helpers/defineProperty"));

var _basic = require("../basic");

var _chain = require("../chain");

var _protocol = require("../chain/id/protocol");

var _collections = require("../collections");

function ownKeys(object, enumerableOnly) { var keys = _Object$keys(object); if (_Object$getOwnPropertySymbols) { var symbols = _Object$getOwnPropertySymbols(object); if (enumerableOnly) { symbols = _filterInstanceProperty(symbols).call(symbols, function (sym) { return _Object$getOwnPropertyDescriptor(object, sym).enumerable; }); } keys.push.apply(keys, symbols); } return keys; }

function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i] != null ? arguments[i] : {}; if (i % 2) { var _context; _forEachInstanceProperty(_context = ownKeys(Object(source), true)).call(_context, function (key) { (0, _defineProperty2["default"])(target, key, source[key]); }); } else if (_Object$getOwnPropertyDescriptors) { _Object$defineProperties(target, _Object$getOwnPropertyDescriptors(source)); } else { var _context2; _forEachInstanceProperty(_context2 = ownKeys(Object(source))).call(_context2, function (key) { _Object$defineProperty(target, key, _Object$getOwnPropertyDescriptor(source, key)); }); } } return target; }

var contractBaseOperationPropsSerializer = (0, _collections.struct)({
  fee: _chain.asset,
  registrar: _protocol.accountId,
  value: _chain.asset,
  code: _basic.string
});
exports.contractBaseOperationPropsSerializer = contractBaseOperationPropsSerializer;
var contractCreateOperationPropsSerializer = (0, _collections.struct)(_objectSpread(_objectSpread({}, contractBaseOperationPropsSerializer.serializers), {}, {
  supported_asset_id: (0, _collections.optional)(_protocol.assetId),
  eth_accuracy: _basic.bool,
  extensions: _chain.extensions
}));
exports.contractCreateOperationPropsSerializer = contractCreateOperationPropsSerializer;
var contractCallOperationPropsSerializer = (0, _collections.struct)(_objectSpread(_objectSpread({}, contractBaseOperationPropsSerializer.serializers), {}, {
  callee: _protocol.contractId,
  extensions: _chain.extensions
}));
exports.contractCallOperationPropsSerializer = contractCallOperationPropsSerializer;
var contractFundPoolOperationPropsSerializer = (0, _collections.struct)({
  fee: _chain.asset,
  sender: _protocol.accountId,
  contract: _protocol.contractId,
  value: _chain.asset,
  extensions: _chain.extensions
});
exports.contractFundPoolOperationPropsSerializer = contractFundPoolOperationPropsSerializer;
var contractWhitelistOperationPropsSerializer = (0, _collections.struct)({
  fee: _chain.asset,
  sender: _protocol.accountId,
  contract: _protocol.contractId,
  add_to_whitelist: (0, _collections.set)(_protocol.accountId),
  remove_from_whitelist: (0, _collections.set)(_protocol.accountId),
  add_to_blacklist: (0, _collections.set)(_protocol.accountId),
  remove_from_blacklist: (0, _collections.set)(_protocol.accountId),
  extensions: _chain.extensions
});
exports.contractWhitelistOperationPropsSerializer = contractWhitelistOperationPropsSerializer;
var contractUpdateOperationPropsSerializer = (0, _collections.struct)({
  fee: _chain.asset,
  sender: _protocol.accountId,
  contract: _protocol.contractId,
  new_owner: (0, _collections.optional)(_protocol.accountId),
  extensions: _chain.extensions
});
exports.contractUpdateOperationPropsSerializer = contractUpdateOperationPropsSerializer;
var contractInternalCreateOperationPropsSerializer = (0, _collections.struct)({
  fee: _chain.asset,
  caller: _protocol.contractId,
  new_contract: _protocol.contractId,
  value: _chain.asset,
  eth_accuracy: _basic.bool,
  supported_asset_id: (0, _collections.optional)(_protocol.assetId),
  extensions: _chain.extensions
});
exports.contractInternalCreateOperationPropsSerializer = contractInternalCreateOperationPropsSerializer;
var contractInternalCallOperationPropsSerializer = (0, _collections.struct)({
  fee: _chain.asset,
  caller: _protocol.contractId,
  callee: _protocol.accountId,
  method: _basic.string,
  value: _chain.asset,
  extensions: _chain.extensions
});
exports.contractInternalCallOperationPropsSerializer = contractInternalCallOperationPropsSerializer;
var contractSelfdestructOperationPropsSerializer = (0, _collections.struct)({
  fee: _chain.asset,
  contract: _protocol.contractId,
  recipient: _protocol.accountId,
  amounts: (0, _collections.vector)(_chain.asset),
  extensions: _chain.extensions
});
exports.contractSelfdestructOperationPropsSerializer = contractSelfdestructOperationPropsSerializer;