"use strict";

var _Object$defineProperty = require("@babel/runtime-corejs3/core-js-stable/object/define-property");

var _interopRequireDefault = require("@babel/runtime-corejs3/helpers/interopRequireDefault");

_Object$defineProperty(exports, "__esModule", {
  value: true
});

exports.feeParametersWithPricePerKByte = exports.defaultFeeParametersSerializer = exports["default"] = void 0;

var _defineProperty2 = _interopRequireDefault(require("@babel/runtime-corejs3/helpers/defineProperty"));

var _integers = require("../basic/integers");

var _constants = require("../../constants");

var _collections = require("../collections");

var _staticVariant;

var defaultFeeParametersSerializer = (0, _collections.struct)({
  fee: _integers.uint64
});
exports.defaultFeeParametersSerializer = defaultFeeParametersSerializer;
var feeParametersWithPricePerKByte = (0, _collections.struct)({
  fee: _integers.uint64,
  price_per_kbyte: _integers.uint32
});
exports.feeParametersWithPricePerKByte = feeParametersWithPricePerKByte;
var feeParametersSerializer = (0, _collections.staticVariant)((_staticVariant = {}, (0, _defineProperty2["default"])(_staticVariant, _constants.OPERATIONS_IDS.TRANSFER, defaultFeeParametersSerializer), (0, _defineProperty2["default"])(_staticVariant, _constants.OPERATIONS_IDS.TRANSFER_TO_ADDRESS, defaultFeeParametersSerializer), (0, _defineProperty2["default"])(_staticVariant, _constants.OPERATIONS_IDS.OVERRIDE_TRANSFER, defaultFeeParametersSerializer), (0, _defineProperty2["default"])(_staticVariant, _constants.OPERATIONS_IDS.ACCOUNT_CREATE, (0, _collections.struct)({
  basic_fee: _integers.uint64,
  premium_fee: _integers.uint64,
  price_per_kbyte: _integers.uint32
})), (0, _defineProperty2["default"])(_staticVariant, _constants.OPERATIONS_IDS.ACCOUNT_UPDATE, (0, _collections.struct)({
  fee: _integers.int64,
  price_per_kbyte: _integers.uint32
})), (0, _defineProperty2["default"])(_staticVariant, _constants.OPERATIONS_IDS.ACCOUNT_WHITELIST, (0, _collections.struct)({
  fee: _integers.int64
})), (0, _defineProperty2["default"])(_staticVariant, _constants.OPERATIONS_IDS.ACCOUNT_ADDRESS_CREATE, feeParametersWithPricePerKByte), (0, _defineProperty2["default"])(_staticVariant, _constants.OPERATIONS_IDS.ASSET_CREATE, (0, _collections.struct)({
  symbol3: _integers.uint64,
  symbol4: _integers.uint64,
  long_symbol: _integers.uint64,
  price_per_kbyte: _integers.uint32
})), (0, _defineProperty2["default"])(_staticVariant, _constants.OPERATIONS_IDS.ASSET_UPDATE, feeParametersWithPricePerKByte), (0, _defineProperty2["default"])(_staticVariant, _constants.OPERATIONS_IDS.ASSET_UPDATE_BITASSET, defaultFeeParametersSerializer), (0, _defineProperty2["default"])(_staticVariant, _constants.OPERATIONS_IDS.ASSET_UPDATE_FEED_PRODUCERS, defaultFeeParametersSerializer), (0, _defineProperty2["default"])(_staticVariant, _constants.OPERATIONS_IDS.ASSET_ISSUE, defaultFeeParametersSerializer), (0, _defineProperty2["default"])(_staticVariant, _constants.OPERATIONS_IDS.ASSET_RESERVE, defaultFeeParametersSerializer), (0, _defineProperty2["default"])(_staticVariant, _constants.OPERATIONS_IDS.ASSET_FUND_FEE_POOL, defaultFeeParametersSerializer), (0, _defineProperty2["default"])(_staticVariant, _constants.OPERATIONS_IDS.ASSET_PUBLISH_FEED, defaultFeeParametersSerializer), (0, _defineProperty2["default"])(_staticVariant, _constants.OPERATIONS_IDS.ASSET_CLAIM_FEES, defaultFeeParametersSerializer), (0, _defineProperty2["default"])(_staticVariant, _constants.OPERATIONS_IDS.PROPOSAL_CREATE, feeParametersWithPricePerKByte), (0, _defineProperty2["default"])(_staticVariant, _constants.OPERATIONS_IDS.PROPOSAL_UPDATE, feeParametersWithPricePerKByte), (0, _defineProperty2["default"])(_staticVariant, _constants.OPERATIONS_IDS.PROPOSAL_DELETE, defaultFeeParametersSerializer), (0, _defineProperty2["default"])(_staticVariant, _constants.OPERATIONS_IDS.COMMITTEE_MEMBER_CREATE, defaultFeeParametersSerializer), (0, _defineProperty2["default"])(_staticVariant, _constants.OPERATIONS_IDS.COMMITTEE_MEMBER_UPDATE, defaultFeeParametersSerializer), (0, _defineProperty2["default"])(_staticVariant, _constants.OPERATIONS_IDS.COMMITTEE_MEMBER_UPDATE_GLOBAL_PARAMETERS, defaultFeeParametersSerializer), (0, _defineProperty2["default"])(_staticVariant, _constants.OPERATIONS_IDS.COMMITTEE_MEMBER_ACTIVATE, defaultFeeParametersSerializer), (0, _defineProperty2["default"])(_staticVariant, _constants.OPERATIONS_IDS.COMMITTEE_MEMBER_DEACTIVATE, defaultFeeParametersSerializer), (0, _defineProperty2["default"])(_staticVariant, _constants.OPERATIONS_IDS.COMMITTEE_FROZEN_BALANCE_DEPOSIT, defaultFeeParametersSerializer), (0, _defineProperty2["default"])(_staticVariant, _constants.OPERATIONS_IDS.COMMITTEE_FROZEN_BALANCE_WITHDRAW, defaultFeeParametersSerializer), (0, _defineProperty2["default"])(_staticVariant, _constants.OPERATIONS_IDS.VESTING_BALANCE_CREATE, defaultFeeParametersSerializer), (0, _defineProperty2["default"])(_staticVariant, _constants.OPERATIONS_IDS.VESTING_BALANCE_WITHDRAW, defaultFeeParametersSerializer), (0, _defineProperty2["default"])(_staticVariant, _constants.OPERATIONS_IDS.BALANCE_CLAIM, (0, _collections.struct)({})), (0, _defineProperty2["default"])(_staticVariant, _constants.OPERATIONS_IDS.BALANCE_FREEZE, defaultFeeParametersSerializer), (0, _defineProperty2["default"])(_staticVariant, _constants.OPERATIONS_IDS.BALANCE_UNFREEZE, defaultFeeParametersSerializer), (0, _defineProperty2["default"])(_staticVariant, _constants.OPERATIONS_IDS.CONTRACT_CREATE, defaultFeeParametersSerializer), (0, _defineProperty2["default"])(_staticVariant, _constants.OPERATIONS_IDS.CONTRACT_CALL, defaultFeeParametersSerializer), (0, _defineProperty2["default"])(_staticVariant, _constants.OPERATIONS_IDS.CONTRACT_INTERNAL_CREATE, defaultFeeParametersSerializer), (0, _defineProperty2["default"])(_staticVariant, _constants.OPERATIONS_IDS.CONTRACT_INTERNAL_CALL, defaultFeeParametersSerializer), (0, _defineProperty2["default"])(_staticVariant, _constants.OPERATIONS_IDS.CONTRACT_SELFDESTRUCT, defaultFeeParametersSerializer), (0, _defineProperty2["default"])(_staticVariant, _constants.OPERATIONS_IDS.CONTRACT_UPDATE, (0, _collections.struct)({
  fee: _integers.int64
})), (0, _defineProperty2["default"])(_staticVariant, _constants.OPERATIONS_IDS.CONTRACT_FUND_POOL, defaultFeeParametersSerializer), (0, _defineProperty2["default"])(_staticVariant, _constants.OPERATIONS_IDS.CONTRACT_WHITELIST, defaultFeeParametersSerializer), (0, _defineProperty2["default"])(_staticVariant, _constants.OPERATIONS_IDS.SIDECHAIN_ISSUE, defaultFeeParametersSerializer), (0, _defineProperty2["default"])(_staticVariant, _constants.OPERATIONS_IDS.SIDECHAIN_BURN, defaultFeeParametersSerializer), (0, _defineProperty2["default"])(_staticVariant, _constants.OPERATIONS_IDS.SIDECHAIN_ETH_SPV_CREATE, defaultFeeParametersSerializer), (0, _defineProperty2["default"])(_staticVariant, _constants.OPERATIONS_IDS.SIDECHAIN_ETH_SPV_ADD_MISSED_TX_RECEIPT, defaultFeeParametersSerializer), (0, _defineProperty2["default"])(_staticVariant, _constants.OPERATIONS_IDS.SIDECHAIN_ETH_CREATE_ADDRESS, defaultFeeParametersSerializer), (0, _defineProperty2["default"])(_staticVariant, _constants.OPERATIONS_IDS.SIDECHAIN_ETH_APPROVE_ADDRESS, (0, _collections.struct)({})), (0, _defineProperty2["default"])(_staticVariant, _constants.OPERATIONS_IDS.SIDECHAIN_ETH_DEPOSIT, (0, _collections.struct)({})), (0, _defineProperty2["default"])(_staticVariant, _constants.OPERATIONS_IDS.SIDECHAIN_ETH_SEND_DEPOSIT, defaultFeeParametersSerializer), (0, _defineProperty2["default"])(_staticVariant, _constants.OPERATIONS_IDS.SIDECHAIN_ETH_WITHDRAW, defaultFeeParametersSerializer), (0, _defineProperty2["default"])(_staticVariant, _constants.OPERATIONS_IDS.SIDECHAIN_ETH_SEND_WITHDRAW, defaultFeeParametersSerializer), (0, _defineProperty2["default"])(_staticVariant, _constants.OPERATIONS_IDS.SIDECHAIN_ETH_APPROVE_WITHDRAW, (0, _collections.struct)({})), (0, _defineProperty2["default"])(_staticVariant, _constants.OPERATIONS_IDS.SIDECHAIN_ETH_UPDATE_CONTRACT_ADDRESS, defaultFeeParametersSerializer), (0, _defineProperty2["default"])(_staticVariant, _constants.OPERATIONS_IDS.SIDECHAIN_ERC20_REGISTER_CONTRACT_OPERATION, defaultFeeParametersSerializer), (0, _defineProperty2["default"])(_staticVariant, _constants.OPERATIONS_IDS.SIDECHAIN_ERC20_REGISTER_TOKEN, (0, _collections.struct)({
  fee: _integers.uint64,
  pool_fee: _integers.uint64
})), (0, _defineProperty2["default"])(_staticVariant, _constants.OPERATIONS_IDS.SIDECHAIN_ERC20_DEPOSIT_TOKEN, (0, _collections.struct)({})), (0, _defineProperty2["default"])(_staticVariant, _constants.OPERATIONS_IDS.SIDECHAIN_ERC20_SEND_DEPOSIT_TOKEN, defaultFeeParametersSerializer), (0, _defineProperty2["default"])(_staticVariant, _constants.OPERATIONS_IDS.SIDECHAIN_ERC20_WITHDRAW_TOKEN, defaultFeeParametersSerializer), (0, _defineProperty2["default"])(_staticVariant, _constants.OPERATIONS_IDS.SIDECHAIN_ERC20_SEND_WITHDRAW_TOKEN, defaultFeeParametersSerializer), (0, _defineProperty2["default"])(_staticVariant, _constants.OPERATIONS_IDS.SIDECHAIN_ERC20_APPROVE_TOKEN_WITHDRAW, (0, _collections.struct)({})), (0, _defineProperty2["default"])(_staticVariant, _constants.OPERATIONS_IDS.SIDECHAIN_ERC20_ISSUE, (0, _collections.struct)({})), (0, _defineProperty2["default"])(_staticVariant, _constants.OPERATIONS_IDS.SIDECHAIN_ERC20_BURN, (0, _collections.struct)({})), (0, _defineProperty2["default"])(_staticVariant, _constants.OPERATIONS_IDS.SIDECHAIN_ERC20_TRANSFER_ASSET, defaultFeeParametersSerializer), (0, _defineProperty2["default"])(_staticVariant, _constants.OPERATIONS_IDS.SIDECHAIN_BTC_CREATE_ADDRESS, defaultFeeParametersSerializer), (0, _defineProperty2["default"])(_staticVariant, _constants.OPERATIONS_IDS.SIDECHAIN_BTC_DEPOSIT, defaultFeeParametersSerializer), (0, _defineProperty2["default"])(_staticVariant, _constants.OPERATIONS_IDS.SIDECHAIN_BTC_WITHDRAW, defaultFeeParametersSerializer), (0, _defineProperty2["default"])(_staticVariant, _constants.OPERATIONS_IDS.SIDECHAIN_BTC_AGGREGATE, defaultFeeParametersSerializer), (0, _defineProperty2["default"])(_staticVariant, _constants.OPERATIONS_IDS.SIDECHAIN_BTC_APPROVE_AGGREGATE, defaultFeeParametersSerializer), (0, _defineProperty2["default"])(_staticVariant, _constants.OPERATIONS_IDS.SIDECHAIN_BTC_SPV_CREATE, defaultFeeParametersSerializer), (0, _defineProperty2["default"])(_staticVariant, _constants.OPERATIONS_IDS.SIDECHAIN_BTC_SPV_ADD_MISSED_TX_RECEIPT, defaultFeeParametersSerializer), (0, _defineProperty2["default"])(_staticVariant, _constants.OPERATIONS_IDS.SIDECHAIN_SPV_EXCHANGE_EXCESS_FUNDS, defaultFeeParametersSerializer), (0, _defineProperty2["default"])(_staticVariant, _constants.OPERATIONS_IDS.SIDECHAIN_STAKE_ETH_UPDATE, (0, _collections.struct)({})), (0, _defineProperty2["default"])(_staticVariant, _constants.OPERATIONS_IDS.SIDECHAIN_BTC_CREATE_STAKE_SCRIPT, defaultFeeParametersSerializer), (0, _defineProperty2["default"])(_staticVariant, _constants.OPERATIONS_IDS.SIDECHAIN_STAKE_BTC_UPDATE, defaultFeeParametersSerializer), (0, _defineProperty2["default"])(_staticVariant, _constants.OPERATIONS_IDS.BLOCK_REWARD, defaultFeeParametersSerializer), (0, _defineProperty2["default"])(_staticVariant, _constants.OPERATIONS_IDS.EVM_ADDRESS_REGISTER, defaultFeeParametersSerializer), (0, _defineProperty2["default"])(_staticVariant, _constants.OPERATIONS_IDS.DID_CREATE_OPERATION, defaultFeeParametersSerializer), (0, _defineProperty2["default"])(_staticVariant, _constants.OPERATIONS_IDS.DID_UPDATE_OPERATION, defaultFeeParametersSerializer), (0, _defineProperty2["default"])(_staticVariant, _constants.OPERATIONS_IDS.DID_DELETE_OPERATION, defaultFeeParametersSerializer), _staticVariant));
var _default = feeParametersSerializer;
exports["default"] = _default;