"use strict";

var _typeof = require("@babel/runtime-corejs3/helpers/typeof");

var _WeakMap = require("@babel/runtime-corejs3/core-js-stable/weak-map");

var _Object$defineProperty = require("@babel/runtime-corejs3/core-js-stable/object/define-property");

var _Object$getOwnPropertyDescriptor = require("@babel/runtime-corejs3/core-js-stable/object/get-own-property-descriptor");

var _interopRequireDefault = require("@babel/runtime-corejs3/helpers/interopRequireDefault");

_Object$defineProperty(exports, "__esModule", {
  value: true
});

_Object$defineProperty(exports, "ACCOUNT_LISTING", {
  enumerable: true,
  get: function get() {
    return _account.ACCOUNT_LISTING;
  }
});

_Object$defineProperty(exports, "AccountListingSerializer", {
  enumerable: true,
  get: function get() {
    return _account.AccountListingSerializer;
  }
});

_Object$defineProperty(exports, "VoteIdSerializer", {
  enumerable: true,
  get: function get() {
    return _VoteId["default"];
  }
});

exports.account = void 0;

_Object$defineProperty(exports, "accountListing", {
  enumerable: true,
  get: function get() {
    return _account.accountListing;
  }
});

exports.asset = void 0;

_Object$defineProperty(exports, "authority", {
  enumerable: true,
  get: function get() {
    return _authority["default"];
  }
});

exports.balance = void 0;

_Object$defineProperty(exports, "blockReward", {
  enumerable: true,
  get: function get() {
    return _block_reward.blockRewardOperationPropsSerializer;
  }
});

_Object$defineProperty(exports, "chainParameters", {
  enumerable: true,
  get: function get() {
    return _chain_parameters["default"];
  }
});

exports.economy = exports.did = exports.contract = exports.committeeMember = exports.committeeFrozenBalance = void 0;

_Object$defineProperty(exports, "ethAddress", {
  enumerable: true,
  get: function get() {
    return _ethAddress["default"];
  }
});

_Object$defineProperty(exports, "evmAddress", {
  enumerable: true,
  get: function get() {
    return _evm_address["default"];
  }
});

_Object$defineProperty(exports, "feeParameters", {
  enumerable: true,
  get: function get() {
    return _fee_parameters["default"];
  }
});

_Object$defineProperty(exports, "feeSchedule", {
  enumerable: true,
  get: function get() {
    return _fee_schedule["default"];
  }
});

_Object$defineProperty(exports, "price", {
  enumerable: true,
  get: function get() {
    return _asset.priceSerializer;
  }
});

_Object$defineProperty(exports, "priceFeed", {
  enumerable: true,
  get: function get() {
    return _asset.priceFeedSerializer;
  }
});

exports.voteId = exports.vesting = exports.transfer = exports.sidechain = exports.proposal = void 0;

var _account = require("./account");

var _asset = require("./asset");

var _balance = require("./balance");

var _committee_member = require("./committee_member");

var _committee_frozen_balance = require("./committee_frozen_balance");

var _contract = require("./contract");

var economy = _interopRequireWildcard(require("./economy"));

exports.economy = economy;

var _proposal = require("./proposal");

var _sidechain = _interopRequireWildcard(require("./sidechain"));

var _transfer = require("./transfer");

var _vesting = require("./vesting");

var _VoteId = _interopRequireDefault(require("./VoteId"));

var _evm_address = _interopRequireDefault(require("./evm_address"));

var _did = require("./did");

var _authority = _interopRequireDefault(require("./authority"));

var _chain_parameters = _interopRequireDefault(require("./chain_parameters"));

var _ethAddress = _interopRequireDefault(require("./ethAddress"));

var _fee_parameters = _interopRequireDefault(require("./fee_parameters"));

var _fee_schedule = _interopRequireDefault(require("./fee_schedule"));

var _block_reward = require("./block_reward");

function _getRequireWildcardCache(nodeInterop) { if (typeof _WeakMap !== "function") return null; var cacheBabelInterop = new _WeakMap(); var cacheNodeInterop = new _WeakMap(); return (_getRequireWildcardCache = function _getRequireWildcardCache(nodeInterop) { return nodeInterop ? cacheNodeInterop : cacheBabelInterop; })(nodeInterop); }

function _interopRequireWildcard(obj, nodeInterop) { if (!nodeInterop && obj && obj.__esModule) { return obj; } if (obj === null || _typeof(obj) !== "object" && typeof obj !== "function") { return { "default": obj }; } var cache = _getRequireWildcardCache(nodeInterop); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = _Object$defineProperty && _Object$getOwnPropertyDescriptor; for (var key in obj) { if (key !== "default" && Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? _Object$getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { _Object$defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj["default"] = obj; if (cache) { cache.set(obj, newObj); } return newObj; }

var account = {
  options: _account.accountOptionsSerializer,
  create: _account.accountCreateOperationPropsSerializer,
  update: _account.accountUpdateOperationPropsSerializer,
  whitelist: _account.accountWhitelistOperationPropsSerializer,
  addressCreate: _account.accountAddressCreateOperationPropsSerializer
};
exports.account = account;
var asset = {
  options: _asset.assetOptionsSerializer,
  bitassetOptions: _asset.bitassetOptionsSerializer,
  create: _asset.assetCreateOperationPropsSerializer,
  update: _asset.assetUpdateOperationPropsSerializer,
  updateBitasset: _asset.assetUpdateBitassetOperationPropsSerializer,
  updateFeedProducers: _asset.assetUpdateFeedProducersOperationPropsSerializer,
  issue: _asset.assetIssueOperationPropsSerializer,
  reserve: _asset.assetReserveOperationPropsSerializer,
  fundFeePool: _asset.assetFundFeePoolOperationPropsSerializer,
  publishFeed: _asset.assetPublishFeedOperationPropsSerializer,
  claimFees: _asset.assetClaimFeesOperationPropsSerializer
};
exports.asset = asset;
var balance = {
  claim: _balance.balanceClaimOperationPropsSerializer,
  freeze: _balance.balanceFreezeOperationPropsSerializer,
  unfreeze: _balance.balanceUnfreezeOperationPropsSerializer,
  requestUnfreeze: _balance.requestBalanceUnfreezeOperation
};
exports.balance = balance;
var committeeMember = {
  activate: _committee_member.committeeMemberActivateOperationPropsSerializer,
  deactivate: _committee_member.committeeMemberDeactivateOperationPropsSerializer,
  create: _committee_member.committeeMemberCreateOperationPropsSerializer,
  update: _committee_member.committeeMemberUpdateOperationPropsSerializer,
  updateGlobalParameters: _committee_member.committeeMemberUpdateGlobalParametersOperationPropsSerializer
};
exports.committeeMember = committeeMember;
var committeeFrozenBalance = {
  deposit: _committee_frozen_balance.committeeFrozenBalanceDepositOperationPropSerializer,
  withdraw: _committee_frozen_balance.committeeFrozenBalanceWithdrawOperationPropSerializer
};
exports.committeeFrozenBalance = committeeFrozenBalance;
var contract = {
  base: _contract.contractBaseOperationPropsSerializer,
  create: _contract.contractCreateOperationPropsSerializer,
  call: _contract.contractCallOperationPropsSerializer,
  internalCreate: _contract.contractInternalCreateOperationPropsSerializer,
  internalCall: _contract.contractInternalCallOperationPropsSerializer,
  selfdestruct: _contract.contractSelfdestructOperationPropsSerializer,
  fundPool: _contract.contractFundPoolOperationPropsSerializer,
  whitelist: _contract.contractWhitelistOperationPropsSerializer,
  update: _contract.contractUpdateOperationPropsSerializer
};
exports.contract = contract;
var proposal = {
  create: _proposal.proposalCreateOperationPropsSerializer,
  update: _proposal.proposalUpdateOperationPropsSerializer,
  "delete": _proposal.proposalDeleteOperationPropsSerializer
};
exports.proposal = proposal;
var sidechain = {
  issue: _sidechain.sidechainIssueOperationPropsSerializer,
  burn: _sidechain.sidechainBurnOperationPropsSerializer,
  spvExchangeExcessFunds: _sidechain.sidechainSpvExchangeExcessFundsOperationPropsSerializer,
  erc20: _sidechain.erc20,
  eth: _sidechain.eth,
  btc: _sidechain.btc
};
exports.sidechain = sidechain;
var transfer = {
  "default": _transfer.transferOperationPropsSerializer,
  override: _transfer.overrideTransferOperationPropsSerializer,
  toAddress: _transfer.transferToAddressOperationPropsSerializer
};
exports.transfer = transfer;
var vesting = {
  balanceCreate: _vesting.vestingBalanceCreateOperationPropsSerializer,
  policyInitializer: _vesting.vestingPolicyInitializer,
  linearPolicyInitializer: _vesting.linearVestingPolicyInitializer,
  cddPolicyInitializer: _vesting.cddVestingPolicyInitializer,
  balanceWithdraw: _vesting.vestingBalanceWithdrawOperationPropsSerializer
};
exports.vesting = vesting;
var voteId = new _VoteId["default"]();
exports.voteId = voteId;
var did = {
  create: _did.didCreateOperationSerializer,
  update: _did.didUpdateOperationSerializer,
  "delete": _did.didDeleteOperationSerializer
};
exports.did = did;