"use strict";

var _Reflect$construct = require("@babel/runtime-corejs3/core-js-stable/reflect/construct");

var _Object$defineProperty = require("@babel/runtime-corejs3/core-js-stable/object/define-property");

var _interopRequireDefault = require("@babel/runtime-corejs3/helpers/interopRequireDefault");

_Object$defineProperty(exports, "__esModule", {
  value: true
});

exports["default"] = void 0;

var _classCallCheck2 = _interopRequireDefault(require("@babel/runtime-corejs3/helpers/classCallCheck"));

var _createClass2 = _interopRequireDefault(require("@babel/runtime-corejs3/helpers/createClass"));

var _inherits2 = _interopRequireDefault(require("@babel/runtime-corejs3/helpers/inherits"));

var _possibleConstructorReturn2 = _interopRequireDefault(require("@babel/runtime-corejs3/helpers/possibleConstructorReturn"));

var _getPrototypeOf2 = _interopRequireDefault(require("@babel/runtime-corejs3/helpers/getPrototypeOf"));

var _ISerializer2 = _interopRequireDefault(require("../ISerializer"));

function _createSuper(Derived) { var hasNativeReflectConstruct = _isNativeReflectConstruct(); return function _createSuperInternal() { var Super = (0, _getPrototypeOf2["default"])(Derived), result; if (hasNativeReflectConstruct) { var NewTarget = (0, _getPrototypeOf2["default"])(this).constructor; result = _Reflect$construct(Super, arguments, NewTarget); } else { result = Super.apply(this, arguments); } return (0, _possibleConstructorReturn2["default"])(this, result); }; }

function _isNativeReflectConstruct() { if (typeof Reflect === "undefined" || !_Reflect$construct) return false; if (_Reflect$construct.sham) return false; if (typeof Proxy === "function") return true; try { Boolean.prototype.valueOf.call(_Reflect$construct(Boolean, [], function () {})); return true; } catch (e) { return false; } }

/** @typedef {import("../../echo/transaction").OperationId} OperationId */
var OperationWrapperSerializer = /*#__PURE__*/function (_ISerializer) {
  (0, _inherits2["default"])(OperationWrapperSerializer, _ISerializer);

  var _super = _createSuper(OperationWrapperSerializer);

  function OperationWrapperSerializer() {
    var _this;

    (0, _classCallCheck2["default"])(this, OperationWrapperSerializer);
    _this = _super.call(this);
    /**
     * @private
     * @type {ISerializer}
     */

    _this._operationSerializer = null;
    return _this;
  }
  /** @private */


  (0, _createClass2["default"])(OperationWrapperSerializer, [{
    key: "operationSerializer",
    get:
    /**
     * @readonly
     * @type {ISerializer}
     */
    function get() {
      return this._operationSerializer;
    }
  }, {
    key: "onlyIfInited",
    value: function onlyIfInited() {
      if (!this.operationSerializer) throw new Error('operation wrapper is not inited');
    }
    /** @param {import("../operation").default} operationSerializer */

  }, {
    key: "init",
    value: function init(operationSerializer) {
      if (this.operationSerializer) throw new Error('already inited');
      if (!(operationSerializer instanceof _ISerializer2["default"])) throw new Error('inited with no serializer');
      this._operationSerializer = operationSerializer;
    }
    /**
     * @template {OperationId} T
     * @param {[T, { [key: string]: any }]} value
     * @returns {[T, { [key: string]: any }]}
     */

  }, {
    key: "toRaw",
    value: function toRaw(value) {
      this.onlyIfInited();
      return this.operationSerializer.toRaw(value);
    }
    /**
     * @template {OperationId} T
     * @param {Buffer} buffer
     * @param {number} [offset]
     * @returns {{ res: [T, { [key: string]: any }], newOffset: number }}
     */

  }, {
    key: "readFromBuffer",
    value: function readFromBuffer(buffer) {
      var offset = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : 0;
      this.onlyIfInited();
      return this.operationSerializer.readFromBuffer(buffer, offset);
    }
  }]);
  return OperationWrapperSerializer;
}(_ISerializer2["default"]);

var opWrapper = new OperationWrapperSerializer();
var _default = opWrapper;
exports["default"] = _default;