"use strict";

var _Object$defineProperty = require("@babel/runtime-corejs3/core-js-stable/object/define-property");

var _interopRequireDefault = require("@babel/runtime-corejs3/helpers/interopRequireDefault");

_Object$defineProperty(exports, "__esModule", {
  value: true
});

exports.proposalUpdateOperationPropsSerializer = exports.proposalDeleteOperationPropsSerializer = exports.proposalCreateOperationPropsSerializer = void 0;

var _basic = require("../basic");

var _integers = require("../basic/integers");

var _chain = require("../chain");

var _protocol = require("../chain/id/protocol");

var _collections = require("../collections");

var _opWrapper = _interopRequireDefault(require("./opWrapper"));

var proposalCreateOperationPropsSerializer = (0, _collections.struct)({
  fee: _chain.asset,
  fee_paying_account: _protocol.accountId,
  expiration_time: _basic.timePointSec,
  proposed_ops: (0, _collections.vector)(_opWrapper["default"]),
  review_period_seconds: (0, _collections.optional)(_integers.uint32),
  extensions: _chain.extensions
});
exports.proposalCreateOperationPropsSerializer = proposalCreateOperationPropsSerializer;
var proposalUpdateOperationPropsSerializer = (0, _collections.struct)({
  fee_paying_account: _protocol.accountId,
  fee: _chain.asset,
  proposal: _protocol.proposalId,
  active_approvals_to_add: (0, _collections.set)(_protocol.accountId),
  active_approvals_to_remove: (0, _collections.set)(_protocol.accountId),
  key_approvals_to_add: (0, _collections.set)(_chain.publicKey),
  key_approvals_to_remove: (0, _collections.set)(_chain.publicKey),
  extensions: _chain.extensions
});
exports.proposalUpdateOperationPropsSerializer = proposalUpdateOperationPropsSerializer;
var proposalDeleteOperationPropsSerializer = (0, _collections.struct)({
  fee_paying_account: _protocol.accountId,
  using_owner_authority: _basic.bool,
  fee: _chain.asset,
  proposal: _protocol.proposalId,
  extensions: _chain.extensions
});
exports.proposalDeleteOperationPropsSerializer = proposalDeleteOperationPropsSerializer;