"use strict";

var _mapInstanceProperty = require("@babel/runtime-corejs3/core-js-stable/instance/map");

var _Object$defineProperty = require("@babel/runtime-corejs3/core-js-stable/object/define-property");

var _interopRequireDefault = require("@babel/runtime-corejs3/helpers/interopRequireDefault");

_Object$defineProperty(exports, "__esModule", {
  value: true
});

exports.sidechainStakeBtcUpdateOperationPropsSerializer = exports.sidechainBtcWithdrawOperationPropsSerializer = exports.sidechainBtcSpvCreateOperationPropsSerializer = exports.sidechainBtcSpvAddMissedTxReceiptOperationPropsSerializer = exports.sidechainBtcDepositOperationPropsSerializer = exports.sidechainBtcCreateStakeScriptOperationPropsSerializer = exports.sidechainBtcCreateAddressOperationPropsSerializer = exports.sidechainBtcApproveAggregateOperationPropsSerializer = exports.sidechainBtcAggregateOperationPropsSerializer = void 0;

var _chain = require("../../chain");

var _protocol = require("../../chain/id/protocol");

var _btc = require("../../chain/sidechain/btc");

var _collections = require("../../collections");

var _basic = require("../../basic");

var _btcPublicKey = _interopRequireDefault(require("../btcPublicKey"));

var _integers = require("../../basic/integers");

var _btc2 = require("../../spv/btc");

// sidechain_btc_spv_create_operation
var sidechainBtcSpvCreateOperationPropsSerializer = (0, _collections.struct)({
  fee: _chain.asset,
  committee_member_id: _protocol.accountId,
  header: _btc2.spvBtcBlockHeaderSerializer,
  proofs: (0, _collections.vector)(_btc2.spvBtcMerkleProofSerializer),
  extensions: _chain.extensions
}); // sidechain_btc_spv_add_missed_tx_operation

exports.sidechainBtcSpvCreateOperationPropsSerializer = sidechainBtcSpvCreateOperationPropsSerializer;
var sidechainBtcSpvAddMissedTxReceiptOperationPropsSerializer = (0, _collections.struct)({
  fee: _chain.asset,
  reporter: _protocol.accountId,
  block_hash: _chain.sha256,
  proofs: (0, _collections.vector)(_btc2.spvBtcMerkleProofSerializer),
  extensions: _chain.extensions
});
exports.sidechainBtcSpvAddMissedTxReceiptOperationPropsSerializer = sidechainBtcSpvAddMissedTxReceiptOperationPropsSerializer;
var sidechainBtcCreateAddressOperationPropsSerializer = (0, _collections.struct)({
  fee: _chain.asset,
  account: _protocol.accountId,
  extensions: _chain.extensions
});
exports.sidechainBtcCreateAddressOperationPropsSerializer = sidechainBtcCreateAddressOperationPropsSerializer;
var sidechainBtcDepositOperationPropsSerializer = (0, _collections.struct)({
  fee: _chain.asset,
  account: _protocol.accountId,
  btc_address_id: _protocol.btcAddressId,
  tx_info: _btc.btcTransactionDetailsSerializer,
  extensions: _chain.extensions
});
exports.sidechainBtcDepositOperationPropsSerializer = sidechainBtcDepositOperationPropsSerializer;
var sidechainBtcWithdrawOperationPropsSerializer = (0, _collections.struct)({
  fee: _chain.asset,
  account: _protocol.accountId,
  btc_addr: _basic.string,
  value: _basic.integers.uint64,
  extensions: _chain.extensions
});
exports.sidechainBtcWithdrawOperationPropsSerializer = sidechainBtcWithdrawOperationPropsSerializer;
var sidechainBtcAggregateOperationPropsSerializer = (0, _collections.struct)({
  fee: _chain.asset,
  committee_member_id: _protocol.accountId,
  deposits: (0, _collections.set)(_protocol.btcDepositId),
  withdrawals: (0, _collections.set)(_protocol.btcWithdrawId),
  transaction_id: _chain.sha256,
  sma_address: (0, _collections.struct)({
    address: _basic.string
  }),
  committee_member_ids_in_script: (0, _mapInstanceProperty(_collections))(_protocol.accountId, _btcPublicKey["default"]),
  aggregation_out_value: _basic.integers.uint64,
  btc_block_number: _integers.uint32,
  previous_aggregation: (0, _collections.optional)(_protocol.btcAggregatingId),
  cpfp_depth: _integers.uint8,
  signatures: (0, _mapInstanceProperty(_collections))(_basic.integers.uint32, _basic.string),
  extensions: _chain.extensions
});
exports.sidechainBtcAggregateOperationPropsSerializer = sidechainBtcAggregateOperationPropsSerializer;
var sidechainBtcApproveAggregateOperationPropsSerializer = (0, _collections.struct)({
  fee: _chain.asset,
  committee_member_id: _protocol.accountId,
  transaction_id: _chain.sha256,
  btc_block_number: _integers.uint32,
  extensions: _chain.extensions
});
exports.sidechainBtcApproveAggregateOperationPropsSerializer = sidechainBtcApproveAggregateOperationPropsSerializer;
var sidechainBtcCreateStakeScriptOperationPropsSerializer = (0, _collections.struct)({
  fee: _chain.asset,
  account: _protocol.accountId,
  pubkey_hash: _chain.ripemd160,
  extensions: _chain.extensions
});
exports.sidechainBtcCreateStakeScriptOperationPropsSerializer = sidechainBtcCreateStakeScriptOperationPropsSerializer;
var sidechainStakeBtcUpdateOperationPropsSerializer = (0, _collections.struct)({
  fee: _chain.asset,
  committee_member_id: _protocol.accountId,
  owner: _protocol.accountId,
  btc_tx_info: _btc.btcTransactionDetailsSerializer,
  is_vin: _basic.bool,
  extensions: _chain.extensions
});
exports.sidechainStakeBtcUpdateOperationPropsSerializer = sidechainStakeBtcUpdateOperationPropsSerializer;