"use strict";

var _Object$defineProperty = require("@babel/runtime-corejs3/core-js-stable/object/define-property");

var _interopRequireDefault = require("@babel/runtime-corejs3/helpers/interopRequireDefault");

_Object$defineProperty(exports, "__esModule", {
  value: true
});

exports.sidechainERC20WithdrawTokenOperationPropsSerializer = exports.sidechainERC20TransferAssetOperationPropsSerializer = exports.sidechainERC20SendWithdrawTokenOperationPropsSerializer = exports.sidechainERC20SendDepositTokenOperationPropsSerializer = exports.sidechainERC20RegisterTokenOperationPropsSerializer = exports.sidechainERC20RegisterContractOperationPropsSerializer = exports.sidechainERC20IssueOperationPropsSerializer = exports.sidechainERC20DepositTokenOperationPropsSerializer = exports.sidechainERC20BurnOperationPropsSerializer = exports.sidechainERC20ApproveTokenWithdrawOperationPropsSerializer = void 0;

var _ethAddress = _interopRequireDefault(require("../ethAddress"));

var _basic = require("../../basic");

var _integers = require("../../basic/integers");

var _chain = require("../../chain");

var _protocol = require("../../chain/id/protocol");

var _collections = require("../../collections");

var sidechainERC20RegisterContractOperationPropsSerializer = (0, _collections.struct)({
  fee: _chain.asset,
  code: _basic.string,
  args: _basic.string,
  address: _ethAddress["default"],
  name: _basic.string,
  symbol: _basic.string,
  decimals: _integers.uint8,
  eth_accuracy: _basic.bool,
  extensions: _chain.extensions
});
exports.sidechainERC20RegisterContractOperationPropsSerializer = sidechainERC20RegisterContractOperationPropsSerializer;
var sidechainERC20RegisterTokenOperationPropsSerializer = (0, _collections.struct)({
  fee: _chain.asset,
  account: _protocol.accountId,
  eth_addr: _ethAddress["default"],
  name: _basic.string,
  symbol: _basic.string,
  decimals: _integers.uint8,
  extensions: _chain.extensions
}); // sidechain_erc20_deposit_token_operation

exports.sidechainERC20RegisterTokenOperationPropsSerializer = sidechainERC20RegisterTokenOperationPropsSerializer;
var sidechainERC20DepositTokenOperationPropsSerializer = (0, _collections.struct)({
  fee: _chain.asset,
  account: _protocol.accountId,
  erc20_token_addr: _ethAddress["default"],
  value: _basic.string,
  transaction_hash: _chain.sha256,
  extensions: _chain.extensions
});
exports.sidechainERC20DepositTokenOperationPropsSerializer = sidechainERC20DepositTokenOperationPropsSerializer;
var sidechainERC20SendDepositTokenOperationPropsSerializer = (0, _collections.struct)({
  fee: _chain.asset,
  committee_member_id: _protocol.accountId,
  deposit_id: _protocol.depositErc20TokenId,
  extensions: _chain.extensions
});
exports.sidechainERC20SendDepositTokenOperationPropsSerializer = sidechainERC20SendDepositTokenOperationPropsSerializer;
var sidechainERC20WithdrawTokenOperationPropsSerializer = (0, _collections.struct)({
  fee: _chain.asset,
  account: _protocol.accountId,
  to: _ethAddress["default"],
  erc20_token: _protocol.erc20TokenId,
  value: _basic.string,
  extensions: _chain.extensions
});
exports.sidechainERC20WithdrawTokenOperationPropsSerializer = sidechainERC20WithdrawTokenOperationPropsSerializer;
var sidechainERC20SendWithdrawTokenOperationPropsSerializer = (0, _collections.struct)({
  fee: _chain.asset,
  committee_member_id: _protocol.accountId,
  deposit_id: _protocol.depositErc20TokenId,
  extensions: _chain.extensions
}); // sidechain_erc20_approve_token_withdraw_operation

exports.sidechainERC20SendWithdrawTokenOperationPropsSerializer = sidechainERC20SendWithdrawTokenOperationPropsSerializer;
var sidechainERC20ApproveTokenWithdrawOperationPropsSerializer = (0, _collections.struct)({
  fee: _chain.asset,
  withdraw_id: _integers.uint64,
  transaction_hash: _chain.sha256,
  extensions: _chain.extensions
});
exports.sidechainERC20ApproveTokenWithdrawOperationPropsSerializer = sidechainERC20ApproveTokenWithdrawOperationPropsSerializer;
var sidechainERC20IssueOperationPropsSerializer = (0, _collections.struct)({
  fee: _chain.asset,
  deposit: _protocol.depositErc20TokenId,
  account: _protocol.accountId,
  token: _protocol.erc20TokenId,
  amount: _basic.string,
  extensions: _chain.extensions
});
exports.sidechainERC20IssueOperationPropsSerializer = sidechainERC20IssueOperationPropsSerializer;
var sidechainERC20BurnOperationPropsSerializer = (0, _collections.struct)({
  fee: _chain.asset,
  withdraw: _protocol.withdrawErc20TokenId,
  account: _protocol.accountId,
  token: _protocol.erc20TokenId,
  amount: _basic.string,
  extensions: _chain.extensions
});
exports.sidechainERC20BurnOperationPropsSerializer = sidechainERC20BurnOperationPropsSerializer;
var sidechainERC20TransferAssetOperationPropsSerializer = (0, _collections.struct)({
  fee: _chain.asset,
  account: _protocol.accountId,
  to: _ethAddress["default"],
  value: _chain.asset,
  extensions: _chain.extensions
});
exports.sidechainERC20TransferAssetOperationPropsSerializer = sidechainERC20TransferAssetOperationPropsSerializer;