"use strict";

var _Object$defineProperty = require("@babel/runtime-corejs3/core-js-stable/object/define-property");

var _interopRequireDefault = require("@babel/runtime-corejs3/helpers/interopRequireDefault");

_Object$defineProperty(exports, "__esModule", {
  value: true
});

exports.sidechainStakeEthUpdateOperationPropsSerializer = exports.sidechainEthWithdrawOperationPropsSerializer = exports.sidechainEthUpdateContractAddressOperationPropsSerializer = exports.sidechainEthSpvCreateOperationPropsSerializer = exports.sidechainEthSpvAddMissedTxReceiptOperationPropsSerializer = exports.sidechainEthSendWithdrawOperationPropsSerializer = exports.sidechainEthSendDepositOperationPropsSerializer = exports.sidechainEthDepositOperationPropsSerializer = exports.sidechainEthCreateAddressOperationPropsSerializer = exports.sidechainEthApproveWithdrawOperationPropsSerializer = exports.sidechainEthApproveAddressOperationPropsSerializer = void 0;

var _ethAddress = _interopRequireDefault(require("../ethAddress"));

var _integers = require("../../basic/integers");

var _chain = require("../../chain");

var _protocol = require("../../chain/id/protocol");

var _collections = require("../../collections");

var _eth = require("../../spv/eth");

// sidechain_eth_spv_create_operation
var sidechainEthSpvCreateOperationPropsSerializer = (0, _collections.struct)({
  fee: _chain.asset,
  committee_member_id: _protocol.accountId,
  header: _eth.spvEthBlockHeader,
  proofs: (0, _collections.vector)(_eth.spvEthMerkleProof),
  extensions: _chain.extensions
}); // sidechain_eth_spv_add_missed_tx_receipt_operation

exports.sidechainEthSpvCreateOperationPropsSerializer = sidechainEthSpvCreateOperationPropsSerializer;
var sidechainEthSpvAddMissedTxReceiptOperationPropsSerializer = (0, _collections.struct)({
  fee: _chain.asset,
  reporter: _protocol.accountId,
  block_hash: _chain.sha256,
  proofs: (0, _collections.vector)(_eth.spvEthMerkleProof),
  extensions: _chain.extensions
});
exports.sidechainEthSpvAddMissedTxReceiptOperationPropsSerializer = sidechainEthSpvAddMissedTxReceiptOperationPropsSerializer;
var sidechainEthCreateAddressOperationPropsSerializer = (0, _collections.struct)({
  fee: _chain.asset,
  account: _protocol.accountId,
  extensions: _chain.extensions
}); // sidechain_eth_approve_address_operation

exports.sidechainEthCreateAddressOperationPropsSerializer = sidechainEthCreateAddressOperationPropsSerializer;
var sidechainEthApproveAddressOperationPropsSerializer = (0, _collections.struct)({
  fee: _chain.asset,
  account: _protocol.accountId,
  eth_addr: _ethAddress["default"],
  transaction_hash: _chain.sha256,
  extensions: _chain.extensions
}); // sidechain_eth_deposit_operation

exports.sidechainEthApproveAddressOperationPropsSerializer = sidechainEthApproveAddressOperationPropsSerializer;
var sidechainEthDepositOperationPropsSerializer = (0, _collections.struct)({
  fee: _chain.asset,
  deposit_id: _integers.uint64,
  account: _protocol.accountId,
  value: _integers.uint64,
  transaction_hash: _chain.sha256,
  extensions: _chain.extensions
});
exports.sidechainEthDepositOperationPropsSerializer = sidechainEthDepositOperationPropsSerializer;
var sidechainEthSendDepositOperationPropsSerializer = (0, _collections.struct)({
  fee: _chain.asset,
  committee_member_id: _protocol.accountId,
  deposit_id: _protocol.ethDepositId,
  extensions: _chain.extensions
});
exports.sidechainEthSendDepositOperationPropsSerializer = sidechainEthSendDepositOperationPropsSerializer;
var sidechainEthWithdrawOperationPropsSerializer = (0, _collections.struct)({
  fee: _chain.asset,
  account: _protocol.accountId,
  eth_addr: _ethAddress["default"],
  value: _integers.uint64,
  extensions: _chain.extensions
});
exports.sidechainEthWithdrawOperationPropsSerializer = sidechainEthWithdrawOperationPropsSerializer;
var sidechainEthSendWithdrawOperationPropsSerializer = (0, _collections.struct)({
  fee: _chain.asset,
  committee_member_id: _protocol.accountId,
  withdraw_id: _protocol.ethWithdrawId,
  extensions: _chain.extensions
}); // sidechain_eth_approve_withdraw_operation

exports.sidechainEthSendWithdrawOperationPropsSerializer = sidechainEthSendWithdrawOperationPropsSerializer;
var sidechainEthApproveWithdrawOperationPropsSerializer = (0, _collections.struct)({
  fee: _chain.asset,
  withdraw_id: _integers.uint64,
  transaction_hash: _chain.sha256,
  extensions: _chain.extensions
});
exports.sidechainEthApproveWithdrawOperationPropsSerializer = sidechainEthApproveWithdrawOperationPropsSerializer;
var sidechainEthUpdateContractAddressOperationPropsSerializer = (0, _collections.struct)({
  fee: _chain.asset,
  new_addr: _ethAddress["default"],
  extensions: _chain.extensions
}); // sidechain_stake_eth_update_operation

exports.sidechainEthUpdateContractAddressOperationPropsSerializer = sidechainEthUpdateContractAddressOperationPropsSerializer;
var sidechainStakeEthUpdateOperationPropsSerializer = (0, _collections.struct)({
  fee: _chain.asset,
  asset_id: _protocol.assetId,
  current_balance: _integers.uint64,
  account: _protocol.accountId,
  transaction_hash: _chain.sha256,
  extensions: _chain.extensions
});
exports.sidechainStakeEthUpdateOperationPropsSerializer = sidechainStakeEthUpdateOperationPropsSerializer;