"use strict";

var _typeof = require("@babel/runtime-corejs3/helpers/typeof");

var _WeakMap = require("@babel/runtime-corejs3/core-js-stable/weak-map");

var _Object$defineProperty = require("@babel/runtime-corejs3/core-js-stable/object/define-property");

var _Object$getOwnPropertyDescriptor = require("@babel/runtime-corejs3/core-js-stable/object/get-own-property-descriptor");

_Object$defineProperty(exports, "__esModule", {
  value: true
});

exports.sidechainSpvExchangeExcessFundsOperationPropsSerializer = exports.sidechainIssueOperationPropsSerializer = exports.sidechainBurnOperationPropsSerializer = exports.eth = exports.erc20 = exports.btc = void 0;

var _erc20 = _interopRequireWildcard(require("./erc20"));

var _eth = _interopRequireWildcard(require("./eth"));

var _btc = _interopRequireWildcard(require("./btc"));

var _collections = require("../../collections");

var _chain = require("../../chain");

var _protocol = require("../../chain/id/protocol");

function _getRequireWildcardCache(nodeInterop) { if (typeof _WeakMap !== "function") return null; var cacheBabelInterop = new _WeakMap(); var cacheNodeInterop = new _WeakMap(); return (_getRequireWildcardCache = function _getRequireWildcardCache(nodeInterop) { return nodeInterop ? cacheNodeInterop : cacheBabelInterop; })(nodeInterop); }

function _interopRequireWildcard(obj, nodeInterop) { if (!nodeInterop && obj && obj.__esModule) { return obj; } if (obj === null || _typeof(obj) !== "object" && typeof obj !== "function") { return { "default": obj }; } var cache = _getRequireWildcardCache(nodeInterop); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = _Object$defineProperty && _Object$getOwnPropertyDescriptor; for (var key in obj) { if (key !== "default" && Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? _Object$getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { _Object$defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj["default"] = obj; if (cache) { cache.set(obj, newObj); } return newObj; }

var sidechainIssueOperationPropsSerializer = (0, _collections.struct)({
  fee: _chain.asset,
  value: _chain.asset,
  account: _protocol.accountId,
  deposit_id: _protocol.ethDepositId,
  extensions: _chain.extensions
});
exports.sidechainIssueOperationPropsSerializer = sidechainIssueOperationPropsSerializer;
var sidechainBurnOperationPropsSerializer = (0, _collections.struct)({
  fee: _chain.asset,
  value: _chain.asset,
  account: _protocol.accountId,
  withdraw_id: _protocol.ethWithdrawId,
  extensions: _chain.extensions
}); // sidechain_spv_exchange_excess_funds_operation

exports.sidechainBurnOperationPropsSerializer = sidechainBurnOperationPropsSerializer;
var sidechainSpvExchangeExcessFundsOperationPropsSerializer = (0, _collections.struct)({
  fee: _chain.asset,
  account: _protocol.accountId,
  amount: _chain.asset,
  extensions: _chain.extensions
});
exports.sidechainSpvExchangeExcessFundsOperationPropsSerializer = sidechainSpvExchangeExcessFundsOperationPropsSerializer;
var erc20 = {
  registerContractOperation: _erc20.sidechainERC20RegisterContractOperationPropsSerializer,
  registerToken: _erc20.sidechainERC20RegisterTokenOperationPropsSerializer,
  depositToken: _erc20.sidechainERC20DepositTokenOperationPropsSerializer,
  sendDepositToken: _erc20.sidechainERC20SendDepositTokenOperationPropsSerializer,
  withdrawToken: _erc20.sidechainERC20WithdrawTokenOperationPropsSerializer,
  sendWithdrawToken: _erc20.sidechainERC20SendWithdrawTokenOperationPropsSerializer,
  approveTokenWithdraw: _erc20.sidechainERC20ApproveTokenWithdrawOperationPropsSerializer,
  issue: _erc20.sidechainERC20IssueOperationPropsSerializer,
  burn: _erc20.sidechainERC20BurnOperationPropsSerializer,
  transferAsset: _erc20.sidechainERC20TransferAssetOperationPropsSerializer
};
exports.erc20 = erc20;
var eth = {
  spvCreate: _eth.sidechainEthSpvCreateOperationPropsSerializer,
  spvAddMissedTxReceipt: _eth.sidechainEthSpvAddMissedTxReceiptOperationPropsSerializer,
  createAddress: _eth.sidechainEthCreateAddressOperationPropsSerializer,
  approveAddress: _eth.sidechainEthApproveAddressOperationPropsSerializer,
  deposit: _eth.sidechainEthDepositOperationPropsSerializer,
  sendDeposit: _eth.sidechainEthSendDepositOperationPropsSerializer,
  withdraw: _eth.sidechainEthWithdrawOperationPropsSerializer,
  sendWithdraw: _eth.sidechainEthSendWithdrawOperationPropsSerializer,
  approveWithdraw: _eth.sidechainEthApproveWithdrawOperationPropsSerializer,
  updateContractAddress: _eth.sidechainEthUpdateContractAddressOperationPropsSerializer,
  stakeUpdate: _eth.sidechainStakeEthUpdateOperationPropsSerializer
};
exports.eth = eth;
var btc = {
  createAddress: _btc.sidechainBtcCreateAddressOperationPropsSerializer,
  deposit: _btc.sidechainBtcDepositOperationPropsSerializer,
  withdraw: _btc.sidechainBtcWithdrawOperationPropsSerializer,
  aggregate: _btc.sidechainBtcAggregateOperationPropsSerializer,
  approveAggregate: _btc.sidechainBtcApproveAggregateOperationPropsSerializer,
  spvCreate: _btc.sidechainBtcSpvCreateOperationPropsSerializer,
  spvAddMissedTxReceipt: _btc.sidechainBtcSpvAddMissedTxReceiptOperationPropsSerializer,
  createStakeScript: _btc.sidechainBtcCreateStakeScriptOperationPropsSerializer,
  stakeUpdate: _btc.sidechainStakeBtcUpdateOperationPropsSerializer
};
exports.btc = btc;