"use strict";

var _Object$defineProperty = require("@babel/runtime-corejs3/core-js-stable/object/define-property");

var _interopRequireDefault = require("@babel/runtime-corejs3/helpers/interopRequireDefault");

_Object$defineProperty(exports, "__esModule", {
  value: true
});

exports.vestingPolicyInitializer = exports.vestingBalanceWithdrawOperationPropsSerializer = exports.vestingBalanceCreateOperationPropsSerializer = exports.linearVestingPolicyInitializer = exports.cddVestingPolicyInitializer = void 0;

var _defineProperty2 = _interopRequireDefault(require("@babel/runtime-corejs3/helpers/defineProperty"));

var _basic = require("../basic");

var _integers = require("../basic/integers");

var _chain = require("../chain");

var _protocol = require("../chain/id/protocol");

var _collections = require("../collections");

var _protocol2 = require("../../constants/protocol");

var _staticVariant;

var linearVestingPolicyInitializer = (0, _collections.struct)({
  begin_timestamp: _basic.timePointSec,
  vesting_cliff_seconds: _integers.uint32,
  vesting_duration_seconds: _integers.uint32
});
exports.linearVestingPolicyInitializer = linearVestingPolicyInitializer;
var cddVestingPolicyInitializer = (0, _collections.struct)({
  start_claim: _basic.timePointSec,
  vesting_seconds: _integers.uint32
});
exports.cddVestingPolicyInitializer = cddVestingPolicyInitializer;
var vestingPolicyInitializer = (0, _collections.staticVariant)((_staticVariant = {}, (0, _defineProperty2["default"])(_staticVariant, _protocol2.vesting.policyInitializerTypes.LINEAR, linearVestingPolicyInitializer), (0, _defineProperty2["default"])(_staticVariant, _protocol2.vesting.policyInitializerTypes.CDD, cddVestingPolicyInitializer), _staticVariant));
exports.vestingPolicyInitializer = vestingPolicyInitializer;
var vestingBalanceCreateOperationPropsSerializer = (0, _collections.struct)({
  fee: _chain.asset,
  creator: _protocol.accountId,
  owner: _protocol.accountId,
  amount: _chain.asset,
  policy: vestingPolicyInitializer,
  extensions: _chain.extensions
});
exports.vestingBalanceCreateOperationPropsSerializer = vestingBalanceCreateOperationPropsSerializer;
var vestingBalanceWithdrawOperationPropsSerializer = (0, _collections.struct)({
  fee: _chain.asset,
  vesting_balance: _protocol.vestingBalanceId,
  owner: _protocol.accountId,
  amount: _chain.asset,
  extensions: _chain.extensions
});
exports.vestingBalanceWithdrawOperationPropsSerializer = vestingBalanceWithdrawOperationPropsSerializer;