"use strict";

var _Object$defineProperty = require("@babel/runtime-corejs3/core-js-stable/object/define-property");

_Object$defineProperty(exports, "__esModule", {
  value: true
});

exports.spvBtcMerkleProofSerializer = exports.spvBtcBlockHeaderSerializer = void 0;

var _basic = require("../basic");

var _integers = require("../basic/integers");

var _chain = require("../chain");

var _btc = require("../chain/sidechain/btc");

var _collections = require("../collections");

var merkleLeaf = (0, _collections.struct)({
  leaf: _chain.sha256,
  is_left: _basic.bool
});
var merklePath = (0, _collections.struct)({
  leafs: (0, _collections.vector)(merkleLeaf)
});
var spvBtcBlockHeaderSerializer = (0, _collections.struct)({
  version: _integers.int32,
  prev_block_hash: _chain.sha256,
  merkle_root: _chain.sha256,
  timestamp: _integers.uint32,
  bits: _integers.uint32,
  nonce: _integers.uint32,
  height: _integers.uint32
});
exports.spvBtcBlockHeaderSerializer = spvBtcBlockHeaderSerializer;
var spvBtcMerkleProofSerializer = (0, _collections.struct)({
  tx: _btc.sidechainBtcTransaction,
  path: merklePath
});
exports.spvBtcMerkleProofSerializer = spvBtcMerkleProofSerializer;