"use strict";

var _Object$defineProperty = require("@babel/runtime-corejs3/core-js-stable/object/define-property");

_Object$defineProperty(exports, "__esModule", {
  value: true
});

exports.spvTransactionReceipt = exports.spvEthMerkleProof = exports.spvEthBlockHeader = void 0;

var _basic = require("../basic");

var _integers = require("../basic/integers");

var _chain = require("../chain");

var _collections = require("../collections");

var _pmTrie = require("./pmTrie");

var logEntry = (0, _collections.struct)({
  logIndex: (0, _basic.bytes)(undefined, true),
  address: (0, _basic.bytes)(undefined, true),
  data: (0, _basic.bytes)(undefined, true),
  topics: (0, _collections.vector)(_chain.sha256With0xPrefix)
});
var spvTransactionReceipt = (0, _collections.structWithVariantKeys)({
  type: _integers.uint8,
  transactionHash: _chain.sha256With0xPrefix,
  transactionIndex: _integers.uint64,
  cumulativeGasUsed: _integers.uint256,
  logs: (0, _collections.vector)(logEntry),
  logsBloom: (0, _basic.bytes)()
}, [{
  keyIndexInStructure: 6,
  serializersData: [['status', _integers.uint8], ['root', _chain.sha256With0xPrefix]]
}]);
exports.spvTransactionReceipt = spvTransactionReceipt;
var spvEthBlockHeader = (0, _collections.struct)({
  parentHash: _chain.sha256With0xPrefix,
  sha3Uncles: _chain.sha256With0xPrefix,
  miner: (0, _basic.bytes)(undefined, true),
  stateRoot: _chain.sha256With0xPrefix,
  transactionsRoot: _chain.sha256With0xPrefix,
  receiptsRoot: _chain.sha256With0xPrefix,
  logsBloom: (0, _basic.bytes)(undefined, true),
  difficulty: _integers.uint256,
  number: _integers.uint64,
  gasLimit: _integers.uint256,
  gasUsed: _integers.uint256,
  timestamp: _integers.uint64,
  extraData: (0, _basic.bytes)(undefined, true),
  mixHash: _chain.sha256With0xPrefix,
  nonce: (0, _basic.bytes)(undefined, true),
  baseFeePerGas: (0, _collections.optional)(_integers.uint256)
});
exports.spvEthBlockHeader = spvEthBlockHeader;
var spvEthMerkleProof = (0, _collections.struct)({
  receipt: spvTransactionReceipt,
  path_data: _pmTrie.spvPmTrieNodesRlpData
});
exports.spvEthMerkleProof = spvEthMerkleProof;