"use strict";

var _Object$defineProperty = require("@babel/runtime-corejs3/core-js-stable/object/define-property");

var _interopRequireDefault = require("@babel/runtime-corejs3/helpers/interopRequireDefault");

_Object$defineProperty(exports, "__esModule", {
  value: true
});

exports.isVoteId = exports.isVoid = exports.isVestingBalanceId = exports.isValidAmount = exports.isUndefined = exports.isUInt8 = exports.isUInt64 = exports.isUInt32 = exports.isUInt16 = exports.isTransactionId = exports.isTimePointSec = exports.isString = exports.isRipemd160 = exports.isPublicKey = exports.isProposalId = exports.isOperationPrototypeExists = exports.isOperationId = exports.isOperationHistoryId = exports.isOldPrivateKey = exports.isObjectId = exports.isObject = exports.isNumber = exports.isNotEmptyString = exports.isMethodExists = exports.isInt64 = exports.isHex = exports.isFunction = exports.isFrozenBalanceId = exports.isEthereumAddress = exports.isEthAddressId = exports.isEmptyObject = exports.isEmptyArray = exports.isEmpty = exports.isEchoRandKey = exports.isERC20TokenId = exports.isDynamicGlobalObjectId = exports.isDynamicAssetDataId = exports.isContractResultId = exports.isContractPoolId = exports.isContractId = exports.isContractHistoryId = exports.isContractCode = exports.isCommitteeMemberId = exports.isBytes = exports.isBytecode = exports.isBuffer = exports.isBtcAddressId = exports.isBoolean = exports.isBlockSummaryId = exports.isBitAssetId = exports.isBalanceId = exports.isAssetName = exports.isAssetIdOrName = exports.isAssetId = exports.isArray = exports.isAccountTransactionHistoryId = exports.isAccountStatisticsId = exports.isAccountName = exports.isAccountIdOrName = exports.isAccountId = exports.isAccountBalanceId = exports.isAccountAddressId = exports.idRegex = exports.checkCheapName = exports.checkAccountName = void 0;
exports.validateAmount = validateAmount;
exports.validateOptionsError = void 0;
exports.validatePositiveSafeInteger = validatePositiveSafeInteger;
exports.validateSafeInteger = validateSafeInteger;
exports.validateSidechainType = validateSidechainType;
exports.validateUnsignedSafeInteger = validateUnsignedSafeInteger;
exports.validateUrl = void 0;

var _typeof2 = _interopRequireDefault(require("@babel/runtime-corejs3/helpers/typeof"));

var _isInteger = _interopRequireDefault(require("@babel/runtime-corejs3/core-js-stable/number/is-integer"));

var _isArray = _interopRequireDefault(require("@babel/runtime-corejs3/core-js-stable/array/is-array"));

var _maxSafeInteger = _interopRequireDefault(require("@babel/runtime-corejs3/core-js-stable/number/max-safe-integer"));

var _minSafeInteger = _interopRequireDefault(require("@babel/runtime-corejs3/core-js-stable/number/min-safe-integer"));

var _keys = _interopRequireDefault(require("@babel/runtime-corejs3/core-js-stable/object/keys"));

var _slice = _interopRequireDefault(require("@babel/runtime-corejs3/core-js-stable/instance/slice"));

var _every = _interopRequireDefault(require("@babel/runtime-corejs3/core-js-stable/instance/every"));

var _includes = _interopRequireDefault(require("@babel/runtime-corejs3/core-js-stable/instance/includes"));

var _trim = _interopRequireDefault(require("@babel/runtime-corejs3/core-js-stable/instance/trim"));

var _bignumber = _interopRequireDefault(require("bignumber.js"));

var _bs = _interopRequireDefault(require("bs58"));

var _chainConfig = require("../config/chain-config");

var _wsConstants = require("../constants/ws-constants");

var _constants = require("../constants");

var _methodsOperationsData = require("./methods-operations-data");

/* eslint-disable max-len */
function validateSafeInteger(value, fieldName) {
  if (typeof value !== 'number') throw new Error("".concat(fieldName, " is not a number"));
  if (!(0, _isInteger["default"])(value)) throw new Error("".concat(fieldName, " is not a integer"));
}

function validatePositiveSafeInteger(value) {
  validateSafeInteger(value);
  if (value <= 0) throw new Error('value is not positive');
}

function validateUnsignedSafeInteger(value) {
  var fieldName = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : 'value';
  validateSafeInteger(value, fieldName);
  if (value < 0) throw new Error("".concat(fieldName, " is negative"));
}

var urlRegex = new RegExp('^(https|http|wss|ws):\\/\\/' + // protocol
'((([a-z\\d]([a-z\\d-]*[a-z\\d])*)\\.)+[a-z]{2,}|' + // domain name
'(([0-9]|[1-9][0-9]|1[0-9]{2}|2[0-4][0-9]|25[0-5])\\.){3}([0-9]|[1-9][0-9]|1[0-9]{2}|2[0-4][0-9]|25[0-5])|' + // OR ip (v4) address
'\\[(([0-9a-fA-F]{1,4}:){7,7}[0-9a-fA-F]{1,4}|([0-9a-fA-F]{1,4}:){1,7}:|([0-9a-fA-F]{1,4}:){1,6}:[0-9a-fA-F]{1,4}|([0-9a-fA-F]{1,4}:){1,5}(:[0-9a-fA-F]{1,4}){1,2}|([0-9a-fA-F]{1,4}:){1,4}(:[0-9a-fA-F]{1,4}){1,3}|([0-9a-fA-F]{1,4}:){1,3}(:[0-9a-fA-F]{1,4}){1,4}|([0-9a-fA-F]{1,4}:){1,2}(:[0-9a-fA-F]{1,4}){1,5}|[0-9a-fA-F]{1,4}:((:[0-9a-fA-F]{1,4}){1,6})|:((:[0-9a-fA-F]{1,4}){1,7}|:)|fe80:(:[0-9a-fA-F]{0,4}){0,4}%[0-9a-zA-Z]{1,}|::(ffff(:0{1,4}){0,1}:){0,1}((25[0-5]|(2[0-4]|1{0,1}[0-9]){0,1}[0-9])\\.){3,3}(25[0-5]|(2[0-4]|1{0,1}[0-9]){0,1}[0-9])|([0-9a-fA-F]{1,4}:){1,4}:((25[0-5]|(2[0-4]|1{0,1}[0-9]){0,1}[0-9])\\.){3,3}(25[0-5]|(2[0-4]|1{0,1}[0-9]){0,1}[0-9]))\\])' + // OR ip (v6) address
'(:([0-9]{1,4}|[1-5][0-9]{4}|6[0-4][0-9]{3}|65[0-4][0-9]{2}|655[0-2][0-9]|6553[0-5]))?' + // port
'(\\/[-a-z\\d%_.~+]*)*(\\?[;&a-z\\d%_.~+=-]*)?' + // query string
'(\\#[-a-z\\d_]*)?$' // fragment locater
, 'i');
var idRegex = /^([1-9]\d*)(\.(0|([1-9]\d*))){2}$/;
exports.idRegex = idRegex;

function generateProtocolObjectIdRegExp(protocolObjectId) {
  return new RegExp("^1\\.".concat(protocolObjectId, "\\.(0|[1-9]\\d*)$"));
}

function generateProtocolImplObjectIdRegExp(ImplObjectId) {
  return new RegExp("^2\\.".concat(ImplObjectId, "\\.(0|[1-9]\\d*)$"));
}

var accountIdRegex = generateProtocolObjectIdRegExp(_constants.PROTOCOL_OBJECT_TYPE_ID.ACCOUNT);
var assetIdRegex = generateProtocolObjectIdRegExp(_constants.PROTOCOL_OBJECT_TYPE_ID.ASSET);
var committeeMemberIdRegex = generateProtocolObjectIdRegExp(_constants.PROTOCOL_OBJECT_TYPE_ID.COMMITTEE_MEMBER);
var proposalIdRegex = generateProtocolObjectIdRegExp(_constants.PROTOCOL_OBJECT_TYPE_ID.PROPOSAL);
var operationHistoryIdRegex = generateProtocolObjectIdRegExp(_constants.PROTOCOL_OBJECT_TYPE_ID.OPERATION_HISTORY);
var vestingBalanceIdRegex = generateProtocolObjectIdRegExp(_constants.PROTOCOL_OBJECT_TYPE_ID.VESTING_BALANCE);
var balanceIdRegex = generateProtocolObjectIdRegExp(_constants.PROTOCOL_OBJECT_TYPE_ID.BALANCE);
var frozenBalanceIdRegex = generateProtocolObjectIdRegExp(_constants.PROTOCOL_OBJECT_TYPE_ID.FROZEN_BALANCE);
var contractIdRegex = generateProtocolObjectIdRegExp(_constants.PROTOCOL_OBJECT_TYPE_ID.CONTRACT);
var contractResultIdRegex = generateProtocolObjectIdRegExp(_constants.PROTOCOL_OBJECT_TYPE_ID.CONTRACT_RESULT);
var ethAddressIdRegex = generateProtocolObjectIdRegExp(_constants.PROTOCOL_OBJECT_TYPE_ID.ETH_ADDRESS);
var btcAddressIdRegex = generateProtocolObjectIdRegExp(_constants.PROTOCOL_OBJECT_TYPE_ID.BTC_ADDRESS);
var erc20TokenIdRegex = generateProtocolObjectIdRegExp(_constants.PROTOCOL_OBJECT_TYPE_ID.ERC20_TOKEN);
var dynamicGlobalObjectIdRegex = new RegExp("^2\\.".concat(_constants.CHAIN_TYPES.IMPLEMENTATION_OBJECT_TYPE_ID.DYNAMIC_GLOBAL_PROPERTY, "\\.0$"));
var dynamicAssetDataIdRegex = generateProtocolImplObjectIdRegExp(_constants.CHAIN_TYPES.IMPLEMENTATION_OBJECT_TYPE_ID.ASSET_DYNAMIC_DATA);
var bitAssetIdRegex = generateProtocolImplObjectIdRegExp(_constants.CHAIN_TYPES.IMPLEMENTATION_OBJECT_TYPE_ID.ASSET_BITASSET_DATA);
var accountBalanceIdRegex = generateProtocolImplObjectIdRegExp(_constants.CHAIN_TYPES.IMPLEMENTATION_OBJECT_TYPE_ID.ACCOUNT_BALANCE);
var accountStatisticsIdRegex = generateProtocolImplObjectIdRegExp(_constants.CHAIN_TYPES.IMPLEMENTATION_OBJECT_TYPE_ID.ACCOUNT_STATISTICS);
var transactionDedupeIdRegex = generateProtocolImplObjectIdRegExp(_constants.CHAIN_TYPES.IMPLEMENTATION_OBJECT_TYPE_ID.TRANSACTION_DEDUPE);
var blockSummaryIdRegex = generateProtocolImplObjectIdRegExp(_constants.CHAIN_TYPES.IMPLEMENTATION_OBJECT_TYPE_ID.BLOCK_SUMMARY);
var accountTransactionHistoryIdRegex = generateProtocolImplObjectIdRegExp(_constants.CHAIN_TYPES.IMPLEMENTATION_OBJECT_TYPE_ID.ACCOUNT_TRANSACTION_HISTORY);
var contractHistoryIdRegex = generateProtocolImplObjectIdRegExp(_constants.CHAIN_TYPES.IMPLEMENTATION_OBJECT_TYPE_ID.CONTRACT_HISTORY);
var contractPoolIdRegex = generateProtocolImplObjectIdRegExp(_constants.CHAIN_TYPES.IMPLEMENTATION_OBJECT_TYPE_ID.CONTRACT_POOL);
var accountAddressRegex = generateProtocolImplObjectIdRegExp(_constants.CHAIN_TYPES.IMPLEMENTATION_OBJECT_TYPE_ID.ACCOUNT_ADDRESS);
var hexRegex = /^[0-9a-fA-F]+/;
var bytecodeRegex = /^[\da-fA-F0-9]{8}([\da-fA-F0-9]{64})*$/;
var voteIdTypeRegex = /^[0]{1}:[0-9]+/;
var amountRegex = /^(-?)([1-9](\d)*|0)(\.\d{0,11}[1-9])?$/;
var MAX_UINTX_VALUES = {
  64: new _bignumber["default"](2).pow(64).minus(1),
  32: new _bignumber["default"](2).pow(32).minus(1),
  16: new _bignumber["default"](2).pow(16).minus(1),
  8: new _bignumber["default"](2).pow(8).minus(1)
};
var MAX_INTX_VALUES = {
  64: new _bignumber["default"](2).pow(63).minus(1),
  32: new _bignumber["default"](2).pow(31).minus(1),
  16: new _bignumber["default"](2).pow(15).minus(1),
  8: new _bignumber["default"](2).pow(7).minus(1)
};
var NAME_MIN_LENGTH = 1;
var NAME_MAX_LENGTH = 63;

var validateUrl = function validateUrl(url) {
  return urlRegex.test(String(url));
};

exports.validateUrl = validateUrl;

var isString = function isString(v) {
  return typeof v === 'string';
};

exports.isString = isString;

var isEmpty = function isEmpty(v) {
  return v === null || typeof v === 'undefined' || typeof v.length !== 'undefined' && v.length === 0;
};

exports.isEmpty = isEmpty;

var isVoid = function isVoid(v) {
  return v === null || typeof v === 'undefined';
};

exports.isVoid = isVoid;

var isUndefined = function isUndefined(v) {
  return typeof v === 'undefined';
};

exports.isUndefined = isUndefined;

var isArray = function isArray(v) {
  return (0, _isArray["default"])(v) && !isEmpty(v.length);
};

exports.isArray = isArray;

var isEmptyArray = function isEmptyArray(v) {
  return (0, _isArray["default"])(v) && v.length === 0;
};

exports.isEmptyArray = isEmptyArray;

var isNumber = function isNumber(v) {
  return typeof v === 'number';
};

exports.isNumber = isNumber;

var isUInt = function isUInt(v, x) {
  if (isNumber(v) && v > _maxSafeInteger["default"]) return false;
  var bn = new _bignumber["default"](v);
  return bn.isInteger() && bn.gte(0) && bn.lte(MAX_UINTX_VALUES[x]);
};

var isInt = function isInt(v, x) {
  if (isNumber(v) && (v > _maxSafeInteger["default"] || v < _minSafeInteger["default"])) return false;
  var bn = new _bignumber["default"](v);
  return bn.isInteger() && bn.abs().lte(MAX_INTX_VALUES[x]);
};

var isUInt64 = function isUInt64(v) {
  return isUInt(v, 64);
};

exports.isUInt64 = isUInt64;

var isUInt32 = function isUInt32(v) {
  return isUInt(v, 32);
};

exports.isUInt32 = isUInt32;

var isUInt16 = function isUInt16(v) {
  return isUInt(v, 16);
};

exports.isUInt16 = isUInt16;

var isUInt8 = function isUInt8(v) {
  return isUInt(v, 8);
};

exports.isUInt8 = isUInt8;

var isInt64 = function isInt64(v) {
  return isInt(v, 64);
};

exports.isInt64 = isInt64;

var isFunction = function isFunction(v) {
  return typeof v === 'function';
};

exports.isFunction = isFunction;

var isBoolean = function isBoolean(v) {
  return typeof v === 'boolean';
};

exports.isBoolean = isBoolean;

var isObject = function isObject(v) {
  return (0, _typeof2["default"])(v) === 'object' && v !== null;
};

exports.isObject = isObject;

var isEmptyObject = function isEmptyObject(v) {
  return isObject(v) && (0, _keys["default"])(v).length === 0;
};

exports.isEmptyObject = isEmptyObject;

var isAccountId = function isAccountId(v) {
  return isString(v) && accountIdRegex.test(v);
};

exports.isAccountId = isAccountId;

var isAccountAddressId = function isAccountAddressId(v) {
  return isString(v) && accountAddressRegex.test(v);
};

exports.isAccountAddressId = isAccountAddressId;

var isAssetId = function isAssetId(v) {
  return isString(v) && assetIdRegex.test(v);
};

exports.isAssetId = isAssetId;

var isBtcAddressId = function isBtcAddressId(v) {
  return isString(v) && btcAddressIdRegex.test(v);
};

exports.isBtcAddressId = isBtcAddressId;

var isERC20TokenId = function isERC20TokenId(v) {
  return isString(v) && erc20TokenIdRegex.test(v);
};

exports.isERC20TokenId = isERC20TokenId;

var isEthAddressId = function isEthAddressId(v) {
  return isString(v) && ethAddressIdRegex.test(v);
};

exports.isEthAddressId = isEthAddressId;

var isCommitteeMemberId = function isCommitteeMemberId(v) {
  return isString(v) && committeeMemberIdRegex.test(v);
};

exports.isCommitteeMemberId = isCommitteeMemberId;

var isProposalId = function isProposalId(v) {
  return isString(v) && proposalIdRegex.test(v);
};

exports.isProposalId = isProposalId;

var isOperationHistoryId = function isOperationHistoryId(v) {
  return isString(v) && operationHistoryIdRegex.test(v);
};

exports.isOperationHistoryId = isOperationHistoryId;

var isVestingBalanceId = function isVestingBalanceId(v) {
  return isString(v) && vestingBalanceIdRegex.test(v);
};

exports.isVestingBalanceId = isVestingBalanceId;

var isBalanceId = function isBalanceId(v) {
  return isString(v) && balanceIdRegex.test(v);
};

exports.isBalanceId = isBalanceId;

var isFrozenBalanceId = function isFrozenBalanceId(v) {
  return isString(v) && frozenBalanceIdRegex.test(v);
};

exports.isFrozenBalanceId = isFrozenBalanceId;

var isContractId = function isContractId(v) {
  return isString(v) && contractIdRegex.test(v);
};

exports.isContractId = isContractId;

var isContractResultId = function isContractResultId(v) {
  return isString(v) && contractResultIdRegex.test(v);
};

exports.isContractResultId = isContractResultId;

var isAccountBalanceId = function isAccountBalanceId(v) {
  return isString(v) && accountBalanceIdRegex.test(v);
};

exports.isAccountBalanceId = isAccountBalanceId;

var isOperationId = function isOperationId(v) {
  return isUInt8(v) && v < 49;
};

exports.isOperationId = isOperationId;

var isVoteId = function isVoteId(v) {
  return isString(v) && voteIdTypeRegex.test(v);
};

exports.isVoteId = isVoteId;

var isObjectId = function isObjectId(v) {
  if (!isString(v)) return false;
  var match = idRegex.exec(v);
  return match !== null && v.split('.').length === 3;
};

exports.isObjectId = isObjectId;

var isBuffer = function isBuffer(v) {
  return Buffer.isBuffer(v);
};

exports.isBuffer = isBuffer;

var isHex = function isHex(v) {
  return isString(v) && hexRegex.test(v);
};

exports.isHex = isHex;

var isBytes = function isBytes(v, length) {
  return isHex(v) && v.length === length * 2;
};

exports.isBytes = isBytes;

var isBytecode = function isBytecode(v) {
  return isString(v) && bytecodeRegex.test(v);
};

exports.isBytecode = isBytecode;

var isRipemd160 = function isRipemd160(v) {
  return isHex(v) && v.length === 40;
};

exports.isRipemd160 = isRipemd160;

var isEthereumAddress = function isEthereumAddress(v) {
  return isBytes(v, 20);
};

exports.isEthereumAddress = isEthereumAddress;

var isAssetName = function isAssetName(v) {
  return !isEmpty(v) && v.split('.').length <= 2 && v.length >= 3 && v.length <= 16 && /^[A-Z]/.test(v) && /[A-Z]$/.test(v) && !/^[A-Z0-9.]$/.test(v);
};

exports.isAssetName = isAssetName;

var isBitAssetId = function isBitAssetId(v) {
  return isString(v) && bitAssetIdRegex.test(v);
};

exports.isBitAssetId = isBitAssetId;

var isDynamicAssetDataId = function isDynamicAssetDataId(v) {
  return isString(v) && dynamicAssetDataIdRegex.test(v);
};

exports.isDynamicAssetDataId = isDynamicAssetDataId;

var isAccountStatisticsId = function isAccountStatisticsId(v) {
  return isString(v) && accountStatisticsIdRegex.test(v);
};

exports.isAccountStatisticsId = isAccountStatisticsId;

var isTransactionId = function isTransactionId(v) {
  return isString(v) && transactionDedupeIdRegex.test(v);
};

exports.isTransactionId = isTransactionId;

var isBlockSummaryId = function isBlockSummaryId(v) {
  return isString(v) && blockSummaryIdRegex.test(v);
};

exports.isBlockSummaryId = isBlockSummaryId;

var isAccountTransactionHistoryId = function isAccountTransactionHistoryId(v) {
  return isString(v) && accountTransactionHistoryIdRegex.test(v);
};

exports.isAccountTransactionHistoryId = isAccountTransactionHistoryId;

var isContractHistoryId = function isContractHistoryId(v) {
  return isString(v) && contractHistoryIdRegex.test(v);
};

exports.isContractHistoryId = isContractHistoryId;

var isContractPoolId = function isContractPoolId(v) {
  return isString(v) && contractPoolIdRegex.test(v);
};

exports.isContractPoolId = isContractPoolId;

var isDynamicGlobalObjectId = function isDynamicGlobalObjectId(v) {
  return isString(v) && dynamicGlobalObjectIdRegex.test(v);
};

exports.isDynamicGlobalObjectId = isDynamicGlobalObjectId;

var isPublicKey = function isPublicKey(v) {
  var addressPrefix = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : _chainConfig.ADDRESS_PREFIX;
  if (!isString(v)) return false;
  var prefix = (0, _slice["default"])(v).call(v, 0, addressPrefix.length);

  if (addressPrefix !== prefix || _bs["default"].decode((0, _slice["default"])(v).call(v, addressPrefix.length)).length !== _chainConfig.LENGTH_DECODE_PUBLIC_KEY) {
    return false;
  }

  return true;
};

exports.isPublicKey = isPublicKey;

var isEchoRandKey = function isEchoRandKey(v) {
  var echorandPrefix = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : _chainConfig.ADDRESS_PREFIX;
  return isPublicKey(v, echorandPrefix);
};

exports.isEchoRandKey = isEchoRandKey;

var isAccountName = function isAccountName(v) {
  if (!isString(v)) {
    return false;
  }

  if (isEmpty(v)) {
    return false;
  }

  var length = v.length;

  if (length < NAME_MIN_LENGTH || length > NAME_MAX_LENGTH) {
    return false;
  }

  var ref = v.split('.');

  for (var i = 0; i < ref.length; i += 1) {
    var label = ref[i];

    if (!(/^[a-z][a-z0-9-]*$/.test(label) && label.length >= NAME_MIN_LENGTH)) {
      return false;
    }
  }

  return true;
};
/**
 * @method checkAccountName
 *
 * Return name of error if account name is invalid
 *
 * @param {String} value
 */


exports.isAccountName = isAccountName;

var checkAccountName = function checkAccountName(value) {
  var suffix = 'Account name should';

  if (value == null || value.length === 0) {
    return "".concat(suffix, " not be empty.");
  }

  if (value.length < NAME_MIN_LENGTH) {
    return "".concat(suffix, " be longer.");
  }

  if (value.length > NAME_MAX_LENGTH) {
    return "".concat(suffix, " be shorter.");
  }

  if (/\./.test(value)) {
    suffix = 'Each account segment should';
  }

  var ref = value.split('.');

  for (var i = 0; i < ref.length; i += 1) {
    var label = ref[i];

    if (!/^[a-z]/.test(label)) {
      return "".concat(suffix, " start with a lowercase letter.");
    }

    if (!/^[a-z0-9-]*$/.test(label)) {
      return "".concat(suffix, " have only lowercase letters, digits, or dashes.");
    }

    if (!/[a-z0-9]$/.test(label)) {
      return "".concat(suffix, " end with a lowercase letter or digit.");
    }

    if (!(label.length >= NAME_MIN_LENGTH)) {
      return "".concat(suffix, " be longer.");
    }
  }

  return null;
};
/**
 * @method checkCheapName
 *
 * Check cheap name
 *
 * @param {String} name
 * @deprecated
 */


exports.checkAccountName = checkAccountName;

var checkCheapName = function checkCheapName(name) {
  return /[a-z0-9-]/.test(name) || !/[aeiouy]/.test(name);
};

exports.checkCheapName = checkCheapName;

var validateOptionsError = function validateOptionsError(options) {
  var _context;

  if (!options || (0, _typeof2["default"])(options) !== 'object') return 'Options should be an object';
  var errorParameter;

  if (!((0, _isInteger["default"])(options.connectionTimeout) || typeof options.connectionTimeout === 'undefined')) {
    errorParameter = 'connectionTimeout';
  } else if (!((0, _isInteger["default"])(options.maxRetries) || typeof options.maxRetries === 'undefined')) {
    errorParameter = 'maxRetries';
  } else if (!((0, _isInteger["default"])(options.pingTimeout) || typeof options.pingTimeout === 'undefined')) {
    errorParameter = 'pingTimeout';
  } else if (!((0, _isInteger["default"])(options.pingDelay) || typeof options.pingDelay === 'undefined')) {
    errorParameter = 'pingDelay';
  } else if (!(typeof options.debug === 'boolean' || typeof options.debug === 'undefined')) {
    errorParameter = 'debug';
  } else if (!((0, _isArray["default"])(options.apis) && (0, _every["default"])(_context = options.apis).call(_context, function (api) {
    return (0, _includes["default"])(_wsConstants.CHAIN_APIS).call(_wsConstants.CHAIN_APIS, api);
  }) || typeof options.apis === 'undefined')) {
    errorParameter = 'apis';
  }

  return errorParameter ? "Parameter ".concat(errorParameter, " is invalid") : false;
};

exports.validateOptionsError = validateOptionsError;

var isTimePointSec = function isTimePointSec(v) {
  if (!isString(v)) return false;

  try {
    return new Date(v).toISOString();
  } catch (error) {
    return false;
  }
};

exports.isTimePointSec = isTimePointSec;

var isAccountIdOrName = function isAccountIdOrName(v) {
  return isAccountId(v) || isAccountName(v);
};

exports.isAccountIdOrName = isAccountIdOrName;

var isAssetIdOrName = function isAssetIdOrName(v) {
  return isAssetId(v) || isAssetName(v);
};

exports.isAssetIdOrName = isAssetIdOrName;

var isMethodExists = function isMethodExists(v) {
  return (0, _includes["default"])(_methodsOperationsData.walletAPIMethodsArray).call(_methodsOperationsData.walletAPIMethodsArray, v);
};

exports.isMethodExists = isMethodExists;

var isOperationPrototypeExists = function isOperationPrototypeExists(v) {
  return (0, _includes["default"])(_methodsOperationsData.operationPrototypeArray).call(_methodsOperationsData.operationPrototypeArray, v);
};

exports.isOperationPrototypeExists = isOperationPrototypeExists;

var isNotEmptyString = function isNotEmptyString(v) {
  return isString(v) && !!(0, _trim["default"])(v).call(v);
};

exports.isNotEmptyString = isNotEmptyString;

var isContractCode = function isContractCode(v) {
  return v === '' || isHex(v) && v.length % 2 === 0;
};

exports.isContractCode = isContractCode;

var isOldPrivateKey = function isOldPrivateKey(v) {
  return isString(v) && _bs["default"].decode(v).length === _chainConfig.LENGTH_DECODE_PRIVATE_KEY;
};

exports.isOldPrivateKey = isOldPrivateKey;

var isValidAmount = function isValidAmount(v) {
  if (!isString(v)) return false;
  var integer = new _bignumber["default"](v.split('.')[0]).absoluteValue();
  if (integer.gt(_constants.AMOUNT_MAX_NUMBER)) return false;
  return integer.times(1e12).lt(_constants.ECHO_MAX_SHARE_SUPPLY) && amountRegex.test(v);
};
/** @param {string} v */


exports.isValidAmount = isValidAmount;

function validateSidechainType(v) {
  var _context2;

  if (typeof v !== 'string') throw new Error('Type is not a string');
  if (!(0, _includes["default"])(_context2 = ['', 'eth', 'btc']).call(_context2, v)) throw new Error("Unsupported withdrawal type \"".concat(v, "\""));
}
/**
 * @param {number|BN|string} v
 * @returns {string}
 */


function validateAmount(v) {
  if (typeof v === 'number' || typeof v === 'string') v = new _bignumber["default"](v);
  if (!(v instanceof _bignumber["default"])) throw new Error('amount: invalid type');
  if (v.isNaN()) throw new Error('amount: not a number');
  var dp = v.dp();
  if (dp > 12) throw new Error('amont: invalid precision');
  var minSatoshis = v.times("1e".concat(dp.toString(10))).abs();
  if (minSatoshis > _constants.chain.config.ECHO_MAX_SHARE_SUPPLY) throw new Error('amount: overflow');
  return v.toString(10);
}