export default interface Config {
	ECHO_SYMBOL: string,
	ECHO_ADDRESS_PREFIX: string,
	ECHO_ED_PREFIX: string,
	ECHO_MIN_ACCOUNT_NAME_LENGTH: number,
	ECHO_MAX_ACCOUNT_NAME_LENGTH: number,
	ECHO_MIN_ASSET_SYMBOL_LENGTH: number,
	ECHO_MAX_ASSET_SYMBOL_LENGTH: number,
	ECHO_MAX_SHARE_SUPPLY: string,
	ECHO_MAX_PAY_RATE: number,
	ECHO_MAX_SIG_CHECK_DEPTH: number,
	ECHO_MIN_TRANSACTION_SIZE_LIMIT: number,
	ECHO_MIN_BLOCK_INTERVAL: number,
	ECHO_MAX_BLOCK_INTERVAL: number,
	ECHO_DEFAULT_BLOCK_INTERVAL: number,
	ECHO_DEFAULT_MAX_TRANSACTION_SIZE: number,
	ECHO_DEFAULT_MAX_BLOCK_SIZE: number,
	ECHO_DEFAULT_MAX_TIME_UNTIL_EXPIRATION: number,
	ECHO_DEFAULT_MAINTENANCE_INTERVAL: number,
	ECHO_DEFAULT_MAINTENANCE_SKIP_SLOTS: number,
	ECHO_MIN_UNDO_HISTORY: number,
	ECHO_MAX_UNDO_HISTORY: number,
	ECHO_MIN_BLOCK_SIZE_LIMIT: number,
	ECHO_MIN_TRANSACTION_EXPIRATION_LIMIT: number,
	ECHO_BLOCKCHAIN_PRECISION: number,
	ECHO_BLOCKCHAIN_PRECISION_DIGITS: number,
	ECHO_DEFAULT_TRANSFER_FEE: number,
	ECHO_MAX_INSTANCE_ID: string,
	ECHO_100_PERCENT: number,
	ECHO_1_PERCENT: number,
	ECHO_MAX_MARKET_FEE_PERCENT: number,
	ECHO_DEFAULT_FORCE_SETTLEMENT_DELAY: number,
	ECHO_DEFAULT_FORCE_SETTLEMENT_OFFSET: number,
	ECHO_DEFAULT_FORCE_SETTLEMENT_MAX_VOLUME: number,
	ECHO_DEFAULT_PRICE_FEED_LIFETIME: number,
	ECHO_MAX_FEED_PRODUCERS: number,
	ECHO_DEFAULT_MAX_AUTHORITY_MEMBERSHIP: number,
	ECHO_DEFAULT_MAX_ASSET_WHITELIST_AUTHORITIES: number,
	ECHO_DEFAULT_MAX_ASSET_FEED_PUBLISHERS: number,
	ECHO_COLLATERAL_RATIO_DENOM: number,
	ECHO_MIN_COLLATERAL_RATIO: number,
	ECHO_MAX_COLLATERAL_RATIO: number,
	ECHO_DEFAULT_MAINTENANCE_COLLATERAL_RATIO: number,
	ECHO_DEFAULT_MAX_SHORT_SQUEEZE_RATIO: number,
	ECHO_DEFAULT_MARGIN_PERIOD_SEC: number,
	ECHO_DEFAULT_MAX_COMMITTEE: number,
	ECHO_DEFAULT_MAX_PROPOSAL_LIFETIME_SEC: number,
	ECHO_DEFAULT_COMMITTEE_PROPOSAL_REVIEW_PERIOD_SEC: number,
	ECHO_DEFAULT_NETWORK_PERCENT_OF_FEE: number,
	ECHO_DEFAULT_MAX_BULK_DISCOUNT_PERCENT: number,
	ECHO_DEFAULT_BULK_DISCOUNT_THRESHOLD_MIN: number,
	ECHO_DEFAULT_BULK_DISCOUNT_THRESHOLD_MAX: string,
	ECHO_DEFAULT_CASHBACK_VESTING_PERIOD_SEC: number,
	ECHO_DEFAULT_BURN_PERCENT_OF_FEE: number,
	ECHO_DEFAULT_MAX_ASSERT_OPCODE: number,
	ECHO_DEFAULT_ACCOUNTS_PER_FEE_SCALE: number,
	ECHO_DEFAULT_ACCOUNT_FEE_SCALE_BITSHIFTS: number,
	ECHO_MAX_URL_LENGTH: number,
	ECHO_NEAR_SCHEDULE_CTR_IV: string,
	ECHO_FAR_SCHEDULE_CTR_IV: string,
	ECHO_CORE_ASSET_CYCLE_RATE: number,
	ECHO_CORE_ASSET_CYCLE_RATE_BITS: number,
	ECHO_MAX_INTEREST_APR: number,
	ECHO_COMMITTEE_ACCOUNT: string,
	ECHO_RELAXED_COMMITTEE_ACCOUNT: string,
	ECHO_NULL_ACCOUNT: string,
	ECHO_TEMP_ACCOUNT: string
}
